--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- Name: auth; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA auth;


SET search_path = auth, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: clients; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE clients (
    id integer NOT NULL,
    name text NOT NULL,
    dbhost text NOT NULL,
    dbport integer DEFAULT 5432 NOT NULL,
    dbname text NOT NULL,
    dbuser text NOT NULL,
    dbpasswd text NOT NULL,
    is_default boolean DEFAULT false NOT NULL
);


--
-- Name: clients_groups; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE clients_groups (
    client_id integer NOT NULL,
    group_id integer NOT NULL
);


--
-- Name: clients_id_seq; Type: SEQUENCE; Schema: auth; Owner: -
--

CREATE SEQUENCE clients_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: clients_id_seq; Type: SEQUENCE OWNED BY; Schema: auth; Owner: -
--

ALTER SEQUENCE clients_id_seq OWNED BY clients.id;


--
-- Name: clients_id_seq; Type: SEQUENCE SET; Schema: auth; Owner: -
--

SELECT pg_catalog.setval('clients_id_seq', 1, true);


--
-- Name: clients_users; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE clients_users (
    client_id integer NOT NULL,
    user_id integer NOT NULL
);


--
-- Name: group_id_seq; Type: SEQUENCE; Schema: auth; Owner: -
--

CREATE SEQUENCE group_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: group_id_seq; Type: SEQUENCE SET; Schema: auth; Owner: -
--

SELECT pg_catalog.setval('group_id_seq', 1, true);


--
-- Name: group; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE "group" (
    id integer DEFAULT nextval('group_id_seq'::regclass) NOT NULL,
    name text NOT NULL,
    description text
);


--
-- Name: group_rights; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE group_rights (
    group_id integer NOT NULL,
    "right" text NOT NULL,
    granted boolean NOT NULL
);


--
-- Name: schema_info; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE schema_info (
    tag text NOT NULL,
    login text,
    itime timestamp without time zone DEFAULT now()
);


--
-- Name: session; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE session (
    id text NOT NULL,
    ip_address inet,
    mtime timestamp without time zone,
    api_token text
);


--
-- Name: session_content; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE session_content (
    session_id text,
    sess_key text,
    sess_value text,
    auto_restore boolean
);


--
-- Name: user_id_seq; Type: SEQUENCE; Schema: auth; Owner: -
--

CREATE SEQUENCE user_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: user_id_seq; Type: SEQUENCE SET; Schema: auth; Owner: -
--

SELECT pg_catalog.setval('user_id_seq', 1, true);


--
-- Name: user; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE "user" (
    id integer DEFAULT nextval('user_id_seq'::regclass) NOT NULL,
    login text NOT NULL,
    password text
);


--
-- Name: user_config; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE user_config (
    user_id integer NOT NULL,
    cfg_key text NOT NULL,
    cfg_value text
);


--
-- Name: user_group; Type: TABLE; Schema: auth; Owner: -; Tablespace: 
--

CREATE TABLE user_group (
    user_id integer NOT NULL,
    group_id integer NOT NULL
);


--
-- Name: id; Type: DEFAULT; Schema: auth; Owner: -
--

ALTER TABLE clients ALTER COLUMN id SET DEFAULT nextval('clients_id_seq'::regclass);


--
-- Data for Name: clients; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY clients (id, name, dbhost, dbport, dbname, dbuser, dbpasswd, is_default) FROM stdin;
1	standard	localhost	5432	kivitendo	kivitendo	test	t
\.


--
-- Data for Name: clients_groups; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY clients_groups (client_id, group_id) FROM stdin;
1	1
\.


--
-- Data for Name: clients_users; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY clients_users (client_id, user_id) FROM stdin;
1	1
\.


--
-- Data for Name: group; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY "group" (id, name, description) FROM stdin;
1	Vollzugriff	
\.


--
-- Data for Name: group_rights; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY group_rights (group_id, "right", granted) FROM stdin;
1	crm_search	t
1	crm_new	t
1	crm_service	t
1	crm_admin	t
1	crm_adminuser	t
1	crm_adminstatus	t
1	crm_email	t
1	crm_termin	t
1	crm_opportunity	t
1	crm_knowhow	t
1	crm_follow	t
1	crm_notices	t
1	crm_other	t
1	customer_vendor_edit	t
1	customer_vendor_all_edit	t
1	part_service_assembly_edit	t
1	part_service_assembly_details	t
1	project_edit	t
1	sales_quotation_edit	t
1	sales_order_edit	t
1	sales_delivery_order_edit	t
1	invoice_edit	t
1	dunning_edit	t
1	sales_all_edit	t
1	edit_prices	t
1	show_ar_transactions	t
1	delivery_plan	t
1	request_quotation_edit	t
1	purchase_order_edit	t
1	purchase_delivery_order_edit	t
1	vendor_invoice_edit	t
1	show_ap_transactions	t
1	warehouse_contents	t
1	warehouse_management	t
1	general_ledger	t
1	datev_export	t
1	cash	t
1	report	t
1	advance_turnover_tax_return	t
1	batch_printing	t
1	config	t
1	admin	t
1	email_bcc	t
1	productivity	t
1	display_admin_link	t
\.


--
-- Data for Name: schema_info; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY schema_info (tag, login, itime) FROM stdin;
add_api_token	admin	2014-03-03 15:30:36.089601
add_batch_printing_to_full_access	admin	2014-03-03 15:30:36.102698
auth_schema_normalization_1	admin	2014-03-03 15:30:36.11107
password_hashing	admin	2014-03-03 15:30:36.294717
remove_menustyle_v4	admin	2014-03-03 15:30:36.302956
remove_menustyle_xml	admin	2014-03-03 15:30:36.311245
session_content_auto_restore	admin	2014-03-03 15:30:36.319425
release_3_0_0	admin	2014-03-03 15:30:36.327686
clients	admin	2014-03-03 15:30:36.3391
delivery_plan_rights	admin	2014-03-03 15:30:36.695396
details_and_report_of_parts	admin	2014-03-03 15:30:36.703329
productivity_rights	admin	2014-03-03 15:30:36.711688
rights_for_showing_ar_and_ap_transactions	admin	2014-03-03 15:30:36.720059
clients_webdav	admin	2014-03-03 15:30:36.729797
foreign_key_constraints_on_delete	admin	2014-03-03 15:30:36.736667
\.


--
-- Data for Name: session; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY session (id, ip_address, mtime, api_token) FROM stdin;
c5521c23ab417cdd08d6ad9dd713b04a	127.0.0.1	2014-03-05 09:23:11.666128	9367ae3415073fdc60e6413e0c7a6348
\.


--
-- Data for Name: session_content; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY session_content (session_id, sess_key, sess_value, auto_restore) FROM stdin;
\.


--
-- Data for Name: user; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY "user" (id, login, password) FROM stdin;
1	demo	{SHA256S}4011ba02e51104c678c31a76a444485b38f3865e504d89c3a0a80b439bb1a237
\.


--
-- Data for Name: user_config; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY user_config (user_id, cfg_key, cfg_value) FROM stdin;
1	mandatory_departments	0
1	dateformat	dd.mm.yy
1	name	
1	countrycode	de
1	menustyle	neu
1	email	
1	signature	
1	tel	
1	fax	
1	stylesheet	kivitendo.css
1	numberformat	1.000,00
1	vclimit	200
\.


--
-- Data for Name: user_group; Type: TABLE DATA; Schema: auth; Owner: -
--

COPY user_group (user_id, group_id) FROM stdin;
1	1
\.


--
-- Name: clients_dbhost_key; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY clients
    ADD CONSTRAINT clients_dbhost_key UNIQUE (dbhost, dbport, dbname);


--
-- Name: clients_groups_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY clients_groups
    ADD CONSTRAINT clients_groups_pkey PRIMARY KEY (client_id, group_id);


--
-- Name: clients_name_key; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY clients
    ADD CONSTRAINT clients_name_key UNIQUE (name);


--
-- Name: clients_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY clients
    ADD CONSTRAINT clients_pkey PRIMARY KEY (id);


--
-- Name: clients_users_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY clients_users
    ADD CONSTRAINT clients_users_pkey PRIMARY KEY (client_id, user_id);


--
-- Name: group_name_key; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY "group"
    ADD CONSTRAINT group_name_key UNIQUE (name);


--
-- Name: group_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY "group"
    ADD CONSTRAINT group_pkey PRIMARY KEY (id);


--
-- Name: group_rights_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY group_rights
    ADD CONSTRAINT group_rights_pkey PRIMARY KEY (group_id, "right");


--
-- Name: schema_info_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY schema_info
    ADD CONSTRAINT schema_info_pkey PRIMARY KEY (tag);


--
-- Name: session_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY session
    ADD CONSTRAINT session_pkey PRIMARY KEY (id);


--
-- Name: user_config_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY user_config
    ADD CONSTRAINT user_config_pkey PRIMARY KEY (user_id, cfg_key);


--
-- Name: user_group_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY user_group
    ADD CONSTRAINT user_group_pkey PRIMARY KEY (user_id, group_id);


--
-- Name: user_login_key; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY "user"
    ADD CONSTRAINT user_login_key UNIQUE (login);


--
-- Name: user_pkey; Type: CONSTRAINT; Schema: auth; Owner: -; Tablespace: 
--

ALTER TABLE ONLY "user"
    ADD CONSTRAINT user_pkey PRIMARY KEY (id);


--
-- Name: clients_groups_client_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY clients_groups
    ADD CONSTRAINT clients_groups_client_id_fkey FOREIGN KEY (client_id) REFERENCES clients(id) ON DELETE CASCADE;


--
-- Name: clients_groups_group_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY clients_groups
    ADD CONSTRAINT clients_groups_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id) ON DELETE CASCADE;


--
-- Name: clients_users_client_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY clients_users
    ADD CONSTRAINT clients_users_client_id_fkey FOREIGN KEY (client_id) REFERENCES clients(id) ON DELETE CASCADE;


--
-- Name: clients_users_user_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY clients_users
    ADD CONSTRAINT clients_users_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE CASCADE;


--
-- Name: group_rights_group_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY group_rights
    ADD CONSTRAINT group_rights_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id) ON DELETE CASCADE;


--
-- Name: session_content_session_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY session_content
    ADD CONSTRAINT session_content_session_id_fkey FOREIGN KEY (session_id) REFERENCES session(id) ON DELETE CASCADE;


--
-- Name: user_config_user_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY user_config
    ADD CONSTRAINT user_config_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE CASCADE;


--
-- Name: user_group_group_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY user_group
    ADD CONSTRAINT user_group_group_id_fkey FOREIGN KEY (group_id) REFERENCES "group"(id) ON DELETE CASCADE;


--
-- Name: user_group_user_id_fkey; Type: FK CONSTRAINT; Schema: auth; Owner: -
--

ALTER TABLE ONLY user_group
    ADD CONSTRAINT user_group_user_id_fkey FOREIGN KEY (user_id) REFERENCES "user"(id) ON DELETE CASCADE;


--
-- Name: public; Type: ACL; Schema: -; Owner: -
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

