--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

--
-- Name: tax; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA tax;


SET search_path = public, pg_catalog;

--
-- Name: chart_category_to_sgn(character); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION chart_category_to_sgn(character) RETURNS integer
    LANGUAGE sql
    AS $_$SELECT  1 WHERE $1 IN ('I', 'L', 'Q')
      UNION 
    SELECT -1 WHERE $1 IN ('E', 'A')$_$;


--
-- Name: check_inventory(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION check_inventory() RETURNS trigger
    LANGUAGE plpgsql
    AS $$declare  itemid int;  row_data inventory%rowtype;begin  if not old.quotation then    for row_data in select * from inventory where oe_id = old.id loop      select into itemid id from orderitems where trans_id = old.id and id = row_data.orderitems_id;      if itemid is null then	delete from inventory where oe_id = old.id and orderitems_id = row_data.orderitems_id;      end if;    end loop;  end if;  return old;end;$$;


--
-- Name: clean_up_acc_trans_after_ar_ap_gl_delete(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION clean_up_acc_trans_after_ar_ap_gl_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM acc_trans WHERE trans_id = OLD.id;
    RETURN OLD;
  END;
$$;


--
-- Name: clean_up_after_customer_vendor_delete(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION clean_up_after_customer_vendor_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM contacts
    WHERE cp_cv_id = OLD.id;

    DELETE FROM shipto
    WHERE (trans_id = OLD.id)
      AND (module   = 'CT');

    RETURN OLD;
  END;
$$;


--
-- Name: clean_up_record_links_before_ap_delete(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION clean_up_record_links_before_ap_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM record_links
      WHERE (from_table = 'ap' AND from_id = OLD.id)
         OR (to_table   = 'ap' AND to_id   = OLD.id);
    RETURN OLD;
  END;
$$;


--
-- Name: clean_up_record_links_before_ar_delete(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION clean_up_record_links_before_ar_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM record_links
      WHERE (from_table = 'ar' AND from_id = OLD.id)
         OR (to_table   = 'ar' AND to_id   = OLD.id);
    RETURN OLD;
  END;
$$;


--
-- Name: clean_up_record_links_before_delivery_orders_delete(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION clean_up_record_links_before_delivery_orders_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM record_links
      WHERE (from_table = 'delivery_orders' AND from_id = OLD.id)
         OR (to_table   = 'delivery_orders' AND to_id   = OLD.id);
    RETURN OLD;
  END;
$$;


--
-- Name: clean_up_record_links_before_oe_delete(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION clean_up_record_links_before_oe_delete() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM record_links
      WHERE (from_table = 'oe' AND from_id = OLD.id)
         OR (to_table   = 'oe' AND to_id   = OLD.id);
    RETURN OLD;
  END;
$$;


--
-- Name: comma_aggregate(text, text); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION comma_aggregate(text, text) RETURNS text
    LANGUAGE sql IMMUTABLE STRICT
    AS $_$
  SELECT CASE WHEN $1 <> '' THEN $1 || ', ' || $2 
                              ELSE $2 
         END; 
$_$;


--
-- Name: del_customer(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION del_customer() RETURNS trigger
    LANGUAGE plpgsql
    AS $$BEGIN
     DELETE FROM shipto WHERE trans_id = old.id;
     RETURN NULL;
   END;$$;


--
-- Name: del_vendor(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION del_vendor() RETURNS trigger
    LANGUAGE plpgsql
    AS $$BEGIN
    DELETE FROM shipto WHERE trans_id = old.id;
    RETURN NULL;
  END;$$;


--
-- Name: delete_contact_custom_variables_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION delete_contact_custom_variables_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE (sub_module = '' OR sub_module IS NULL)
                                         AND trans_id = OLD.cp_id
                                         AND (SELECT module FROM custom_variable_configs WHERE id = config_id) = 'Contacts';

          RETURN OLD;
        END;
      $$;


--
-- Name: delete_cv_custom_variables_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION delete_cv_custom_variables_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE (sub_module = '' OR sub_module IS NULL)
                                         AND trans_id = OLD.id
                                         AND (SELECT module FROM custom_variable_configs WHERE id = config_id) = 'CT';

          RETURN OLD;
        END;
      $$;


--
-- Name: delete_part_custom_variables_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION delete_part_custom_variables_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE (sub_module = '' OR sub_module IS NULL)
                                         AND trans_id = OLD.id
                                         AND (SELECT module FROM custom_variable_configs WHERE id = config_id) = 'IC';

          RETURN OLD;
        END;
      $$;


--
-- Name: delete_project_custom_variables_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION delete_project_custom_variables_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE (sub_module = '' OR sub_module IS NULL)
                                         AND trans_id = OLD.id
                                         AND (SELECT module FROM custom_variable_configs WHERE id = config_id) = 'Projects';

          RETURN OLD;
        END;
      $$;


--
-- Name: delivery_order_items_before_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION delivery_order_items_before_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE sub_module = 'delivery_order_items' AND trans_id = OLD.id;

          RETURN OLD;
        END;
      $$;


--
-- Name: delivery_orders_before_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION delivery_orders_before_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM status                     WHERE trans_id = OLD.id;
          DELETE FROM delivery_order_items_stock WHERE delivery_order_item_id IN (SELECT id FROM delivery_order_items WHERE delivery_order_id = OLD.id);
          DELETE FROM shipto                     WHERE (trans_id = OLD.id) AND (module = 'OE');

          RETURN OLD;
        END;
      $$;


--
-- Name: follow_up_close_when_oe_closed_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION follow_up_close_when_oe_closed_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    IF COALESCE(NEW.closed, FALSE) AND NOT COALESCE(OLD.closed, FALSE) THEN
      UPDATE follow_ups
      SET done = TRUE
      WHERE id IN (
        SELECT follow_up_id
        FROM follow_up_links
        WHERE (trans_id   = NEW.id)
          AND (trans_type IN ('sales_quotation',   'sales_order',    'sales_delivery_order',
                              'request_quotation', 'purchase_order', 'purchase_delivery_order'))
      );
    END IF;

    RETURN NEW;
  END;
$$;


--
-- Name: follow_up_delete_notes_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION follow_up_delete_notes_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM notes
    WHERE (trans_id     = OLD.id)
      AND (trans_module = 'fu');
    RETURN OLD;
  END;
$$;


--
-- Name: follow_up_delete_when_customer_vendor_is_deleted_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION follow_up_delete_when_customer_vendor_is_deleted_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM follow_ups
    WHERE id IN (
      SELECT follow_up_id
      FROM follow_up_links
      WHERE (trans_id   = OLD.id)
        AND (trans_type IN ('customer', 'vendor'))
    );

    DELETE FROM notes
    WHERE (trans_id     = OLD.id)
      AND (trans_module = 'ct');

    RETURN OLD;
  END;
$$;


--
-- Name: follow_up_delete_when_oe_is_deleted_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION follow_up_delete_when_oe_is_deleted_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM follow_ups
    WHERE id IN (
      SELECT follow_up_id
      FROM follow_up_links
      WHERE (trans_id   = OLD.id)
        AND (trans_type IN ('sales_quotation',   'sales_order',    'sales_delivery_order',    'sales_invoice',
                            'request_quotation', 'purchase_order', 'purchase_delivery_order', 'purchase_invoice'))
    );

    RETURN OLD;
  END;
$$;


--
-- Name: generic_translations_delete_on_delivery_terms_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION generic_translations_delete_on_delivery_terms_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM generic_translations
      WHERE translation_id = OLD.id AND translation_type LIKE 'SL::DB::DeliveryTerm/description_long';
    RETURN OLD;
  END;
$$;


--
-- Name: generic_translations_delete_on_payment_terms_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION generic_translations_delete_on_payment_terms_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM generic_translations
      WHERE translation_id = OLD.id AND translation_type LIKE 'SL::DB::PaymentTerm/description_long';
    RETURN OLD;
  END;
$$;


--
-- Name: generic_translations_delete_on_tax_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION generic_translations_delete_on_tax_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
  BEGIN
    DELETE FROM generic_translations
      WHERE translation_id = OLD.id AND translation_type LIKE 'SL::DB::Tax/taxdescription';
    RETURN OLD;
  END;
$$;


--
-- Name: invoice_before_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION invoice_before_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE sub_module = 'invoice' AND trans_id = OLD.id;

          RETURN OLD;
        END;
      $$;


--
-- Name: oe_before_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION oe_before_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM status WHERE trans_id = OLD.id;
          DELETE FROM shipto WHERE (trans_id = OLD.id) AND (module = 'OE');

          RETURN OLD;
        END;
      $$;


--
-- Name: orderitems_before_delete_trigger(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION orderitems_before_delete_trigger() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
        BEGIN
          DELETE FROM custom_variables WHERE sub_module = 'orderitems' AND trans_id = OLD.id;

          RETURN OLD;
        END;
      $$;

--
-- Name: set_mtime(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION set_mtime() RETURNS trigger
    LANGUAGE plpgsql
    AS $$    BEGIN        NEW.mtime := 'now';        RETURN NEW;    END;$$;


--
-- Name: set_priceupdate_parts(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION set_priceupdate_parts() RETURNS trigger
    LANGUAGE plpgsql
    AS $$    BEGIN        NEW.priceupdate := 'now';        RETURN NEW;    END;$$;


--
-- Name: update_onhand(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION update_onhand() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
  IF tg_op = 'INSERT' THEN
    UPDATE parts SET onhand = COALESCE(onhand, 0) + new.qty WHERE id = new.parts_id;
    RETURN new;
  ELSIF tg_op = 'DELETE' THEN
    UPDATE parts SET onhand = COALESCE(onhand, 0) - old.qty WHERE id = old.parts_id;
    RETURN old;
  ELSE
    UPDATE parts SET onhand = COALESCE(onhand, 0) - old.qty + new.qty WHERE id = old.parts_id;
    RETURN new;
  END IF;
END;
$$;


--
-- Name: update_purchase_price(); Type: FUNCTION; Schema: public; Owner: -
--

CREATE FUNCTION update_purchase_price() RETURNS trigger
    LANGUAGE plpgsql
    AS $$
BEGIN
  if tg_op = 'DELETE' THEN
    UPDATE parts SET lastcost = COALESCE((select sum ((a.qty * (p.lastcost / COALESCE(pf.factor,
    1)))) as summe from assembly a left join parts p on (p.id = a.parts_id) 
    LEFT JOIN price_factors pf on (p.price_factor_id = pf.id) where a.id = parts.id),0) 
    WHERE assembly = TRUE and id = old.id;
    return old;	
  ELSE
    UPDATE parts SET lastcost = COALESCE((select sum ((a.qty * (p.lastcost / COALESCE(pf.factor, 
    1)))) as summe from assembly a left join parts p on (p.id = a.parts_id)
    LEFT JOIN price_factors pf on (p.price_factor_id = pf.id) 
    WHERE a.id = parts.id),0) where assembly = TRUE and id = new.id;
    return new; 
		
  END IF;
END;
$$;


--
-- Name: comma(text); Type: AGGREGATE; Schema: public; Owner: -
--

CREATE AGGREGATE comma(text) (
    SFUNC = comma_aggregate,
    STYPE = text,
    INITCOND = ''
);


--
-- Name: acc_trans_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE acc_trans_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: acc_trans_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('acc_trans_id_seq', 814, true);


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: acc_trans; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE acc_trans (
    acc_trans_id bigint DEFAULT nextval('acc_trans_id_seq'::regclass) NOT NULL,
    trans_id integer NOT NULL,
    chart_id integer NOT NULL,
    amount numeric(15,5),
    transdate date DEFAULT ('now'::text)::date,
    gldate date DEFAULT ('now'::text)::date,
    source text,
    cleared boolean DEFAULT false NOT NULL,
    fx_transaction boolean DEFAULT false NOT NULL,
    ob_transaction boolean DEFAULT false NOT NULL,
    cb_transaction boolean DEFAULT false NOT NULL,
    project_id integer,
    memo text,
    taxkey integer,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    chart_link text NOT NULL,
    tax_id integer NOT NULL
);


--
-- Name: ap; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ap (
    id integer DEFAULT nextval(('glid'::text)::regclass) NOT NULL,
    invnumber text NOT NULL,
    transdate date DEFAULT ('now'::text)::date,
    gldate date DEFAULT ('now'::text)::date,
    vendor_id integer,
    taxincluded boolean DEFAULT false,
    amount numeric(15,5),
    netamount numeric(15,5),
    paid numeric(15,5),
    datepaid date,
    duedate date,
    invoice boolean DEFAULT false,
    ordnumber text,
    notes text,
    employee_id integer,
    quonumber text,
    intnotes text,
    department_id integer,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    shipvia text,
    cp_id integer,
    language_id integer,
    payment_id integer,
    storno boolean DEFAULT false,
    taxzone_id integer,
    type text,
    orddate date,
    quodate date,
    globalproject_id integer,
    storno_id integer,
    transaction_description text,
    direct_debit boolean DEFAULT false,
    deliverydate date,
    delivery_term_id integer,
    currency_id integer NOT NULL
);


--
-- Name: ar; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE ar (
    id integer DEFAULT nextval(('glid'::text)::regclass) NOT NULL,
    invnumber text NOT NULL,
    transdate date DEFAULT ('now'::text)::date,
    gldate date DEFAULT ('now'::text)::date,
    customer_id integer,
    taxincluded boolean,
    amount numeric(15,5),
    netamount numeric(15,5),
    paid numeric(15,5),
    datepaid date,
    duedate date,
    deliverydate date,
    invoice boolean DEFAULT false,
    shippingpoint text,
    terms smallint DEFAULT 0,
    notes text,
    ordnumber text,
    employee_id integer,
    quonumber text,
    cusordnumber text,
    intnotes text,
    department_id integer,
    shipvia text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    cp_id integer,
    language_id integer,
    payment_id integer,
    delivery_customer_id integer,
    delivery_vendor_id integer,
    storno boolean DEFAULT false,
    taxzone_id integer,
    shipto_id integer,
    type text,
    dunning_config_id integer,
    orddate date,
    quodate date,
    globalproject_id integer,
    salesman_id integer,
    marge_total numeric(15,5),
    marge_percent numeric(15,5),
    storno_id integer,
    transaction_description text,
    donumber text,
    invnumber_for_credit_note text,
    direct_debit boolean DEFAULT false,
    delivery_term_id integer,
    currency_id integer NOT NULL
);


--
-- Name: assembly_assembly_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE assembly_assembly_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: assembly_assembly_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('assembly_assembly_id_seq', 1, false);


SET default_with_oids = true;

--
-- Name: assembly; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE assembly (
    id integer,
    parts_id integer,
    qty real,
    bom boolean,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    assembly_id integer DEFAULT nextval('assembly_assembly_id_seq'::regclass) NOT NULL
);


SET default_with_oids = false;

--
-- Name: background_job_histories; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE background_job_histories (
    id integer NOT NULL,
    package_name character varying(255),
    run_at timestamp without time zone,
    status character varying(255),
    result text,
    error text,
    data text
);


--
-- Name: background_job_histories_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE background_job_histories_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: background_job_histories_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE background_job_histories_id_seq OWNED BY background_job_histories.id;


--
-- Name: background_job_histories_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('background_job_histories_id_seq', 8, true);


--
-- Name: background_jobs; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE background_jobs (
    id integer NOT NULL,
    type character varying(255),
    package_name character varying(255),
    last_run_at timestamp without time zone,
    next_run_at timestamp without time zone,
    data text,
    active boolean,
    cron_spec character varying(255)
);


--
-- Name: background_jobs_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE background_jobs_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: background_jobs_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE background_jobs_id_seq OWNED BY background_jobs.id;


--
-- Name: background_jobs_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('background_jobs_id_seq', 4, true);


--
-- Name: id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE id
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


--
-- Name: id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('id', 1914, true);


--
-- Name: bank_accounts; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE bank_accounts (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    account_number character varying(100),
    bank_code character varying(100),
    iban character varying(100),
    bic character varying(100),
    bank text,
    chart_id integer NOT NULL
);


--
-- Name: bin; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE bin (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    warehouse_id integer NOT NULL,
    description text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: buchungsgruppen; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE buchungsgruppen (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    inventory_accno_id integer,
    income_accno_id_0 integer,
    expense_accno_id_0 integer,
    income_accno_id_1 integer,
    expense_accno_id_1 integer,
    income_accno_id_2 integer,
    expense_accno_id_2 integer,
    income_accno_id_3 integer,
    expense_accno_id_3 integer,
    sortkey integer NOT NULL
);


--
-- Name: business; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE business (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    discount real,
    customernumberinit text,
    salesman boolean DEFAULT false,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: chart; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE chart (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    accno text NOT NULL,
    description text,
    charttype character(1) DEFAULT 'A'::bpchar,
    category character(1),
    link text NOT NULL,
    taxkey_id integer,
    pos_bwa integer,
    pos_bilanz integer,
    pos_eur integer,
    datevautomatik boolean DEFAULT false,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    new_chart_id integer,
    valid_from date
);


--
-- Name: contacts; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE contacts (
    cp_id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    cp_cv_id integer,
    cp_title character varying(75),
    cp_givenname character varying(75),
    cp_name character varying(75),
    cp_email text,
    cp_phone1 character varying(75),
    cp_phone2 character varying(75),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    cp_fax text,
    cp_mobile1 text,
    cp_mobile2 text,
    cp_satphone text,
    cp_satfax text,
    cp_project text,
    cp_privatphone text,
    cp_privatemail text,
    cp_abteilung text,
    cp_gender character(1),
    cp_street text,
    cp_zipcode text,
    cp_city text,
    cp_birthday date,
    cp_position character varying(75)
);


--
-- Name: csv_import_profile_settings; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE csv_import_profile_settings (
    id integer NOT NULL,
    csv_import_profile_id integer NOT NULL,
    key text NOT NULL,
    value text
);


--
-- Name: csv_import_profile_settings_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE csv_import_profile_settings_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: csv_import_profile_settings_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE csv_import_profile_settings_id_seq OWNED BY csv_import_profile_settings.id;


--
-- Name: csv_import_profile_settings_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('csv_import_profile_settings_id_seq', 1, false);


--
-- Name: csv_import_profiles; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE csv_import_profiles (
    id integer NOT NULL,
    name text NOT NULL,
    type character varying(20) NOT NULL,
    is_default boolean DEFAULT false,
    login text
);


--
-- Name: csv_import_profiles_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE csv_import_profiles_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: csv_import_profiles_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE csv_import_profiles_id_seq OWNED BY csv_import_profiles.id;


--
-- Name: csv_import_profiles_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('csv_import_profiles_id_seq', 1, false);


--
-- Name: csv_import_report_rows; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE csv_import_report_rows (
    id integer NOT NULL,
    csv_import_report_id integer NOT NULL,
    col integer NOT NULL,
    "row" integer NOT NULL,
    value text
);


--
-- Name: csv_import_report_rows_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE csv_import_report_rows_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: csv_import_report_rows_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE csv_import_report_rows_id_seq OWNED BY csv_import_report_rows.id;


--
-- Name: csv_import_report_rows_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('csv_import_report_rows_id_seq', 1, false);


--
-- Name: csv_import_report_status; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE csv_import_report_status (
    id integer NOT NULL,
    csv_import_report_id integer NOT NULL,
    "row" integer NOT NULL,
    type text NOT NULL,
    value text
);


--
-- Name: csv_import_report_status_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE csv_import_report_status_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: csv_import_report_status_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE csv_import_report_status_id_seq OWNED BY csv_import_report_status.id;


--
-- Name: csv_import_report_status_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('csv_import_report_status_id_seq', 1, false);


--
-- Name: csv_import_reports; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE csv_import_reports (
    id integer NOT NULL,
    session_id text NOT NULL,
    profile_id integer NOT NULL,
    type text NOT NULL,
    file text NOT NULL,
    numrows integer NOT NULL,
    numheaders integer NOT NULL
);


--
-- Name: csv_import_reports_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE csv_import_reports_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: csv_import_reports_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE csv_import_reports_id_seq OWNED BY csv_import_reports.id;


--
-- Name: csv_import_reports_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('csv_import_reports_id_seq', 1, false);


--
-- Name: currencies; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE currencies (
    id integer NOT NULL,
    name text NOT NULL
);


--
-- Name: currencies_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE currencies_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: currencies_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE currencies_id_seq OWNED BY currencies.id;


--
-- Name: currencies_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('currencies_id_seq', 2, true);


--
-- Name: custom_variable_configs_id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE custom_variable_configs_id
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: custom_variable_configs_id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('custom_variable_configs_id', 1, false);


--
-- Name: custom_variable_configs; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE custom_variable_configs (
    id integer DEFAULT nextval('custom_variable_configs_id'::regclass) NOT NULL,
    name text NOT NULL,
    description text NOT NULL,
    type text NOT NULL,
    module text NOT NULL,
    default_value text,
    options text,
    searchable boolean NOT NULL,
    includeable boolean NOT NULL,
    included_by_default boolean NOT NULL,
    sortkey integer NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    flags text,
    CONSTRAINT custom_variable_configs_name_description_type_module_not_empty CHECK (((((type <> ''::text) AND (module <> ''::text)) AND (name <> ''::text)) AND (description <> ''::text))),
    CONSTRAINT custom_variable_configs_options_not_empty_for_select CHECK (((type <> 'select'::text) OR (COALESCE(options, ''::text) <> ''::text)))
);


--
-- Name: custom_variables_id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE custom_variables_id
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: custom_variables_id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('custom_variables_id', 1, false);


--
-- Name: custom_variables; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE custom_variables (
    id integer DEFAULT nextval('custom_variables_id'::regclass) NOT NULL,
    config_id integer NOT NULL,
    trans_id integer NOT NULL,
    bool_value boolean,
    timestamp_value timestamp without time zone,
    text_value text,
    number_value numeric(25,5),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    sub_module text DEFAULT ''::text NOT NULL
);


--
-- Name: custom_variables_validity; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE custom_variables_validity (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    config_id integer NOT NULL,
    trans_id integer NOT NULL,
    itime timestamp without time zone DEFAULT now()
);


--
-- Name: customer; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE customer (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    name text NOT NULL,
    department_1 character varying(75),
    department_2 character varying(75),
    street character varying(75),
    zipcode character varying(10),
    city character varying(75),
    country character varying(75),
    contact text,
    phone text,
    fax character varying(30),
    homepage text,
    email text,
    notes text,
    discount real,
    taxincluded boolean,
    creditlimit numeric(15,5) DEFAULT 0,
    terms smallint DEFAULT 0,
    customernumber text,
    cc text,
    bcc text,
    business_id integer,
    taxnumber text,
    account_number text,
    bank_code text,
    bank text,
    language character varying(5),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    obsolete boolean DEFAULT false,
    username character varying(50),
    user_password text,
    salesman_id integer,
    c_vendor_id text,
    klass integer DEFAULT 0,
    language_id integer,
    payment_id integer,
    taxzone_id integer DEFAULT 0 NOT NULL,
    greeting text,
    ustid text,
    iban character varying(100),
    bic character varying(100),
    direct_debit boolean DEFAULT false,
    taxincluded_checked boolean,
    depositor text,
    mandator_id text,
    mandate_date_of_signature date,
    delivery_term_id integer,
    currency_id integer NOT NULL
);


--
-- Name: datev; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE datev (
    beraternr character varying(7),
    beratername character varying(9),
    mandantennr character varying(5),
    dfvkz character varying(2),
    datentraegernr character varying(3),
    abrechnungsnr character varying(6),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    id integer NOT NULL
);


--
-- Name: datev_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE datev_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: datev_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE datev_id_seq OWNED BY datev.id;


--
-- Name: datev_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('datev_id_seq', 27, true);


--
-- Name: defaults; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE defaults (
    inventory_accno_id integer,
    income_accno_id integer,
    expense_accno_id integer,
    fxgain_accno_id integer,
    fxloss_accno_id integer,
    invnumber text,
    sonumber text,
    weightunit character varying(5),
    businessnumber text,
    version character varying(8),
    closedto date,
    revtrans boolean DEFAULT false,
    ponumber text,
    sqnumber text,
    rfqnumber text,
    customernumber text,
    vendornumber text,
    articlenumber text,
    servicenumber text,
    coa text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    rmanumber text,
    cnnumber text,
    accounting_method text,
    inventory_system text,
    profit_determination text,
    dunning_ar_amount_fee integer,
    dunning_ar_amount_interest integer,
    dunning_ar integer,
    pdonumber text,
    sdonumber text,
    ar_paid_accno_id integer,
    id integer NOT NULL,
    language_id integer,
    datev_check_on_sales_invoice boolean DEFAULT true,
    datev_check_on_purchase_invoice boolean DEFAULT true,
    datev_check_on_ar_transaction boolean DEFAULT true,
    datev_check_on_ap_transaction boolean DEFAULT true,
    datev_check_on_gl_transaction boolean DEFAULT true,
    payments_changeable integer DEFAULT 0 NOT NULL,
    is_changeable integer DEFAULT 2 NOT NULL,
    ir_changeable integer DEFAULT 2 NOT NULL,
    ar_changeable integer DEFAULT 2 NOT NULL,
    ap_changeable integer DEFAULT 2 NOT NULL,
    gl_changeable integer DEFAULT 2 NOT NULL,
    show_bestbefore boolean DEFAULT false,
    sales_order_show_delete boolean DEFAULT true,
    purchase_order_show_delete boolean DEFAULT true,
    sales_delivery_order_show_delete boolean DEFAULT true,
    purchase_delivery_order_show_delete boolean DEFAULT true,
    is_show_mark_as_paid boolean DEFAULT true,
    ir_show_mark_as_paid boolean DEFAULT true,
    ar_show_mark_as_paid boolean DEFAULT true,
    ap_show_mark_as_paid boolean DEFAULT true,
    warehouse_id integer,
    bin_id integer,
    company text,
    address text,
    taxnumber text,
    co_ustid text,
    duns text,
    sepa_creditor_id text,
    templates text,
    max_future_booking_interval integer DEFAULT 360,
    webdav boolean DEFAULT false,
    webdav_documents boolean DEFAULT false,
    vertreter boolean DEFAULT false,
    parts_show_image boolean DEFAULT true,
    parts_listing_image boolean DEFAULT true,
    parts_image_css text DEFAULT 'border:0;float:left;max-width:250px;margin-top:20px:margin-right:10px;margin-left:10px;'::text,
    normalize_vc_names boolean DEFAULT true,
    normalize_part_descriptions boolean DEFAULT true,
    assemblynumber text,
    show_weight boolean DEFAULT false NOT NULL,
    transfer_default boolean DEFAULT true,
    transfer_default_use_master_default_bin boolean DEFAULT false,
    transfer_default_ignore_onhand boolean DEFAULT false,
    warehouse_id_ignore_onhand integer,
    bin_id_ignore_onhand integer,
    balance_startdate_method text,
    currency_id integer NOT NULL,
    signature text
);


--
-- Name: defaults_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE defaults_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: defaults_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE defaults_id_seq OWNED BY defaults.id;


--
-- Name: defaults_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('defaults_id_seq', 1, true);


--
-- Name: delivery_order_items_id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE delivery_order_items_id
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: delivery_order_items_id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('delivery_order_items_id', 35, true);


SET default_with_oids = true;

--
-- Name: delivery_order_items; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE delivery_order_items (
    id integer DEFAULT nextval('delivery_order_items_id'::regclass) NOT NULL,
    delivery_order_id integer NOT NULL,
    parts_id integer NOT NULL,
    description text,
    qty numeric(25,5),
    sellprice numeric(15,5),
    discount real,
    project_id integer,
    reqdate date,
    serialnumber text,
    ordnumber text,
    transdate text,
    cusordnumber text,
    unit character varying(20),
    base_qty real,
    longdescription text,
    lastcost numeric(15,5),
    price_factor_id integer,
    price_factor numeric(15,5) DEFAULT 1,
    marge_price_factor numeric(15,5) DEFAULT 1,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    pricegroup_id integer
);


SET default_with_oids = false;

--
-- Name: delivery_order_items_stock; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE delivery_order_items_stock (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    delivery_order_item_id integer NOT NULL,
    qty numeric(15,5) NOT NULL,
    unit character varying(20) NOT NULL,
    warehouse_id integer NOT NULL,
    bin_id integer NOT NULL,
    chargenumber text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    bestbefore date
);


--
-- Name: delivery_orders; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE delivery_orders (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    donumber text NOT NULL,
    ordnumber text,
    transdate date DEFAULT now(),
    vendor_id integer,
    customer_id integer,
    reqdate date,
    shippingpoint text,
    notes text,
    intnotes text,
    employee_id integer,
    closed boolean DEFAULT false,
    delivered boolean DEFAULT false,
    cusordnumber text,
    oreqnumber text,
    department_id integer,
    shipvia text,
    cp_id integer,
    language_id integer,
    shipto_id integer,
    globalproject_id integer,
    salesman_id integer,
    transaction_description text,
    is_sales boolean,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    taxzone_id integer,
    taxincluded boolean,
    terms integer,
    delivery_term_id integer,
    currency_id integer NOT NULL
);


--
-- Name: delivery_terms; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE delivery_terms (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    description text,
    description_long text,
    sortkey integer NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: department; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE department (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: drafts; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE drafts (
    id character varying(50) NOT NULL,
    module character varying(50) NOT NULL,
    submodule character varying(50) NOT NULL,
    description text,
    itime timestamp without time zone DEFAULT now(),
    form text,
    employee_id integer
);


--
-- Name: dunning; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE dunning (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    trans_id integer,
    dunning_id integer,
    dunning_level integer,
    transdate date,
    duedate date,
    fee numeric(15,5),
    interest numeric(15,5),
    dunning_config_id integer,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    fee_interest_ar_id integer
);


--
-- Name: dunning_config; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE dunning_config (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    dunning_level integer,
    dunning_description text,
    active boolean,
    auto boolean,
    email boolean,
    terms integer,
    payment_terms integer,
    fee numeric(15,5),
    interest_rate numeric(15,5),
    email_body text,
    email_subject text,
    email_attachment boolean,
    template text,
    create_invoices_for_fees boolean DEFAULT true
);


--
-- Name: employee; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE employee (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    login text,
    startdate date DEFAULT ('now'::text)::date,
    enddate date,
    sales boolean DEFAULT true,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    name text,
    deleted boolean DEFAULT false,
    deleted_email text,
    deleted_signature text,
    deleted_tel text,
    deleted_fax text
);


--
-- Name: exchangerate; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE exchangerate (
    transdate date,
    buy numeric(15,5),
    sell numeric(15,5),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    id integer NOT NULL,
    currency_id integer NOT NULL
);


--
-- Name: exchangerate_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE exchangerate_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: exchangerate_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE exchangerate_id_seq OWNED BY exchangerate.id;


--
-- Name: exchangerate_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('exchangerate_id_seq', 8, true);


--
-- Name: finanzamt; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE finanzamt (
    fa_land_nr text,
    fa_bufa_nr text,
    fa_name text,
    fa_strasse text,
    fa_plz text,
    fa_ort text,
    fa_telefon text,
    fa_fax text,
    fa_plz_grosskunden text,
    fa_plz_postfach text,
    fa_postfach text,
    fa_blz_1 text,
    fa_kontonummer_1 text,
    fa_bankbezeichnung_1 text,
    fa_blz_2 text,
    fa_kontonummer_2 text,
    fa_bankbezeichnung_2 text,
    fa_oeffnungszeiten text,
    fa_email text,
    fa_internet text,
    id integer NOT NULL
);


--
-- Name: finanzamt_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE finanzamt_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: finanzamt_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE finanzamt_id_seq OWNED BY finanzamt.id;


--
-- Name: finanzamt_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('finanzamt_id_seq', 686, true);


--
-- Name: follow_up_access; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE follow_up_access (
    who integer NOT NULL,
    what integer NOT NULL,
    id integer NOT NULL
);


--
-- Name: follow_up_access_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE follow_up_access_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: follow_up_access_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE follow_up_access_id_seq OWNED BY follow_up_access.id;


--
-- Name: follow_up_access_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('follow_up_access_id_seq', 1, false);


--
-- Name: follow_up_id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE follow_up_id
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: follow_up_id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('follow_up_id', 1, false);


--
-- Name: follow_up_link_id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE follow_up_link_id
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: follow_up_link_id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('follow_up_link_id', 1, false);


--
-- Name: follow_up_links; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE follow_up_links (
    id integer DEFAULT nextval('follow_up_link_id'::regclass) NOT NULL,
    follow_up_id integer NOT NULL,
    trans_id integer NOT NULL,
    trans_type text NOT NULL,
    trans_info text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: follow_ups; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE follow_ups (
    id integer DEFAULT nextval('follow_up_id'::regclass) NOT NULL,
    follow_up_date date NOT NULL,
    created_for_user integer NOT NULL,
    done boolean DEFAULT false,
    note_id integer NOT NULL,
    created_by integer NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: generic_translations; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE generic_translations (
    id integer NOT NULL,
    language_id integer,
    translation_type character varying(100) NOT NULL,
    translation_id integer,
    translation text
);


--
-- Name: generic_translations_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE generic_translations_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: generic_translations_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE generic_translations_id_seq OWNED BY generic_translations.id;


--
-- Name: generic_translations_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('generic_translations_id_seq', 1, false);


--
-- Name: gl; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE gl (
    id integer DEFAULT nextval(('glid'::text)::regclass) NOT NULL,
    reference text,
    description text,
    transdate date DEFAULT ('now'::text)::date,
    gldate date DEFAULT ('now'::text)::date,
    employee_id integer,
    notes text,
    department_id integer,
    taxincluded boolean,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    type text,
    ob_transaction boolean,
    cb_transaction boolean,
    storno boolean DEFAULT false,
    storno_id integer
);


--
-- Name: glid; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE glid
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


--
-- Name: glid; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('glid', 249, true);


--
-- Name: history_erp; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE history_erp (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    trans_id integer,
    employee_id integer,
    addition text,
    what_done text,
    itime timestamp without time zone DEFAULT now(),
    snumbers text
);


--
-- Name: inventory; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE inventory (
    warehouse_id integer NOT NULL,
    parts_id integer NOT NULL,
    oe_id integer,
    orderitems_id integer,
    shippingdate date,
    employee_id integer NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    bin_id integer NOT NULL,
    qty numeric(25,5),
    trans_id integer NOT NULL,
    trans_type_id integer NOT NULL,
    project_id integer,
    chargenumber text DEFAULT ''::text NOT NULL,
    comment text,
    bestbefore date,
    id integer NOT NULL
);


--
-- Name: inventory_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE inventory_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: inventory_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE inventory_id_seq OWNED BY inventory.id;


--
-- Name: inventory_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('inventory_id_seq', 110, true);


SET default_with_oids = true;

--
-- Name: invoice; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE invoice (
    id integer DEFAULT nextval(('invoiceid'::text)::regclass) NOT NULL,
    trans_id integer,
    parts_id integer,
    description text,
    qty real,
    allocated real,
    sellprice numeric(15,5),
    fxsellprice numeric(15,5),
    discount real,
    assemblyitem boolean DEFAULT false,
    project_id integer,
    deliverydate date,
    serialnumber text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    pricegroup_id integer,
    ordnumber text,
    transdate text,
    cusordnumber text,
    unit character varying(20),
    base_qty real,
    subtotal boolean DEFAULT false,
    longdescription text,
    marge_total numeric(15,5),
    marge_percent numeric(15,5),
    lastcost numeric(15,5),
    price_factor_id integer,
    price_factor numeric(15,5) DEFAULT 1,
    marge_price_factor numeric(15,5) DEFAULT 1
);


--
-- Name: invoiceid; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE invoiceid
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


--
-- Name: invoiceid; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('invoiceid', 61, true);


SET default_with_oids = false;

--
-- Name: language; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE language (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    template_code text,
    article_code text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    output_numberformat text,
    output_dateformat text,
    output_longdates boolean
);


--
-- Name: leads; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE leads (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    lead character varying(50)
);


--
-- Name: makemodel_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE makemodel_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: makemodel_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('makemodel_id_seq', 159, true);


--
-- Name: makemodel; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE makemodel (
    parts_id integer,
    model text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    lastcost numeric(15,5),
    lastupdate date,
    sortorder integer,
    make integer,
    id integer DEFAULT nextval('makemodel_id_seq'::regclass) NOT NULL
);


--
-- Name: note_id; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE note_id
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: note_id; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('note_id', 1, false);


--
-- Name: notes; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE notes (
    id integer DEFAULT nextval('note_id'::regclass) NOT NULL,
    subject text,
    body text,
    created_by integer NOT NULL,
    trans_id integer,
    trans_module character varying(10),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: oe; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE oe (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    ordnumber text NOT NULL,
    transdate date DEFAULT ('now'::text)::date,
    vendor_id integer,
    customer_id integer,
    amount numeric(15,5),
    netamount numeric(15,5),
    reqdate date,
    taxincluded boolean,
    shippingpoint text,
    notes text,
    employee_id integer,
    closed boolean DEFAULT false,
    quotation boolean DEFAULT false,
    quonumber text,
    cusordnumber text,
    intnotes text,
    department_id integer,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    shipvia text,
    cp_id integer,
    language_id integer,
    payment_id integer,
    delivery_customer_id integer,
    delivery_vendor_id integer,
    taxzone_id integer,
    proforma boolean DEFAULT false,
    shipto_id integer,
    globalproject_id integer,
    delivered boolean DEFAULT false,
    salesman_id integer,
    marge_total numeric(15,5),
    marge_percent numeric(15,5),
    transaction_description text,
    delivery_term_id integer,
    currency_id integer NOT NULL
);


SET default_with_oids = true;

--
-- Name: orderitems; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE orderitems (
    trans_id integer,
    parts_id integer,
    description text,
    qty real,
    sellprice numeric(15,5),
    discount real,
    project_id integer,
    reqdate date,
    ship real,
    serialnumber text,
    id integer DEFAULT nextval(('orderitemsid'::text)::regclass) NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    pricegroup_id integer,
    ordnumber text,
    transdate text,
    cusordnumber text,
    unit character varying(20),
    base_qty real,
    subtotal boolean DEFAULT false,
    longdescription text,
    marge_total numeric(15,5),
    marge_percent numeric(15,5),
    lastcost numeric(15,5),
    price_factor_id integer,
    price_factor numeric(15,5) DEFAULT 1,
    marge_price_factor numeric(15,5) DEFAULT 1
);


--
-- Name: orderitemsid; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE orderitemsid
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1
    CYCLE;


--
-- Name: orderitemsid; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('orderitemsid', 82, true);


--
-- Name: parts; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE parts (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    partnumber text NOT NULL,
    description text,
    listprice numeric(15,5),
    sellprice numeric(15,5),
    lastcost numeric(15,5),
    priceupdate date DEFAULT ('now'::text)::date,
    weight real,
    notes text,
    makemodel boolean DEFAULT false,
    assembly boolean DEFAULT false,
    alternate boolean DEFAULT false,
    rop real,
    inventory_accno_id integer,
    income_accno_id integer,
    expense_accno_id integer,
    shop boolean DEFAULT false,
    obsolete boolean DEFAULT false,
    bom boolean DEFAULT false,
    image text,
    drawing text,
    microfiche text,
    partsgroup_id integer,
    ve integer,
    gv numeric(15,5),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    unit character varying(20) NOT NULL,
    formel text,
    not_discountable boolean DEFAULT false,
    buchungsgruppen_id integer,
    payment_id integer,
    ean text,
    price_factor_id integer,
    onhand numeric(25,5) DEFAULT 0,
    stockable boolean DEFAULT false,
    has_sernumber boolean DEFAULT false,
    warehouse_id integer,
    bin_id integer
);


--
-- Name: partsgroup; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE partsgroup (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    partsgroup text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


SET default_with_oids = false;

--
-- Name: payment_terms; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE payment_terms (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    description_long text,
    terms_netto integer,
    terms_skonto integer,
    percent_skonto real,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    ranking integer,
    sortkey integer NOT NULL
);


--
-- Name: periodic_invoices; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE periodic_invoices (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    config_id integer NOT NULL,
    ar_id integer NOT NULL,
    period_start_date date NOT NULL,
    itime timestamp without time zone DEFAULT now()
);


--
-- Name: periodic_invoices_configs; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE periodic_invoices_configs (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    oe_id integer NOT NULL,
    periodicity character varying(10) NOT NULL,
    print boolean DEFAULT false,
    printer_id integer,
    copies integer,
    active boolean DEFAULT true,
    terminated boolean DEFAULT false,
    start_date date,
    end_date date,
    ar_chart_id integer NOT NULL,
    extend_automatically_by integer
);


--
-- Name: price_factors; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE price_factors (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    factor numeric(15,5),
    sortkey integer
);


--
-- Name: pricegroup; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE pricegroup (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    pricegroup text NOT NULL
);


--
-- Name: prices; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE prices (
    parts_id integer,
    pricegroup_id integer,
    price numeric(15,5),
    id integer NOT NULL
);


--
-- Name: prices_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE prices_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: prices_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE prices_id_seq OWNED BY prices.id;


--
-- Name: prices_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('prices_id_seq', 3, true);


--
-- Name: printers; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE printers (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    printer_description text NOT NULL,
    printer_command text,
    template_code text
);


--
-- Name: project; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE project (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    projectnumber text,
    description text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    active boolean DEFAULT true,
    customer_id integer,
    valid boolean DEFAULT true,
    project_type_id integer NOT NULL
);


--
-- Name: project_types; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE project_types (
    id integer NOT NULL,
    "position" integer NOT NULL,
    description text
);


--
-- Name: project_types_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE project_types_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: project_types_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE project_types_id_seq OWNED BY project_types.id;


--
-- Name: project_types_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('project_types_id_seq', 3, true);


--
-- Name: record_links; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE record_links (
    from_table character varying(50) NOT NULL,
    from_id integer NOT NULL,
    to_table character varying(50) NOT NULL,
    to_id integer NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    id integer NOT NULL
);


--
-- Name: record_links_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE record_links_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: record_links_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE record_links_id_seq OWNED BY record_links.id;


--
-- Name: record_links_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('record_links_id_seq', 57, true);


--
-- Name: schema_info; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE schema_info (
    tag text NOT NULL,
    login text,
    itime timestamp without time zone DEFAULT now()
);


--
-- Name: sepa_export_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE sepa_export_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: sepa_export_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('sepa_export_id_seq', 1, false);


--
-- Name: sepa_export; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE sepa_export (
    id integer DEFAULT nextval('sepa_export_id_seq'::regclass) NOT NULL,
    employee_id integer NOT NULL,
    executed boolean DEFAULT false,
    closed boolean DEFAULT false,
    itime timestamp without time zone DEFAULT now(),
    vc character varying(10)
);


--
-- Name: sepa_export_items; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE sepa_export_items (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    sepa_export_id integer NOT NULL,
    ap_id integer,
    chart_id integer NOT NULL,
    amount numeric(25,5),
    reference character varying(35),
    requested_execution_date date,
    executed boolean DEFAULT false,
    execution_date date,
    our_iban character varying(100),
    our_bic character varying(100),
    vc_iban character varying(100),
    vc_bic character varying(100),
    end_to_end_id character varying(35),
    ar_id integer,
    our_depositor text,
    vc_depositor text,
    vc_mandator_id text,
    vc_mandate_date_of_signature date
);


--
-- Name: shipto; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE shipto (
    trans_id integer,
    shiptoname character varying(75),
    shiptodepartment_1 character varying(75),
    shiptodepartment_2 character varying(75),
    shiptostreet character varying(75),
    shiptozipcode character varying(75),
    shiptocity character varying(75),
    shiptocountry character varying(75),
    shiptocontact character varying(75),
    shiptophone character varying(30),
    shiptofax character varying(30),
    shiptoemail text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    module text,
    shipto_id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    shiptocp_gender text
);


--
-- Name: status; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE status (
    trans_id integer,
    formname text,
    printed boolean DEFAULT false,
    emailed boolean DEFAULT false,
    spoolfile text,
    chart_id integer,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    id integer NOT NULL
);


--
-- Name: status_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE status_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: status_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE status_id_seq OWNED BY status.id;


--
-- Name: status_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('status_id_seq', 1, false);


--
-- Name: tax; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE tax (
    chart_id integer,
    rate numeric(15,5) DEFAULT 0 NOT NULL,
    taxnumber text,
    taxkey integer NOT NULL,
    taxdescription text NOT NULL,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    chart_categories text NOT NULL
);


--
-- Name: tax_zones; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE tax_zones (
    id integer NOT NULL,
    description text
);


--
-- Name: taxkeys; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE taxkeys (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    chart_id integer NOT NULL,
    tax_id integer NOT NULL,
    taxkey_id integer NOT NULL,
    pos_ustva integer,
    startdate date NOT NULL
);


--
-- Name: todo_user_config; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE todo_user_config (
    employee_id integer NOT NULL,
    show_after_login boolean DEFAULT true,
    show_follow_ups boolean DEFAULT true,
    show_follow_ups_login boolean DEFAULT true,
    show_overdue_sales_quotations boolean DEFAULT true,
    show_overdue_sales_quotations_login boolean DEFAULT true,
    id integer NOT NULL
);


--
-- Name: todo_user_config_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE todo_user_config_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: todo_user_config_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE todo_user_config_id_seq OWNED BY todo_user_config.id;


--
-- Name: todo_user_config_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('todo_user_config_id_seq', 3, true);


--
-- Name: transfer_type; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE transfer_type (
    id integer DEFAULT nextval('id'::regclass) NOT NULL,
    direction character varying(10) NOT NULL,
    description text,
    sortkey integer,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone
);


--
-- Name: translation; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE translation (
    parts_id integer,
    language_id integer,
    translation text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    longdescription text,
    id integer NOT NULL
);


--
-- Name: translation_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE translation_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: translation_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE translation_id_seq OWNED BY translation.id;


--
-- Name: translation_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('translation_id_seq', 1, false);


--
-- Name: units; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE units (
    name character varying(20) NOT NULL,
    base_unit character varying(20),
    factor numeric(20,5),
    type character varying(20),
    sortkey integer NOT NULL,
    id integer NOT NULL
);


--
-- Name: units_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE units_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: units_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE units_id_seq OWNED BY units.id;


--
-- Name: units_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('units_id_seq', 15, true);


--
-- Name: units_language; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE units_language (
    unit character varying(20) NOT NULL,
    language_id integer NOT NULL,
    localized character varying(20),
    localized_plural character varying(20),
    id integer NOT NULL
);


--
-- Name: units_language_id_seq; Type: SEQUENCE; Schema: public; Owner: -
--

CREATE SEQUENCE units_language_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


--
-- Name: units_language_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: -
--

ALTER SEQUENCE units_language_id_seq OWNED BY units_language.id;


--
-- Name: units_language_id_seq; Type: SEQUENCE SET; Schema: public; Owner: -
--

SELECT pg_catalog.setval('units_language_id_seq', 1, false);


--
-- Name: vendor; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE vendor (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    name character varying(75) NOT NULL,
    department_1 character varying(75),
    department_2 character varying(75),
    street character varying(75),
    zipcode character varying(10),
    city character varying(75),
    country character varying(75),
    contact character varying(75),
    phone text,
    fax character varying(30),
    homepage text,
    email text,
    notes text,
    terms smallint DEFAULT 0,
    taxincluded boolean,
    vendornumber text,
    cc text,
    bcc text,
    business_id integer,
    taxnumber text,
    discount real,
    creditlimit numeric(15,5),
    account_number character varying(15),
    bank_code character varying(10),
    bank text,
    language character varying(5),
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    obsolete boolean DEFAULT false,
    username character varying(50),
    user_password character varying(12),
    salesman_id integer,
    v_customer_id text,
    language_id integer,
    payment_id integer,
    taxzone_id integer DEFAULT 0 NOT NULL,
    greeting text,
    ustid character varying(14),
    iban character varying(100),
    bic character varying(100),
    direct_debit boolean DEFAULT false,
    depositor text,
    delivery_term_id integer,
    currency_id integer NOT NULL
);


--
-- Name: warehouse; Type: TABLE; Schema: public; Owner: -; Tablespace: 
--

CREATE TABLE warehouse (
    id integer DEFAULT nextval(('id'::text)::regclass) NOT NULL,
    description text,
    itime timestamp without time zone DEFAULT now(),
    mtime timestamp without time zone,
    sortkey integer,
    invalid boolean
);


SET search_path = tax, pg_catalog;

--
-- Name: report_categories; Type: TABLE; Schema: tax; Owner: -; Tablespace: 
--

CREATE TABLE report_categories (
    id integer NOT NULL,
    description text,
    subdescription text
);


--
-- Name: report_headings; Type: TABLE; Schema: tax; Owner: -; Tablespace: 
--

CREATE TABLE report_headings (
    id integer NOT NULL,
    category_id integer NOT NULL,
    type text,
    description text,
    subdescription text
);


--
-- Name: report_variables; Type: TABLE; Schema: tax; Owner: -; Tablespace: 
--

CREATE TABLE report_variables (
    id integer NOT NULL,
    "position" text NOT NULL,
    heading_id integer,
    description text,
    taxbase text,
    dec_places text,
    valid_from date
);


SET search_path = public, pg_catalog;

--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE background_job_histories ALTER COLUMN id SET DEFAULT nextval('background_job_histories_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE background_jobs ALTER COLUMN id SET DEFAULT nextval('background_jobs_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE csv_import_profile_settings ALTER COLUMN id SET DEFAULT nextval('csv_import_profile_settings_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE csv_import_profiles ALTER COLUMN id SET DEFAULT nextval('csv_import_profiles_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE csv_import_report_rows ALTER COLUMN id SET DEFAULT nextval('csv_import_report_rows_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE csv_import_report_status ALTER COLUMN id SET DEFAULT nextval('csv_import_report_status_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE csv_import_reports ALTER COLUMN id SET DEFAULT nextval('csv_import_reports_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE currencies ALTER COLUMN id SET DEFAULT nextval('currencies_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE datev ALTER COLUMN id SET DEFAULT nextval('datev_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE defaults ALTER COLUMN id SET DEFAULT nextval('defaults_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE exchangerate ALTER COLUMN id SET DEFAULT nextval('exchangerate_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE finanzamt ALTER COLUMN id SET DEFAULT nextval('finanzamt_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE follow_up_access ALTER COLUMN id SET DEFAULT nextval('follow_up_access_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE generic_translations ALTER COLUMN id SET DEFAULT nextval('generic_translations_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE inventory ALTER COLUMN id SET DEFAULT nextval('inventory_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE prices ALTER COLUMN id SET DEFAULT nextval('prices_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE project_types ALTER COLUMN id SET DEFAULT nextval('project_types_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE record_links ALTER COLUMN id SET DEFAULT nextval('record_links_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE status ALTER COLUMN id SET DEFAULT nextval('status_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE todo_user_config ALTER COLUMN id SET DEFAULT nextval('todo_user_config_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE translation ALTER COLUMN id SET DEFAULT nextval('translation_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE units ALTER COLUMN id SET DEFAULT nextval('units_id_seq'::regclass);


--
-- Name: id; Type: DEFAULT; Schema: public; Owner: -
--

ALTER TABLE units_language ALTER COLUMN id SET DEFAULT nextval('units_language_id_seq'::regclass);


--
-- Data for Name: acc_trans; Type: TABLE DATA; Schema: public; Owner: -
--

COPY acc_trans (acc_trans_id, trans_id, chart_id, amount, transdate, gldate, source, cleared, fx_transaction, ob_transaction, cb_transaction, project_id, memo, taxkey, itime, mtime, chart_link, tax_id) FROM stdin;
713	223	57	142800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-10-08 15:29:43.023031	2014-03-03 15:32:20.425237	AP	0
714	223	168	-120000.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	9	2012-10-08 15:29:43.023031	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
715	223	33	-22800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-10-08 15:29:43.023031	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
735	214	17	23800.00000	2012-06-01	2012-06-01	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:40:13.313536	2014-03-03 15:32:20.425237	AR	0
736	214	45	-23800.00000	2012-06-01	2012-06-01		f	f	f	f	\N		\N	2012-10-08 15:40:13.313536	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
20	9	368	2024660.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:54:32.928509	2014-03-03 15:32:20.425237		0
23	11	368	-129315022.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:25:40.212878	2014-03-03 15:32:20.425237		0
25	12	368	-5800500.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:27:10.303141	2014-03-03 15:32:20.425237		0
27	13	368	-2300705.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:28:11.552002	2014-03-03 15:32:20.425237		0
29	14	368	-12836179.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:29:02.562595	2014-03-03 15:32:20.425237		0
599	183	1230	-2300705.00000	2012-01-18	2012-01-18		f	f	f	f	\N		0	2012-09-14 11:39:33.140067	2014-03-03 15:32:20.425237		0
600	183	45	2300705.00000	2012-01-18	2012-01-18		f	f	f	f	\N		0	2012-09-14 11:39:33.140067	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
601	184	302	-1500.00000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-09-14 11:43:46.20216	2014-03-03 15:32:20.425237	AP_amount	0
602	184	44	1500.00000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-09-14 11:43:46.20216	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
603	185	219	-8911.78000	2012-12-31	2012-12-31		f	f	f	f	\N		0	2012-09-14 15:15:43.512224	2014-03-03 15:32:20.425237		0
604	185	4	8911.78000	2012-12-31	2012-12-31		f	f	f	f	\N		0	2012-09-14 15:15:43.512224	2014-03-03 15:32:20.425237	AP_amount	0
605	186	14	1361.34000	2012-12-31	2012-12-31		f	f	f	f	\N		0	2012-09-14 15:39:03.186572	2014-03-03 15:32:20.425237	AP_amount	0
606	186	1664	-1361.34000	2012-12-31	2012-12-31		f	f	f	f	\N		0	2012-09-14 15:39:03.186572	2014-03-03 15:32:20.425237		0
607	187	192	-52273.00000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-14 16:01:30.340884	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	0
608	187	38	-109250.00000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-14 16:01:30.340884	2014-03-03 15:32:20.425237		0
609	187	45	161523.00000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-14 16:01:30.340884	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
610	188	31	-342000.00000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-17 10:49:21.617425	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
611	188	64	342000.00000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-17 10:49:21.617425	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
614	190	316	-58.30000	2012-01-06	2012-01-06		f	f	f	f	\N		0	2012-09-17 13:54:38.544742	2014-03-03 15:32:20.425237		0
615	190	45	58.30000	2012-01-06	2012-01-06		f	f	f	f	\N		0	2012-09-17 13:54:38.544742	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
6	3	45	-50000000.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:37:59.674835	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
716	224	57	-142800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-10-08 15:30:57.901724	2014-03-03 15:32:20.425237	AP	0
717	224	168	120000.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	9	2012-10-08 15:30:57.901724	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
718	224	33	22800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-10-08 15:30:57.901724	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
743	227	1234	-12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-08 15:56:31.038748	2014-03-03 15:32:20.425237		0
744	227	45	12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-08 15:56:31.038748	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
587	179	45	200000.00000	2012-11-22	2012-11-22		f	f	f	f	1020		0	2012-09-12 14:41:19.85977	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
8	4	44	-30000.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:39:53.166922	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
15	7	6	-10527271.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:50:35.740764	2014-03-03 15:32:20.425237	AP_amount	0
17	8	4	-89117833.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:52:44.225147	2014-03-03 15:32:20.425237	AP_amount	0
548	172	168	-3907563.03000	2012-09-10	2012-09-10	\N	f	f	f	f	1020	\N	9	2012-09-12 14:14:06.926166	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
549	172	33	-742436.97000	2012-09-10	2012-09-10	\N	f	f	f	f	1020	\N	0	2012-09-12 14:14:06.926166	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
616	191	316	-52.30000	2012-02-03	2012-02-03		f	f	f	f	\N		0	2012-09-17 13:55:40.08567	2014-03-03 15:32:20.425237		0
617	191	45	52.30000	2012-02-03	2012-02-03		f	f	f	f	\N		0	2012-09-17 13:55:40.08567	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
618	192	316	-78.75000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-09-17 13:56:16.130118	2014-03-03 15:32:20.425237		0
619	192	45	78.75000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-09-17 13:56:16.130118	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
620	193	316	-88.50000	2012-04-06	2012-04-06		f	f	f	f	\N		0	2012-09-17 13:56:47.06526	2014-03-03 15:32:20.425237		0
621	193	45	88.50000	2012-04-06	2012-04-06		f	f	f	f	\N		0	2012-09-17 13:56:47.06526	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
622	194	316	-64.25000	2012-05-04	2012-05-04		f	f	f	f	\N		0	2012-09-17 13:57:25.354312	2014-03-03 15:32:20.425237		0
623	194	45	64.25000	2012-05-04	2012-05-04		f	f	f	f	\N		0	2012-09-17 13:57:25.354312	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
624	195	316	-66.20000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-17 13:57:57.706063	2014-03-03 15:32:20.425237		0
19	9	15	-2024660.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:54:32.928509	2014-03-03 15:32:20.425237	IC	0
24	11	1228	129315022.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:25:40.212878	2014-03-03 15:32:20.425237		0
26	12	54	5800500.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:27:10.303141	2014-03-03 15:32:20.425237		0
28	13	1230	2300705.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:28:11.552002	2014-03-03 15:32:20.425237		0
30	14	1234	12836179.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:29:02.562595	2014-03-03 15:32:20.425237		0
31	15	303	-781.51261	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 13:57:08.242206	2014-03-03 15:32:20.425237	AP_amount	389
32	15	33	-148.48739	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 13:57:08.242206	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
33	15	45	930.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 13:57:08.242206	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
34	16	306	-114.90654	2012-01-01	2012-01-01		f	f	f	f	\N		8	2012-08-30 13:57:10.113343	2014-03-03 15:32:20.425237	AP_amount	377
35	16	28	-8.04346	2012-01-01	2012-01-01		f	f	f	f	\N		8	2012-08-30 13:57:10.113343	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	377
36	16	45	122.95000	2012-01-01	2012-01-01		f	f	f	f	\N		0	2012-08-30 13:57:10.113343	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
37	17	255	-99500.00000	2012-01-01	2012-01-01		f	f	f	f	\N		0	2012-08-30 13:57:41.638499	2014-03-03 15:32:20.425237	AP_amount	0
38	17	45	99500.00000	2012-01-01	2012-01-01		f	f	f	f	\N		0	2012-08-30 13:57:41.638499	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
39	18	244	-5798.31933	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 13:58:35.010203	2014-03-03 15:32:20.425237	AP_amount	389
40	18	33	-1101.68067	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 13:58:35.010203	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
41	18	45	6900.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 13:58:35.010203	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
42	19	303	-781.51261	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 13:58:42.785234	2014-03-03 15:32:20.425237	AP_amount	389
43	19	33	-148.48739	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 13:58:42.785234	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
44	19	45	930.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 13:58:42.785234	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
45	20	244	-5798.31933	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 13:59:12.001294	2014-03-03 15:32:20.425237	AP_amount	389
46	20	33	-1101.68067	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 13:59:12.001294	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
47	20	45	6900.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 13:59:12.001294	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
48	21	303	-781.51261	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 13:59:13.571963	2014-03-03 15:32:20.425237	AP_amount	389
49	21	33	-148.48739	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 13:59:13.571963	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
50	21	45	930.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 13:59:13.571963	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
51	22	244	-5798.31933	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:00:11.608811	2014-03-03 15:32:20.425237	AP_amount	389
52	22	33	-1101.68067	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:00:11.608811	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
53	22	45	6900.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:00:11.608811	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
54	23	303	-781.51261	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:00:23.879965	2014-03-03 15:32:20.425237	AP_amount	389
55	23	33	-148.48739	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:00:23.879965	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
56	23	45	930.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:00:23.879965	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
57	24	244	-5630.25210	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:00:39.503505	2014-03-03 15:32:20.425237	AP_amount	389
58	24	33	-1069.74790	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:00:39.503505	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
59	24	45	6700.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:00:39.503505	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
60	25	303	-781.51261	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:01:01.68727	2014-03-03 15:32:20.425237	AP_amount	389
61	25	33	-148.48739	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:01:01.68727	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
62	25	45	930.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:01:01.68727	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
63	26	244	-5798.31933	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:01:26.509661	2014-03-03 15:32:20.425237	AP_amount	389
64	26	33	-1101.68067	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:01:26.509661	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
65	26	45	6900.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:01:26.509661	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
66	27	303	-781.51261	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:01:39.489868	2014-03-03 15:32:20.425237	AP_amount	389
67	27	33	-148.48739	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:01:39.489868	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
68	27	45	930.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:01:39.489868	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
72	29	303	-781.51261	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:02:41.459301	2014-03-03 15:32:20.425237	AP_amount	389
73	29	33	-148.48739	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:02:41.459301	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
74	29	45	930.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:02:41.459301	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
75	30	244	-4369.74790	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:05:11.020766	2014-03-03 15:32:20.425237	AP_amount	389
76	30	33	-830.25210	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:05:11.020766	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
77	30	45	5200.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:05:11.020766	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
78	31	244	-4369.74790	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:05:45.396049	2014-03-03 15:32:20.425237	AP_amount	389
79	31	33	-830.25210	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:05:45.396049	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
80	31	45	5200.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:05:45.396049	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
81	32	238	-48.04202	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:07:59.966575	2014-03-03 15:32:20.425237	AP_amount	389
82	32	33	-9.12798	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:07:59.966575	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
83	32	45	57.17000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:07:59.966575	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
84	33	245	-16605.04202	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:08:17.739565	2014-03-03 15:32:20.425237	AP_amount	389
85	33	33	-3154.95798	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:08:17.739565	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
86	33	45	19760.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:08:17.739565	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
87	34	238	-48.04202	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:08:29.678496	2014-03-03 15:32:20.425237	AP_amount	389
88	34	33	-9.12798	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:08:29.678496	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
89	34	45	57.17000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:08:29.678496	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
90	35	245	-16689.07563	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:08:58.811817	2014-03-03 15:32:20.425237	AP_amount	389
91	35	33	-3170.92437	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:08:58.811817	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
92	35	45	19860.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:08:58.811817	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
93	36	238	-48.04202	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:09:00.348871	2014-03-03 15:32:20.425237	AP_amount	389
94	36	33	-9.12798	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:09:00.348871	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
95	36	45	57.17000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:09:00.348871	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
96	37	238	-48.04202	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:09:33.388886	2014-03-03 15:32:20.425237	AP_amount	389
97	37	33	-9.12798	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:09:33.388886	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
5	2	53	130000000.00000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-08-30 11:07:21.63752	2014-03-03 15:32:20.425237		0
7	3	368	50000000.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:37:59.674835	2014-03-03 15:32:20.425237		0
98	37	45	57.17000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:09:33.388886	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
99	38	245	-16605.04202	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:09:41.483389	2014-03-03 15:32:20.425237	AP_amount	389
100	38	33	-3154.95798	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:09:41.483389	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
101	38	45	19760.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:09:41.483389	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
102	39	238	-48.04202	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:09:50.809317	2014-03-03 15:32:20.425237	AP_amount	389
103	39	33	-9.12798	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:09:50.809317	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
104	39	45	57.17000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:09:50.809317	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
105	40	238	-48.04202	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:10:10.039075	2014-03-03 15:32:20.425237	AP_amount	389
106	40	33	-9.12798	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:10:10.039075	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
107	40	45	57.17000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:10:10.039075	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
108	41	238	-48.04202	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:10:25.370291	2014-03-03 15:32:20.425237	AP_amount	389
22	10	1226	75000000.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:24:23.521796	2014-03-03 15:32:20.425237		0
109	41	33	-9.12798	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:10:25.370291	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
110	41	45	57.17000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:10:25.370291	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
111	42	245	-16521.00840	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:10:28.969769	2014-03-03 15:32:20.425237	AP_amount	389
112	42	33	-3138.99160	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:10:28.969769	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
113	42	45	19660.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:10:28.969769	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
114	43	245	-16436.97479	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:12:02.996916	2014-03-03 15:32:20.425237	AP_amount	389
115	43	33	-3123.02521	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:12:02.996916	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
116	43	45	19560.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:12:02.996916	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
117	44	245	-16689.07563	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:12:55.60813	2014-03-03 15:32:20.425237	AP_amount	389
118	44	33	-3170.92437	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:12:55.60813	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
119	44	45	19860.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:12:55.60813	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
120	45	199	-6000000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:13:30.796015	2014-03-03 15:32:20.425237		0
121	45	45	3711792.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:13:30.796015	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
122	45	1195	1103208.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:13:30.796015	2014-03-03 15:32:20.425237		0
123	45	1196	1185000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:13:30.796015	2014-03-03 15:32:20.425237		0
124	46	245	-16857.14286	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:13:54.080095	2014-03-03 15:32:20.425237	AP_amount	389
125	46	33	-3202.85714	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:13:54.080095	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
126	46	45	20060.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:13:54.080095	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
127	47	199	-6000000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:13:55.34856	2014-03-03 15:32:20.425237		0
128	47	45	3711792.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:13:55.34856	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
129	47	1195	1103208.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:13:55.34856	2014-03-03 15:32:20.425237		0
130	47	1196	1185000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:13:55.34856	2014-03-03 15:32:20.425237		0
131	48	303	-781.51261	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:14:34.736875	2014-03-03 15:32:20.425237	AP_amount	389
132	48	33	-148.48739	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:14:34.736875	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
133	48	45	930.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:14:34.736875	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
134	49	238	-48.04202	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:14:55.695843	2014-03-03 15:32:20.425237	AP_amount	389
135	49	33	-9.12798	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:14:55.695843	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
136	49	45	57.17000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:14:55.695843	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
137	50	244	-5882.35294	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:15:06.672014	2014-03-03 15:32:20.425237	AP_amount	389
138	50	33	-1117.64706	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:15:06.672014	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
139	50	45	7000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:15:06.672014	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
140	51	199	-6000000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:15:18.22019	2014-03-03 15:32:20.425237		0
141	51	45	3711792.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:15:18.22019	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
142	51	1195	1103208.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:15:18.22019	2014-03-03 15:32:20.425237		0
143	51	1196	1185000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:15:18.22019	2014-03-03 15:32:20.425237		0
144	52	199	-6000000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:15:40.726513	2014-03-03 15:32:20.425237		0
145	52	45	3711792.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:15:40.726513	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
146	52	1195	1103208.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:15:40.726513	2014-03-03 15:32:20.425237		0
147	52	1196	1185000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:15:40.726513	2014-03-03 15:32:20.425237		0
148	53	245	-16773.10924	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:15:43.953206	2014-03-03 15:32:20.425237	AP_amount	389
149	53	33	-3186.89076	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:15:43.953206	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
150	53	45	19960.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:15:43.953206	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
151	54	199	-6000000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:15:58.219481	2014-03-03 15:32:20.425237		0
152	54	45	3711792.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:15:58.219481	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
153	54	1195	1103208.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:15:58.219481	2014-03-03 15:32:20.425237		0
154	54	1196	1185000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:15:58.219481	2014-03-03 15:32:20.425237		0
155	55	199	-6000000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:16:28.400973	2014-03-03 15:32:20.425237		0
156	55	45	3711792.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:16:28.400973	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
157	55	1195	1103208.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:16:28.400973	2014-03-03 15:32:20.425237		0
158	55	1196	1185000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:16:28.400973	2014-03-03 15:32:20.425237		0
159	56	199	-6000000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:16:51.326535	2014-03-03 15:32:20.425237		0
160	56	45	3711792.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:16:51.326535	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
161	56	1195	1103208.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:16:51.326535	2014-03-03 15:32:20.425237		0
162	56	1196	1185000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:16:51.326535	2014-03-03 15:32:20.425237		0
163	57	246	-645.37815	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:16:53.838506	2014-03-03 15:32:20.425237	AP_amount	389
164	57	33	-122.62185	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:16:53.838506	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
165	57	45	768.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:16:53.838506	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
166	58	199	-6000000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:17:12.83903	2014-03-03 15:32:20.425237		0
167	58	45	3711792.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:17:12.83903	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
168	58	1195	1103208.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:17:12.83903	2014-03-03 15:32:20.425237		0
169	58	1196	1185000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:17:12.83903	2014-03-03 15:32:20.425237		0
170	59	246	-645.37815	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:17:18.968113	2014-03-03 15:32:20.425237	AP_amount	389
171	59	33	-122.62185	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:17:18.968113	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
172	59	45	768.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:17:18.968113	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
173	60	246	-645.37815	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:17:41.512612	2014-03-03 15:32:20.425237	AP_amount	389
174	60	33	-122.62185	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:17:41.512612	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
175	60	45	768.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:17:41.512612	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
176	61	211	-1254000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:17:50.203132	2014-03-03 15:32:20.425237		0
177	61	1196	1254000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:17:50.203132	2014-03-03 15:32:20.425237		0
178	62	246	-645.37815	2012-04-03	2012-04-03		f	f	f	f	\N		9	2012-08-30 14:18:11.107015	2014-03-03 15:32:20.425237	AP_amount	389
179	62	33	-122.62185	2012-04-03	2012-04-03		f	f	f	f	\N		9	2012-08-30 14:18:11.107015	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
180	62	45	768.00000	2012-04-03	2012-04-03		f	f	f	f	\N		0	2012-08-30 14:18:11.107015	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
181	63	211	-1254000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:18:11.475386	2014-03-03 15:32:20.425237		0
182	63	1196	1254000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:18:11.475386	2014-03-03 15:32:20.425237		0
183	64	211	-1254000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:18:35.235861	2014-03-03 15:32:20.425237		0
184	64	1196	1254000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:18:35.235861	2014-03-03 15:32:20.425237		0
185	65	246	-645.37815	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:18:42.077607	2014-03-03 15:32:20.425237	AP_amount	389
186	65	33	-122.62185	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:18:42.077607	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
187	65	45	768.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:18:42.077607	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
188	66	211	-1254000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:18:53.182157	2014-03-03 15:32:20.425237		0
189	66	1196	1254000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:18:53.182157	2014-03-03 15:32:20.425237		0
190	67	246	-645.37815	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:19:10.765487	2014-03-03 15:32:20.425237	AP_amount	389
191	67	33	-122.62185	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:19:10.765487	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
192	67	45	768.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:19:10.765487	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
193	68	246	-645.37815	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:19:37.9525	2014-03-03 15:32:20.425237	AP_amount	389
194	68	33	-122.62185	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:19:37.9525	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
195	68	45	768.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:19:37.9525	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
196	69	246	-645.37815	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:19:59.928917	2014-03-03 15:32:20.425237	AP_amount	389
197	69	33	-122.62185	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:19:59.928917	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
198	69	45	768.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:19:59.928917	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
199	70	211	-1254000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:20:39.046737	2014-03-03 15:32:20.425237		0
200	70	1196	1254000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:20:39.046737	2014-03-03 15:32:20.425237		0
201	71	211	-1254000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:20:58.928577	2014-03-03 15:32:20.425237		0
202	71	1196	1254000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:20:58.928577	2014-03-03 15:32:20.425237		0
203	72	211	-1254000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:21:24.091362	2014-03-03 15:32:20.425237		0
204	72	1196	1254000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:21:24.091362	2014-03-03 15:32:20.425237		0
205	73	270	-34243.69748	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:21:33.318243	2014-03-03 15:32:20.425237	AP_amount	389
206	73	33	-6506.30252	2012-01-02	2012-01-02		f	f	f	f	\N		9	2012-08-30 14:21:33.318243	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
207	73	45	40750.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:21:33.318243	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
208	74	211	-1254000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:21:40.580583	2014-03-03 15:32:20.425237		0
209	74	1196	1254000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:21:40.580583	2014-03-03 15:32:20.425237		0
210	75	270	-34243.69748	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:22:26.592586	2014-03-03 15:32:20.425237	AP_amount	389
211	75	33	-6506.30252	2012-02-02	2012-02-02		f	f	f	f	\N		9	2012-08-30 14:22:26.592586	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
212	75	45	40750.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:22:26.592586	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
213	76	1196	-810000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:22:38.80826	2014-03-03 15:32:20.425237		0
214	76	45	810000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:22:38.80826	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
215	77	270	-34243.69748	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:22:51.90226	2014-03-03 15:32:20.425237	AP_amount	389
216	77	33	-6506.30252	2012-03-02	2012-03-02		f	f	f	f	\N		9	2012-08-30 14:22:51.90226	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
217	77	45	40750.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:22:51.90226	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
218	78	1196	-810000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:23:10.990421	2014-03-03 15:32:20.425237		0
219	78	45	810000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:23:10.990421	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
220	79	270	-34243.69748	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:23:14.920897	2014-03-03 15:32:20.425237	AP_amount	389
221	79	33	-6506.30252	2012-04-02	2012-04-02		f	f	f	f	\N		9	2012-08-30 14:23:14.920897	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
222	79	45	40750.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:23:14.920897	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
223	80	1196	-810000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:23:36.489436	2014-03-03 15:32:20.425237		0
224	80	45	810000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:23:36.489436	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
225	81	270	-34243.69748	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:23:39.360874	2014-03-03 15:32:20.425237	AP_amount	389
226	81	33	-6506.30252	2012-05-02	2012-05-02		f	f	f	f	\N		9	2012-08-30 14:23:39.360874	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
227	81	45	40750.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:23:39.360874	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
228	82	1196	-810000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:24:03.271422	2014-03-03 15:32:20.425237		0
229	82	45	810000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:24:03.271422	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
230	83	270	-34243.69748	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:24:08.522961	2014-03-03 15:32:20.425237	AP_amount	389
231	83	33	-6506.30252	2012-06-04	2012-06-04		f	f	f	f	\N		9	2012-08-30 14:24:08.522961	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
232	83	45	40750.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:24:08.522961	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
233	84	1196	-810000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:24:21.167344	2014-03-03 15:32:20.425237		0
234	84	45	810000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:24:21.167344	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
235	85	270	-34243.69748	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:24:32.565411	2014-03-03 15:32:20.425237	AP_amount	389
236	85	33	-6506.30252	2012-07-02	2012-07-02		f	f	f	f	\N		9	2012-08-30 14:24:32.565411	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
237	85	45	40750.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:24:32.565411	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
238	86	1196	-810000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:24:38.818809	2014-03-03 15:32:20.425237		0
239	86	45	810000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:24:38.818809	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
240	87	1196	-810000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:24:56.488009	2014-03-03 15:32:20.425237		0
241	87	45	810000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:24:56.488009	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
242	88	270	-34243.69748	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:24:56.6316	2014-03-03 15:32:20.425237	AP_amount	389
243	88	33	-6506.30252	2012-08-02	2012-08-02		f	f	f	f	\N		9	2012-08-30 14:24:56.6316	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
244	88	45	40750.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:24:56.6316	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
245	89	1196	-810000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:25:19.309855	2014-03-03 15:32:20.425237		0
246	89	45	810000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:25:19.309855	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
247	90	1195	-1103208.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:26:28.74811	2014-03-03 15:32:20.425237		0
248	90	1196	-1629000.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:26:28.74811	2014-03-03 15:32:20.425237		0
249	90	45	2732208.00000	2012-01-02	2012-01-02		f	f	f	f	\N		0	2012-08-30 14:26:28.74811	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
250	91	1195	-1103208.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:26:51.298831	2014-03-03 15:32:20.425237		0
251	91	1196	-1629000.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:26:51.298831	2014-03-03 15:32:20.425237		0
252	91	45	2732208.00000	2012-02-02	2012-02-02		f	f	f	f	\N		0	2012-08-30 14:26:51.298831	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
253	92	1195	-1103208.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:27:15.375472	2014-03-03 15:32:20.425237		0
254	92	1196	-1629000.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:27:15.375472	2014-03-03 15:32:20.425237		0
255	92	45	2732208.00000	2012-03-02	2012-03-02		f	f	f	f	\N		0	2012-08-30 14:27:15.375472	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
256	93	1195	-1103208.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:27:40.506306	2014-03-03 15:32:20.425237		0
257	93	1196	-1629000.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:27:40.506306	2014-03-03 15:32:20.425237		0
258	93	45	2732208.00000	2012-04-02	2012-04-02		f	f	f	f	\N		0	2012-08-30 14:27:40.506306	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
259	94	1195	-1103208.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:28:01.807576	2014-03-03 15:32:20.425237		0
260	94	1196	-1629000.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:28:01.807576	2014-03-03 15:32:20.425237		0
261	94	45	2732208.00000	2012-05-02	2012-05-02		f	f	f	f	\N		0	2012-08-30 14:28:01.807576	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
262	95	1195	-1103208.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:28:30.459147	2014-03-03 15:32:20.425237		0
263	95	1196	-1629000.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:28:30.459147	2014-03-03 15:32:20.425237		0
264	95	45	2732208.00000	2012-06-04	2012-06-04		f	f	f	f	\N		0	2012-08-30 14:28:30.459147	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
265	96	1195	-1103208.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:28:55.727384	2014-03-03 15:32:20.425237		0
266	96	1196	-1629000.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:28:55.727384	2014-03-03 15:32:20.425237		0
267	96	45	2732208.00000	2012-07-02	2012-07-02		f	f	f	f	\N		0	2012-08-30 14:28:55.727384	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
268	97	1195	-1103208.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:29:14.554387	2014-03-03 15:32:20.425237		0
269	97	1196	-1629000.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:29:14.554387	2014-03-03 15:32:20.425237		0
270	97	45	2732208.00000	2012-08-02	2012-08-02		f	f	f	f	\N		0	2012-08-30 14:29:14.554387	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
291	103	275	-5000000.00000	2012-07-20	2012-07-20		f	f	f	f	\N		0	2012-08-30 15:19:46.615715	2014-03-03 15:32:20.425237	AP_amount	0
292	103	45	5000000.00000	2012-07-20	2012-07-20		f	f	f	f	\N		0	2012-08-30 15:19:46.615715	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
293	105	305	-326.89000	2012-01-05	2012-01-05	\N	f	f	f	f	\N	\N	9	2012-08-30 15:26:07.829581	2014-03-03 15:32:20.425237	AP_amount	389
294	105	33	-62.11000	2012-01-05	2012-01-05	\N	f	f	f	f	\N	\N	9	2012-08-30 15:26:07.829581	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
295	105	56	389.00000	2012-01-05	2012-01-05	\N	f	f	f	f	\N	\N	0	2012-08-30 15:26:07.829581	2014-03-03 15:32:20.425237	AP	0
296	105	56	-389.00000	2012-01-20	2012-01-20	\N	f	f	f	f	\N	\N	0	2012-08-30 15:26:07.829581	2014-03-03 15:32:20.425237	AP	0
297	105	45	389.00000	2012-01-20	2012-01-20		f	f	f	f	\N		0	2012-08-30 15:26:07.829581	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
298	106	305	-326.89000	2012-04-05	2012-04-05	\N	f	f	f	f	\N	\N	9	2012-08-30 15:27:17.515737	2014-03-03 15:32:20.425237	AP_amount	389
299	106	33	-62.11000	2012-04-05	2012-04-05	\N	f	f	f	f	\N	\N	9	2012-08-30 15:27:17.515737	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
300	106	56	389.00000	2012-04-05	2012-04-05	\N	f	f	f	f	\N	\N	0	2012-08-30 15:27:17.515737	2014-03-03 15:32:20.425237	AP	0
301	106	56	-389.00000	2012-04-20	2012-04-20	\N	f	f	f	f	\N	\N	0	2012-08-30 15:27:17.515737	2014-03-03 15:32:20.425237	AP	0
302	106	45	389.00000	2012-04-20	2012-04-20		f	f	f	f	\N		0	2012-08-30 15:27:17.515737	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
308	108	305	-326.89000	2012-08-03	2012-08-03	\N	f	f	f	f	\N	\N	9	2012-08-30 15:32:52.50715	2014-03-03 15:32:20.425237	AP_amount	389
309	108	33	-62.11000	2012-08-03	2012-08-03	\N	f	f	f	f	\N	\N	9	2012-08-30 15:32:52.50715	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
310	108	56	389.00000	2012-08-03	2012-08-03	\N	f	f	f	f	\N	\N	0	2012-08-30 15:32:52.50715	2014-03-03 15:32:20.425237	AP	0
311	108	56	-389.00000	2012-08-21	2012-08-21	\N	f	f	f	f	\N	\N	0	2012-08-30 15:32:52.50715	2014-03-03 15:32:20.425237	AP	0
312	108	45	389.00000	2012-08-21	2012-08-21		f	f	f	f	\N		0	2012-08-30 15:32:52.50715	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
313	109	305	-2352.94118	2012-01-03	2012-01-03		f	f	f	f	\N		9	2012-08-30 15:34:57.348977	2014-03-03 15:32:20.425237	AP_amount	389
314	109	33	-447.05882	2012-01-03	2012-01-03		f	f	f	f	\N		9	2012-08-30 15:34:57.348977	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
315	109	44	2800.00000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-08-30 15:34:57.348977	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
316	110	14	-6806.72000	2012-03-02	2012-03-02	\N	f	f	f	f	\N	\N	9	2012-09-03 11:39:52.615662	2014-03-03 15:32:20.425237	AP_amount	389
317	110	33	-1293.28000	2012-03-02	2012-03-02	\N	f	f	f	f	\N	\N	9	2012-09-03 11:39:52.615662	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
318	110	56	8100.00000	2012-03-02	2012-03-02	\N	f	f	f	f	\N	\N	0	2012-09-03 11:39:52.615662	2014-03-03 15:32:20.425237	AP	0
319	110	56	-8100.00000	2012-04-13	2012-04-13	\N	f	f	f	f	\N	\N	0	2012-09-03 11:41:21.47004	2014-03-03 15:32:20.425237	AP	0
320	110	45	8100.00000	2012-04-13	2012-04-13		f	f	f	f	\N		0	2012-09-03 11:41:21.47004	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
321	111	280	-113.05000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-09-03 13:52:32.403679	2014-03-03 15:32:20.425237	AP_amount	0
322	111	282	-48.45000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-09-03 13:52:32.403679	2014-03-03 15:32:20.425237	AP_amount	0
323	111	33	-28.50000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-09-03 13:52:32.403679	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
324	111	44	190.00000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-09-03 13:52:32.403679	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
325	112	280	-133.56000	2012-03-16	2012-03-16		f	f	f	f	\N		0	2012-09-03 14:08:11.269131	2014-03-03 15:32:20.425237	AP_amount	0
326	112	282	-57.24000	2012-03-16	2012-03-16		f	f	f	f	\N		0	2012-09-03 14:08:11.269131	2014-03-03 15:32:20.425237	AP_amount	0
327	112	213	-120.00000	2012-03-16	2012-03-16		f	f	f	f	\N		0	2012-09-03 14:08:11.269131	2014-03-03 15:32:20.425237		0
328	112	238	-7.20000	2012-03-16	2012-03-16		f	f	f	f	\N		0	2012-09-03 14:08:11.269131	2014-03-03 15:32:20.425237	AP_amount	0
329	112	33	-57.00000	2012-03-16	2012-03-16		f	f	f	f	\N		0	2012-09-03 14:08:11.269131	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
330	112	44	375.00000	2012-03-16	2012-03-16		f	f	f	f	\N		0	2012-09-03 14:08:11.269131	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
331	113	290	-151.26050	2012-04-09	2012-04-09		f	f	f	f	\N		9	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_amount	389
332	113	33	-28.73950	2012-04-09	2012-04-09		f	f	f	f	\N		9	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
333	113	292	-672.89720	2012-04-09	2012-04-09		f	f	f	f	\N		8	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_amount	377
334	113	28	-47.10280	2012-04-09	2012-04-09		f	f	f	f	\N		8	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	377
335	113	307	-1277.31092	2012-04-09	2012-04-09		f	f	f	f	\N		9	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_amount	389
336	113	33	-242.68908	2012-04-09	2012-04-09		f	f	f	f	\N		9	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
337	113	289	-25.21008	2012-04-09	2012-04-09		f	f	f	f	\N		9	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_amount	389
338	113	33	-4.78992	2012-04-09	2012-04-09		f	f	f	f	\N		9	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
339	113	45	2450.00000	2012-04-09	2012-04-09		f	f	f	f	\N		0	2012-09-03 15:41:51.843265	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
344	114	291	-132.00000	2012-04-16	2012-04-16	\N	f	f	f	f	\N	\N	0	2012-09-03 15:53:54.354204	2014-03-03 15:32:20.425237	AP_amount	0
345	114	290	-18.69000	2012-04-16	2012-04-16	\N	f	f	f	f	\N	\N	8	2012-09-03 15:53:54.354204	2014-03-03 15:32:20.425237	AP_amount	377
346	114	28	-1.30830	2012-04-16	2012-04-16	\N	f	f	f	f	\N	\N	8	2012-09-03 15:53:54.354204	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	377
347	114	56	151.99830	2012-04-16	2012-04-16	\N	f	f	f	f	\N	\N	0	2012-09-03 15:53:54.354204	2014-03-03 15:32:20.425237	AP	0
350	114	56	-152.00000	2012-04-20	2012-04-20	\N	f	f	f	f	\N	\N	0	2012-09-04 10:24:40.551011	2014-03-03 15:32:20.425237	AP	0
351	114	44	152.00000	2012-04-20	2012-04-20		f	f	f	f	\N		0	2012-09-04 10:24:40.551011	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
352	115	199	-6000000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:12:37.937712	2014-03-03 15:32:20.425237		0
353	115	45	3711792.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:12:37.937712	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
354	115	1195	1103208.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:12:37.937712	2014-03-03 15:32:20.425237		0
355	115	1196	1185000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:12:37.937712	2014-03-03 15:32:20.425237		0
356	116	199	-6000000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:13:13.572412	2014-03-03 15:32:20.425237		0
357	116	45	3711792.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:13:13.572412	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
358	116	1195	1103208.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:13:13.572412	2014-03-03 15:32:20.425237		0
359	116	1196	1185000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:13:13.572412	2014-03-03 15:32:20.425237		0
360	117	199	-6000000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:13:38.838168	2014-03-03 15:32:20.425237		0
361	117	45	3711792.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:13:38.838168	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
362	117	1195	1103208.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:13:38.838168	2014-03-03 15:32:20.425237		0
363	117	1196	1185000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:13:38.838168	2014-03-03 15:32:20.425237		0
364	118	199	-6000000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:14:21.318575	2014-03-03 15:32:20.425237		0
365	118	45	3711792.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:14:21.318575	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
366	118	1195	1103208.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:14:21.318575	2014-03-03 15:32:20.425237		0
367	118	1196	1185000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:14:21.318575	2014-03-03 15:32:20.425237		0
368	119	211	-1254000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:15:04.011787	2014-03-03 15:32:20.425237		0
369	119	1196	1254000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:15:04.011787	2014-03-03 15:32:20.425237		0
370	120	211	-1254000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:15:26.007829	2014-03-03 15:32:20.425237		0
371	120	1196	1254000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:15:26.007829	2014-03-03 15:32:20.425237		0
372	121	211	-1254000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:15:52.458026	2014-03-03 15:32:20.425237		0
373	121	1196	1254000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:15:52.458026	2014-03-03 15:32:20.425237		0
374	122	211	-1254000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:16:13.747741	2014-03-03 15:32:20.425237		0
375	122	1196	1254000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:16:13.747741	2014-03-03 15:32:20.425237		0
376	123	1196	-810000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:16:44.937331	2014-03-03 15:32:20.425237		0
377	123	45	810000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:16:44.937331	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
378	124	1196	-810000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:17:09.017573	2014-03-03 15:32:20.425237		0
379	124	45	810000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:17:09.017573	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
380	125	1196	-810000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:17:32.185448	2014-03-03 15:32:20.425237		0
381	125	45	810000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:17:32.185448	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
382	126	1196	-810000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:18:02.849303	2014-03-03 15:32:20.425237		0
383	126	45	810000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:18:02.849303	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
384	127	1195	-1103208.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:18:29.044068	2014-03-03 15:32:20.425237		0
385	127	1196	-1629000.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:18:29.044068	2014-03-03 15:32:20.425237		0
386	127	45	2732208.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:18:29.044068	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
390	129	1195	-1103208.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:19:15.533662	2014-03-03 15:32:20.425237		0
391	129	1196	-1629000.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:19:15.533662	2014-03-03 15:32:20.425237		0
392	129	45	2732208.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:19:15.533662	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
393	130	1195	-1103208.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:19:36.880097	2014-03-03 15:32:20.425237		0
394	130	1196	-1629000.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:19:36.880097	2014-03-03 15:32:20.425237		0
395	130	45	2732208.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:19:36.880097	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
396	131	270	-34243.69748	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:19:58.528336	2014-03-03 15:32:20.425237	AP_amount	389
397	131	33	-6506.30252	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:19:58.528336	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
398	131	45	40750.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:19:58.528336	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
399	132	270	-34243.69748	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:20:23.165061	2014-03-03 15:32:20.425237	AP_amount	389
400	132	33	-6506.30252	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:20:23.165061	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
401	132	45	40750.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:20:23.165061	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
402	133	270	-34243.69748	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:20:47.521783	2014-03-03 15:32:20.425237	AP_amount	389
403	133	33	-6506.30252	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:20:47.521783	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
404	133	45	40750.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:20:47.521783	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
405	134	270	-34243.69748	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:21:07.713027	2014-03-03 15:32:20.425237	AP_amount	389
406	134	33	-6506.30252	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:21:07.713027	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
407	134	45	40750.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:21:07.713027	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
408	135	246	-645.37815	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:21:29.099351	2014-03-03 15:32:20.425237	AP_amount	389
409	135	33	-122.62185	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:21:29.099351	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
410	135	45	768.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:21:29.099351	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
411	136	246	-645.37815	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:21:46.496475	2014-03-03 15:32:20.425237	AP_amount	389
412	136	33	-122.62185	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:21:46.496475	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
413	136	45	768.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:21:46.496475	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
414	137	246	-645.37815	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:22:02.828217	2014-03-03 15:32:20.425237	AP_amount	389
415	137	33	-122.62185	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:22:02.828217	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
416	137	45	768.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:22:02.828217	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
417	138	246	-645.37815	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:22:29.777103	2014-03-03 15:32:20.425237	AP_amount	389
418	138	33	-122.62185	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:22:29.777103	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
419	138	45	768.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:22:29.777103	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
420	139	303	-781.51261	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:22:48.816382	2014-03-03 15:32:20.425237	AP_amount	389
421	139	33	-148.48739	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:22:48.816382	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
422	139	45	930.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:22:48.816382	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
423	140	303	-781.51261	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:23:12.940129	2014-03-03 15:32:20.425237	AP_amount	389
424	140	33	-148.48739	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:23:12.940129	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
425	140	45	930.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:23:12.940129	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
426	141	303	-781.51261	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:23:28.769878	2014-03-03 15:32:20.425237	AP_amount	389
427	141	33	-148.48739	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:23:28.769878	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
428	141	45	930.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:23:28.769878	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
429	142	303	-781.51261	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:23:47.157906	2014-03-03 15:32:20.425237	AP_amount	389
430	142	33	-148.48739	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:23:47.157906	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
431	142	45	930.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:23:47.157906	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
432	143	238	-48.04202	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:24:10.009285	2014-03-03 15:32:20.425237	AP_amount	389
433	143	33	-9.12798	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:24:10.009285	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
434	143	45	57.17000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:24:10.009285	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
435	144	238	-48.04202	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:24:33.718978	2014-03-03 15:32:20.425237	AP_amount	389
436	144	33	-9.12798	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:24:33.718978	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
437	144	45	57.17000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:24:33.718978	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
438	145	238	-48.04202	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:24:55.528835	2014-03-03 15:32:20.425237	AP_amount	389
439	145	33	-9.12798	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:24:55.528835	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
440	145	45	57.17000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:24:55.528835	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
441	146	238	-48.04202	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:25:13.04833	2014-03-03 15:32:20.425237	AP_amount	389
442	146	33	-9.12798	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:25:13.04833	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
443	146	45	57.17000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:25:13.04833	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
444	147	244	-5380.67227	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:25:55.905909	2014-03-03 15:32:20.425237	AP_amount	389
445	147	33	-1022.32773	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:25:55.905909	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
446	147	45	6403.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:25:55.905909	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
447	148	244	-5294.95798	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:27:16.467774	2014-03-03 15:32:20.425237	AP_amount	389
448	148	33	-1006.04202	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:27:16.467774	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
449	148	45	6301.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:27:16.467774	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
450	149	244	-5630.25210	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:27:50.010807	2014-03-03 15:32:20.425237	AP_amount	389
451	149	33	-1069.74790	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:27:50.010807	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
452	149	45	6700.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:27:50.010807	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
453	150	244	-5756.30252	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:28:33.222593	2014-03-03 15:32:20.425237	AP_amount	389
454	150	33	-1093.69748	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:28:33.222593	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
455	150	45	6850.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:28:33.222593	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
456	151	245	-16689.07563	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:29:07.396039	2014-03-03 15:32:20.425237	AP_amount	389
457	151	33	-3170.92437	2012-09-03	2012-09-03		f	f	f	f	\N		9	2012-09-04 11:29:07.396039	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
458	151	45	19860.00000	2012-09-03	2012-09-03		f	f	f	f	\N		0	2012-09-04 11:29:07.396039	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
459	152	245	-16607.56303	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:29:34.190884	2014-03-03 15:32:20.425237	AP_amount	389
460	152	33	-3155.43697	2012-10-02	2012-10-02		f	f	f	f	\N		9	2012-09-04 11:29:34.190884	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
461	152	45	19763.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:29:34.190884	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
462	153	245	-16487.39496	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:30:02.925771	2014-03-03 15:32:20.425237	AP_amount	389
463	153	33	-3132.60504	2012-11-02	2012-11-02		f	f	f	f	\N		9	2012-09-04 11:30:02.925771	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
464	153	45	19620.00000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-04 11:30:02.925771	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
465	154	245	-16739.49580	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:30:25.840343	2014-03-03 15:32:20.425237	AP_amount	389
466	154	33	-3180.50420	2012-12-03	2012-12-03		f	f	f	f	\N		9	2012-09-04 11:30:25.840343	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
467	154	45	19920.00000	2012-12-03	2012-12-03		f	f	f	f	\N		0	2012-09-04 11:30:25.840343	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
468	155	1195	-1103208.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:42:50.790799	2014-03-03 15:32:20.425237		0
469	155	1196	-1629000.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:42:50.790799	2014-03-03 15:32:20.425237		0
470	155	45	2732208.00000	2012-10-02	2012-10-02		f	f	f	f	\N		0	2012-09-04 11:42:50.790799	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
471	156	305	-326.89000	2012-11-02	2012-11-02	\N	f	f	f	f	\N	\N	9	2012-09-04 11:46:08.253302	2014-03-03 15:32:20.425237	AP_amount	389
472	156	33	-62.11000	2012-11-02	2012-11-02	\N	f	f	f	f	\N	\N	9	2012-09-04 11:46:08.253302	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
473	156	56	389.00000	2012-11-02	2012-11-02	\N	f	f	f	f	\N	\N	0	2012-09-04 11:46:08.253302	2014-03-03 15:32:20.425237	AP	0
474	156	56	-389.00000	2012-11-13	2012-11-13	\N	f	f	f	f	\N	\N	0	2012-09-04 11:46:08.253302	2014-03-03 15:32:20.425237	AP	0
475	156	45	389.00000	2012-11-13	2012-11-13		f	f	f	f	\N		0	2012-09-04 11:46:08.253302	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
476	157	305	-4369.74790	2012-10-12	2012-10-12		f	f	f	f	\N		9	2012-09-04 12:00:21.679317	2014-03-03 15:32:20.425237	AP_amount	389
477	157	33	-830.25210	2012-10-12	2012-10-12		f	f	f	f	\N		9	2012-09-04 12:00:21.679317	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
478	157	44	5200.00000	2012-10-12	2012-10-12		f	f	f	f	\N		0	2012-09-04 12:00:21.679317	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
479	158	28	-1962.62000	2012-01-02	2012-01-02	\N	f	f	f	f	1020	\N	0	2012-09-12 11:31:38.368947	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
480	158	56	30000.00000	2012-01-02	2012-01-02	\N	f	f	f	f	1020	\N	0	2012-09-12 11:31:38.368947	2014-03-03 15:32:20.425237	AP	0
481	158	167	-28037.38000	2012-01-02	2012-01-02	\N	f	f	f	f	1020	\N	8	2012-09-12 11:31:38.368947	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	377
482	158	56	-30000.00000	2012-01-06	2012-01-06	\N	f	f	f	f	1020	\N	0	2012-09-12 11:31:38.368947	2014-03-03 15:32:20.425237	AP	0
483	158	45	30000.00000	2012-01-06	2012-01-06		f	f	f	f	1020		0	2012-09-12 11:31:38.368947	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
484	159	168	-1890756.30000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	9	2012-09-12 11:46:35.764079	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
485	159	33	-359243.70000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	0	2012-09-12 11:46:35.764079	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
486	159	56	2250000.00000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	0	2012-09-12 11:46:35.764079	2014-03-03 15:32:20.425237	AP	0
487	159	56	-2250000.00000	2012-01-16	2012-01-16	\N	f	f	f	f	1020	\N	0	2012-09-12 11:46:35.764079	2014-03-03 15:32:20.425237	AP	0
488	159	45	2250000.00000	2012-01-16	2012-01-16		f	f	f	f	1020		0	2012-09-12 11:46:35.764079	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
489	160	168	-1176470.59000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	9	2012-09-12 11:51:00.529905	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
490	160	33	-223529.41000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	0	2012-09-12 11:51:00.529905	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
491	160	56	1400000.00000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	0	2012-09-12 11:51:00.529905	2014-03-03 15:32:20.425237	AP	0
492	160	56	-1400000.00000	2012-01-18	2012-01-18	\N	f	f	f	f	1020	\N	0	2012-09-12 11:51:00.529905	2014-03-03 15:32:20.425237	AP	0
493	160	45	1400000.00000	2012-01-18	2012-01-18		f	f	f	f	1020		0	2012-09-12 11:51:00.529905	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
494	161	168	-823529.41000	2012-05-01	2012-05-01	\N	f	f	f	f	1020	\N	9	2012-09-12 11:55:21.123487	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
495	161	33	-156470.59000	2012-05-01	2012-05-01	\N	f	f	f	f	1020	\N	0	2012-09-12 11:55:21.123487	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
496	161	56	980000.00000	2012-05-01	2012-05-01	\N	f	f	f	f	1020	\N	0	2012-09-12 11:55:21.123487	2014-03-03 15:32:20.425237	AP	0
497	161	56	-980000.00000	2012-05-04	2012-05-04	\N	f	f	f	f	1020	\N	0	2012-09-12 11:55:21.123487	2014-03-03 15:32:20.425237	AP	0
498	161	45	980000.00000	2012-05-04	2012-05-04		f	f	f	f	1020		0	2012-09-12 11:55:21.123487	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
499	162	168	-2250084.03000	2012-05-01	2012-05-01	\N	f	f	f	f	1020	\N	9	2012-09-12 12:00:50.338662	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
500	162	33	-427515.97000	2012-05-01	2012-05-01	\N	f	f	f	f	1020	\N	0	2012-09-12 12:00:50.338662	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
501	162	56	2677600.00000	2012-05-01	2012-05-01	\N	f	f	f	f	1020	\N	0	2012-09-12 12:00:50.338662	2014-03-03 15:32:20.425237	AP	0
502	162	56	-2677600.00000	2012-05-09	2012-05-09	\N	f	f	f	f	1020	\N	0	2012-09-12 12:00:50.338662	2014-03-03 15:32:20.425237	AP	0
503	162	45	2677600.00000	2012-05-09	2012-05-09		f	f	f	f	1020		0	2012-09-12 12:00:50.338662	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
504	163	168	-16806722.69000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	9	2012-09-12 12:11:50.790617	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
505	163	33	-3193277.31000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	0	2012-09-12 12:11:50.790617	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
506	163	56	20000000.00000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	0	2012-09-12 12:11:50.790617	2014-03-03 15:32:20.425237	AP	0
507	163	56	-20000000.00000	2012-05-18	2012-05-18	\N	f	f	f	f	1020	\N	0	2012-09-12 12:11:50.790617	2014-03-03 15:32:20.425237	AP	0
508	163	45	20000000.00000	2012-05-18	2012-05-18		f	f	f	f	1020		0	2012-09-12 12:11:50.790617	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
509	164	168	-1579831.93000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	9	2012-09-12 12:16:58.361196	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
510	164	33	-300168.07000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	0	2012-09-12 12:16:58.361196	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
511	164	56	1880000.00000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	0	2012-09-12 12:16:58.361196	2014-03-03 15:32:20.425237	AP	0
512	164	56	-1880000.00000	2012-05-22	2012-05-22	\N	f	f	f	f	1020	\N	0	2012-09-12 12:16:58.361196	2014-03-03 15:32:20.425237	AP	0
513	164	45	1880000.00000	2012-05-22	2012-05-22		f	f	f	f	1020		0	2012-09-12 12:16:58.361196	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
514	165	168	-13445378.15000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	9	2012-09-12 12:17:13.904978	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
515	165	33	-2554621.85000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	0	2012-09-12 12:17:13.904978	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
516	165	56	16000000.00000	2012-05-14	2012-05-14	\N	f	f	f	f	1020	\N	0	2012-09-12 12:17:13.904978	2014-03-03 15:32:20.425237	AP	0
517	165	56	-16000000.00000	2012-05-18	2012-05-18	\N	f	f	f	f	1020	\N	0	2012-09-12 12:17:13.904978	2014-03-03 15:32:20.425237	AP	0
518	165	45	16000000.00000	2012-05-18	2012-05-18		f	f	f	f	1020		0	2012-09-12 12:17:13.904978	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
519	166	168	-4237008.40000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	9	2012-09-12 12:34:31.518335	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
520	166	33	-805031.60000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	0	2012-09-12 12:34:31.518335	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
521	166	56	5042040.00000	2012-01-13	2012-01-13	\N	f	f	f	f	1020	\N	0	2012-09-12 12:34:31.518335	2014-03-03 15:32:20.425237	AP	0
522	166	56	-5042040.00000	2012-01-18	2012-01-18	\N	f	f	f	f	1020	\N	0	2012-09-12 12:34:31.518335	2014-03-03 15:32:20.425237	AP	0
523	166	45	5042040.00000	2012-01-18	2012-01-18		f	f	f	f	1020		0	2012-09-12 12:34:31.518335	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
524	167	168	-193277.31000	2012-06-11	2012-06-11	\N	f	f	f	f	1020	\N	9	2012-09-12 12:40:21.584179	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
525	167	33	-36722.69000	2012-06-11	2012-06-11	\N	f	f	f	f	1020	\N	0	2012-09-12 12:40:21.584179	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
526	167	56	230000.00000	2012-06-11	2012-06-11	\N	f	f	f	f	1020	\N	0	2012-09-12 12:40:21.584179	2014-03-03 15:32:20.425237	AP	0
527	167	56	-230000.00000	2012-06-15	2012-06-15	\N	f	f	f	f	1020	\N	0	2012-09-12 12:40:21.584179	2014-03-03 15:32:20.425237	AP	0
528	167	45	230000.00000	2012-06-15	2012-06-15		f	f	f	f	1020		0	2012-09-12 12:40:21.584179	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
529	168	56	70000.00000	2012-07-09	2012-07-09	\N	f	f	f	f	1020	\N	0	2012-09-12 12:51:04.811484	2014-03-03 15:32:20.425237	AP	0
531	168	56	-70000.00000	2012-07-12	2012-07-12	\N	f	f	f	f	1020	\N	0	2012-09-12 12:51:04.811484	2014-03-03 15:32:20.425237	AP	0
532	168	45	70000.00000	2012-07-12	2012-07-12		f	f	f	f	1020		0	2012-09-12 12:51:04.811484	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
533	169	168	-294117.65000	2012-08-08	2012-08-08	\N	f	f	f	f	1020	\N	9	2012-09-12 14:03:23.525778	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
534	169	33	-55882.35000	2012-08-08	2012-08-08	\N	f	f	f	f	1020	\N	0	2012-09-12 14:03:23.525778	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
535	169	56	350000.00000	2012-08-08	2012-08-08	\N	f	f	f	f	1020	\N	0	2012-09-12 14:03:23.525778	2014-03-03 15:32:20.425237	AP	0
536	169	56	-350000.00000	2012-08-15	2012-08-15	\N	f	f	f	f	1020	\N	0	2012-09-12 14:03:23.525778	2014-03-03 15:32:20.425237	AP	0
537	169	45	350000.00000	2012-08-15	2012-08-15		f	f	f	f	1020		0	2012-09-12 14:03:23.525778	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
538	170	168	-840336.13000	2012-08-13	2012-08-13	\N	f	f	f	f	1020	\N	9	2012-09-12 14:07:26.811402	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
539	170	33	-159663.87000	2012-08-13	2012-08-13	\N	f	f	f	f	1020	\N	0	2012-09-12 14:07:26.811402	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
540	170	56	1000000.00000	2012-08-13	2012-08-13	\N	f	f	f	f	1020	\N	0	2012-09-12 14:07:26.811402	2014-03-03 15:32:20.425237	AP	0
541	170	56	-1000000.00000	2012-08-17	2012-08-17	\N	f	f	f	f	1020	\N	0	2012-09-12 14:07:26.811402	2014-03-03 15:32:20.425237	AP	0
542	170	45	1000000.00000	2012-08-17	2012-08-17		f	f	f	f	1020		0	2012-09-12 14:07:26.811402	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
543	171	168	-804201.68000	2012-08-13	2012-08-13	\N	f	f	f	f	1020	\N	9	2012-09-12 14:08:20.092458	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
544	171	33	-152798.32000	2012-08-13	2012-08-13	\N	f	f	f	f	1020	\N	0	2012-09-12 14:08:20.092458	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
545	171	56	957000.00000	2012-08-13	2012-08-13	\N	f	f	f	f	1020	\N	0	2012-09-12 14:08:20.092458	2014-03-03 15:32:20.425237	AP	0
546	171	56	-957000.00000	2012-08-20	2012-08-20	\N	f	f	f	f	1020	\N	0	2012-09-12 14:08:20.092458	2014-03-03 15:32:20.425237	AP	0
547	171	45	957000.00000	2012-08-20	2012-08-20		f	f	f	f	1020		0	2012-09-12 14:08:20.092458	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
550	172	56	4650000.00000	2012-09-10	2012-09-10	\N	f	f	f	f	1020	\N	0	2012-09-12 14:14:06.926166	2014-03-03 15:32:20.425237	AP	0
551	172	56	-4650000.00000	2012-09-14	2012-09-14	\N	f	f	f	f	1020	\N	0	2012-09-12 14:14:06.926166	2014-03-03 15:32:20.425237	AP	0
552	172	45	4650000.00000	2012-09-14	2012-09-14		f	f	f	f	1020		0	2012-09-12 14:14:06.926166	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
553	173	168	-952722.69000	2012-09-10	2012-09-10	\N	f	f	f	f	1020	\N	9	2012-09-12 14:16:01.336668	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
554	173	33	-181017.31000	2012-09-10	2012-09-10	\N	f	f	f	f	1020	\N	0	2012-09-12 14:16:01.336668	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
555	173	56	1133740.00000	2012-09-10	2012-09-10	\N	f	f	f	f	1020	\N	0	2012-09-12 14:16:01.336668	2014-03-03 15:32:20.425237	AP	0
556	173	56	-1133740.00000	2012-09-18	2012-09-18	\N	f	f	f	f	1020	\N	0	2012-09-12 14:16:01.336668	2014-03-03 15:32:20.425237	AP	0
557	173	45	1133740.00000	2012-09-18	2012-09-18		f	f	f	f	1020		0	2012-09-12 14:16:01.336668	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
563	175	168	-4453781.51000	2012-11-05	2012-11-05	\N	f	f	f	f	1020	\N	9	2012-09-12 14:26:50.138796	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
564	175	33	-846218.49000	2012-11-05	2012-11-05	\N	f	f	f	f	1020	\N	0	2012-09-12 14:26:50.138796	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
565	175	56	5300000.00000	2012-11-05	2012-11-05	\N	f	f	f	f	1020	\N	0	2012-09-12 14:26:50.138796	2014-03-03 15:32:20.425237	AP	0
566	175	56	-5300000.00000	2012-11-09	2012-11-09	\N	f	f	f	f	1020	\N	0	2012-09-12 14:26:50.138796	2014-03-03 15:32:20.425237	AP	0
567	175	45	5300000.00000	2012-11-09	2012-11-09		f	f	f	f	1020		0	2012-09-12 14:26:50.138796	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
568	176	168	-1764705.88000	2012-11-23	2012-11-23	\N	f	f	f	f	1020	\N	9	2012-09-12 14:30:44.163604	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
569	176	33	-335294.12000	2012-11-23	2012-11-23	\N	f	f	f	f	1020	\N	0	2012-09-12 14:30:44.163604	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
570	176	56	2100000.00000	2012-11-23	2012-11-23	\N	f	f	f	f	1020	\N	0	2012-09-12 14:30:44.163604	2014-03-03 15:32:20.425237	AP	0
571	176	56	-2100000.00000	2012-12-07	2012-12-07	\N	f	f	f	f	1020	\N	0	2012-09-12 14:30:44.163604	2014-03-03 15:32:20.425237	AP	0
530	168	170	-70000.00000	2012-07-09	2012-07-09	\N	f	f	f	f	1020	\N	0	2012-09-12 12:51:04.811484	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	0
572	176	45	2100000.00000	2012-12-07	2012-12-07		f	f	f	f	1020		0	2012-09-12 14:30:44.163604	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
573	177	168	-54621.85000	2012-11-26	2012-11-26	\N	f	f	f	f	1020	\N	9	2012-09-12 14:34:33.16189	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
574	177	33	-10378.15000	2012-11-26	2012-11-26	\N	f	f	f	f	1020	\N	0	2012-09-12 14:34:33.16189	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
575	177	56	65000.00000	2012-11-26	2012-11-26	\N	f	f	f	f	1020	\N	0	2012-09-12 14:34:33.16189	2014-03-03 15:32:20.425237	AP	0
576	177	56	-65000.00000	2012-11-30	2012-11-30	\N	f	f	f	f	1020	\N	0	2012-09-12 14:34:33.16189	2014-03-03 15:32:20.425237	AP	0
577	177	45	65000.00000	2012-11-30	2012-11-30		f	f	f	f	1020		0	2012-09-12 14:34:33.16189	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
578	178	168	-1411764.71000	2012-11-29	2012-11-29	\N	f	f	f	f	1020	\N	9	2012-09-12 14:38:20.675653	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
579	178	33	-268235.29000	2012-11-29	2012-11-29	\N	f	f	f	f	1020	\N	0	2012-09-12 14:38:20.675653	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
580	178	56	1680000.00000	2012-11-29	2012-11-29	\N	f	f	f	f	1020	\N	0	2012-09-12 14:38:20.675653	2014-03-03 15:32:20.425237	AP	0
581	178	56	-1680000.00000	2012-12-04	2012-12-04	\N	f	f	f	f	1020	\N	0	2012-09-12 14:38:20.675653	2014-03-03 15:32:20.425237	AP	0
582	178	45	1680000.00000	2012-12-04	2012-12-04		f	f	f	f	1020		0	2012-09-12 14:38:20.675653	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
583	179	168	-168067.23000	2012-11-14	2012-11-14	\N	f	f	f	f	1020	\N	9	2012-09-12 14:41:19.85977	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	389
584	179	33	-31932.77000	2012-11-14	2012-11-14	\N	f	f	f	f	1020	\N	0	2012-09-12 14:41:19.85977	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
585	179	56	200000.00000	2012-11-14	2012-11-14	\N	f	f	f	f	1020	\N	0	2012-09-12 14:41:19.85977	2014-03-03 15:32:20.425237	AP	0
586	179	56	-200000.00000	2012-11-22	2012-11-22	\N	f	f	f	f	1020	\N	0	2012-09-12 14:41:19.85977	2014-03-03 15:32:20.425237	AP	0
588	180	28	-1654.88000	2012-11-30	2012-11-30	\N	f	f	f	f	1020	\N	0	2012-09-12 14:44:44.722246	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
589	180	56	25296.00000	2012-11-30	2012-11-30	\N	f	f	f	f	1020	\N	0	2012-09-12 14:44:44.722246	2014-03-03 15:32:20.425237	AP	0
590	180	167	-23641.12000	2012-11-30	2012-11-30	\N	f	f	f	f	1020	\N	8	2012-09-12 14:44:44.722246	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	377
591	180	56	-25296.00000	2012-12-04	2012-12-04	\N	f	f	f	f	1020	\N	0	2012-09-12 14:44:44.722246	2014-03-03 15:32:20.425237	AP	0
592	180	45	25296.00000	2012-12-04	2012-12-04		f	f	f	f	1020		0	2012-09-12 14:44:44.722246	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
593	181	56	1800000.00000	2012-06-11	2012-06-11	\N	f	f	f	f	1020	\N	0	2012-09-12 14:56:01.117455	2014-03-03 15:32:20.425237	AP	0
595	181	56	-1800000.00000	2012-06-20	2012-06-20	\N	f	f	f	f	1020	\N	0	2012-09-12 14:56:01.117455	2014-03-03 15:32:20.425237	AP	0
596	181	45	1800000.00000	2012-06-20	2012-06-20		f	f	f	f	1020		0	2012-09-12 14:56:01.117455	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
4	2	45	-130000000.00000	2012-01-03	2012-01-03		f	f	f	f	\N		0	2012-08-30 11:07:21.63752	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
594	181	170	-1800000.00000	2012-06-11	2012-06-11	\N	f	f	f	f	1020	\N	0	2012-09-12 14:56:01.117455	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	0
9	4	368	30000.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:39:53.166922	2014-03-03 15:32:20.425237		0
16	7	368	10527271.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:50:35.740764	2014-03-03 15:32:20.425237		0
18	8	368	89117833.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:52:44.225147	2014-03-03 15:32:20.425237		0
625	195	45	66.20000	2012-06-01	2012-06-01		f	f	f	f	\N		0	2012-09-17 13:57:57.706063	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
626	196	316	-58.89000	2012-07-06	2012-07-06		f	f	f	f	\N		0	2012-09-17 13:58:19.052965	2014-03-03 15:32:20.425237		0
627	196	45	58.89000	2012-07-06	2012-07-06		f	f	f	f	\N		0	2012-09-17 13:58:19.052965	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
628	197	316	-73.98000	2012-08-03	2012-08-03		f	f	f	f	\N		0	2012-09-17 13:58:54.160665	2014-03-03 15:32:20.425237		0
629	197	45	73.98000	2012-08-03	2012-08-03		f	f	f	f	\N		0	2012-09-17 13:58:54.160665	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
630	198	316	-62.52000	2012-09-07	2012-09-07		f	f	f	f	\N		0	2012-09-17 13:59:30.899808	2014-03-03 15:32:20.425237		0
631	198	45	62.52000	2012-09-07	2012-09-07		f	f	f	f	\N		0	2012-09-17 13:59:30.899808	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
632	199	316	-59.63000	2012-10-05	2012-10-05		f	f	f	f	\N		0	2012-09-17 14:00:08.471779	2014-03-03 15:32:20.425237		0
633	199	45	59.63000	2012-10-05	2012-10-05		f	f	f	f	\N		0	2012-09-17 14:00:08.471779	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
634	200	316	-49.74000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-17 14:00:39.482533	2014-03-03 15:32:20.425237		0
635	200	45	49.74000	2012-11-02	2012-11-02		f	f	f	f	\N		0	2012-09-17 14:00:39.482533	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
636	201	316	-98.35000	2012-12-07	2012-12-07		f	f	f	f	\N		0	2012-09-17 14:01:09.693627	2014-03-03 15:32:20.425237		0
637	201	45	98.35000	2012-12-07	2012-12-07		f	f	f	f	\N		0	2012-09-17 14:01:09.693627	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
658	206	57	522730.00000	2012-06-01	2012-06-01	\N	f	f	f	f	1020	\N	0	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.425237	AP	0
659	206	173	-522730.00000	2012-06-01	2012-06-01	\N	f	f	f	f	1020	\N	0	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.425237	AP_amount:IC_cogs	0
660	206	57	-522730.00000	2012-06-08	2012-06-08	\N	f	f	f	f	1020	\N	0	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.425237	AP	0
661	206	45	650000.00000	2012-06-08	2012-06-08		f	f	f	f	1020		0	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
662	206	45	-130650.00000	2012-06-08	2012-06-08	\N	f	t	f	f	1020	\N	0	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
663	206	142	3380.00000	2012-06-08	2012-06-08	\N	f	t	f	f	1020	\N	0	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.425237		0
21	10	368	-75000000.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 13:24:23.521796	2014-03-03 15:32:20.425237		0
702	218	336	-8450000.00000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:45:37.123643	2014-03-03 15:32:20.425237		0
703	218	53	8450000.00000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:45:37.123643	2014-03-03 15:32:20.425237		0
704	219	336	-377032.50000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:47:20.17199	2014-03-03 15:32:20.425237		0
705	219	54	377032.50000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:47:20.17199	2014-03-03 15:32:20.425237		0
706	220	54	-6177532.50000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:48:26.110156	2014-03-03 15:32:20.425237		0
707	220	45	6177532.50000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:48:26.110156	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
708	221	53	-138450000.00000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:49:36.816497	2014-03-03 15:32:20.425237		0
709	221	45	138450000.00000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-09-21 15:49:36.816497	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
13	6	1217	-73552642.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:49:30.509822	2014-03-03 15:32:20.425237	AP_amount	0
14	6	368	73552642.00000	2012-01-01	2012-01-01		f	f	t	f	\N		0	2012-08-30 12:49:30.509822	2014-03-03 15:32:20.425237		0
719	225	61	8.40000	2012-12-08	2012-12-08	\N	f	f	f	f	\N	\N	0	2012-10-08 15:34:13.374781	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
720	225	17	-128.40000	2012-12-08	2012-12-08	\N	f	f	f	f	\N	\N	0	2012-10-08 15:34:13.374781	2014-03-03 15:32:20.425237	AR	0
721	225	84	120.00000	2012-12-08	2012-12-08	\N	f	f	f	f	\N	\N	2	2012-10-08 15:34:13.374781	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	374
722	226	61	-8.40000	2012-12-08	2012-12-08	\N	f	f	f	f	\N	\N	0	2012-10-08 15:34:30.042286	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
723	226	17	128.40000	2012-12-08	2012-12-08	\N	f	f	f	f	\N	\N	0	2012-10-08 15:34:30.042286	2014-03-03 15:32:20.425237	AR	0
724	226	84	-120.00000	2012-12-08	2012-12-08	\N	f	f	f	f	\N	\N	2	2012-10-08 15:34:30.042286	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	374
670	208	90	350000000.00000	2012-11-23	2012-11-23	\N	f	f	f	f	\N	\N	3	2012-09-21 15:31:12.755264	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
671	208	66	66500000.00000	2012-11-23	2012-11-23	\N	f	f	f	f	\N	\N	0	2012-09-21 15:31:12.755264	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
672	208	17	-416500000.00000	2012-11-23	2012-11-23	\N	f	f	f	f	\N	\N	0	2012-09-21 15:31:12.755264	2014-03-03 15:32:20.425237	AR	0
675	209	90	20000.00000	2012-01-02	2012-01-02	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:32.645385	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
676	209	66	3800.00000	2012-01-02	2012-01-02	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:32.645385	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
677	209	17	-23800.00000	2012-01-02	2012-01-02	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:32.645385	2014-03-03 15:32:20.425237	AR	0
678	210	90	20000.00000	2012-02-01	2012-02-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.068754	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
679	210	66	3800.00000	2012-02-01	2012-02-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.068754	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
680	210	17	-23800.00000	2012-02-01	2012-02-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.068754	2014-03-03 15:32:20.425237	AR	0
681	211	90	20000.00000	2012-03-01	2012-03-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.265917	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
682	211	66	3800.00000	2012-03-01	2012-03-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.265917	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
683	211	17	-23800.00000	2012-03-01	2012-03-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.265917	2014-03-03 15:32:20.425237	AR	0
684	212	90	20000.00000	2012-04-01	2012-04-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.365752	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
685	212	66	3800.00000	2012-04-01	2012-04-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.365752	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
686	212	17	-23800.00000	2012-04-01	2012-04-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.365752	2014-03-03 15:32:20.425237	AR	0
687	213	90	20000.00000	2012-05-01	2012-05-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.491077	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
688	213	66	3800.00000	2012-05-01	2012-05-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.491077	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
689	213	17	-23800.00000	2012-05-01	2012-05-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.491077	2014-03-03 15:32:20.425237	AR	0
757	228	17	23800.00000	2012-10-05	2012-10-05	\N	f	f	f	f	\N	\N	\N	2012-10-09 09:52:10.414821	2014-03-03 15:32:20.425237	AR	0
690	214	90	20000.00000	2012-06-01	2012-06-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.596295	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
691	214	66	3800.00000	2012-06-01	2012-06-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.596295	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
692	214	17	-23800.00000	2012-06-01	2012-06-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.596295	2014-03-03 15:32:20.425237	AR	0
693	215	90	20000.00000	2012-07-01	2012-07-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.715663	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
694	215	66	3800.00000	2012-07-01	2012-07-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.715663	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
695	215	17	-23800.00000	2012-07-01	2012-07-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.715663	2014-03-03 15:32:20.425237	AR	0
696	216	90	20000.00000	2012-08-01	2012-08-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:33.819959	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
697	216	66	3800.00000	2012-08-01	2012-08-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.819959	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
698	216	17	-23800.00000	2012-08-01	2012-08-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:33.819959	2014-03-03 15:32:20.425237	AR	0
699	217	90	20000.00000	2012-09-01	2012-09-01	\N	f	f	f	f	\N	\N	3	2012-09-21 15:36:34.018694	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
700	217	66	3800.00000	2012-09-01	2012-09-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:34.018694	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
701	217	17	-23800.00000	2012-09-01	2012-09-01	\N	f	f	f	f	\N	\N	0	2012-09-21 15:36:34.018694	2014-03-03 15:32:20.425237	AR	0
710	222	90	20000.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	3	2012-09-21 16:20:17.548256	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
711	222	66	3800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-09-21 16:20:17.548256	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
712	222	17	-23800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-09-21 16:20:17.548256	2014-03-03 15:32:20.425237	AR	0
745	228	90	20000.00000	2012-10-01	2012-10-01	\N	f	f	f	f	\N	\N	3	2012-10-09 08:49:39.436806	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
746	228	66	3800.00000	2012-10-01	2012-10-01	\N	f	f	f	f	\N	\N	0	2012-10-09 08:49:39.436806	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
747	228	17	-23800.00000	2012-10-01	2012-10-01	\N	f	f	f	f	\N	\N	0	2012-10-09 08:49:39.436806	2014-03-03 15:32:20.425237	AR	0
748	229	90	20000.00000	2012-11-01	2012-11-01	\N	f	f	f	f	\N	\N	3	2012-12-12 12:48:18.476016	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
749	229	66	3800.00000	2012-11-01	2012-11-01	\N	f	f	f	f	\N	\N	0	2012-12-12 12:48:18.476016	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
750	229	17	-23800.00000	2012-11-01	2012-11-01	\N	f	f	f	f	\N	\N	0	2012-12-12 12:48:18.476016	2014-03-03 15:32:20.425237	AR	0
751	230	90	20000.00000	2012-12-01	2012-12-01	\N	f	f	f	f	\N	\N	3	2012-12-12 12:48:18.77791	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
752	230	66	3800.00000	2012-12-01	2012-12-01	\N	f	f	f	f	\N	\N	0	2012-12-12 12:48:18.77791	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
753	230	17	-23800.00000	2012-12-01	2012-12-01	\N	f	f	f	f	\N	\N	0	2012-12-12 12:48:18.77791	2014-03-03 15:32:20.425237	AR	0
754	231	90	-20000.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	3	2012-10-09 08:58:55.226341	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
755	231	66	-3800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-10-09 08:58:55.226341	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
756	231	17	23800.00000	2012-09-21	2012-09-21	\N	f	f	f	f	\N	\N	0	2012-10-09 08:58:55.226341	2014-03-03 15:32:20.425237	AR	0
766	232	10	-1000.00000	2012-02-06	2012-02-06	\N	f	f	f	f	\N	\N	9	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP_amount	389
767	232	33	-190.00000	2012-02-06	2012-02-06	\N	f	f	f	f	\N	\N	9	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	389
768	232	56	1190.00000	2012-02-06	2012-02-06	\N	f	f	f	f	\N	\N	0	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP	0
769	232	56	-1166.20000	2012-02-10	2012-02-10	\N	f	f	f	f	\N	\N	0	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP	0
770	232	45	1166.20000	2012-02-10	2012-02-10		f	f	f	f	\N		0	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
771	232	56	-20.00000	2012-02-10	2012-02-10	\N	f	f	f	f	\N	\N	0	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP	0
772	232	183	20.00000	2012-02-10	2012-02-10		f	f	f	f	\N		9	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP_paid	389
773	232	56	-3.80000	2012-02-10	2012-02-10	\N	f	f	f	f	\N	\N	0	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP	0
774	232	36	3.80000	2012-02-10	2012-02-10		f	f	f	f	\N		0	2012-10-09 10:36:16.300764	2014-03-03 15:32:20.425237	AP_paid:IC_taxpart:IC_taxservice	0
775	233	36	-3.80000	2012-02-29	2012-02-29		f	f	f	f	\N		0	2012-10-09 12:33:16.675643	2014-03-03 15:32:20.425237	AP_paid:IC_taxpart:IC_taxservice	0
776	233	33	3.80000	2012-02-29	2012-02-29		f	f	f	f	\N		0	2012-10-09 12:33:16.675643	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
597	182	31	-13300.00000	2012-07-12	2012-07-12		f	f	f	f	\N		0	2012-09-12 16:56:01.548386	2014-03-03 15:32:20.425237	AP_tax:IC_taxpart:IC_taxservice	0
598	182	64	13300.00000	2012-07-12	2012-07-12		f	f	f	f	\N		0	2012-09-12 16:56:01.548386	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
777	208	17	403663821.00000	2012-11-23	2012-11-23	\N	f	f	f	f	\N	\N	0	2012-10-09 15:31:42.138763	2014-03-03 15:32:20.425237	AR	0
778	208	45	-403663821.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-09 15:31:42.138763	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
779	208	17	12836179.00000	2012-11-23	2012-11-23	\N	f	f	f	f	\N	\N	0	2012-10-09 15:31:42.138763	2014-03-03 15:32:20.425237	AR	0
781	234	1855	12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-09 15:35:42.440863	2014-03-03 15:32:20.425237	AR_paid	0
782	234	1234	-12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-09 15:35:42.440863	2014-03-03 15:32:20.425237		0
788	237	45	-1397604.12000	2012-02-13	2012-02-13		f	f	f	f	\N		0	2012-10-09 16:53:05.064453	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
789	237	68	1397604.12000	2012-02-13	2012-02-13		f	f	f	f	\N		0	2012-10-09 16:53:05.064453	2014-03-03 15:32:20.425237		0
790	238	45	-7429.38000	2012-03-12	2012-03-12		f	f	f	f	\N		0	2012-10-09 16:55:22.095412	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
791	238	68	7429.38000	2012-03-12	2012-03-12		f	f	f	f	\N		0	2012-10-09 16:55:22.095412	2014-03-03 15:32:20.425237		0
792	239	45	-8609.42000	2012-04-16	2012-04-16		f	f	f	f	\N		0	2012-10-09 16:56:19.153922	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
793	239	68	8609.42000	2012-04-16	2012-04-16		f	f	f	f	\N		0	2012-10-09 16:56:19.153922	2014-03-03 15:32:20.425237		0
794	240	45	-7629.92000	2012-05-14	2012-05-14		f	f	f	f	\N		0	2012-10-09 16:57:23.354414	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
795	240	68	7629.92000	2012-05-14	2012-05-14		f	f	f	f	\N		0	2012-10-09 16:57:23.354414	2014-03-03 15:32:20.425237		0
796	241	45	-6639249.07000	2012-06-18	2012-06-18		f	f	f	f	\N		0	2012-10-09 16:58:47.50797	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
797	241	68	6639249.07000	2012-06-18	2012-06-18		f	f	f	f	\N		0	2012-10-09 16:58:47.50797	2014-03-03 15:32:20.425237		0
798	242	45	-153183.94000	2012-07-16	2012-07-16		f	f	f	f	\N		0	2012-10-09 16:59:54.002626	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
799	242	68	153183.94000	2012-07-16	2012-07-16		f	f	f	f	\N		0	2012-10-09 16:59:54.002626	2014-03-03 15:32:20.425237		0
800	243	45	-6987.71000	2012-08-13	2012-08-13		f	f	f	f	\N		0	2012-10-09 17:01:15.212281	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
801	243	68	6987.71000	2012-08-13	2012-08-13		f	f	f	f	\N		0	2012-10-09 17:01:15.212281	2014-03-03 15:32:20.425237		0
802	244	45	-375426.30000	2012-09-17	2012-09-17		f	f	f	f	\N		0	2012-10-09 17:02:19.987038	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
803	244	68	375426.30000	2012-09-17	2012-09-17		f	f	f	f	\N		0	2012-10-09 17:02:19.987038	2014-03-03 15:32:20.425237		0
804	245	45	-930634.08000	2012-10-15	2012-10-15		f	f	f	f	\N		0	2012-10-09 17:03:28.013251	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
805	245	68	930634.08000	2012-10-15	2012-10-15		f	f	f	f	\N		0	2012-10-09 17:03:28.013251	2014-03-03 15:32:20.425237		0
806	246	45	-7978.27000	2012-11-19	2012-11-19		f	f	f	f	\N		0	2012-10-09 17:11:10.372906	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
807	246	68	7978.27000	2012-11-19	2012-11-19		f	f	f	f	\N		0	2012-10-09 17:11:10.372906	2014-03-03 15:32:20.425237		0
808	247	68	-64999035.29000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-10-09 17:13:16.376938	2014-03-03 15:32:20.425237		0
809	247	45	64999035.29000	2012-12-17	2012-12-17		f	f	f	f	\N		0	2012-10-09 17:13:16.376938	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
810	248	1234	12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-09 21:06:02.040213	2014-03-03 15:32:20.425237		0
811	248	45	-12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		0	2012-10-09 21:06:02.040213	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
812	249	90	18000.00000	2012-11-15	2012-11-15	\N	f	f	f	f	\N	\N	3	2012-11-15 14:31:30.163919	2014-03-03 15:32:20.425237	AR_amount:IC_sale:IC_income	388
813	249	66	3420.00000	2012-11-15	2012-11-15	\N	f	f	f	f	\N	\N	0	2012-11-15 14:31:30.163919	2014-03-03 15:32:20.425237	AR_tax:IC_taxpart:IC_taxservice	0
814	249	17	-21420.00000	2012-11-15	2012-11-15	\N	f	f	f	f	\N	\N	0	2012-11-15 14:31:30.163919	2014-03-03 15:32:20.425237	AR	0
733	213	17	23800.00000	2012-05-04	2012-05-04	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:39:43.761473	2014-03-03 15:32:20.425237	AR	0
737	215	17	23800.00000	2012-07-06	2012-07-06	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:40:41.145792	2014-03-03 15:32:20.425237	AR	0
738	215	45	-23800.00000	2012-07-06	2012-07-06		f	f	f	f	\N		\N	2012-10-08 15:40:41.145792	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
739	216	17	23800.00000	2012-08-03	2012-08-03	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:41:08.87364	2014-03-03 15:32:20.425237	AR	0
740	216	45	-23800.00000	2012-08-03	2012-08-03		f	f	f	f	\N		\N	2012-10-08 15:41:08.87364	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
741	217	17	23800.00000	2012-09-07	2012-09-07	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:41:36.984951	2014-03-03 15:32:20.425237	AR	0
742	217	45	-23800.00000	2012-09-07	2012-09-07		f	f	f	f	\N		\N	2012-10-08 15:41:36.984951	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
725	209	17	23800.00000	2012-01-05	2012-01-05	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:36:40.883908	2014-03-03 15:32:20.425237	AR	0
726	209	45	-23800.00000	2012-01-05	2012-01-05		f	f	f	f	\N		\N	2012-10-08 15:36:40.883908	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
727	210	17	23800.00000	2012-02-07	2012-02-07	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:37:08.466191	2014-03-03 15:32:20.425237	AR	0
728	210	45	-23800.00000	2012-02-07	2012-02-07		f	f	f	f	\N		\N	2012-10-08 15:37:08.466191	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
729	211	17	23800.00000	2012-03-02	2012-03-02	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:38:38.869707	2014-03-03 15:32:20.425237	AR	0
730	211	45	-23800.00000	2012-03-02	2012-03-02		f	f	f	f	\N		\N	2012-10-08 15:38:38.869707	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
731	212	17	23800.00000	2012-04-06	2012-04-06	\N	f	f	f	f	\N	\N	\N	2012-10-08 15:39:05.516751	2014-03-03 15:32:20.425237	AR	0
732	212	45	-23800.00000	2012-04-06	2012-04-06		f	f	f	f	\N		\N	2012-10-08 15:39:05.516751	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
734	213	45	-23800.00000	2012-05-04	2012-05-04		f	f	f	f	\N		\N	2012-10-08 15:39:43.761473	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
758	228	45	-23800.00000	2012-10-05	2012-10-05		f	f	f	f	\N		\N	2012-10-09 09:52:10.414821	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
759	229	17	23800.00000	2012-11-02	2012-11-02	\N	f	f	f	f	\N	\N	\N	2012-10-09 09:52:37.754799	2014-03-03 15:32:20.425237	AR	0
760	229	45	-23800.00000	2012-11-02	2012-11-02		f	f	f	f	\N		\N	2012-10-09 09:52:37.754799	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
761	230	17	23800.00000	2012-12-07	2012-12-07	\N	f	f	f	f	\N	\N	\N	2012-10-09 09:53:01.875368	2014-03-03 15:32:20.425237	AR	0
762	230	45	-23800.00000	2012-12-07	2012-12-07		f	f	f	f	\N		\N	2012-10-09 09:53:01.875368	2014-03-03 15:32:20.425237	AR_paid:AP_paid	0
780	208	1855	-12836179.00000	2012-11-23	2012-11-23		f	f	f	f	\N		\N	2012-10-09 15:31:42.138763	2014-03-03 15:32:20.425237	AR_paid	0
\.


--
-- Data for Name: ap; Type: TABLE DATA; Schema: public; Owner: -
--

COPY ap (id, invnumber, transdate, gldate, vendor_id, taxincluded, amount, netamount, paid, datepaid, duedate, invoice, ordnumber, notes, employee_id, quonumber, intnotes, department_id, itime, mtime, shipvia, cp_id, language_id, payment_id, storno, taxzone_id, type, orddate, quodate, globalproject_id, storno_id, transaction_description, direct_debit, deliverydate, delivery_term_id, currency_id) FROM stdin;
158	201201	2012-01-02	2012-01-02	1190	t	30000.00000	28037.38000	30000.00000	2012-01-06	2012-01-16	t	201201		938	\N		\N	2012-09-12 11:31:38.368947	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2011-12-19	\N	1020	\N	\N	f	\N	\N	1
161	i784363	2012-05-01	2012-05-01	1139	t	980000.00000	823529.41000	980000.00000	2012-05-04	2012-05-15	t	201204		938	\N		\N	2012-09-12 11:55:21.123487	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-04-23	\N	1020	\N	\N	f	\N	\N	1
165	siemann213	2012-05-14	2012-05-14	1022	t	16000000.00000	13445378.15000	16000000.00000	2012-05-18	2012-05-28	t	201208		938	\N		\N	2012-09-12 12:17:13.904978	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-05-07	\N	1020	\N	\N	f	\N	\N	1
160	R201243	2012-01-13	2012-01-13	1076	t	1400000.00000	1176470.59000	1400000.00000	2012-01-18	2012-01-26	t	201204		1213	\N		\N	2012-09-12 11:51:00.529905	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-01-04	\N	1020	\N	\N	f	\N	\N	1
166	KS547843	2012-01-13	2012-01-13	1028	t	5042040.00000	4237008.40000	5042040.00000	2012-01-18	2012-01-26	t	201202		1213	\N		\N	2012-09-12 12:34:31.518335	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-01-04	\N	1020	\N	\N	f	\N	\N	1
159	kr20120113	2012-01-13	2012-01-13	1024	t	2250000.00000	1890756.30000	2250000.00000	2012-01-16	2012-01-27	t	201203		938	\N		\N	2012-09-12 11:46:35.764079	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-01-04	\N	1020	\N	\N	f	\N	\N	1
162	KBL42348	2012-05-01	2012-05-01	1030	t	2677600.00000	2250084.03000	2677600.00000	2012-05-09	2012-05-15	t	201207		1213	\N		\N	2012-09-12 12:00:50.338662	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-04-23	\N	1020	\N	\N	f	\N	\N	1
105	29100	2012-01-05	2012-01-05	1323	t	389.00000	326.89000	389.00000	2012-01-20	2012-02-27	f			1213	\N	\N	\N	2012-08-30 15:26:07.829581	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
164	PSR45325	2012-05-14	2012-05-14	1074	t	1880000.00000	1579831.93000	1880000.00000	2012-05-22	2012-05-28	t	201210		1213	\N		\N	2012-09-12 12:16:58.361196	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-05-07	\N	1020	\N	\N	f	\N	\N	1
163	dog13498	2012-05-14	2012-05-14	1032	t	20000000.00000	16806722.69000	20000000.00000	2012-05-18	2012-05-28	t	201207		938	\N		\N	2012-09-12 12:11:50.790617	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-05-07	\N	1020	\N	\N	f	\N	\N	1
224	Storno zu 65780	2012-09-21	2012-09-21	1821	f	-142800.00000	-120000.00000	-142800.00000	\N	2012-09-21	t			1473	\N		\N	2012-10-08 15:30:57.901724	2014-03-03 15:32:20.898927	\N	\N	\N	\N	t	0	\N	\N	\N	\N	223	\N	f	\N	\N	1
206	APSXT400012	2012-06-01	2012-06-01	1397	f	522730.00000	522730.00000	522730.00000	2012-06-08	2012-07-02	t	201211		1213	\N		\N	2012-09-21 14:43:12.462592	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	3	\N	2012-05-18	\N	1020	\N	\N	f	\N	\N	2
167	B123St	2012-06-11	2012-06-11	1078	t	230000.00000	193277.31000	230000.00000	2012-06-15	2012-06-25	t	201212		938	\N		\N	2012-09-12 12:40:21.584179	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-06-01	\N	1020	\N	\N	f	\N	\N	1
181	RB485373	2012-06-11	2012-06-11	1401	f	1800000.00000	1800000.00000	1800000.00000	2012-06-20	2012-06-25	t	201205		1213	\N		\N	2012-09-12 14:56:01.117455	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	1	\N	2012-04-11	\N	1020	\N	\N	f	\N	\N	1
106	35743	2012-04-05	2012-04-05	1323	t	389.00000	326.89000	389.00000	2012-04-20	2012-05-30	f			1213	\N	\N	\N	2012-08-30 15:27:17.515737	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
108	41568	2012-08-03	2012-08-03	1323	t	389.00000	326.89000	389.00000	2012-08-21	2012-09-28	f			1213	\N	\N	\N	2012-08-30 15:32:52.50715	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
110	d201206400	2012-03-02	2012-03-02	1343	t	8100.00000	6806.72000	8100.00000	2012-04-13	2012-04-30	f		10 Pc für Mitarbeiter	938	\N	\N	\N	2012-09-03 11:39:52.615662	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
114	114	2012-04-16	2012-04-16	1349	f	151.99830	150.69000	152.00000	2012-04-20	2012-04-30	f			938	\N	\N	\N	2012-09-03 15:52:54.919564	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
156	63415	2012-11-02	2012-11-02	1323	t	389.00000	326.89000	389.00000	2012-11-13	2012-11-23	f			938	\N	\N	\N	2012-09-04 11:46:08.253302	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
168	nsoy2314	2012-07-09	2012-07-09	1401	f	70000.00000	70000.00000	70000.00000	2012-07-12	2012-07-23	t	201211		938	\N		\N	2012-09-12 12:51:04.811484	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	1	\N	2012-07-02	\N	1020	\N	\N	f	\N	\N	1
169	BC54895	2012-08-08	2012-08-08	1035	t	350000.00000	294117.65000	350000.00000	2012-08-15	2012-08-22	t	201214		1213	\N		\N	2012-09-12 14:03:23.525778	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-08-01	\N	1020	\N	\N	f	\N	\N	1
171	UM438947	2012-08-13	2012-08-13	1082	t	957000.00000	804201.68000	957000.00000	2012-08-20	2012-08-27	t	201215		1213	\N		\N	2012-09-12 14:08:20.092458	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-08-06	\N	1020	\N	\N	f	\N	\N	1
170	Kule14314	2012-08-13	2012-08-13	1050	t	1000000.00000	840336.13000	1000000.00000	2012-08-17	2012-08-27	t	201216		938	\N		\N	2012-09-12 14:07:26.811402	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-08-06	\N	1020	\N	\N	f	\N	\N	1
172	sbi542534	2012-09-10	2012-09-10	1082	t	4650000.00000	3907563.03000	4650000.00000	2012-09-14	2012-09-24	t	201217		938	\N		\N	2012-09-12 14:14:06.926166	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-08-27	\N	1020	\N	\N	f	\N	\N	1
173	PH480956	2012-09-10	2012-09-10	1062	t	1133740.00000	952722.69000	1133740.00000	2012-09-18	2012-09-24	t	201218		1213	\N		\N	2012-09-12 14:16:01.336668	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-09-03	\N	1020	\N	\N	f	\N	\N	1
175	Reiter05543	2012-11-05	2012-11-05	1041	t	5300000.00000	4453781.51000	5300000.00000	2012-11-09	2012-11-19	t	201219		938	\N		\N	2012-09-12 14:26:50.138796	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-09-03	\N	1020	\N	\N	f	\N	\N	1
179	BR54574567	2012-11-14	2012-11-14	1080	t	200000.00000	168067.23000	200000.00000	2012-11-22	2012-11-28	t	201222		1213	\N		\N	2012-09-12 14:41:19.85977	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-09-27	\N	1020	\N	\N	f	\N	\N	1
176	IPG38765	2012-11-23	2012-11-23	1059	t	2100000.00000	1764705.88000	2100000.00000	2012-12-07	2012-12-10	t	201220		1213	\N		\N	2012-09-12 14:30:44.163604	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-09-03	\N	1020	\N	\N	f	\N	\N	1
177	MA05987078	2012-11-26	2012-11-26	1052	t	65000.00000	54621.85000	65000.00000	2012-11-30	2012-12-03	t	201221		1213	\N		\N	2012-09-12 14:34:33.16189	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-09-12	\N	1020	\N	\N	f	\N	\N	1
178	ICL654667	2012-11-29	2012-11-29	1043	t	1680000.00000	1411764.71000	1680000.00000	2012-12-04	2012-12-13	t	201223		1213	\N		\N	2012-09-12 14:38:20.675653	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-09-27	\N	1020	\N	\N	f	\N	\N	1
180	fkidsg93	2012-11-30	2012-11-30	1085	t	25296.00000	23641.12000	25296.00000	2012-12-04	2012-12-14	t	201222		938	\N		\N	2012-09-12 14:44:44.722246	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	0	\N	2012-11-15	\N	1020	\N	\N	f	\N	\N	1
223	65780	2012-09-21	2012-09-21	1821	f	142800.00000	120000.00000	142800.00000	\N	2012-09-21	t			1473	\N	Rechnung storniert am 21.09.2012 	\N	2012-10-08 15:29:43.023031	2014-03-03 15:32:20.898927	\N	\N	\N	\N	t	0	\N	\N	\N	\N	\N	\N	f	\N	\N	1
232	oat528	2012-02-06	2012-02-06	1323	f	1190.00000	1000.00000	1190.00000	2012-02-10	2012-02-20	f		Konferenztisch 1. OG	938	\N	\N	\N	2012-10-09 10:02:59.773129	2014-03-03 15:32:20.898927	\N	\N	\N	\N	f	\N	\N	\N	\N	\N	\N	\N	f	\N	\N	1
\.


--
-- Data for Name: ar; Type: TABLE DATA; Schema: public; Owner: -
--

COPY ar (id, invnumber, transdate, gldate, customer_id, taxincluded, amount, netamount, paid, datepaid, duedate, deliverydate, invoice, shippingpoint, terms, notes, ordnumber, employee_id, quonumber, cusordnumber, intnotes, department_id, shipvia, itime, mtime, cp_id, language_id, payment_id, delivery_customer_id, delivery_vendor_id, storno, taxzone_id, shipto_id, type, dunning_config_id, orddate, quodate, globalproject_id, salesman_id, marge_total, marge_percent, storno_id, transaction_description, donumber, invnumber_for_credit_note, direct_debit, delivery_term_id, currency_id) FROM stdin;
208	13	2012-11-23	2012-11-23	1037	f	416500000.00000	350000000.00000	416500000.00000	2012-11-23	2012-11-30	2012-11-30	t		\N			938				\N		2012-09-21 15:31:12.755264	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	\N	\N	\N	938	350000000.00000	100.00000	\N		ste20121	\N	f	\N	1
225	15	2012-12-08	2012-12-08	1037	f	128.40000	120.00000	128.40000	\N	2012-12-25	\N	t		\N			1473			Rechnung storniert am 08.12.2012 Nachbestellung Palme	\N		2012-10-08 15:34:13.374781	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	t	0	\N	invoice	\N	\N	\N	\N	1473	-114.11000	-95.09167	\N			\N	f	\N	1
226	Storno zu 15	2012-12-08	2012-12-08	1037	f	-128.40000	-120.00000	-128.40000	\N	2012-12-25	\N	t		\N			1473			Nachbestellung Palme	\N		2012-10-08 15:34:30.042286	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	t	0	\N	invoice	\N	\N	\N	\N	1473	114.11000	-95.09167	225			\N	f	\N	1
249	16	2012-11-15	2012-11-15	1754	f	21420.00000	18000.00000	0.00000	\N	2012-11-15	2012-11-15	t		\N		1	1871				\N		2012-11-15 14:31:30.163919	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2012-11-15	\N	\N	1871	18000.00000	100.00000	\N		1	\N	f	\N	1
217	9	2012-09-01	2012-09-01	1754	f	23800.00000	20000.00000	23800.00000	2012-09-07	2012-09-21	2012-09-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:34.018694	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
209	1	2012-01-02	2012-01-02	1754	f	23800.00000	20000.00000	23800.00000	2012-01-05	2012-09-21	2012-01-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:32.645385	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
228	11	2012-10-01	2012-10-01	1754	f	23800.00000	20000.00000	23800.00000	2012-10-05	2012-10-09	2012-10-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	201126	938			Automatisch am 09.10.12 erzeugte Rechnung	\N		2012-10-09 08:49:39.436806	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
229	12	2012-11-01	2012-11-01	1754	f	23800.00000	20000.00000	23800.00000	2012-11-02	2012-12-12	2012-11-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	201126	938			Automatisch am 12.12.12 erzeugte Rechnung	\N		2012-12-12 12:48:18.476016	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
231	Storno zu 10	2012-09-21	2012-09-21	1754	f	-23800.00000	-20000.00000	-23800.00000	\N	2012-09-21	2012-09-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-10-09 08:58:55.226341	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	t	0	\N	invoice	\N	2011-12-02	\N	\N	938	-20000.00000	100.00000	222		\N	\N	f	\N	1
230	14	2012-12-01	2012-12-01	1754	f	23800.00000	20000.00000	23800.00000	2012-12-07	2012-12-12	2012-12-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	201126	938			Automatisch am 12.12.12 erzeugte Rechnung	\N		2012-12-12 12:48:18.77791	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
210	2	2012-02-01	2012-02-01	1754	f	23800.00000	20000.00000	23800.00000	2012-02-07	2012-09-21	2012-02-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.068754	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
211	3	2012-03-01	2012-03-01	1754	f	23800.00000	20000.00000	23800.00000	2012-03-02	2012-09-21	2012-03-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.265917	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
212	4	2012-04-01	2012-04-01	1754	f	23800.00000	20000.00000	23800.00000	2012-04-06	2012-09-21	2012-04-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.365752	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
213	5	2012-05-01	2012-05-01	1754	f	23800.00000	20000.00000	23800.00000	2012-05-04	2012-09-21	2012-05-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.491077	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
214	6	2012-06-01	2012-06-01	1754	f	23800.00000	20000.00000	23800.00000	2012-06-01	2012-09-21	2012-06-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.596295	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
215	7	2012-07-01	2012-07-01	1754	f	23800.00000	20000.00000	23800.00000	2012-07-06	2012-09-21	2012-07-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.715663	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
216	8	2012-08-01	2012-08-01	1754	f	23800.00000	20000.00000	23800.00000	2012-08-03	2012-09-21	2012-08-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 15:36:33.819959	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	f	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
222	10	2012-09-21	2012-09-21	1754	f	23800.00000	20000.00000	23800.00000	\N	2012-09-21	2012-09-02	t		0	Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	022012	938			Rechnung storniert am 21.09.2012 Automatisch am 21.09.12 erzeugte Rechnung	\N		2012-09-21 16:20:17.548256	2014-03-03 15:32:20.898927	\N	\N	\N	\N	\N	t	0	\N	invoice	\N	2011-12-02	\N	\N	938	20000.00000	100.00000	\N		\N	\N	f	\N	1
\.


--
-- Data for Name: assembly; Type: TABLE DATA; Schema: public; Owner: -
--

COPY assembly (id, parts_id, qty, bom, itime, mtime, assembly_id) WITH OIDS FROM stdin;
\.


--
-- Data for Name: background_job_histories; Type: TABLE DATA; Schema: public; Owner: -
--

COPY background_job_histories (id, package_name, run_at, status, result, error, data) FROM stdin;
1	CreatePeriodicInvoices	2012-09-21 15:29:57	success	1	\N	\N
2	CreatePeriodicInvoices	2012-09-21 15:30:26	success	1	\N	\N
3	CreatePeriodicInvoices	2012-09-21 15:36:32	success	1	\N	\N
4	CreatePeriodicInvoices	2012-09-21 16:20:17	success	1	\N	\N
5	CreatePeriodicInvoices	2012-09-21 16:22:39	success	1	\N	\N
6	CreatePeriodicInvoices	2012-09-21 16:31:23	success	1	\N	\N
7	CreatePeriodicInvoices	2012-10-09 08:49:39	success	1	\N	\N
8	CreatePeriodicInvoices	2012-12-12 12:48:18	success	1	\N	\N
\.


--
-- Data for Name: background_jobs; Type: TABLE DATA; Schema: public; Owner: -
--

COPY background_jobs (id, type, package_name, last_run_at, next_run_at, data, active, cron_spec) FROM stdin;
1	interval	CleanBackgroundJobHistory	\N	2012-11-01 03:00:00	\N	t	0 3 * * *
3	interval	SelfTest	\N	2012-11-01 03:00:00	\N	t	20 2 * * *
4	interval	BackgroundJobCleanup	\N	2014-03-04 03:00:00	\N	t	0 3 * * *
2	interval	CreatePeriodicInvoices	2012-12-12 12:48:18	2014-03-04 03:00:00	\N	t	0 3 * * *
\.


--
-- Data for Name: bank_accounts; Type: TABLE DATA; Schema: public; Owner: -
--

COPY bank_accounts (id, account_number, bank_code, iban, bic, bank, chart_id) FROM stdin;
\.


--
-- Data for Name: bin; Type: TABLE DATA; Schema: public; Owner: -
--

COPY bin (id, warehouse_id, description, itime, mtime) FROM stdin;
957	956	Halle1	2012-08-17 12:54:39.431761	\N
959	958	Lagerplatz1	2012-08-17 12:55:17.503286	\N
960	958	Lagerplatz2	2012-08-17 12:55:17.503286	\N
961	958	Lagerplatz3	2012-08-17 12:55:17.503286	\N
962	958	Lagerplatz4	2012-08-17 12:55:17.503286	\N
963	958	Lagerplatz5	2012-08-17 12:55:17.503286	\N
964	958	Lagerplatz6	2012-08-17 12:55:17.503286	\N
965	958	Lagerplatz7	2012-08-17 12:55:17.503286	\N
966	958	Lagerplatz8	2012-08-17 12:55:17.503286	\N
967	958	Lagerplatz9	2012-08-17 12:55:17.503286	\N
968	958	Lagerplatz10	2012-08-17 12:55:17.503286	\N
970	969	Lagerplatz1	2012-08-17 12:55:48.385448	\N
971	969	Lagerplatz2	2012-08-17 12:55:48.385448	\N
972	969	Lagerplatz3	2012-08-17 12:55:48.385448	\N
973	969	Lagerplatz4	2012-08-17 12:55:48.385448	\N
974	969	Lagerplatz5	2012-08-17 12:55:48.385448	\N
975	969	Lagerplatz6	2012-08-17 12:55:48.385448	\N
976	969	Lagerplatz7	2012-08-17 12:55:48.385448	\N
977	969	Lagerplatz8	2012-08-17 12:55:48.385448	\N
978	969	Lagerplatz9	2012-08-17 12:55:48.385448	\N
979	969	Lagerplatz10	2012-08-17 12:55:48.385448	\N
980	969	Lagerplatz11	2012-08-17 12:55:48.385448	\N
981	969	Lagerplatz12	2012-08-17 12:55:48.385448	\N
982	969	Lagerplatz13	2012-08-17 12:55:48.385448	\N
983	969	Lagerplatz14	2012-08-17 12:55:48.385448	\N
984	969	Lagerplatz15	2012-08-17 12:55:48.385448	\N
985	969	Lagerplatz16	2012-08-17 12:55:48.385448	\N
986	969	Lagerplatz17	2012-08-17 12:55:48.385448	\N
987	969	Lagerplatz18	2012-08-17 12:55:48.385448	\N
988	969	Lagerplatz19	2012-08-17 12:55:48.385448	\N
989	969	Lagerplatz20	2012-08-17 12:55:48.385448	\N
990	969	Lagerplatz21	2012-08-17 12:55:48.385448	\N
991	969	Lagerplatz22	2012-08-17 12:55:48.385448	\N
992	969	Lagerplatz23	2012-08-17 12:55:48.385448	\N
993	969	Lagerplatz24	2012-08-17 12:55:48.385448	\N
994	969	Lagerplatz25	2012-08-17 12:55:48.385448	\N
995	969	Lagerplatz26	2012-08-17 12:55:48.385448	\N
996	969	Lagerplatz27	2012-08-17 12:55:48.385448	\N
997	969	Lagerplatz28	2012-08-17 12:55:48.385448	\N
998	969	Lagerplatz29	2012-08-17 12:55:48.385448	\N
999	969	Lagerplatz30	2012-08-17 12:55:48.385448	\N
1000	969	Lagerplatz31	2012-08-17 12:55:48.385448	\N
1001	969	Lagerplatz32	2012-08-17 12:55:48.385448	\N
1002	969	Lagerplatz33	2012-08-17 12:55:48.385448	\N
1003	969	Lagerplatz34	2012-08-17 12:55:48.385448	\N
1004	969	Lagerplatz35	2012-08-17 12:55:48.385448	\N
1005	969	Lagerplatz36	2012-08-17 12:55:48.385448	\N
1006	969	Lagerplatz37	2012-08-17 12:55:48.385448	\N
1007	969	Lagerplatz38	2012-08-17 12:55:48.385448	\N
1008	969	Lagerplatz39	2012-08-17 12:55:48.385448	\N
1009	969	Lagerplatz40	2012-08-17 12:55:48.385448	\N
1010	969	Lagerplatz41	2012-08-17 12:55:48.385448	\N
1011	969	Lagerplatz42	2012-08-17 12:55:48.385448	\N
1012	969	Lagerplatz43	2012-08-17 12:55:48.385448	\N
1013	969	Lagerplatz44	2012-08-17 12:55:48.385448	\N
1014	969	Lagerplatz45	2012-08-17 12:55:48.385448	\N
1015	969	Lagerplatz46	2012-08-17 12:55:48.385448	\N
1016	969	Lagerplatz47	2012-08-17 12:55:48.385448	\N
1017	969	Lagerplatz48	2012-08-17 12:55:48.385448	\N
1018	969	Lagerplatz49	2012-08-17 12:55:48.385448	\N
1019	969	Lagerplatz50	2012-08-17 12:55:48.385448	\N
\.


--
-- Data for Name: buchungsgruppen; Type: TABLE DATA; Schema: public; Owner: -
--

COPY buchungsgruppen (id, description, inventory_accno_id, income_accno_id_0, expense_accno_id_0, income_accno_id_1, expense_accno_id_1, income_accno_id_2, expense_accno_id_2, income_accno_id_3, expense_accno_id_3, sortkey) FROM stdin;
936	Standard 19%	16	90	168	77	172	86	170	80	173	1
937	Standard 7%	16	84	167	77	172	85	169	80	173	2
\.


--
-- Data for Name: business; Type: TABLE DATA; Schema: public; Owner: -
--

COPY business (id, description, discount, customernumberinit, salesman, itime, mtime) FROM stdin;
1872	Testgruppe	0.1		f	2012-11-15 14:19:47.684111	\N
\.


--
-- Data for Name: chart; Type: TABLE DATA; Schema: public; Owner: -
--

COPY chart (id, accno, description, charttype, category, link, taxkey_id, pos_bwa, pos_bilanz, pos_eur, datevautomatik, itime, mtime, new_chart_id, valid_from) FROM stdin;
1	0135	EDV-Software	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
2	0150	Geschäfts- oder Firmenwert	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
3	0240	Geschäftsbauten	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
4	0400	Techn. Anlagen und Maschinen	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
5	0440	Maschinen	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
6	0500	Andere Anlagen, Betriebs- und Geschäftsausstattung	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
7	0510	Andere Anlagen	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
8	0520	PKW	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
68	3820	Umsatzsteuer-Vorauszahlungen	A	E		0	\N	\N	28	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
69	3830	Umsatzsteuer-Vorauszahlungen 1/11	A	E		0	\N	\N	28	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
70	3835	Umsatzsteuer nach § 13b UStG	A	I		0	33	\N	7	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
72	3837	Umsatzsteuer nach § 13b UStG 19%	A	I		0	33	\N	7	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
73	3841	Umsatzsteuer Vorjahr	A	E		0	\N	\N	28	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
74	3845	Umsatzsteuer frühere Jahre	A	E		0	\N	\N	28	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
75	4110	Sonstige steuerfreie Umsätze Inland	A	I	AR_amount	0	\N	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
131	4750	Gewährte Boni 7% USt	A	E	AR_paid	2	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
132	4760	Gewährte Boni 19% USt	A	E	AR_paid	3	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
134	4780	Gewährte Rabatte 7% USt	A	E	AR_paid	2	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
135	4790	Gewährte Rabatte 19% USt	A	E	AR_paid	3	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
137	4800	Bestandsveränd. fert. Erzeugnisse	A	E		0	2	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
195	5900	Fremdleistungen	A	E	AP_amount	9	5	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
9	0560	Sonstige Transportmittel	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
10	0650	Büroeinrichtung	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
11	0640	Ladeneinrichtung	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
12	0620	Werkzeuge	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
360	7675	Verbrauchssteuer	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
13	0670	Geringwertige Wirtschaftsgüter	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
14	0675	Geringwertige Wirtschaftsggüter 150 - 1000 EUR (Sammelposten)	A	A	AP_amount	9	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
15	1000	Roh-, Hilfs- und Betriebsstoffe (Bestand)	A	E	IC	9	4	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
16	1140	Waren (Bestand)	A	E	IC	9	4	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
18	1215	Forder. aus LuL zum allg. UST-Satz oder eines Kleinunternehmers (EÜR)	A	A	AR	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
19	1216	Forder. aus LuL zum ermäßigten USTsatz (EÜR)	A	A	AR	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
20	1217	Forder. aus steuerfreien o. Nicht steuerbaren LuL (EÜR)	A	A	AR	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
21	1218	Forder. aus LuL nach Durchschnitzsätzen § 24 UStG (EÜR)	A	A	AR	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
22	1219	Gegenkonto 1215-1218 bei Auteilung d. Forder. nach Steuersätzen (EÜR)	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
23	1220	Forder. nach § 11 Abs. 1 Satz 2 EStG für § 4/3 EStG	A	A	AR	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
24	1248	Pauschwertber. zu Forder. Restlzeit <1 Jahr	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
25	1249	Pauschwertber. zu Forder. Restlzeit >1 Jahr	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
26	1370	Durchlaufende Posten	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
27	1374	Fremdgeld	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
37	1432	abziehb. VorSt EU-Erwerb Neufzg.b.Lief. o. USt-IdNr.	A	E	AR_tax	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
38	1433	Bezahlte Einfuhrumsatzsteuer	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
39	1460	Geldtransit	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
40	1480	Gegenkonto Vorsteuer §4/3 EStG	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
41	1481	Auflösung Vorst.a.Vorjahr §4/3 EStG	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
42	1482	Vorst.aus Investitionen §4/3 EStG	A	E		0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
43	1484	abziehb.VorSt EU-Erwerb Neufzg.b.Lief. o. USt.Ident.Nr	A	E	AR_tax	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
44	1600	Kasse	A	A	AR_paid:AP_paid	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
46	2100	Privatentnahmen allgemein	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
47	2150	Privatsteuern	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
48	2180	Privateinlagen	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
49	2200	Sonderausgaben beschränkt abzugsfähig	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
50	2230	Sonderausgaben unbeschränkt abzugsfähig	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
51	2250	Zuwendungen, Spenden	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
52	2950	Satzungsmäßige Rücklagen	A	Q		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
57	3305	Verbindlk. aus LuL zum allg. USTsatz (EÜR)	A	L	AP	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
58	3306	Verbindlk. aus LuL zum erm. USTsatz (EÜR)	A	L	AP	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
59	3307	Verbindlk. aus LuL ohne Vorsteuer (EÜR)	A	L	AP	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
60	3309	Gegenkonto 3305-3307 bei Auteilung d. Forder. nach Steuersätzen (EÜR)	A	L		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
61	3801	Umsatzsteuer 7%	A	I	AR_tax:IC_taxpart:IC_taxservice	0	\N	\N	5	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
62	3802	Umsatzsteuer aus innergemeinschftl. Erwerb	A	I	AR_tax:IC_taxpart:IC_taxservice	0	\N	\N	6	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
63	3803	Umsatzsteuer aus innergemeinschftl. Erwerb 16%	A	I	AR_tax:IC_taxpart:IC_taxservice	0	\N	\N	28	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
65	3805	Umsatzsteuer 16%	A	I	AR_tax:IC_taxpart:IC_taxservice	0	\N	\N	6	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
67	3817	Umsatzsteuer aus in anderen EG-Land stpfl. Lieferungen	A	 		10	0	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
53	3151	Verbindlk. geg Krditinst. - Restlzeit <1 Jahr 	A	L		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
54	3160	Verbindlk. geg Krditinst. - Restlzeit 1 - 5 Jahre 	A	L		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
55	3170	Verbindlk. geg Krditinst. - Restlzeit >5 Jahre	A	L		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
76	4120	Steuerfreie Umsätze §4Nr.1a UstG	A	I	AR_amount:IC_sale:IC_income	0	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
77	4125	Steuerfrei innergem. Lieferungen §41bUStG	A	I	AR_amount:IC_sale:IC_income	0	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
78	4130	Liefe.d.1.Abnehm.bei innergem.Dreiecksg §25b2UStG	A	I	AR_amount:IC_sale:IC_income	0	\N	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
79	4135	Steuerfr.innergem.Lief.v.Neufahrz.an Abn.o. USt-IdNr.	A	I	AR_amount:IC_sale	0	\N	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
80	4150	Sonstige steuerfreie Umsätze §42-7UStG	A	I	AR_amount:IC_sale:IC_income	0	\N	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
83	4200	Erlöse	A	I	AR_amount:IC_sale:IC_income	0	1	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
84	4300	Erlöse 7% USt	A	I	AR_amount:IC_sale:IC_income	2	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
85	4310	Erlöse aus im Inland strpfl. EG-Lieferungen 7%	A	I	AR_amount:IC_sale:IC_income	12	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
86	4315	Erlöse aus im Inland strpfl. EG-Lieferungen 19%	A	I	AR_amount:IC_sale:IC_income	13	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
87	4320	Erlöse aus im anderen EG-Land strpfl. Lieferungen	A	I	AR_amount:IC_sale:IC_income	10	1	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
91	4500	Provisionserlöse	A	I	AR_amount:IC_income	3	5	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
92	4504	Steuerfreie Umsätze §4Nr.8ff UstG	A	I	AR_amount	0	1	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
93	4566	Provisionserlöse 7% USt.	A	I	AR_amount:IC_income	2	\N	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
95	4569	Provisionserlöse 19% USt	A	I	AR_amount:IC_income	3	\N	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
96	4510	Erlöse Abfallverwertung	A	I	AR_amount:IC_sale	3	\N	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
97	4520	Erlös Leergut	A	I	AR_amount:IC_sale	3	5	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
98	4580	Erlöse zum allg.Umsatzsteuersatz (EÜR)	A	I		0	1	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
99	4581	Erlöse zum ermä.Umsatzsteuersatz (EÜR)	A	I		0	1	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
100	4582	Erlöse steuerfrei u.nicht steuerbar (EÜR)	A	I		0	1	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
101	4589	Gegenkonto 8580-8582 b.Aufteilung d.Erlöse n.Steuersätzen(EÜR)	A	C		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
102	4600	Unentgeltliche Wertabgaben	A	I	AR_amount	0	\N	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
103	4605	Entnahme von Gegenständen o. USt	A	I		0	5	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
104	4610	Entnahme (Waren) d. Unternehmer f. Zwecke außerh. des Untern. 7% USt	A	I	AR_amount	2	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
105	4619	Entnahme (Waren) d. Unternehmer f. Zwecke außerh. des Untern. o. USt	A	I		0	5	\N	3	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
106	4620	Entnahme (Waren) d. Unternehmer f. Zwecke außerh. des Untern. 19% USt	A	I	AR_amount	3	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
107	4630	Verwendung v.Gegenst.f.Zwecke außerhalb d.Unternehmens 7% USt.	A	I	AR_amount	2	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
108	4637	Verwendung v.Gegenständen f.Zwecke außerhalb d.Untern.o.USt.	A	I		0	\N	\N	3	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
109	4640	Verw. v. Gegenst. f. Zwecke außerh. des Untern. 19% USt	A	I		3	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
110	4645	Verw. v. Gegenst. f. Zwecke außerh. des Untern. 19% USt (Kfz-Nutzung)	A	I		0	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
111	4646	Verw. v. Gegenst. f. Zwecke außerh. des Untern. 19% USt (Tel-Nutzung)	A	I		0	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
112	4660	Unentgeltl. Erbringung sonst. Leist. 19% USt	A	I	AR_amount	3	\N	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
113	4670	Unentgeltl. Zuwend. Waren 19% USt	A	I		2	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
114	4679	Unentgeltl. Zuwend. Waren o. USt	A	I		0	5	\N	3	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
116	4686	Unentgeltl. Zuwend. Gegenst. 19% USt	A	I	AR_amount	3	\N	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
117	4689	Unentgeltl. Zuwend. Gegenst. o. USt	A	I		0	5	\N	3	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
118	4690	Nicht steuerbare Umsätze (Innenumsätze)	A	I		0	5	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
119	4695	Umsatzsteuervergütungen	A	I		0	\N	\N	7	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
120	4700	Erlösschmälerungen	A	I		0	32	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
121	4710	Erlösschmälerung 7% USt.	A	I		2	32	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
122	4720	Erlösschmälerung 19% USt.	A	I		3	32	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
124	4725	Erlösschmäler aus im inl. Stpflcht. EG-Lieferungen 7%USt	A	I		12	32	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
125	4726	Erlösschmäler aus im inl. Stpflcht. EG-Lieferungen 19% USt	A	I		13	32	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
126	4727	Erlösschmäler. im and. EG-land Stpflchtg. Lieferungen	A	I		0	32	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
81	4180	Erlöse,die mit den Durchschnittssätzen d.§24UStG vers.werd.	A	I	AR_amount	0	\N	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
82	4185	Erlöse als Kleinunternehmer i.S.d.§19(1)UStG	A	I	AR_amount	0	1	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
138	4810	Bestandsveränd. unfert. Erzeugnisse	A	E		0	2	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
139	4815	Bestandsveränd. unfert. Leistungen	A	E		0	2	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
140	4820	And.aktiv.Eigenleistungen	A	E		0	3	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
141	4830	Sonstige betrbl. Erträge	A	I		3	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
142	4840	Erträge aus Kursdifferenzen	A	I		0	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
143	4835	Sonstige Erlöse betriebl.u.regelmäß	A	I	AR_amount	3	5	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
144	4837	Sonstige Erträge betrfremd und regelm.	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
145	6884	Erlöse a.Verk.Sachanlagen steuerfrei§4Nr.1aUStG(b.Buchverlust)	A	E		0	\N	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
146	6885	Erlöse aus Verk. Sachanl.verm. 19% USt (bei Buchverlust)	A	E		0	\N	\N	2	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
128	4731	Gewährte Skonti 7% USt	A	I	AR_paid	2	1	\N	1	t	2012-08-17 12:51:15.918799	2012-11-15 16:39:19.170385	\N	\N
147	6888	Erlöse a.Verk.Sachanlagen steuerfrei§4Nr.1bUStG(b.Buchverlust)	A	E		0	\N	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
148	4849	Erlöse aus Verk. Sachanl.verm. (bei Buchgewinn)	A	I	AR_amount	3	\N	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
149	4860	Grundstückserträge	A	I		3	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
150	4900	Erträge Abgang Gegst. d. Anlageverm.	A	I		0	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
151	4905	Erträge Abgang Gegst. d. Umlaufverm.	A	I		0	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
152	4910	Erträge Zuschreibung d. Sachanl.verm.	A	I		0	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
153	4915	Erträge Zuschreibung d. Umlaufverm.	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
154	4920	Erträge d. Herabs. Pauschwber. zu Forderungen	A	I		0	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
155	4925	Erträge aus abgeschriebenen Forderungen	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
156	4930	Erträge aus Auflösung von Rückstellungen	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
157	4934	Erträge a.d.Auflösung v.SoPo m.Rücklageant.(Exitenzgründungszusch.)	A	I		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
158	4939	Erträge aus Auflösung SoPo mit Rücklagenanteil (AnsparAfA)	A	I		0	5	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
159	4941	Sachbezüge 7% USt (Waren)	A	I	AR_amount	2	5	\N	2	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
160	4945	Sachbezüge 19% Ust (Waren)	A	I	AR_amount	3	5	\N	2	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
161	4946	Verrechnete sons. Sachbezüge	A	I	AR_amount	0	5	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
162	4960	Periodenfremde Erträge nicht außero	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
163	4970	Versicherungsentschädigungen	A	I		0	33	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
164	4981	Steuerfr.Erträge a.d.Auflös.v.SoPo m.Rücklageanteil	A	I		0	\N	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
165	4982	Sonst.steuerfreie Betriebseinnahmen	A	I		0	\N	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
166	5190	Energiestoffe (Fert.)	A	E	IC	9	4	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
167	5300	Wareneingang 7% Vorsteuer	A	E	AP_amount:IC_cogs	8	4	\N	8	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
168	5400	Wareneingang 19% Vorsteuer	A	E	AP_amount:IC_cogs	9	4	\N	8	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
169	5420	Innergemein.Erwerb 7% VorSt u. Ust	A	E	AP_amount:IC_cogs	18	4	\N	8	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
171	5440	Innergem.Erwerb v.Neufahrz.v.Lief.o.USt-IdNr. 19%VSt.u.19%USt.	A	E	AP_amount:IC_cogs	19	\N	\N	8	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
172	5550	Steuerfreier innergem.Erwerb	A	E	AP_amount:IC_cogs	0	\N	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
174	5580	Wareneinkauf z.allg.Umsatzsteuersatz (EÜR)	A	E		0	4	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
175	5581	Wareneinkauf z.erm.Umsatzsteuersatz(EÜR)	A	E		0	4	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
176	5582	Wareneinkauf ohne Vorsteuerabzug(EÜR)	A	E		0	4	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
177	5589	Gegenkto.3580-3582 b.Aufteilung d.WE n.Steuersätzen(EüR)	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
178	5600	Nicht abziehbare Vorsteuer	A	E		0	5	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
179	5610	Nicht abziehb.Vorsteuer 7%	A	E		0	5	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
180	5660	Nicht abziehb.Vorsteuer 19%	A	E		0	5	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
184	5750	Erhaltene Boni 7% Vorsteuer	A	I	AP_paid	8	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
185	5760	Erhaltene Boni 19% Vorsteuer	A	I	AP_paid	9	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
187	5780	Erhaltene Rabatte 7% Vorsteuer	A	I	AP_paid	8	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
188	5790	Erhaltene Rabatte 19% Vorsteuer	A	I	AP_paid	9	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
190	5800	Bezugsnebenkosten	A	E	AP_amount:IC_cogs:IC_expense	0	4	\N	8	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
191	5820	Leergut	A	E	AP_amount:IC_cogs	0	4	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
192	5840	Zölle und Einfuhrabgaben	A	E	AP_amount:IC_cogs	0	4	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
193	5860	Verrechnete Stoffkosten (GegenKto 5000-99)	A	E	IC_cogs	0	4	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
194	5880	Bestandsveränd. Roh-, Hilfs-,  Betriebsstoffe/Waren	A	E		0	2	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
196	5915	Leist.v.ausländ.Untern. 7% VSt.u.7%USt.	A	E	AP_amount	18	5	\N	8	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
197	5925	Leist.v.ausländ.Untern. 19% VSt.u.19%USt.	A	E	AP_amount	19	5	\N	8	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
198	6010	Löhne	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
200	6026	Tantiemen	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
201	6027	Geschäftsführergehälter	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
202	6030	Aushilfslöhne	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
203	6040	Pauschale Steuer für Aushilfen	A	E		0	10	\N	10	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
204	6045	Bedienungsgelder	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
205	6050	Ehegattengehalt	A	E		0	10	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
206	6060	Freiwillige sozi.Aufw.lohnsteuerpflichtig.	A	E		0	10	\N	10	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
272	6580	Mautgebühren	A	E		0	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
207	6069	Pauschale Steuer auf sonst. Bezüge (z.B. Fahrtkostenzuschuss)	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
208	6070	Krankengeldzuschüsse	A	E		0	10	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
209	6080	Vermögenswirksame Leistungen	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
210	6090	Fahrtkostenerst.Wohnung/Arbeitsstät	A	E		0	10	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
211	6110	Gesetzlich soziale Aufwendungen	A	E		0	10	\N	10	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
212	6120	Beiträge zur Berufsgenossenschaft	A	E		0	10	\N	10	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
173	5559	Steuerfreie Einfuhren	A	E	AP_amount:IC_cogs	0	\N	\N	8	f	2012-08-17 12:51:15.918799	2012-10-09 14:29:28.869042	\N	\N
213	6130	Freiwillig soziale Aufwendungen lohnsteuerfrei	A	E		0	10	\N	10	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
214	6147	Pauschale Lohnsteuer auf sonst.Bezüge(z.B.Direktversicherung	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
215	6200	Abschreibungen a.immat.Vermögensgeg	A	E		0	\N	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
216	6205	Abschreibung auf Gesch.- o. Firmenwert	A	E		0	\N	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
217	6210	Außerplan.AfA a.immat.Vermögensgeg.	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
218	6221	Abschreibung auf Gebäude	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
219	6220	Abschreibungen auf Sachanlagen (o.Kfz u.Geb.)	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
220	6222	Abschreibungen auf Kfz	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
221	6230	Außerplanmäßig Abschr.a.Sachanlagen	A	E		0	\N	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
222	6231	Absetzung f.außergew.techn.u.wirtschaftl.AfA bei Gebäuden	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
223	6232	Absetzung f.außergew.techn.u.wirtschaftl.AfA des Kfz	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
224	6233	Absetzung f.außergew.techn.u.wirtschaftl.AfA sonst.WG	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
225	6240	Abschr.a.Sachanl.aufgr.steuerl.Sondervorschriften	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
226	6241	Sonderabschreibung nach §7g(1)u.(2)EStG (ohne Kfz)	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
227	6242	Sonderabschreibung n.§7g(1)u.(2)EStG (für Kfz)	A	E		0	17	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
228	6250	Kaufleasing	A	E	AP_amount	0	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
229	6260	Sofortabschreibung GWG	A	E	AP_amount	0	\N	\N	26	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
230	6262	Abschreibungen auf aktivierte GWG	A	E		0	\N	\N	25	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
232	6275	Abschr.a.Wertp.d.Umlaufvermögens (unübl. hoch)	A	E		0	17	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
233	6280	Forderungsverlust (unübl. hoch)	A	E		0	20	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
234	6281	Forderungsverluste 7% USt (unübl. hoch)	A	E		2	20	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
236	6286	Forderungsverluste 19% USt (unübl. hoch)	A	E		3	20	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
237	6287	Forderungsverluste 15% USt (unübl. hoch)	A	E		3	20	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
238	6300	Sonstige betriebliche Aufwendungen	A	E	AP_amount	9	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
239	6303	Fremdleistungen	A	E	AP_amount	0	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
240	6304	Sons.Aufw.betriebl. und regelmäßig	A	E	AP_amount	9	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
241	6305	Raumkosten	A	E	AP_amount	9	11	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
242	6310	Miete (unbewegl. WG)	A	E	AP_amount	9	11	\N	11	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
243	6315	Pacht (unbewegl. WG)	A	E	AP_amount	0	\N	\N	11	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
244	6320	Heizung	A	E	AP_amount	9	11	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
245	6325	Gas,Strom, Wasser	A	E	AP_amount	9	11	\N	12	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
247	6335	Instandhaltung betrieb.Räume	A	E	AP_amount	9	11	\N	13	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
248	6345	Sonstige Raumkosten	A	E	AP_amount	9	11	\N	13	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
249	6348	Aufwend.f.ein häusliches Arbeitszimmer(abziehb.Anteil)	A	E		0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
250	6349	Aufwend.f.ein häusliches Arbeitszimmer(nicht abziehb.Anteil)	A	E		0	11	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
251	6350	Grundstücksaufwendungen	A	E		9	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
252	6390	Zuwend.,Spenden,steuerlich n.abziehbar	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
253	6405	Versicherungen für Gebäude	A	E		0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
254	6420	Beiträge	A	E	AP_amount	0	\N	\N	14	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
255	6400	Versicherungen	A	E	AP_amount	0	13	\N	14	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
256	6430	Sonstige Abgaben	A	E	AP_amount	0	\N	\N	14	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
257	6436	Steuerl.abzugs.Verspätungszuschl.u.Zwangsgelder	A	E		0	\N	\N	31	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
258	6437	Steuerl.n.abzugsf.Verspätungszuschläge u.Zwangsgelder	A	E		0	\N	\N	31	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
259	6440	Ausgleichsabgabe i.S.d.Schwerbehinterdengesetzes	A	E		0	10	\N	10	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
260	6460	Rep.u.Instandhaltungen v.techn.Anlagen u.Maschinen	A	E	AP_amount	9	18	\N	19	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
261	6470	Rep u. Instandh. v. Betr.- u. Geschäftsausstattung	A	E	AP_amount	9	18	\N	19	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
262	6495	Wartungskosten für Hard-u.Software	A	E	AP_amount:IC_expense	9	18	\N	19	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
263	6490	Sonstige Reparaturen u.Instandhalt.	A	E	AP_amount	9	\N	\N	19	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
231	6270	Abschreibungen auf Finanzanlagen (unübl. hoch)	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
246	6330	Reinigung	A	E	AP_amount	9	11	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
264	6498	Mietleasing	A	E	AP_amount	0	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
265	6500	Fahrzeugkosten	A	E	AP_amount	0	\N	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
266	6520	Kfz-Versicherungen	A	E	AP_amount	0	14	\N	16	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
267	6530	Laufende Kfz-Betriebskosten	A	E	AP_amount	9	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
268	6540	Kfz-Reparaturen	A	E	AP_amount	9	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
269	6550	Garagenmiete	A	E	AP_amount	0	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
270	6560	Mietleasing Kfz	A	E	AP_amount	0	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
271	6570	Sonstige Kfz-Kosten	A	E	AP_amount	9	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
273	6590	Fahrzeugkosten f.Kfz,die nicht zum BV gehören	A	E		0	\N	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
274	6595	Fremdfahrzeuge	A	E	AP_amount	0	14	\N	17	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
276	6610	Geschenke bis 35 EUR abzugsfähig	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
277	6620	Geschenke über 35EUR nicht abzugsf.	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
278	6625	Geschenke ausschließl.betrieb.genut	A	E	AP_amount	9	\N	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
279	6630	Repräsentationskosten	A	E	AP_amount	9	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
280	6640	Bewirtungskosten	A	E	AP_amount	9	20	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
281	6643	Aufmerksamkeiten	A	E	AP_amount	9	\N	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
282	6644	Nicht abzugsfähige Bewirtungskosten	A	E	AP_amount	0	\N	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
283	6645	Nicht abzugsf.Betriebsausg.a.Werbe-Repräsentatisonk.etc.	A	E	AP_amount	9	15	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
284	6650	Reisekosten Arbeitnehmer	A	E	AP_amount	9	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
285	6663	Reisekosten Arbeitnehmer, Reisekosten	A	E	AP_amount	8	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
286	6664	Reisekosten Arbeitn.Verpflegungmehr	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
287	6660	Reisekosten Arbeitn.Übernachtungsaufwand	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
288	6668	Kilometerentgelderstattung Arbeitnehmer	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
289	6670	Reisekosten Unternehmer	A	E	AP_amount	9	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
290	6673	Reisekosten Unternehmer, Reisekosten	A	E	AP_amount	8	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
291	6674	Reisekosten Untern.Verpflegungsmehr	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
292	6680	Reisekosten Untern.Übernachtungsauf	A	E	AP_amount	0	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
293	6689	Fahrten zw.Wohn.und Arbeitsstätte (nicht abziehb.Teil)	A	E		0	\N	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
294	6690	Fahrten zw.Wohn.-und Arbeitsstätte (Haben)	A	E		0	\N	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
295	6700	Kosten der Warenabgabe	A	E	AP_amount:IC_cogs	0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
296	6710	Verpackungsmaterial	A	E	AP_amount:IC_cogs	0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
297	6740	Ausgangsfracht	A	E	AP_amount:IC_cogs	0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
298	6760	Transportversicherung	A	E	AP_amount:IC_cogs:IC_expense	0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
299	6770	Verkaufsprovision	A	E	AP_amount:IC_expense	0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
300	6780	Fremdarbeiten (Vertrieb)	A	E	AP_amount:IC_expense	0	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
301	6790	Aufwand für Gewährleistungen	A	E	AP_amount:IC_expense	0	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
302	6800	Porto	A	E	AP_amount	0	20	\N	23	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
303	6805	Telefon	A	E	AP_amount	9	20	\N	23	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
304	6810	Telefax und Internet	A	E	AP_amount	9	20	\N	23	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
305	6815	Bürobedarf	A	E	AP_amount	9	20	\N	23	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
306	6820	Zeitschriften, Bücher	A	E	AP_amount	8	20	\N	20	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
307	6821	Fortbildungskosten	A	E	AP_amount	9	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
308	6822	Freiwillige Sozialleistungen	A	E	AP_amount	0	\N	\N	9	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
309	6825	Rechts- und Beratungskosten	A	E	AP_amount	9	20	\N	22	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
310	6827	Abschluß- und Prüfungskosten	A	E	AP_amount	9	20	\N	22	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
311	6830	Buchführungskosten	A	E	AP_amount	9	\N	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
312	6835	Mieten für Einrichtungen	A	E	AP_amount	9	20	\N	21	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
313	6840	Mietleasing (bewegl. WG)	A	E	AP_amount	9	20	\N	21	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
314	6845	Werkzeuge und Kleingeräte	A	E	AP_amount	9	\N	\N	19	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
315	6850	Betriebsbedarf	A	E	AP_amount	9	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
316	6855	Nebenkosten des Geldverkehrs	A	E		0	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
317	6859	Aufwend.f.Abraum-u.Abfallbeseitigung	A	E	AP_amount	9	20	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
318	6865	Nicht abziehbare Vorsteuer 7%	A	E	AP_paid	0	20	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
319	6870	Nicht abziehbare Vorsteuer 19%	A	E	AP_paid	0	20	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
320	6860	Nicht abziehbare Vorsteuer	A	E		0	31	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
321	6880	Aufwendungen aus Kursdifferenzen	A	E		0	31	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
322	6895	Abgänge Sachanlagen Restbuchwert	A	E		0	31	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
323	6900	Verluste aus Anlagenabgang	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
324	6926	Einstellungen in SoPo m.Rücklageanteil (Ansparabschreibung)	A	E		0	20	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
325	6960	Periodenfremde Aufwend.(soweit n.außerordentlich	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
326	6967	Sonst. Aufwendungen betriebsfremd, regelmäßig	A	E		0	31	\N	24	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
327	6970	Kalkulatorischer Unternehmerlohn	A	E		0	34	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
328	6974	Kalkulatorische Zinsen	A	E		0	34	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
329	6976	Kalkulatorische Aschreibungen	A	E		0	34	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
330	6978	Kalkulatorische Wagnisse	A	E		0	34	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
331	6979	Kalkulatorischer Lohn f.unentgeltl.Mitarbeiter	A	E		0	34	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
332	7000	Erträge aus Beteiligungen	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
333	7100	Sonstige Zinsen und änliche Erträge	A	I		0	32	\N	4	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
334	7120	Zinsähnliche Erträge	A	I		0	32	\N	4	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
335	7130	Diskonterträge	A	I		0	32	\N	4	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
336	7300	Zinsen und ähnl.Aufwendungen	A	E		0	30	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
337	7305	Zinsaufwendung-betriebliche Steuern §223aAO	A	E		0	30	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
338	7310	Zinsaufwendung f. kurzf.Verbindlichk	A	E		0	30	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
339	7320	Zinsaufwendung f. langf.Verbindlichk	A	E		0	30	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
340	7325	Zinsaufwend.f.Gebäude,die z.Betriebsvermögen gehören	A	E		0	\N	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
341	7326	Zinsen zur Finanzierung Anlagevermögen	A	E		0	\N	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
342	7330	Zinsähnliche Aufwendungen	A	E		0	30	\N	29	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
343	7340	Diskontaufwendung	A	E		0	30	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
344	7400	Außerordentliche Erträge	A	I		0	33	\N	5	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
345	7401	Ausserordentliche Erträge finanzwirksam	A	I		0	\N	\N	5	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
346	7450	Ausserordentliche Erträge nicht finanzwirksam	A	I		0	\N	\N	5	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
347	7500	Außerordentliche Aufwendung	A	E		0	31	\N	30	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
348	7600	Körperschaftssteuer	A	E		0	35	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
349	7608	Solidaritätszuschlag	A	E		0	35	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
350	7609	Solidaritätszuschlag für Vorjahr	A	E		0	19	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
351	7610	Gewerbesteuer	A	E		0	12	\N	31	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
352	7632	Kapitalertragssteuer 20%	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
353	7634	Anrechenb.Soli auf Kapitalertragssteuer 20%	A	E		0	35	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
354	7635	Zinsabschlagsteuer	A	E		0	35	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
355	7638	Anrechb.Solidari.zuschlag a.Zinsabschlagst.	A	E		0	35	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
356	7640	Gewerbestnachzahl.Vorj.v.Einkomm u.Ertrag	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
357	7642	Gewerbesterstat.Vorj.Steuer v.Eink.u.Ertrag	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
358	7644	Erträge aus Auflösung v. GewSt.Rückst.	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
359	7650	Sonstige Steuern	A	E		0	12	\N	31	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
361	7678	Ökosteuer	A	E		0	12	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
362	7680	Grundsteuer	A	E		0	19	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
363	7685	Kfz-Steuer	A	E	AP_amount	0	19	\N	15	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
364	7690	Steuernachzahlung Vorj.f.sons.Steue	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
365	7692	Steuererstattung Vorj.f.sons.Steuer	A	I		0	33	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
366	7694	Erträge a.d.Aufl.v. Rück.f.sons.Ste	A	E		0	31	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
367	7745	Entnahmen a.satzungsmäßigen Rücklagen	A	E		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
368	9000	Saldenvorträge,Sachkonten	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
369	9008	Saldenvorträge,Debitoren	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
370	9009	Saldenvorträge,Kreditoren	A	L		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
371	9090	Summenvortragskonto	A	A		0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
28	1401	Abziehbare Vorsteuer 7%	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
29	1402	Abziehbare Vorsteuer aus innergemeinschftl. Erwerb	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
30	1403	Abziehbare Vorsteuer aus innergemeinschftl. Erwerb 16%	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
32	1405	Abziehbare Vorsteuer 16%	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
33	1406	Abziehbare Vorsteuer 19 %	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
34	1407	Abziehbare Vorsteuer nach § 13b UStG 19%	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
35	1408	Abziehbare Vorsteuer nach § 13b UStG	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
71	3836	Umsatzsteuer nach § 13b UStG 16%/19%	A	I		0	33	\N	7	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
88	4330	Erlöse aus im Inland strpfl. EG-Lieferungen 16%/19%	A	I	AR_amount:IC_sale:IC_income	13	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
89	4340	Erlöse 16%/19% USt	A	I	AR_amount:IC_sale:IC_income	5	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
94	4568	Provisionserlöse 16%/19% USt	A	I	AR_amount:IC_income	5	\N	\N	2	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
115	4680	Unentgeltl.Zuw.v Waren 16%/19% Ust	A	I		3	5	\N	3	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
123	4723	Erlösschmälerung 16%/19% USt.	A	I		5	32	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
127	4729	Erlösschmäler. aus im inl. Stpflcht. EG-Lieferungen 16%/19% USt	A	I		0	32	\N	1	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
133	4762	Gewährte Boni 16%/19% USt	A	E	AR_paid	5	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
136	4792	Gewährte Rabatte 16%/19% USt	A	E	AR_paid	5	1	\N	1	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
186	5764	Erhaltene Boni 16%/19% Vorsteuer	A	I	AP_paid	7	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
189	5794	Erhaltene Rabatte 16%/19% Vorsteuer	A	I	AP_paid	7	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
235	6285	Forderungsverluste 16%/19% USt (unübl. hoch)	A	E		5	20	\N	\N	t	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
275	6600	Werbekosten	A	E	AP_amount	9	15	\N	18	f	2012-08-17 12:51:15.918799	2012-08-17 12:52:27.840827	\N	\N
1195	3730	Verbindlichkeiten aus Lohn- und Kirchensteuer	A	L		\N	10	\N	\N	f	2012-08-21 12:01:56.312413	2012-08-21 12:01:56.312413	\N	\N
1196	3740	Verbindlichkeiten im Rahmen der sozialen Sicherheit	A	L		\N	10	\N	\N	f	2012-08-21 12:02:22.192124	2012-08-21 12:02:22.192124	\N	\N
1217	0200	Grundstücke, grundstücksgleiche Rechte und Bauten einschließlich der Bauten auf fremden Grundstücken	A	A	AP_amount	9	\N	\N	\N	f	2012-08-30 12:45:55.766834	2012-08-30 12:45:55.766834	\N	\N
1226	2900	Gezeichnetes Kapital	A	Q		0	\N	\N	\N	f	2012-08-30 13:18:27.659909	2012-08-30 13:18:27.659909	\N	\N
1228	2970	Konzernbilanzgewinn vor Verwendung	A	L		0	\N	\N	\N	f	2012-08-30 13:20:01.136759	2012-08-30 13:20:01.136759	\N	\N
1230	3700	Verbindlichkeiten aus Steuern und Abgaben	A	L		\N	10	\N	\N	f	2012-08-30 13:22:05.497332	2012-08-30 13:22:05.497332	\N	\N
1234	3250	Erhaltene Anzahlungen auf Bestellungen	A	L		0	\N	\N	\N	f	2012-08-30 13:27:12.118217	2012-08-30 13:27:12.118217	\N	\N
45	1800	Geizkasse Mecklenburg-Schwerin	A	A	AR_paid:AP_paid	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-09-12 11:33:14.672331	\N	\N
199	6020	Gehälter	A	E		0	10	\N	9	f	2012-08-17 12:51:15.918799	2012-09-13 14:35:58.199328	\N	\N
56	3310	Verbindlichkeiten aus Lief.u.Leist.	A	L	AP	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-09-13 16:14:54.477917	\N	\N
17	1210	Forderungen aus Lieferungen und Leistungen	A	A	AR	0	\N	\N	\N	f	2012-08-17 12:51:15.918799	2012-09-13 16:15:17.319827	\N	\N
1664	6264	Abschreibungen auf den Sammelposten Wirtschaftsgüter	A	E		0	\N	\N	25	f	2012-09-14 15:32:53.681566	2012-09-14 15:32:53.681566	\N	\N
36	1409	Skontokorrektur Vorsteuer 19 %	A	A	AP_paid:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-10-09 10:10:57.413378	\N	\N
90	4400	Erlöse 19% USt	A	I	AR_amount:IC_sale:IC_income	3	1	\N	1	t	2012-08-17 12:51:15.918799	2012-10-09 11:46:37.193189	\N	\N
66	3806	Umsatzsteuer 19%	A	I	AR_tax:IC_taxpart:IC_taxservice	0	\N	\N	6	f	2012-08-17 12:51:15.918799	2012-10-09 11:46:59.559353	\N	\N
183	5736	Erhaltene Skonti 19% Vorsteuer	A	I	AP_paid	9	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-10-09 13:40:16.149138	\N	\N
170	5425	Innergem.Erwerb 19% VorSt u. Ust	A	E	AP_amount:IC_cogs	19	4	\N	8	t	2012-08-17 12:51:15.918799	2012-10-09 14:28:23.118373	\N	\N
129	4735	Gewährte Skonti 16%/19% USt	A	I	AR_paid	5	1	\N	1	f	2012-08-17 12:51:15.918799	2012-11-15 16:39:19.170385	\N	\N
31	1404	Abziehbare Vorsteuer aus innergemeinschftl. Erwerb 19%	A	E	AP_tax:IC_taxpart:IC_taxservice	0	\N	\N	27	f	2012-08-17 12:51:15.918799	2012-10-09 14:40:22.506405	\N	\N
64	3804	Umsatzsteuer aus innergemeinschftl. Erwerb 19%	A	I	AR_tax:IC_taxpart:IC_taxservice	0	\N	\N	28	f	2012-08-17 12:51:15.918799	2012-10-09 14:40:38.147161	\N	\N
1855	1495	Verrechnungskonto geleistete Anzahlungen	A	Q	AR_paid	\N	\N	\N	\N	f	2012-10-09 15:29:33.019979	2012-10-09 15:29:33.019979	\N	\N
130	4736	Gewährte Skonti 19% USt	A	I	AR_paid	3	1	\N	1	f	2012-08-17 12:51:15.918799	2012-11-15 16:39:19.170385	\N	\N
181	5731	Erhaltene Skonti 7% Vorsteuer	A	E	AP_paid	8	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-11-15 16:39:19.170385	\N	\N
182	5735	Erhaltene Skonti 16%/19% Vorsteuer	A	E	AP_paid	7	4	\N	\N	t	2012-08-17 12:51:15.918799	2012-11-15 16:39:19.170385	\N	\N
\.


--
-- Data for Name: contacts; Type: TABLE DATA; Schema: public; Owner: -
--

COPY contacts (cp_id, cp_cv_id, cp_title, cp_givenname, cp_name, cp_email, cp_phone1, cp_phone2, itime, mtime, cp_fax, cp_mobile1, cp_mobile2, cp_satphone, cp_satfax, cp_project, cp_privatphone, cp_privatemail, cp_abteilung, cp_gender, cp_street, cp_zipcode, cp_city, cp_birthday, cp_position) FROM stdin;
\.


--
-- Data for Name: csv_import_profile_settings; Type: TABLE DATA; Schema: public; Owner: -
--

COPY csv_import_profile_settings (id, csv_import_profile_id, key, value) FROM stdin;
\.


--
-- Data for Name: csv_import_profiles; Type: TABLE DATA; Schema: public; Owner: -
--

COPY csv_import_profiles (id, name, type, is_default, login) FROM stdin;
\.


--
-- Data for Name: csv_import_report_rows; Type: TABLE DATA; Schema: public; Owner: -
--

COPY csv_import_report_rows (id, csv_import_report_id, col, "row", value) FROM stdin;
\.


--
-- Data for Name: csv_import_report_status; Type: TABLE DATA; Schema: public; Owner: -
--

COPY csv_import_report_status (id, csv_import_report_id, "row", type, value) FROM stdin;
\.


--
-- Data for Name: csv_import_reports; Type: TABLE DATA; Schema: public; Owner: -
--

COPY csv_import_reports (id, session_id, profile_id, type, file, numrows, numheaders) FROM stdin;
\.


--
-- Data for Name: currencies; Type: TABLE DATA; Schema: public; Owner: -
--

COPY currencies (id, name) FROM stdin;
1	EUR
2	USD
\.


--
-- Data for Name: custom_variable_configs; Type: TABLE DATA; Schema: public; Owner: -
--

COPY custom_variable_configs (id, name, description, type, module, default_value, options, searchable, includeable, included_by_default, sortkey, itime, mtime, flags) FROM stdin;
\.


--
-- Data for Name: custom_variables; Type: TABLE DATA; Schema: public; Owner: -
--

COPY custom_variables (id, config_id, trans_id, bool_value, timestamp_value, text_value, number_value, itime, mtime, sub_module) FROM stdin;
\.


--
-- Data for Name: custom_variables_validity; Type: TABLE DATA; Schema: public; Owner: -
--

COPY custom_variables_validity (id, config_id, trans_id, itime) FROM stdin;
\.


--
-- Data for Name: customer; Type: TABLE DATA; Schema: public; Owner: -
--

COPY customer (id, name, department_1, department_2, street, zipcode, city, country, contact, phone, fax, homepage, email, notes, discount, taxincluded, creditlimit, terms, customernumber, cc, bcc, business_id, taxnumber, account_number, bank_code, bank, language, itime, mtime, obsolete, username, user_password, salesman_id, c_vendor_id, klass, language_id, payment_id, taxzone_id, greeting, ustid, iban, bic, direct_debit, taxincluded_checked, depositor, mandator_id, mandate_date_of_signature, delivery_term_id, currency_id) FROM stdin;
1037	OIDA Cruises German Branch of Costa Crociere S.p.A.			OIDA-Str. 1-10	18001	Rostock	Germany	Herr Michael Augerer	0381 223556786	0381 223556785	oida.de	info@oida.de		0	\N	0.00000	\N	10000	\N		\N					\N	2012-08-20 10:30:46.103522	2014-03-03 15:32:20.898927	f			\N		0	\N	\N	0					f	\N	OIDA Cruises German Branch of Costa Crociere S.p.A.	\N	\N	\N	1
1754	Bootsbau Schumann GmbH			Fischerbruch 50	18055	Rostock	Germany	Herr Robert Schumann	0351 56444648168	0351 56444648169	http://bootservice.de	r.schumann@bootservice.de		0	\N	0.00000	\N	10001	\N		1872					\N	2012-09-21 15:11:10.486087	2014-03-03 15:32:20.898927	f			\N		0	\N	\N	0					f	\N	Bootsbau Schumann GmbH	\N	\N	\N	1
\.


--
-- Data for Name: datev; Type: TABLE DATA; Schema: public; Owner: -
--

COPY datev (beraternr, beratername, mandantennr, dfvkz, datentraegernr, abrechnungsnr, itime, mtime, id) FROM stdin;
						2012-10-09 16:37:14.19187	\N	27
\.


--
-- Data for Name: defaults; Type: TABLE DATA; Schema: public; Owner: -
--

COPY defaults (inventory_accno_id, income_accno_id, expense_accno_id, fxgain_accno_id, fxloss_accno_id, invnumber, sonumber, weightunit, businessnumber, version, closedto, revtrans, ponumber, sqnumber, rfqnumber, customernumber, vendornumber, articlenumber, servicenumber, coa, itime, mtime, rmanumber, cnnumber, accounting_method, inventory_system, profit_determination, dunning_ar_amount_fee, dunning_ar_amount_interest, dunning_ar, pdonumber, sdonumber, ar_paid_accno_id, id, language_id, datev_check_on_sales_invoice, datev_check_on_purchase_invoice, datev_check_on_ar_transaction, datev_check_on_ap_transaction, datev_check_on_gl_transaction, payments_changeable, is_changeable, ir_changeable, ar_changeable, ap_changeable, gl_changeable, show_bestbefore, sales_order_show_delete, purchase_order_show_delete, sales_delivery_order_show_delete, purchase_delivery_order_show_delete, is_show_mark_as_paid, ir_show_mark_as_paid, ar_show_mark_as_paid, ap_show_mark_as_paid, warehouse_id, bin_id, company, address, taxnumber, co_ustid, duns, sepa_creditor_id, templates, max_future_booking_interval, webdav, webdav_documents, vertreter, parts_show_image, parts_listing_image, parts_image_css, normalize_vc_names, normalize_part_descriptions, assemblynumber, show_weight, transfer_default, transfer_default_use_master_default_bin, transfer_default_ignore_onhand, warehouse_id_ignore_onhand, bin_id_ignore_onhand, balance_startdate_method, currency_id, signature) FROM stdin;
15	76	167	142	321	16	2	kg		2.4.0.0	\N	f					2	1		Germany-DATEV-SKR04EU	2012-08-17 12:51:06.622761	\N	\N		accrual	periodic	balance	\N	\N	\N	0	2	44	1	\N	t	t	t	t	t	1	2	2	2	2	2	f	t	t	t	t	t	t	t	t	\N	\N							templates/steigmann	360	f	f	f	t	f	border:0;float:left;max-width:250px;margin-top:20px:margin-right:10px;margin-left:10px;	t	t		f	t	f	f	\N	\N	closed_to	1	
\.


--
-- Data for Name: delivery_order_items; Type: TABLE DATA; Schema: public; Owner: -
--

COPY delivery_order_items (id, delivery_order_id, parts_id, description, qty, sellprice, discount, project_id, reqdate, serialnumber, ordnumber, transdate, cusordnumber, unit, base_qty, longdescription, lastcost, price_factor_id, price_factor, marge_price_factor, itime, mtime, pricegroup_id) WITH OIDS FROM stdin;
330249	1	1412	1093	Schiffbaustahl 2HGr50 (Qualitätstechnik)	4500.00000	500.00000	0	1020	\N		201202	04.01.2012		t	4500	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	0.00000	\N	\N	\N	2012-09-12 11:44:32.579899	\N	\N
330250	2	1419	1137	Rohrleitungen	200.00000	7000.00000	0	1020	\N		201203	04.01.2012		km	200	vorgefertigte Rohrleitungen	0.00000	\N	\N	\N	2012-09-12 11:48:47.582506	\N	\N
330251	3	1434	1142	Elektronik-Pack OIDA/Igel	1.00000	980000.00000	0	1020	\N		201204	23.04.2012		Stck	1	Eigen in Auftrag gegebenes Produktpaket aus Kabelschächten, -führungen, Stecker und -leisten	0.00000	\N	\N	\N	2012-09-12 11:52:49.302474	\N	\N
330252	8	1441	1107	Fernmelde-Schiffskabel FMKHC	280.00000	1020.00000	0	\N	\N		201205	23.04.2012		km	280	Halogen geben, feuerbeständiges Marinekommunikationskabel mit screend Standard	0.00000	\N	\N	\N	2012-09-12 11:57:58.521146	\N	\N
330253	9	1441	1100	Kabel und Leitungen H03VV-F	550.00000	400.00000	0	\N	\N		201205	23.04.2012		km	550000	H03VV-F 3x0,75 - Leichte PVC-Schlauchleitung\r\nfeindrähtig, Ring 50 Meter\r\nFarbe: schwarz\r\nNach DIN VDE 0281\r\n	0.00000	\N	\N	\N	2012-09-12 11:57:58.521146	\N	\N
330254	10	1441	1103	Kabel und Leitungen SiHF-J	530.00000	2400.00000	0	\N	\N		201205	23.04.2012		km	530	feindrähtiger Kupferlitzenleiter verzinnt, Farbe: rot-braun, Flammwidrig nach VDE 0472 Teil 804 Prüfart C	0.00000	\N	\N	\N	2012-09-12 11:57:58.521146	\N	\N
330255	11	1441	1105	Starkstrom-Schiffskabel MPRXCX 	180.00000	5000.00000	0	\N	\N		201205	23.04.2012		km	180	Cu-Litze blank, Verlitzung nach Klasse 2\r\nIsolation aus vernetztem XLPE\r\nAußenmantel Polyolefin, Farbe Schwarz	0.00000	\N	\N	\N	2012-09-12 11:57:58.521146	\N	\N
330256	12	1459	1111	Dieselmotor 9M43D	4.00000	5000000.00000	0	1020	\N		201206	07.05.2012		Stck	4	9.000 kW (12237 PS)	0.00000	\N	\N	\N	2012-09-12 12:09:40.663072	\N	\N
330257	13	1476	1133	SRP Propeller	2.00000	680000.00000	0	1020	\N		201207	24.05.2012		Stck	2	5-Blatt-Festpropeller, Balance-Ruder	0.00000	\N	\N	\N	2012-09-12 12:15:45.170959	\N	\N
330258	14	1476	1135	SST Steuer und Regelsystem	1.00000	520000.00000	0	1020	\N		201207	24.05.2012		Stck	1	computerunterstütztes, ferngesteuertes Joystick-System	0.00000	\N	\N	\N	2012-09-12 12:15:45.170959	\N	\N
330259	15	1484	1098	Elektrischer Propellermotor S-12/5	2.00000	8000000.00000	0	\N	\N		201208	07.05.2012		Stck	2	12,5 MW; Wellenanlage\r\nMaschinenleistung: 12.500 kW (16996 PS)	0.00000	\N	\N	\N	2012-09-12 12:16:02.876219	\N	\N
330260	16	1494	1093	Schiffbaustahl 2HGr50 (Qualitätstechnik)	12000.00000	420.17000	0	1020	\N		201202-02	04.01.2012		t	12000	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	0.00000	\N	\N	\N	2012-09-12 12:33:07.170286	\N	\N
330261	17	1503	1183	Lautsprecheranlage	1.00000	80000.00000	0	1020	\N		201209	01.06.2012		Stck	1		0.00000	\N	\N	\N	2012-09-12 12:39:22.659153	\N	\N
330262	18	1503	1180	SecuritySystem	1.00000	150000.00000	0	1020	\N		201209	01.06.2012		Stck	1	Alarmanlagen, Messsensoren, Videoüberwachungsanlage	0.00000	\N	\N	\N	2012-09-12 12:39:22.659153	\N	\N
330263	19	1512	1404	Anker	1.00000	70000.00000	0	1020	\N		201211	02.07.2012		Stck	1		0.00000	\N	\N	\N	2012-09-12 12:49:24.103479	\N	\N
330264	20	1525	1174	Paket Schiffsinnenbau "Kule"	1.00000	1000000.00000	0	\N	\N		201213	06.08.2012		psch	1	Feuerschutztüren, Schichtstoffplatten HPL, Furniere MIneralwerkstoff, Wand- und Deckenpaneel	0.00000	\N	\N	\N	2012-09-12 14:06:01.064826	\N	\N
330265	21	1529	1144	Ultimate Mineralwolle	330000.00000	2.90000	0	1020	\N		201214	06.08.2012		m²	330000	Hochleistungsdämmstoff für Wärme- und Schalldämmung	0.00000	\N	\N	\N	2012-09-12 14:07:21.77179	\N	\N
330266	22	1540	1117	Siloblau Fassade AE 1730	29.00000	7940.00000	0	1020	\N		201215	03.09.2012		t	29	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	0.00000	\N	\N	\N	2012-09-12 14:14:57.960114	\N	\N
330267	23	1540	1123	Silogelb Fassade AF 2550	9.00000	7940.00000	0	1020	\N		201215	03.09.2012		t	9	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	0.00000	\N	\N	\N	2012-09-12 14:14:57.960114	\N	\N
330268	24	1540	1119	Silorot Fassade AF 2550	4.00000	7940.00000	0	1020	\N		201215	03.09.2012		t	4	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	0.00000	\N	\N	\N	2012-09-12 14:14:57.960114	\N	\N
330269	25	1540	1121	Siloschwarz fassade A0 000	4.00000	7940.00000	0	1020	\N		201215	03.09.2012		t	4	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	0.00000	\N	\N	\N	2012-09-12 14:14:57.960114	\N	\N
330270	26	1540	1115	Siloweiß Fassade AF 5040	145.00000	5300.00000	0	1020	\N		201215	03.09.2012		t	145	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	0.00000	\N	\N	\N	2012-09-12 14:14:57.960114	\N	\N
330271	27	1572	1147	Palme	70.00000	250.50000	0	\N	\N		201222	15.11.2012		Stck	70	blaue Hesperidenpalme, stabilisiert	0.00000	\N	\N	\N	2012-09-12 14:43:11.233866	\N	\N
330272	28	1572	1149	Zypresse	65.00000	105.00000	0	\N	\N		201222	15.11.2012		Stck	65	stabilisiert	0.00000	\N	\N	\N	2012-09-12 14:43:11.233866	\N	\N
330273	29	1572	1152	Hecke	260.00000	3.60000	0	\N	\N		201222	15.11.2012		m²	260	stabilisiert	0.00000	\N	\N	\N	2012-09-12 14:43:11.233866	\N	\N
330274	30	1586	1581	Rettungsboot	12.00000	150000.00000	0	\N	\N		201203-01	11.04.2012		Stck	12		0.00000	\N	\N	\N	2012-09-12 14:54:45.296188	\N	\N
330275	31	1746	1742	Anti-Piracy SystemXT 4000	1.00000	650000.00000	0	\N	\N		201210-1	18.05.2012		Stck	1		0.00000	\N	\N	\N	2012-09-21 14:35:56.192082	\N	\N
330277	35	1896	1888	Musterartikel 1	3.00000	100.00000	0	\N	\N			\N		Stck	3		50.00000	\N	\N	\N	2012-11-15 14:48:22.162861	\N	\N
330276	32	1881	1752	Vermietung Baudock A1	1.00000	20000.00000	0.1	\N	\N		1	15.11.2012		Monat	1		0.00000	\N	\N	\N	2012-11-15 14:31:04.146554	2014-03-03 15:32:20.114896	\N
\.


--
-- Data for Name: delivery_order_items_stock; Type: TABLE DATA; Schema: public; Owner: -
--

COPY delivery_order_items_stock (id, delivery_order_item_id, qty, unit, warehouse_id, bin_id, chargenumber, itime, mtime, bestbefore) FROM stdin;
1413	1	4500.00000	t	956	957		2012-09-12 11:44:32.579899	\N	\N
1420	2	40.00000	km	969	980		2012-09-12 11:48:47.582506	\N	\N
1421	2	40.00000	km	969	981		2012-09-12 11:48:47.582506	\N	\N
1422	2	40.00000	km	969	982		2012-09-12 11:48:47.582506	\N	\N
1423	2	40.00000	km	969	983		2012-09-12 11:48:47.582506	\N	\N
1424	2	40.00000	km	969	984		2012-09-12 11:48:47.582506	\N	\N
1435	3	1.00000	Stck	969	985		2012-09-12 11:52:49.302474	\N	\N
1447	8	280.00000	km	969	971		2012-09-12 11:57:58.521146	\N	\N
1448	9	550.00000	km	969	970		2012-09-12 11:57:58.521146	\N	\N
1449	10	530.00000	km	969	972		2012-09-12 11:57:58.521146	\N	\N
1450	11	180.00000	km	969	973		2012-09-12 11:57:58.521146	\N	\N
1460	12	1.00000	Stck	958	959		2012-09-12 12:09:40.663072	\N	\N
1461	12	1.00000	Stck	958	960		2012-09-12 12:09:40.663072	\N	\N
1462	12	1.00000	Stck	958	961		2012-09-12 12:09:40.663072	\N	\N
1463	12	1.00000	Stck	958	962		2012-09-12 12:09:40.663072	\N	\N
1477	13	1.00000	Stck	969	986		2012-09-12 12:15:45.170959	\N	\N
1478	13	1.00000	Stck	969	987		2012-09-12 12:15:45.170959	\N	\N
1479	14	1.00000	Stck	969	988		2012-09-12 12:15:45.170959	\N	\N
1485	15	1.00000	Stck	958	963		2012-09-12 12:16:02.876219	\N	\N
1486	15	1.00000	Stck	958	964		2012-09-12 12:16:02.876219	\N	\N
1495	16	12000.00000	t	956	957		2012-09-12 12:33:07.170286	\N	\N
1504	17	1.00000	Stck	969	989		2012-09-12 12:39:22.659153	\N	\N
1505	18	1.00000	Stck	969	990		2012-09-12 12:39:22.659153	\N	\N
1513	19	1.00000	Stck	969	991		2012-09-12 12:49:24.103479	\N	\N
1526	20	1.00000	psch	969	992		2012-09-12 14:06:01.064826	\N	\N
1530	21	330000.00000	m²	969	974		2012-09-12 14:07:21.77179	\N	\N
1541	22	29.00000	t	969	977		2012-09-12 14:14:57.960114	\N	\N
1542	23	9.00000	t	969	979		2012-09-12 14:14:57.960114	\N	\N
1543	24	4.00000	t	969	976		2012-09-12 14:14:57.960114	\N	\N
1544	25	4.00000	t	969	978		2012-09-12 14:14:57.960114	\N	\N
1545	26	145.00000	t	969	975		2012-09-12 14:14:57.960114	\N	\N
1573	27	70.00000	Stck	969	993		2012-09-12 14:43:11.233866	\N	\N
1574	28	65.00000	Stck	969	994		2012-09-12 14:43:11.233866	\N	\N
1575	29	260.00000	m²	969	995		2012-09-12 14:43:11.233866	\N	\N
1587	30	6.00000	Stck	969	996		2012-09-12 14:54:45.296188	\N	\N
1588	30	6.00000	Stck	969	997		2012-09-12 14:54:45.296188	\N	\N
1747	31	1.00000	Stck	969	998		2012-09-21 14:35:56.192082	\N	\N
1900	35	3.00000	Stck	958	959		2012-11-15 14:48:22.162861	\N	\N
\.


--
-- Data for Name: delivery_orders; Type: TABLE DATA; Schema: public; Owner: -
--

COPY delivery_orders (id, donumber, ordnumber, transdate, vendor_id, customer_id, reqdate, shippingpoint, notes, intnotes, employee_id, closed, delivered, cusordnumber, oreqnumber, department_id, shipvia, cp_id, language_id, shipto_id, globalproject_id, salesman_id, transaction_description, is_sales, itime, mtime, taxzone_id, taxincluded, terms, delivery_term_id, currency_id) FROM stdin;
1412	kr20120113	201202	2012-01-13	1024	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 11:44:32.579899	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1419	R203913	201203	2012-01-13	1076	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 11:48:47.582506	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1434	i784363	201204	2012-05-01	1139	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 11:52:49.302474	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1441	KBL49384	201205	2012-05-01	1030	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 11:57:39.670908	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1459	dog13498	201206	2012-05-14	1032	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 12:09:40.663072	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1476	PSR4352	201207	2012-05-14	1074	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 12:15:45.170959	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1484	siemann213	201208	2012-05-14	1022	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 12:16:02.876219	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1494	KS3245549	201202-02	2012-01-13	1028	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 12:33:07.170286	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1503	B123St	201209	2012-06-11	1078	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 12:39:22.659153	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1512	nsoy2314	201211	2012-07-09	1401	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 12:49:24.103479	2014-03-03 15:32:20.898927	1	f	\N	\N	1
1525	Kule14314	201213	2012-08-13	1050	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 14:06:01.064826	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1529	UM58490578	201214	2012-08-13	1082	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 14:07:21.77179	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1540	PH34287	201215	2012-09-10	1062	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 14:14:57.960114	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1572	fkidsg93	201222	2012-11-30	1085	\N	\N				938	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 14:43:11.233866	2014-03-03 15:32:20.898927	0	t	\N	\N	1
1586	RB594573	201203-01	2012-09-12	1401	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-12 14:54:45.296188	2014-03-03 15:32:20.898927	1	f	\N	\N	1
1746	APSXT400012	201210-1	2012-06-01	1397	\N	\N				1213	t	t		\N	\N		\N	\N	\N	1020	\N		f	2012-09-21 14:35:56.192082	2014-03-03 15:32:20.898927	3	f	\N	\N	2
1881	1	1	2012-11-15	\N	1754	2012-11-16				1871	t	f		\N	\N		\N	\N	\N	\N	1871		t	2012-11-15 14:31:04.146554	2014-03-03 15:32:20.898927	0	f	\N	\N	1
1896	2		2012-11-15	\N	1754	2012-11-15				1871	f	t		\N	\N		\N	\N	\N	\N	1871		t	2012-11-15 14:47:29.992218	2014-03-03 15:32:20.898927	0	f	\N	\N	1
\.


--
-- Data for Name: delivery_terms; Type: TABLE DATA; Schema: public; Owner: -
--

COPY delivery_terms (id, description, description_long, sortkey, itime, mtime) FROM stdin;
\.


--
-- Data for Name: department; Type: TABLE DATA; Schema: public; Owner: -
--

COPY department (id, description, itime, mtime) FROM stdin;
\.


--
-- Data for Name: drafts; Type: TABLE DATA; Schema: public; Owner: -
--

COPY drafts (id, module, submodule, description, itime, form, employee_id) FROM stdin;
gl-unknown-1345546759-230912-3243	gl	unknown	monatlich_Leasingrate	2012-08-21 12:59:19.204476	--- !!perl/hash:Form\naccno_1: 6560--0\naccno_2: 1800--0\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '40.750,00'\ncredit_3: ''\ndebit_1: '40.750,00'\ndebit_2: ''\ndebit_3: ''\ndescription: Leasingrate\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 6560--0\nprevious_accno_2: 1800--0\nprevious_accno_3: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: Leasingrate\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: '6.506,30'\ntax_2: ''\ntax_3: ''\ntaxchart_1: 389--0.19000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345550440-248165-4729	gl	unknown	monatlich_Reinigung	2012-08-21 14:00:40.228662	--- !!perl/hash:Form\naccno_1: 6330--389\naccno_2: 1800--0\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '768,00'\ncredit_3: ''\ndebit_1: '768,00'\ndebit_2: ''\ndebit_3: ''\ndescription: Reinigung\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 6330--389\nprevious_accno_2: 1800--0\nprevious_accno_3: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: Reinigung\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: '122,62'\ntax_2: ''\ntax_3: ''\ntaxchart_1: 389--0.19000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345550853-126295-4729	gl	unknown	monatlich_Telefon	2012-08-21 14:07:33.098236	--- !!perl/hash:Form\naccno_1: 6805--389\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: 930\ndebit_1: 930\ndebit_2: ''\ndescription: Telefon\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nreference: Telefon\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 389--0.19000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345546514-360847-3243	gl	unknown	monatlich_Abführung_Finanzamt_Personal	2012-08-21 12:55:14.330805	--- !!perl/hash:Form\naccno_1: 3730--\naccno_2: 3740--\naccno_3: 1800--0\naccno_4: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: ''\ncredit_3: '2.732.208,00'\ncredit_4: ''\ndebit_1: '1.103.208,00'\ndebit_2: '1.629.000,00'\ndebit_3: ''\ndebit_4: ''\ndescription: AbführungFinanzamtPersonal\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nmemo_4: ''\nprevious_accno_1: 3730--\nprevious_accno_2: 3740--\nprevious_accno_3: 1800--0\nprevious_accno_4: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nproject_id_4: ''\nreference: AbführungFinanzamtPersonal\nrowcount: 4\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nsource_4: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntax_3: ''\ntax_4: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxchart_3: 0--0.00000\ntaxchart_4: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345545806-159391-3243	gl	unknown	monatlich_Abführung_Krankenkasse_Personal	2012-08-21 12:43:26.121137	--- !!perl/hash:Form\naccno_1: 3740--\naccno_2: 1800--0\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '810.000,00'\ncredit_3: ''\ndebit_1: '810.000,00'\ndebit_2: ''\ndebit_3: ''\ndescription: AbführungKrankenkassePersonal\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 3740--\nprevious_accno_2: 1800--0\nprevious_accno_3: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: AbführungKrankenkassePersonal\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntax_3: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345553569-841234-4729	gl	unknown	monatlich_GEZ	2012-08-21 14:52:49.822202	--- !!perl/hash:Form\naccno_1: 6300--389\naccno_2: 1800--0\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '57,17'\ncredit_3: ''\ndebit_1: '57,17'\ndebit_2: ''\ndebit_3: ''\ndescription: GEZ\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 6300--389\nprevious_accno_2: 1800--0\nprevious_accno_3: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: GEZ\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: '9,13'\ntax_2: ''\ntax_3: ''\ntaxchart_1: 389--0.19000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346316411-641428-2688	gl	unknown	jährlich_Abo_neue_Schiffswelt	2012-08-30 10:46:51.627004	--- !!perl/hash:Form\naccno_1: 6820--377\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '122,95'\ndebit_1: '122,95'\ndebit_2: ''\ndescription: ZeitungsAbo\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nreference: ZeitungsAbo\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 377--0.07000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 30.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346316222-859889-2688	gl	unknown	jährlich_Kfz-Steuer	2012-08-30 10:43:42.825357	--- !!perl/hash:Form\naccno_1: 7685--0\naccno_2: 1800--0\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '13.700,00'\ncredit_3: ''\ndebit_1: '13.700,00'\ndebit_2: ''\ndebit_3: ''\ndescription: Kfz-Steuer\ndraft_description: jährlich_Kfz-Steuer\ndraft_id: gl-unknown-1346316222-859889-2688\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 7685--0\nprevious_accno_2: 1800--0\nprevious_accno_3: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: Kfz-Steuer\nremove_draft: 1\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntax_3: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 30.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346316576-640868-2688	gl	unknown	monatlich_Heizung	2012-08-30 10:49:36.622368	--- !!perl/hash:Form\naccno_1: 6320--389\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: 6900\ndebit_1: 6900\ndebit_2: ''\ndescription: Heizung\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nreference: Heizung\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 389--0.19000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 30.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346316712-822026-2688	gl	unknown	monatlich_Gas,Wasser,Strom	2012-08-30 10:51:52.800345	--- !!perl/hash:Form\naccno_1: 6325--389\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: 19760\ndebit_1: 19760\ndebit_2: ''\ndescription: 'Gas, Wasser, Strom'\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nreference: 'Gas, Wasser, Strom'\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 389--0.19000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 30.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346316890-573277-2688	gl	unknown	jährlich_Versicherungen	2012-08-30 10:54:50.540738	--- !!perl/hash:Form\naccno_1: 6400--0\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: 99500\ndebit_1: 99500\ndebit_2: ''\ndescription: Versicherungen\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nreference: Versicherungen\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 30.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346317099-671297-2688	gl	unknown	jährlich_Grundsteuer	2012-08-30 10:58:19.641037	--- !!perl/hash:Form\naccno_1: 7680--0\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '19999,99'\ndebit_1: '19999,99'\ndebit_2: ''\ndescription: Grundsteuer\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nreference: Grundsteuer\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 30.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345543789-39447-3243	gl	unknown	monatlich_GehälterA	2012-08-21 12:09:49.016449	--- !!perl/hash:Form\naccno_1: 6020--0\naccno_2: 1800--0\naccno_3: 3730--\naccno_4: 3740--\naccno_5: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '3.711.792,00'\ncredit_3: '1.103.208,00'\ncredit_4: '1.185.000,00'\ncredit_5: ''\ndebit_1: '6.000.000,00'\ndebit_2: ''\ndebit_3: ''\ndebit_4: ''\ndebit_5: ''\ndescription: GehälterA\ndraft_description: monatlich_GehälterA\ndraft_id: gl-unknown-1345543789-39447-3243\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nmemo_4: ''\nmemo_5: ''\nprevious_accno_1: 6020--0\nprevious_accno_2: 1800--0\nprevious_accno_3: 3730--\nprevious_accno_4: 3740--\nprevious_accno_5: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nproject_id_4: ''\nproject_id_5: ''\nreference: GehälterA\nrowcount: 5\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nsource_4: ''\nsource_5: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntax_3: ''\ntax_4: ''\ntax_5: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxchart_3: 0--0.00000\ntaxchart_4: 0--0.00000\ntaxchart_5: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1345544124-890835-3243	gl	unknown	monatlich_GehälterB	2012-08-21 12:15:24.855203	--- !!perl/hash:Form\naccno_1: 6110--0\naccno_2: 3740--\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '1.254.000,00'\ncredit_3: ''\ndebit_1: '1.254.000,00'\ndebit_2: ''\ndebit_3: ''\ndescription: GehälterMitarbeiterB\ndraft_description: monatlich_GehälterB\ndraft_id: gl-unknown-1345544124-890835-3243\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 6110--0\nprevious_accno_2: 3740--\nprevious_accno_3: --\nprevious_gldate: --\nprevious_id: --\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: GehälterMitarbeiterB\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntax_3: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 21.08.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346668317-215015-3466	gl	unknown	vierteljährlich_Gewerbesteuer	2012-09-03 12:31:57.183426	--- !!perl/hash:Form\naccno_1: 7610--0\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: 315000\ndebit_1: 315000\ndebit_2: ''\ndescription: Gewerbesteuervorauszahlung\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: 30.08.2012\nprevious_id: 109\nproject_id_1: ''\nproject_id_2: ''\nreference: Gewerbesteuervorauszahlung 1.Quartal\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 03.01.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346668194-900145-3466	gl	unknown	vierteljährlich_Grundsteuer	2012-09-03 12:29:54.868771	--- !!perl/hash:Form\naccno_1: 7680--0\naccno_2: 1800--0\naccno_3: 0135--389\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '54.500,00'\ncredit_3: ''\ndebit_1: '54.500,00'\ndebit_2: ''\ndebit_3: ''\ndescription: Grundsteuer\ndraft_description: vierteljährlich_Grundsteuer\ndraft_id: gl-unknown-1346668194-900145-3466\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nmemo_3: ''\nprevious_accno_1: 7680--0\nprevious_accno_2: 1800--0\nprevious_accno_3: --\nprevious_gldate: 30.08.2012\nprevious_id: 109\nproject_id_1: ''\nproject_id_2: ''\nproject_id_3: ''\nreference: Grundsteuer 1.Quartal\nremove_draft: 1\nrowcount: 3\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nsource_3: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntax_3: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxchart_3: 389--0.19000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 03.01.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1346668787-388218-3466	gl	unknown	vierteljährlich_Körperschaftssteuer	2012-09-03 12:39:47.365	--- !!perl/hash:Form\naccno_1: 7600--0\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: 4725000\ndebit_1: 4725000\ndebit_2: ''\ndescription: Körperschaftssteuer\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: 30.08.2012\nprevious_id: 109\nproject_id_1: ''\nproject_id_2: ''\nreference: Körperschaftssteuer 1.Quartal\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 03.01.2012\nversion: 2.7.1-unstable\n	938
gl-unknown-1347882808-781107-9329	gl	unknown	monatlich_Bankgebühren	2012-09-17 13:53:28.739326	--- !!perl/hash:Form\naccno_1: 6855--0\naccno_2: 1800--0\ncallback: gl.pl?action=add\ncharset: ~\nclosedto: ''\ncredit_1: ''\ncredit_2: '58,30'\ndebit_1: '58,30'\ndebit_2: ''\ndescription: Bankgebühren\ndraft_description: ''\ndraft_id: ''\nfollow_up_rowcount: 1\nfollow_up_trans_id_1: ''\nfollow_up_trans_info_1: ''\nfollow_up_trans_type_1: gl_transaction\nid: ''\nlocked: ''\nmemo_1: ''\nmemo_2: ''\nprevious_accno_1: --\nprevious_accno_2: --\nprevious_gldate: 17.09.2012\nprevious_id: 188\nproject_id_1: ''\nproject_id_2: ''\nreference: Bankgebühren Januar\nrowcount: 2\nscript: gl.pl\nselectaccno: ''\nsource_1: ''\nsource_2: ''\nstorno: ''\nstorno_id: ''\ntax_1: ''\ntax_2: ''\ntaxchart_1: 0--0.00000\ntaxchart_2: 0--0.00000\ntaxincluded: 1\ntitle: Add\ntitlebar: 'kivitendo Version 2.7.1-unstable- martin- steigmann'\ntransdate: 06.01.2012\nversion: 2.7.1-unstable\n	938
\.


--
-- Data for Name: dunning; Type: TABLE DATA; Schema: public; Owner: -
--

COPY dunning (id, trans_id, dunning_id, dunning_level, transdate, duedate, fee, interest, dunning_config_id, itime, mtime, fee_interest_ar_id) FROM stdin;
\.


--
-- Data for Name: dunning_config; Type: TABLE DATA; Schema: public; Owner: -
--

COPY dunning_config (id, dunning_level, dunning_description, active, auto, email, terms, payment_terms, fee, interest_rate, email_body, email_subject, email_attachment, template, create_invoices_for_fees) FROM stdin;
\.


--
-- Data for Name: employee; Type: TABLE DATA; Schema: public; Owner: -
--

COPY employee (id, login, startdate, enddate, sales, itime, mtime, name, deleted, deleted_email, deleted_signature, deleted_tel, deleted_fax) FROM stdin;
1213	timo	2012-08-30	\N	t	2012-08-30 11:35:52.424593	\N	Timo	f	\N	\N	\N	\N
938	martin	2012-08-17	\N	t	2012-08-17 12:51:34.568508	\N	martin	f	\N	\N	\N	\N
1473	geoff	2012-09-12	\N	t	2012-09-12 12:14:24.802298	\N	Geoffrey	f	\N	\N	\N	\N
1871	steigmann	2012-11-11	\N	t	2012-11-11 16:38:29.957028	\N	Senior Steigmann	f	\N	\N	\N	\N
1914	demo	2014-03-03	\N	t	2014-03-03 15:32:21.564901	\N		f	\N	\N	\N	\N
\.


--
-- Data for Name: exchangerate; Type: TABLE DATA; Schema: public; Owner: -
--

COPY exchangerate (transdate, buy, sell, itime, mtime, id, currency_id) FROM stdin;
2012-05-18	\N	0.78360	2012-09-21 14:34:23.851411	\N	2	2
2012-06-01	\N	0.80420	2012-09-12 12:38:12.195981	\N	1	2
2012-06-08	\N	0.79900	2012-09-21 14:43:12.462592	\N	7	2
2012-06-11	\N	0.79900	2012-09-21 14:45:39.960356	\N	8	2
\.


--
-- Data for Name: finanzamt; Type: TABLE DATA; Schema: public; Owner: -
--

COPY finanzamt (fa_land_nr, fa_bufa_nr, fa_name, fa_strasse, fa_plz, fa_ort, fa_telefon, fa_fax, fa_plz_grosskunden, fa_plz_postfach, fa_postfach, fa_blz_1, fa_kontonummer_1, fa_bankbezeichnung_1, fa_blz_2, fa_kontonummer_2, fa_bankbezeichnung_2, fa_oeffnungszeiten, fa_email, fa_internet, id) FROM stdin;
10	1010	Saarlouis 	Gaswerkweg 25	66740	Saarlouis	06831/4490	06831/449397		66714	1440	59000000	59301502	BBK SAARBRUECKEN	59010066	7761668	POSTBANK SAARBRUECKEN	Mo,Di,Do 7.30-15.30, Mi 7.30-18,Fr 7.30-12			1
10	1020	Merzig 	Am Gaswerk	66663	Merzig	06861/7030	06861/703133		66653	100232	59000000	59301502	BBK SAARBRUECKEN	59010066	7761668	POSTBANK SAARBRUECKEN	Mo-Do 7.30-15.30,Mi bis 18.00,Fr 7.30-12.00			2
10	1030	Neunkirchen 	Uhlandstr.	66538	Neunkirchen	06821/1090	06821/109275		66512	1234	59000000	59001508	BBK SAARBRUECKEN	59010066	2988669	POSTBANK SAARBRUECKEN	Mo-Do 7.30-15.30,Mi bis 18.00,Fr 07.30-12.00			3
10	1040	Saarbrücken Am Stadtgr 	Am Stadtgraben 2-4	66111	Saarbrücken	0681/30000	0681/3000329		66009	100952	59000000	59001502	BBK SAARBRUECKEN	59010066	7766663	POSTBANK SAARBRUECKEN	Mo,Di,Do 7.30-15.30, Mi 7.30-18,Fr 7.30-12			4
10	1055	Saarbrücken MainzerStr 	Mainzer Str.109-111	66121	Saarbrücken	0681/30000	0681/3000762		66009	100944	59000000	59001502	BBK SAARBRUECKEN	59010066	7766663	POSTBANK SAARBRUECKEN	Mo,Mi,Fr 8.30-12.00, zus. Mi 13.30 - 15.30			5
10	1060	St. Wendel 	Marienstr. 27	66606	St. Wendel	06851/8040	06851/804189		66592	1240	59000000	59001508	BBK SAARBRUECKEN	59010066	2988669	POSTBANK SAARBRUECKEN	Mo-Do 7.30-15.30,Mi bis 18.00,Fr 07.30-12.00			6
10	1070	Sulzbach 	Vopeliusstr. 8	66280	Sulzbach	06897/9082-0	06897/9082110		66272	1164	59000000	59001502	BBK SAARBRUECKEN	59010066	7766663	POSTBANK SAARBRUECKEN	Mo,Mi,Fr 08.30-12.00, zus. Mi 13.30-18.00			7
10	1075	Homburg 	Schillerstr. 15	66424	Homburg	06841/6970	06841/697199		66406	1551	59000000	59001508	BBK SAARBRUECKEN	59010066	2988669	POSTBANK SAARBRUECKEN	Mo-Do 7.30-15.30,Mi bis 18.00,Fr 07.30-12.00			8
10	1085	St. Ingbert 	Rentamtstr. 39	66386	St. Ingbert	06894/984-01	06894/984159		66364	1420	59000000	59001508	BBK SAARBRUECKEN	59010066	2988669	POSTBANK SAARBRUECKEN	Mo-Do 7.30-15.30,Mi bis 18.00,Fr 7.30-12.00			9
10	1090	Völklingen 	Marktstr.	66333	Völklingen	06898/20301	06898/203133		66304	101440	59000000	59001502	BBK SAARBRUECKEN	59010066	7766663	POSTBANK SAARBRUECKEN	Mo-Do 7.30-15.30,Mi bis 18.00,Fr 07.30-12.00			10
11	1113	Berlin Charlottenburg	Bismarckstraße 48	10627	Berlin	030 9024-13-0	030 9024-13-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	facharlottenburg@berlin.de	http://www.berlin.de/ofd	11
11	1114	Berlin Kreuzberg	Mehringdamm 22	10961	Berlin	030 9024-14-0	030 9024-14-900	10958			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fakreuzberg@berlin.de	http://www.berlin.de/oberfinanzdirektion	12
11	1115	Berlin Neukölln																faneukoelln@berlin.de		13
11	1116	Berlin Neukölln	Thiemannstr. 1	12059	Berlin	030 9024-16-0	030 9024-16-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	faneukoelln@berlin.de	http://www.berlin.de/oberfinanzdirektion	14
11	1117	Berlin Reinickendorf	Eichborndamm 208	13403	Berlin	030 9024-17-0	030 9024-17-900	13400			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fareinickendorf@berlin.de	http://www.berlin.de/oberfinanzdirektion	15
11	1118	Berlin Schöneberg	Bülowstraße 85/88	10783	Berlin	030/9024-18-0	030/9024-18-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Montag und Freitag: 8:00 - 13:00 Uhr Donnerstag: 11:00 - 18:00 Uhr	faschoeneberg@berlin.de	http://www.berlin.de/oberfinanzdirektion	16
11	1119	Berlin Spandau	Nonnendammallee 15-21	13599	Berlin	030/9024-19-0	030/9024-19-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	faspandau@berlin.de	http://www.berlin.de/oberfinanzdirektion	17
11	1120	Berlin Steglitz	Schloßstr. 58/59	12165	Berlin	030/9024-20-0	030/9024-20-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fasteglitz@berlin.de	http://www.berlin.de/oberfinanzdirektion	18
11	1121	Berlin Tempelhof	Tempelhofer Damm 234/236	12099	Berlin	030 9024-21-0	030 9024-21-900	12096			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fatempelhof@berlin.de	http://www.berlin.de/oberfinanzdirektion	19
11	1123	Berlin Wedding	Osloer Straße 37	13359	Berlin	030 9024-23-0	030 9024-23-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fawedding@berlin.de	http://www.berlin.de/oberfinanzdirektion	20
11	1124	Berlin Wilmersdorf	Blissestr. 5	10713	Berlin	030/9024-24-0	030/9024-24-900	10702			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fawilmersdorf@berlin.de	http://www.berlin.de/oberfinanzdirektion	21
11	1125	Berlin Zehlendorf	Martin-Buber-Str. 20/21	14163	Berlin	030 9024-25-0	030 9024-25-900	14160			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fazehlendorf@berlin.de	http://www.berlin.de/oberfinanzdirektion	22
11	1127	Berlin für Körperschaften I	Gerichtstr. 27	13347	Berlin	030 9024-27-0	030 9024-27-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fakoerperschaften1@berlin.de	http://www.berlin.de/oberfinanzdirektion	23
11	1128	Berlin Pankow/Weißennsee - nur KFZ-Steuer -	Berliner Straße 32	13089	Berlin	030/4704-0	030/94704-1777	13083			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	pankow.weissensee@berlin.de	http://www.berlin.de/oberfinanzdirektion	24
11	1129	Berlin für Körperschaften III	Volkmarstr. 13	12099	Berlin	030/70102-0	030/70102-100		12068	420844	10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fakoeperschaften3@berlin.de	http://www.berlin.de/oberfinanzdirektion	25
11	1130	Berlin für Körperschaften IV	Magdalenenstr. 25	10365	Berlin	030 9024-30-0	030 9024-30-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fakoeperschaften4@berlin.de	http://www.berlin.de/oberfinanzdirektion	26
11	1131	Berlin Friedrichsh./Prenzb.	Pappelallee 78/79	10437	Berlin	030 9024-28-0	030 9024-28-900	10431			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fafriedrichshain.prenzlauerberg@berlin.de	http://www.berlin.de/oberfinanzdirektion	27
11	1132	Berlin Lichtenb./Hohenschh.	Josef-Orlopp-Str. 62	10365	Berlin	030/5501-0	030/55012222	10358			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	falichtenberg.hohenschoenhausen@berlin.de	http://www.berlin.de/oberfinanzdirektion	28
11	1133	Berlin Hellersdorf/Marzahn	Allee der Kosmonauten 29	12681	Berlin	030 9024-26-0	030 9024-26-900	12677			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fahellersdorf.marzahn@berlin.de	http://www.berlin.de/oberfinanzdirektion	29
11	1134	Berlin Mitte/Tiergarten	Neue Jakobstr. 6-7	10179	Berlin	030 9024-22-0	030 9024-22-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	famitte.tiergarten@berlin.de	http://www.berlin.de/oberfinanzdirektion	30
11	1135	Berlin Pankow/Weißensee	Berliner Straße 32	13089	Berlin	030/4704-0	030/47041777	13083			10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	pankow.weissensee@berlin.de	http://www.berlin.de/oberfinanzdirektion	31
11	1136	Berlin Treptow/Köpenick	Seelenbinderstr. 99	12555	Berlin	030 9024-12-0	030 9024-12-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fatreptow.koepenick@berlin.de	http://www.berlin.de/oberfinanzdirektion	32
11	1137	Berlin für Körperschaften II	Magdalenenstr. 25	10365	Berlin	030 9024-29-0	030 9024-29-900				10010010	691555100	POSTBANK BERLIN	10050000	6600046463	LBB GZ - BERLINER SPARKASSE	Mo und Fr 8:00 - 13:00, Do 11:00 - 18:00 Uhr und nach Vereinbarung	fakoeperschaften2@berlin.de	http://www.berlin.de/oberfinanzdirektion	33
11	1138	Berlin für Fahndung und Strafsachen	Colditzstr. 41	12099	Berlin	030/70102-777	030/70102-700										Mo - Mi 10:00 - 14:00, Do 10:00 - 18:00, Fr 10:00 - 14:00 Uhr	fafahndung.strafsachen@berlin.de	http://www.berlin.de/oberfinanzdirektion	34
1	2111	Bad Segeberg 	Theodor-Storm-Str. 4-10	23795	Bad Segeberg	04551 54-0	04551 54-303	23792			23000000	23001502	BBK LUEBECK	23051030	744	KR SPK SUEDHOLSTEIN BAD SEG	0830-1200 MO, DI, DO, FR, 1330-1630 DO			35
1	2112	Eckernförde 	Bergstr. 50	24340	Eckernförde	04351 756-0	04351 83379		24331	1180	21000000	21001500	BBK KIEL	21092023	11511260	ECKERNFOERDER BANK VRB	0800-1200 MO-FR			36
1	2113	Elmshorn 	Friedensallee 7-9	25335	Elmshorn	04121 481-0	04121 481-460	25333			22200000	22201502	BBK KIEL EH ITZEHOE				0800-1200 MO-FR			37
1	2114	Eutin 	Robert-Schade-Str. 22	23701	Eutin	04521 704-0	04521 704-406		23691	160	23000000	23001505	BBK LUEBECK	21352240	4283	SPK OSTHOLSTEIN EUTIN	0830-1200 MO-FR, Nebenstelle Janusstr. 5 am Mo., Di, Do und Fr. 0830-1200, Do. 1330-1700			38
1	2115	Flensburg 	Duburger Str. 58-64	24939	Flensburg	0461 813-0	0461 813-254		24905	1552	21500000	21501500	BBK FLENSBURG				0800-1200 MO-FR			39
1	2116	Heide 	Ernst-Mohr-Str. 34	25746	Heide	0481 92-1	0481 92-690	25734			21500000	21701502	BBK FLENSBURG	22250020	60000123	SPK WESTHOLSTEIN	0800-1200 MO, DI, DO, FR, 1400-1700 DO			40
1	2117	Husum 	Herzog-Adolf-Str. 18	25813	Husum	04841 8949-0	04841 8949-200		25802	1230	21500000	21701500	BBK FLENSBURG				0800-1200 MO-FR			41
1	2118	Itzehoe 	Fehrsstr. 5	25524	Itzehoe	04821 66-0	04821 661-499		25503	1344	22200000	22201500	BBK KIEL EH ITZEHOE				0800-1200 MO, DI, DO, FR, 1400-1730 DO			42
1	2119	Kiel-Nord 	Holtenauer Str. 183	24118	Kiel	0431 8819-0	0431 8819-1200	24094			21000000	21001501	BBK KIEL	21050000	52001500	HSH NORDBANK KIEL	0800-1200 MO-FR 1430-1600 DI			43
1	2120	Kiel-Süd 	Hopfenstr. 2a	24114	Kiel	0431 602-0	0431 602-1009	24095			21000000	21001502	BBK KIEL	21050000	52001510	HSH NORDBANK KIEL	0800-1200 MO, DI, DO, FR, 1430-1730 DI			44
1	2121	Leck 	Eesacker Str. 11 a	25917	Leck	04662 85-0	04662 85-266		25912	1240	21700000	21701501	BBK FLENSBURG EH HUSUM	21750000	80003569	NORD-OSTSEE SPK SCHLESWIG	0800-1200 MO-FR			45
1	2122	Lübeck 	Possehlstr. 4	23560	Lübeck	0451 132-0	0451 132-501	23540			23000000	23001500	BBK LUEBECK	21050000	7052000200	HSH NORDBANK KIEL	0730-1300 MO+DI 0730-1700 Do 0730-1200 Fr			46
1	2123	Meldorf 	Jungfernstieg 1	25704	Meldorf	04832 87-0	04832 87-2508		25697	850	21500000	21701503	BBK FLENSBURG	21851830	106747	VERB SPK MELDORF	0800-1200 MO, DI, DO, FR, 1400-1700 MO			47
1	2124	Neumünster 	Bahnhofstr. 9	24534	Neumünster	04321 496 0	04321 496-189	24531			21000000	21001507	BBK KIEL				0800-1200 MO-MI, FR 1400-1700 DO			48
1	2125	Oldenburg 	Lankenstr. 1	23758	Oldenburg	04361 497-0	04361 497-125		23751	1155	23000000	23001504	BBK LUEBECK	21352240	51000396	SPK OSTHOLSTEIN EUTIN	0900-1200 MO-FR 1400-1600 MI			49
1	2126	Plön 	Fünf-Seen-Allee 1	24306	Plön	04522 506-0	04522 506-2149		24301	108	21000000	21001503	BBK KIEL	21051580	2600	SPK KREIS PLOEN	0800-1200 MO, Di, Do, Fr, 1400-1700 Di			50
1	2127	Ratzeburg 	Bahnhofsallee 20	23909	Ratzeburg	04541 882-01	04541 882-200	23903			23000000	23001503	BBK LUEBECK	23052750	100188	KR SPK LAUENBURG RATZEBURG	0830-1230 MO, DI, DO, FR, 1430-1730 DO			51
1	2128	Rendsburg 	Ritterstr. 10	24768	Rendsburg	04331 598-0	04331 598-2770		24752	640	21000000	21001504	BBK KIEL	21450000	1113	SPK MITTELHOLSTEIN RENDSBG	0730-1200 MO-FR			52
1	2129	Schleswig 	Suadicanistr. 26-28	24837	Schleswig	04621 805-0	04621 805-290		24821	1180	21500000	21501501	BBK FLENSBURG	21690020	91111	VOLKSBANK RAIFFEISENBANK	0800-1200 MO, DI, DO, FR, 1430-1700 DO			53
1	2130	Stormarn 	Berliner Ring 25	23843	Bad Oldesloe	04531 507-0	04531 507-399	23840			23000000	23001501	BBK LUEBECK	23051610	20503	SPK BAD OLDESLOE	0830-1200 MO-FR			54
1	2131	Pinneberg 	Friedrich-Ebert-Str. 29	25421	Pinneberg	04101 5472-0	04101 5472-680		25404	1451	22200000	22201503	BBK KIEL EH ITZEHOE				0800-1200 MO-FR			55
1	2132	Bad Segeberg / Außenst.Norderstedt	Europaallee 22	22850	Norderstedt	040 523068-0	040 523068-70				23000000	23001502	BBK LUEBECK	23051030	744	KR SPK SUEDHOLSTEIN BAD SEG	0830-1200 MO, DI, DO, FR, 1330-1630 DO			56
2	2201	Hamburg Steuerkasse	Steinstraße 10	20095	Hamburg	040/42853-03	040/42853-2159		20041	106026	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerSteuererhebung@finanzamt.hamburg.de		57
2	2210	Hamburg f.VerkSt.u.Grundbes-10	Gorch-Fock-Wall 11	20355	Hamburg	040/42843-60	040/42843-6199		20306	301721	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerVerkehrsteuern@finanzamt.hamburg.de		63
2	2216	Hamburg f.VerkSt.u.Grundbes-16	Gorch-Fock-Wall 11	20355	Hamburg	040/42843-60	040/42843-6199		20306	301721	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerVerkehrsteuern@finanzamt.hamburg.de		65
2	2217	Hamburg-Mitte-Altstadt 17 	Wendenstraße 35 b	20097	Hamburg	040/42853-06	040/42853-6671		20503	261338	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgMitteAltstadt@finanzamt.hamburg.de		66
2	2220	Hamburg f.VerkSt.u.Grundbes-20	Gorch-Fock-Wall 11	20355	Hamburg	040/42843-60	040/42843-6599		20306	301721	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerVerkehrsteuern@finanzamt.hamburg.de		67
2	2224	Hamburg-Mitte-Altstadt 	Wendenstr. 35 b	20097	Hamburg	040/42853-06	040/42853-6671		20503	261338	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgMitteAltstadt@finanzamt.hamburg.de		69
2	2225	Hamburg-Neustadt-St.Pauli 	Steinstraße 10	20095	Hamburg	040/42853-02	040/42853-2106		20015	102246	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgNeustadt@finanzamt.hamburg.de		70
2	2227	Hamburg für Großunternehmen	Amsinckstr. 40	20097	Hamburg	040/42853-05	040/42853-5559		20015	102205	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerGroßunternehmen@finanzamt.hamburg.de		72
2	2228	Hamburg Neust.-St.Pauli-28	Steinstr. 10	20095	Hamburg	040/42853-3589	040/42853-2106		20015	102246	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgNeustadt@finanzamt.hamburg.de		73
2	2230	Hamburg f.Verkehrst.u.Grundbes	Gorch-Fock-Wall 11	20355	Hamburg	040/42843-60	040/42843-6799		20306	301721	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerVerkehrsteuern@finanzamt.hamburg.de		74
2	2235	Hamburg f.VerkSt.u.Grundbes-35	Gorch-Fock-Wall 11	20355	Hamburg	040/42843-60	040/42843-6199		20306	301721	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAfuerVerkehrsteuern@finanzamt.hamburg.de		75
3	2311	Alfeld (Leine) 	Ravenstr.10	31061	Alfeld	05181/7050	05181/705240		31042	1244	25000000	25901505	BBK HANNOVER	25950130	10011102	KR SPK HILDESHEIM	Mo. - Fr. 8.30 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-alf.niedersachsen.de	www.ofd.niedersachsen.de	79
3	2312	Bad Gandersheim 	Alte Gasse 24	37581	Bad Gandersheim	05382/760	(05382) 76-213 + 204		37575	1180	26000000	26001501	BBK GOETTINGEN	25050000	22801005	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-gan.niedersachsen.de	www.ofd.niedersachsen.de	80
3	2313	Braunschweig-Altewiekring 	Altewiekring 20	38102	Braunschweig	0531/7050	0531/705309		38022	3229	27000000	27001501	BBK BRAUNSCHWEIG	25050000	2498020	NORD LB HANNOVER	Mo. - Fr. 8.00 - 12.00 Uhr, Mo. 14.00 - 17.00 Uhr	Poststelle@fa-bs-a.niedersachsen.de	www.ofd.niedersachsen.de	81
3	2314	Braunschweig-Wilhelmstr. 	Wilhelmstr. 4	38100	Braunschweig	0531/4890	0531/489224		38022	3249	27000000	27001502	BBK BRAUNSCHWEIG	25050000	811422	NORD LB HANNOVER	Mo. - Fr. 8.00 - 12.00 Uhr, Mo. 14.00 - 17.00 Uhr	Poststelle@fa-bs-w.niedersachsen.de	www.ofd.niedersachsen.de	82
3	2315	Buchholz in der Nordheide 	Bgm.-A.-Meyer-Str. 5	21244	Buchholz	04181/2030	(04181) 203-4444		21232	1262	20000000	20001520	BBK HAMBURG	20750000	3005063	SPK HARBURG-BUXTEHUDE	Mo. - Fr. 8.00 - 12.00 Uhr , Do. 14.00 - 17.00 Uhr	Poststelle@fa-buc.niedersachsen.de	www.ofd.niedersachsen.de	83
3	2316	Burgdorf 	V.d.Hannov. Tor 30	31303	Burgdorf	05136/8060	05136/806144	31300			25000000	25001515	BBK HANNOVER	25050180	1040400010	SPARKASSE HANNOVER	Mo. - Fr. 8.30 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-bu.niedersachsen.de	www.ofd.niedersachsen.de	84
3	2317	Celle 	Sägemühlenstr. 5	29221	Celle	(05141) 915-0	05141/915666		29201	1107	25000000	25701511	BBK HANNOVER	25750001	59	SPARKASSE CELLE	Mo. - Fr. 8.00 - 12.00 Uhr , Do. 14.00 - 17.00 Uhr	Poststelle@fa-ce.niedersachsen.de	www.ofd.niedersachsen.de	85
3	2318	Cuxhaven 	Poststr. 81	27474	Cuxhaven	(04721) 563-0	04721/563313		27452	280	29000000	24101501	BBK BREMEN	24150001	100503	ST SPK CUXHAVEN	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-cux.niedersachsen.de	www.ofd.niedersachsen.de	86
3	2319	Gifhorn 	Braunschw. Str. 6-8	38518	Gifhorn	05371/8000	05371/800241		38516	1249	27000000	27001503	BBK BRAUNSCHWEIG	26951311	11009958	SPK GIFHORN-WOLFSBURG	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00	Poststelle@fa-gf.niedersachsen.de	www.ofd.niedersachsen.de	87
3	2320	Göttingen 	Godehardstr. 6	37073	Göttingen	0551/4070	0551/407449	37070			26000000	26001500	BBK GOETTINGEN	26050001	91	SPARKASSE GOETTINGEN	Servicecenter: Mo., Di., Mi. und Fr. 8.00 - 12.00 u. Do. 8.00 - 17.00 Uhr,	Poststelle@fa-goe.niedersachsen.de	www.ofd.niedersachsen.de	88
3	2321	Goslar 	Wachtelpforte 40	38644	Goslar	05321/5590	05321/559200		38604	1440	27000000	27001505	BBK BRAUNSCHWEIG	26850001	2220	SPARKASSE GOSLAR/HARZ	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-gs.niedersachsen.de	www.ofd.niedersachsen.de	89
3	2390	Braunschweig für Fahndung und Strafsachen	Rudolf-Steiner-Str. 1	38120	Braunschweig	0531/28510	(0531) 2851-150		38009	1931							nach Vereinbarung	Poststelle@fa-fust-bs.niedersachsen.de	www.ofd.niedersachsen.de	144
3	2322	Hameln 	Süntelstraße 2	31785	Hameln	05151/2040	05151/204200		31763	101325	25000000	25401511	BBK HANNOVER	25450001	430	ST SPK HAMELN	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-hm.niedersachsen.de	www.ofd.niedersachsen.de	90
3	2323	Hannover-Land I 	Göttinger Chaus. 83A	30459	Hannover	(0511) 419-1	0511/4192269		30423	910320	25000000	25001512	BBK HANNOVER	25050000	101342434	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-h-l1.niedersachsen.de	www.ofd.niedersachsen.de	91
3	2324	Hannover-Mitte 	Lavesallee 10	30169	Hannover	0511/16750	0511/1675277		30001	143	25000000	25001516	BBK HANNOVER	25050000	101341816	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhrund nach Vereinbarung	Poststelle@fa-h-mi.niedersachsen.de	www.ofd.niedersachsen.de	92
3	2325	Hannover-Nord 	Vahrenwalder Str.206	30165	Hannover	0511/67900	(0511) 6790-6090		30001	167	25000000	25001514	BBK HANNOVER	25050000	101342426	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-h-no.niedersachsen.de	www.ofd.niedersachsen.de	93
3	2326	Hannover-Süd 	Göttinger Chaus. 83B	30459	Hannover	0511/4191	0511/4192575		30423	910355	25000000	25001517	BBK HANNOVER	25050000	101342400	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-h-su.niedersachsen.de	www.ofd.niedersachsen.de	94
3	2327	Hannover-Land II 	Vahrenwalder Str.208	30165	Hannover	0511/67900	(0511) 6790-6633		30001	165	25000000	25001520	BBK HANNOVER	25050000	101342517	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-h-l2.niedersachsen.de	www.ofd.niedersachsen.de	95
3	2328	Helmstedt 	Ernst-Koch-Str.3	38350	Helmstedt	05351/1220	(05351) 122-299		38333	1320	27000000	27101500	BBK BRAUNSCHWEIG	25050000	5801006	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-he.niedersachsen.de	www.ofd.niedersachsen.de	96
3	2329	Herzberg am Harz 	Sieberstr. 1	37412	Herzberg	05521/8570	05521/857220		37401	1153	26000000	26001502	BBK GOETTINGEN	26351015	1229327	SPARKASSE IM KREIS OSTERODE	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-hz.niedersachsen.de	www.ofd.niedersachsen.de	97
3	2330	Hildesheim 	Kaiserstrasse 47	31134	Hildesheim	05121/3020	05121/302480		31104	100455	25000000	25901500	BBK HANNOVER	25950130	5555	KR SPK HILDESHEIM	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-hi.niedersachsen.de	www.ofd.niedersachsen.de	98
3	2331	Holzminden 	Ernst-August-Str.30	37603	Holzminden	05531/1220	05531/122100		37601	1251	25000000	25401512	BBK HANNOVER	25050000	27811140	NORD LB HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-hol.niedersachsen.de	www.ofd.niedersachsen.de	99
3	2332	Lüchow 	Mittelstr.5	29439	Lüchow	(05841) 963-0	05841/963170		29431	1144	24000000	25801503	BBK LUENEBURG	25851335	2080000	KR SPK LUECHOW-DANNENBERG	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-luw.niedersachsen.de	www.ofd.niedersachsen.de	100
3	2333	Lüneburg 	Am Alt. Eisenwerk 4a	21339	Lüneburg	04131/3050	04131/305915	21332			24000000	24001500	BBK LUENEBURG	24050110	18	SPK LUENEBURG	Mo. - Fr. 8.00-12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-lg.niedersachsen.de	www.ofd.niedersachsen.de	101
3	2334	Nienburg/Weser 	Schloßplatz 10	31582	Nienburg	05021/8011	05021/801300		31580	2000	25000000	25601500	BBK HANNOVER	25650106	302224	SPARKASSE NIENBURG	Mo. - Fr. 7.30 - 12.00 Uhr und nach Vereinbarung, zusätzl. Arbeitnehmerbereich: Do. 14 -	Poststelle@fa-ni.niedersachsen.de	www.ofd.niedersachsen.de	102
3	2335	Northeim 	Graf-Otto-Str. 31	37154	Northeim	05551/7040	05551/704221		37142	1261	26000000	26201500	BBK GOETTINGEN	26250001	208	KR SPK NORTHEIM	Mo. - Fr. 8.30 - 12.30 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-nom.niedersachsen.de	www.ofd.niedersachsen.de	103
3	2336	Osterholz-Scharmbeck 	Pappstraße 2	27711	Osterholz-Scharmbeck	04791/3020	04791/302101		27701	1120	29000000	29001523	BBK BREMEN	29152300	202622	KR SPK OSTERHOLZ	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-ohz.niedersachsen.de	www.ofd.niedersachsen.de	104
3	2338	Peine 	Duttenstedt.Str. 106	31224	Peine	05171/4070	05171/407199	31221			27000000	27001507	BBK BRAUNSCHWEIG	25250001	75003210	KR SPK PEINE	Mo. - Mi. Fr. 9.00 - 12.00, Do. 13.30 - 16.00 UhrDo. (Infothek) 13.30 -	Poststelle@fa-pe.niedersachsen.de	www.ofd.niedersachsen.de	105
3	2340	Rotenburg (Wümme) 	Hoffeldstr. 5	27356	Rotenburg	04261/740	04261/74108		27342	1260	29000000	29001522	BBK BREMEN	24151235	26106377	SPK ROTENBURG-BREMERVOERDE	Mo. - Mi., Fr. 8.00 - 12.00 Uhr, Do. 8.00 - 17.30	Poststelle@fa-row.niedersachsen.de	www.ofd.niedersachsen.de	106
3	2341	Soltau 	Rühberg 16 - 20	29614	Soltau	05191/8070	05191/807144		29602	1243	24000000	25801502	BBK LUENEBURG	25851660	100016	KR SPK SOLTAU	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-sol.niedersachsen.de	www.ofd.niedersachsen.de	107
3	2342	Hannover-Land I Außenstelle Springe	Bahnhofstr. 28	31832	Springe	05041/7730	05041/77363		31814	100255	25000000	25001512	BBK HANNOVER	25050180	3001000037	SPARKASSE HANNOVER	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-ast-spr.niedersachsen.de	www.ofd.niedersachsen.de	108
3	2343	Stade 	Harburger Str. 113	21680	Stade	(04141) 536-0	(04141) 536-499	21677			24000000	24001560	BBK LUENEBURG	24151005	42507	SPK STADE-ALTES LAND	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-std.niedersachsen.de	www.ofd.niedersachsen.de	109
3	2344	Stadthagen 	Schloß	31655	Stadthagen	05721/7050	05721/705250	31653			49000000	49001502	BBK MINDEN, WESTF	25551480	470140401	SPARKASSE SCHAUMBURG	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-shg.niedersachsen.de	www.ofd.niedersachsen.de	110
3	2345	Sulingen 	Hindenburgstr. 16	27232	Sulingen	04271/870	04271/87289		27226	1520	29000000	29001516	BBK BREMEN	25651325	30101430	KR SPK DIEPHOLZ	Mo., Mi., Do. und Fr. 8.00 - 12.00 Uhr, Di. 8.00 - 17.00 Uhr	Poststelle@fa-su.niedersachsen.de	www.ofd.niedersachsen.de	111
3	2346	Syke 	Bürgerm.-Mävers-Str. 15	28857	Syke	04242/1620	04242/162423		28845	1164	29000000	29001515	BBK BREMEN	29151700	1110044557	KREISSPARKASSE SYKE	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-sy.niedersachsen.de	www.ofd.niedersachsen.de	112
3	2347	Uelzen 	Am Königsberg 3	29525	Uelzen	0581/8030	0581/803404		29504	1462	24000000	25801501	BBK LUENEBURG	25850110	26	SPARKASSE UELZEN	Mo. - Fr. 8.30 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-ue.niedersachsen.de	www.ofd.niedersachsen.de	113
3	2348	Verden (Aller) 	Bremer Straße 4	27283	Verden	04231/9190	04231/919310		27263	1340	29000000	29001517	BBK BREMEN	29152670	10000776	KR SPK VERDEN	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-ver.niedersachsen.de	www.ofd.niedersachsen.de	114
3	2349	Wesermünde 	Borriesstr. 50	27570	Bremerhaven	0471/1830	0471/183119		27503	100369	29000000	29201501	BBK BREMEN	29250150	100103200	KR SPK WESERMUENDE-HADELN	Mo. - Fr. 8.30 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-wem.niedersachsen.de	www.ofd.niedersachsen.de	115
3	2350	Winsen (Luhe) 	Von-Somnitz-Ring 6	21423	Winsen	04171/6560	(04171) 656-115		21413	1329	24000000	24001550	BBK LUENEBURG	20750000	7051519	SPK HARBURG-BUXTEHUDE	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 18.00 Uhr und nach Vereinbarung	Poststelle@fa-wl.niedersachsen.de	www.ofd.niedersachsen.de	116
3	2351	Wolfenbüttel 	Jägerstr. 19	38304	Wolfenbüttel	05331/8030	(05331) 803-113/266 	38299			27000000	27001504	BBK BRAUNSCHWEIG	25050000	9801002	NORD LB HANNOVER	Mo. - Fr. 8.00 - 12.00 Uhr, Mi. 14.00 - 17.00 Uhr	Poststelle@fa-wf.niedersachsen.de	www.ofd.niedersachsen.de	117
3	2352	Zeven 	Kastanienweg 1	27404	Zeven	04281/7530	04281/753290		27392	1259	29000000	29201503	BBK BREMEN	24151235	404350	SPK ROTENBURG-BREMERVOERDE	Mo. - Fr. 8.30 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-zev.niedersachsen.de	www.ofd.niedersachsen.de	118
3	2353	Papenburg 	Große Straße 32	26871	Aschendorf	04962/5030	04962/503222		26883	2264	28000000	28501512	BBK OLDENBURG (OLDB)	26650001	1020007	SPK EMSLAND	Mo. - Fr. 9.00 - 12.00 Uhr, Mi. 14.00 - 17.00 Uhr	Poststelle@fa-pap.niedersachsen.de	www.ofd.niedersachsen.de	119
3	2354	Aurich 	Hasseburger Str. 3	26603	Aurich	04941/1750	04941/175152		26582	1260	28000000	28501514	BBK OLDENBURG (OLDB)	28350000	90001	SPK AURICH-NORDEN	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-aur.niedersachsen.de	www.ofd.niedersachsen.de	120
3	2355	Bad Bentheim 	Heinrich-Böll-Str. 2	48455	Bad Bentheim	05922/970-0	05922/970-2000		48443	1262	26500000	26601501	BBK OSNABRUECK	26750001	1000066	KR SPK NORDHORN	Mo. - Fr. 9.00 - 12.00 Uhr, Do 14.00 - 15.30 Uhr	Poststelle@fa-ben.niedersachsen.de	www.ofd.niedersachsen.de	121
3	2356	Cloppenburg 	Bahnhofstr. 57	49661	Cloppenburg	04471/8870	04471/887477		49646	1680	28000000	28001501	BBK OLDENBURG (OLDB)	28050100	80402100	LANDESSPARKASSE OLDENBURG	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-clp.niedersachsen.de	www.ofd.niedersachsen.de	122
3	2357	Delmenhorst 	Fr.-Ebert-Allee 15	27749	Delmenhorst	04221/1530	04221/153126	27747			29000000	29001521	BBK BREMEN	28050100	30475669	LANDESSPARKASSE OLDENBURG	Mo. - Fr. 9.00 - 12.00 Uhr, Di. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-del.niedersachsen.de	www.ofd.niedersachsen.de	123
3	2358	Emden 	Ringstr. 5	26721	Emden	(04921) 934-0	(04921) 934-499		26695	1553	28000000	28401500	BBK OLDENBURG (OLDB)	28450000	26	SPARKASSE EMDEN	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-emd.niedersachsen.de	www.ofd.niedersachsen.de	124
3	2360	Leer (Ostfriesland) 	Edzardstr. 12/16	26789	Leer	(0491) 9870-0	0491/9870209	26787			28000000	28501511	BBK OLDENBURG (OLDB)	28550000	849000	SPARKASSE LEER-WEENER	Mo. - Fr. 8.00 - 12.00 Uhr, nur Infothek: Mo., Do. 14.00 - 17.30 Uhr	Poststelle@fa-ler.niedersachsen.de	www.ofd.niedersachsen.de	125
3	2361	Lingen (Ems) 	Mühlentorstr. 14	49808	Lingen	0591/91490	0591/9149468		49784	1440	26500000	26601500	BBK OSNABRUECK	26650001	2402	SPK EMSLAND	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr und nach Vereinbarung	Poststelle@fa-lin.niedersachsen.de	www.ofd.niedersachsen.de	126
3	2362	Norden 	Mühlenweg 20	26506	Norden	04931/1880	04931/188196		26493	100360	28000000	28501515	BBK OLDENBURG (OLDB)	28350000	1115	SPK AURICH-NORDEN	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-nor.niedersachsen.de	www.ofd.niedersachsen.de	127
3	2363	Nordenham 	Plaatweg 1	26954	Nordenham	04731/8700	04731/870100		26942	1264	28000000	28001504	BBK OLDENBURG (OLDB)	28050100	63417000	LANDESSPARKASSE OLDENBURG	Mo. - Fr. 8.30 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-nhm.niedersachsen.de	www.ofd.niedersachsen.de	128
3	2364	Oldenburg (Oldenburg) 	91er Straße 4	26121	Oldenburg	0441/2381	(0441) 238-201/2/3		26014	2445	28000000	28001500	BBK OLDENBURG (OLDB)	28050100	423301	LANDESSPARKASSE OLDENBURG	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-ol.niedersachsen.de	www.ofd.niedersachsen.de	129
3	2365	Osnabrück-Land 	Hannoversche Str. 12	49084	Osnabrück	0541/58420	0541/5842450		49002	1280	26500000	26501501	BBK OSNABRUECK	26552286	110007	KREISSPARKASSE MELLE	Mo., Mi., Do. u. Fr. 8.00 - 12.00 Uhr, Di. 12.00 - 17.00 Uhr	Poststelle@fa-os-l.niedersachsen.de	www.ofd.niedersachsen.de	130
3	2366	Osnabrück-Stadt 	Süsterstr. 46/48	49074	Osnabrück	0541/3540	(0541) 354-312		49009	1920	26500000	26501500	BBK OSNABRUECK	26550105	19000	SPARKASSE OSNABRUECK	Mo. - Mi., Fr. 8.00 - 12.00 Uhr, nur Infothek: Do. 12.00 - 17.00 Uhr	Poststelle@fa-os-s.niedersachsen.de	www.ofd.niedersachsen.de	131
3	2367	Quakenbrück 	Lange Straße 37	49610	Quakenbrück	05431/1840	05431/184101		49602	1261	26500000	26501503	BBK OSNABRUECK	26551540	18837179	KR SPK BERSENBRUECK	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-qua.niedersachsen.de	www.ofd.niedersachsen.de	132
3	2368	Vechta 	Rombergstr. 49	49377	Vechta	04441/180	(04441) 18-100	49375			28000000	28001502	BBK OLDENBURG (OLDB)	28050100	70400049	LANDESSPARKASSE OLDENBURG	Mo. - Fr. 8.30 - 12.00 Uhr, Mo. 14.00 - 16.00 Uhr,Mi. 14.00 - 17.00	Poststelle@fa-vec.niedersachsen.de	www.ofd.niedersachsen.de	133
3	2369	Westerstede 	Ammerlandallee 14	26655	Westerstede	04488/5150	04488/515444	26653			28000000	28001503	BBK OLDENBURG (OLDB)	28050100	40465007	LANDESSPARKASSE OLDENBURG	Mo. - Fr. 9.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-wst.niedersachsen.de	www.ofd.niedersachsen.de	134
3	2370	Wilhelmshaven 	Rathausplatz 3	26382	Wilhelmshaven	04421/1830	04421/183111		26354	1462	28000000	28201500	BBK OLDENBURG (OLDB)	28250110	2117000	SPARKASSE WILHELMSHAVEN	Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-whv.niedersachsen.de	www.ofd.niedersachsen.de	135
3	2371	Wittmund 	Harpertshausen.Str.2	26409	Wittmund	04462/840	04462/84195		26398	1153	28000000	28201502	BBK OLDENBURG (OLDB)				Mo. - Fr. 8.00 - 12.00 Uhr, Do. 14.00 - 17.00 Uhr	Poststelle@fa-wtm.niedersachsen.de	www.ofd.niedersachsen.de	136
3	2380	Braunschweig für Großbetriebsprüfung	Theodor-Heuss-Str.4a	38122	Braunschweig	0531/80970	(0531) 8097-333		38009	1937							nach Vereinbarung	Poststelle@fa-gbp-bs.niedersachsen.de	www.ofd.niedersachsen.de	137
3	2381	Göttingen für Großbetriebsprüfung	Godehardstr. 6	37073	Göttingen	0551/4070	(0551) 407-448											Poststelle@fa-gbp-goe.niedersachsen.de	www.ofd.niedersachsen.de	138
3	2382	Hannover I für Großbetriebsprüfung	Bischofsholer Damm 15	30173	Hannover	(0511) 8563-01	(0511) 8563-195											Poststelle@fa-gbp-h1.niedersachsen.de	www.ofd.niedersachsen.de	139
3	2383	Hannover II für Großbetriebsprüfung	Bischofsholer Damm 15	30173	Hannover	(0511) 8563-02	(0511) 8563-250		30019	1927								Poststelle@fa-gbp-h2.niedersachsen.de	www.ofd.niedersachsen.de	140
3	2384	Stade für Großbetriebsprüfung	Am Ärztehaus 12	21680	Stade	(04141) 602-0	(04141) 602-60											Poststelle@fa-gbp-std.niedersachsen.de	www.ofd.niedersachsen.de	141
3	2385	Oldenburg für Großbetriebsprüfung	Georgstr. 36	26121	Oldenburg	0441/2381	(0441) 238-522		26014	2445								Poststelle@fa-gbp-ol.niedersachsen.de	www.ofd.niedersachsen.de	142
3	2386	Osnabrück für Großbetriebsprüfung	Johann-Domann-Str. 6	49080	Osnabrück	(0541) 503 800	(0541) 503 888											Poststelle@fa-gbp-os.niedersachsen.de	www.ofd.niedersachsen.de	143
3	2391	Hannover für Fahndung und Strafsachen	Göttinger Chaus. 83B	30459	Hannover	(0511) 419-1	(0511) 419-2988		30430	911007								Poststelle@fa-fust-h.niedersachsen.de	www.ofd.niedersachsen.de	145
3	2392	Lüneburg für Fahndung und Strafsachen	Horst-Nickel-Str. 6	21337	Lüneburg	(04131) 8545-600	(04131) 8545-698		21305	1570								Poststelle@fa-fust-lg.niedersachsen.de	www.ofd.niedersachsen.de	146
3	2393	Oldenburg für Fahndung und Strafsachen	Cloppenburger Str. 320	26133	Oldenburg	(0441) 9401-0	(0441) 9401-200		26014	2442								Poststelle@fa-fust-ol.niedersachsen.de	www.ofd.niedersachsen.de	147
4	2457	Bremen-Mitte Bewertung 	Rudolf-Hilferding-Platz 1	28195	Bremen	0421 322-2725	0421 322-2878		28079	10 79 67	29050000	1070110002	BREMER LANDESBANK BREMEN	29050101	109 0901	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtMitte.bremen.de		148
4	2471	Bremen-Mitte 	Rudolf-Hilferding-Platz 1	28195	Bremen	0421 322-2725	0421 322-2878	28187	28079	10 79 67	29000000	29001512	BBK BREMEN	29050101	1090646	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtMitte.bremen.de		149
4	2472	Bremen-Ost 	Rudolf-Hilferding-Platz 1	28195	Bremen	0421 322-3005	0421 322-3178		28057	10 57 09	29000000	29001513	BBK BREMEN	29050101	1090612	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtOst.bremen.de		150
4	2473	Bremen-West 	Rudolf-Hilferding-Platz 1	28195	Bremen	0421 322-3422	0421 322-3478		28057	10 57 29	29000000	29001514	BBK BREMEN	29050101	1090638	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtWest.bremen.de		151
4	2474	Bremen-Nord 	Gerhard-Rohlfs-Str. 32	28757	Bremen	0421 6607-1	0421 6607-300		28734	76 04 34	29000000	29001518	BBK BREMEN	29050101	5016001	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-14:00	office@FinanzamtNord.bremen.de		152
4	2475	Bremerhaven 	Schifferstr. 2-8	27568	Bremerhaven	0471 486-1	0471 486-370		27516	12 02 42	29200000	29201500	BBK BREMEN EH BREMERHAVEN	29250000	1100068	STE SPK BREMERHAVEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtBremerhaven.bremen.de		153
4	2476	Bremen-Mitte KraftfahrzeugSt 	Schillerstr. 22	28195	Bremen	0421 322-2725	0421 322-2878		28079	107967	29000000	29001512	BBK BREMEN	29050101	 109 0646	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtMitte.bremen.de		154
4	2477	Bremerhaven Bewertung 	Schifferstr. 2 - 8	27568	Bremerhaven	0471 486-1	0471 486-370		27516	12 02 42	29200000	29201500	BBK BREMEN EH BREMERHAVEN	29250000	1100068	STE SPK BREMERHAVEN	Zentrale Informations- und Annahmestelle Mo+Do 08.00-18.00/Di+Mi 08.00-16.00/Fr 08.00-15.00	office@FinanzamtBremerhaven.bremen.de		155
4	2478	Bremen für Großbetriebsprüfung	Schillerstr. 6-7	28195	Bremen	0421 322-4019	0421 322-4078		28057	10 57 69							nach Vereinbarung			156
4	2482	Bremen-Ost Arbeitnehmerbereich 	Rudolf-Hilferding-Platz 1	28195	Bremen	0421 322-3005	0421 322-3178		28057	10 57 09	29000000	29001513	BBK BREMEN	29050101	1090612	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtOst.bremen.de		157
4	2484	Bremen-Nord Arbeitnehmerbereic 	Gerhard-Rohlfs-Str. 32	28757	Bremen	0421 6607-1	0421 6607-300		28734	76 04 34	29000000	29001518	BBK BREMEN	29050101	5016001	SPK BREMEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-14:00	office@FinanzamtNord.bremen.de		158
4	2485	Bremerhaven Arbeitnehmerbereic 	Schifferstr. 2-8	27568	Bremerhaven	0471 486-1	0471 486-370		27516	12 02 42	29200000	29201500	BBK BREMEN EH BREMERHAVEN	29250000	1100068	STE SPK BREMERHAVEN	Zentrale Informations- und Annahmestelle Mo+Do 08:00-18:00,Di+Mi 08:00-16:00,Fr 08:00-15:00	office@FinanzamtBremerhaven.bremen.de		159
6	2601	Alsfeld-Lauterbach Verwaltungsstelle Alsfeld	In der Rambach 11	36304	Alsfeld	06631/790-0	06631/790-555		36292	1263	51300000	51301504	BBK GIESSEN	53051130	1022003	SPARKASSE VOGELSBERGKREIS	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr	poststelle@Finanzamt-Alsfeld-Lauterbach.de	www.Finanzamt-Alsfeld-Lauterbach.de	160
6	2602	Hersfeld-Rotenburg Verwaltungsstelle Bad Hersfeld	Im Stift 7	36251	Bad Hersfeld	06621/933-0	06621/933-333		36224	1451	53200000	53201500	BBK KASSEL EH BAD HERSFELD	53250000	1000016	SPK BAD HERSFELD-ROTENBURG	Mo u. Do 8:00-12:00, Di 14:00-18:00 Uhr	poststelle@Finanzamt-Hersfeld-Rotenburg.de	www.Finanzamt-Hersfeld-Rotenburg.de	161
6	2604	Rheingau-Taunus Verwaltungsst. Bad Schwalbach 	Emser Str.27a	65307	Bad Schwalbach	06124/705-0	06124/705-400		65301	1165	51000000	51001502	BBK WIESBADEN	51050015	393000643	NASS SPK WIESBADEN	Mo-Mi 8:00-15:30, Do 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Rheingau-Taunus.de	www.Finanzamt-Rheingau-Taunus.de	163
6	2605	Bensheim 	Berliner Ring 35	64625	Bensheim	06251/15-0	06251/15-267		64603	1351	50800000	50801510	BBK DARMSTADT	50950068	1040005	SPARKASSE BENSHEIM	Mo-Mi 8:00-15:30, Do 13:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Bensheim.de	www.Finanzamt-Bensheim.de	164
6	2606	Marburg-Biedenkopf Verwaltungsstelle Biedenkopf	Im Feldchen 2	35216	Biedenkopf	06421/698-0	06421/698-109				51300000	51301514	BBK GIESSEN	53350000	110027303	SPK MARBURG-BIEDENKOPF	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr Telefon Verwaltungsstelle: 06461/709-0	poststelle@Finanzamt-Marburg-Biedenkopf.de	www.Finanzamt-Marburg-Biedenkopf.de	165
6	2607	Darmstadt 	Soderstraße 30	64283	Darmstadt	06151/102-0	06151/102-1262	64287	64219	110465	50800000	50801500	BBK DARMSTADT	50850049	5093005006	LD BK GZ DARMSTADT	Mo-Mi 8:00-15:30, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Darmstadt.de	www.Finanzamt-Darmstadt.de	166
6	2608	Dieburg 	Marienstraße 19	64807	Dieburg	06071/2006-0	06071/2006-100		64802	1209	50800000	50801501	BBK DARMSTADT	50852651	33211004	SPARKASSE DIEBURG	Mo-Mi 7:30-15:30, Do 13:30-18:00, Fr 7:30-12:00 Uhr	poststelle@Finanzamt-Dieburg.de	www.Finanzamt-Dieburg.de	167
6	2609	Dillenburg 	Wilhelmstraße 9	35683	Dillenburg	02771/908-0	02771/908-100		35663	1362	51300000	51301509	BBK GIESSEN	51650045	18	BEZ SPK DILLENBURG	Mo-Mi 8:00-15:30, Do 14:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Dillenburg.de	www.Finanzamt-Dillenburg.de	168
6	2610	Eschwege-Witzenhausen Verwaltungsstelle Eschwege	Schlesienstraße 2	37269	Eschwege	05651/926-5	05651/926-720	37267	37252	1280	52000000	52001510	BBK KASSEL	52250030	18	SPARKASSE WERRA-MEISSNER	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr	poststelle@Finanzamt-Eschwege-Witzenhausen.de	www.Finanzamt-Eschwege-Witzenhausen.de	169
5	5271	Aachen für Groß- und Konzernbetriebsprüfung	Beverstr. 17	52066	Aachen	0241/940-0	0800 10092675271		52017	101744								Service@FA-5271.fin-nrw.de		504
8	2807	Freiburg-Land 	Stefan-Meier-Str. 133	79104	Freiburg	0761/2040	0761/2043424	79095			68000000	680 015 00	BBK FREIBURG IM BREISGAU	68090000	12222300	VOLKSBANK FREIBURG	ZIA: MO,DI,DO 8-16, MI 8-17:30, FR 8-12 UHR	poststelle@fa-freiburg-land.fv.bwl.de		170
6	2611	Korbach-Frankenberg Verwaltungsstelle Frankenberg 	Geismarer Straße 16	35066	Frankenberg	05631/563-0	05631/563-888				51300000	51301513	BBK GIESSEN	52350005	5001557	SPK WALDECK-FRANKENBERG	Mo, Di u. Do 8:00-15:30, Mi 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Korbach-Frankenberg.de	www.Finanzamt-Korbach-Frankenberg.de	171
6	2612	Frankfurt am Main II 	Gutleutstraße 122	60327	Frankfurt	069/2545-02	069/2545-2999		60305	110862	50000000	50001504	BBK FILIALE FRANKFURT MAIN	50050000	1600006	LD BK HESS-THUER GZ FFM	Mo-Mi 8:00-15:30, Do 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Frankfurt-2.de	www.Finanzamt-Frankfurt-am-Main.de	172
6	2613	Frankfurt am Main I 	Gutleutstraße 124	60327	Frankfurt	069/2545-01	069/2545-1999		60305	110861	50000000	50001504	BBK FILIALE FRANKFURT MAIN	50050000	1600006	LD BK HESS-THUER GZ FFM	Mo-Mi 8:00-15:30, Do 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Frankfurt-1.de	www.Finanzamt-Frankfurt-am-Main.de	173
6	2614	Frankfurt am Main IV 	Gutleutstraße 118	60327	Frankfurt	069/2545-04	069/2545-4999		60305	110864	50000000	50001504	BBK FILIALE FRANKFURT MAIN	50050000	1600006	LD BK HESS-THUER GZ FFM	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr	poststelle@Finanzamt-Frankfurt-4.de	www.Finanzamt-Frankfurt-am-Main.de	174
6	2639	Wetzlar 	Frankfurter Straße 59	35578	Wetzlar	06441/202-0	06441/202-6810	35573	35525	1520	51300000	51301508	BBK GIESSEN	51550035	46003	SPARKASSE WETZLAR	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr	poststelle@Finanzamt-Wetzlar.de	www.Finanzamt-Wetzlar.de	199
6	2615	Frankfurt/M. V-Höchst Verwaltungsstelle Höchst	Hospitalstraße 16 a	65929	Frankfurt	069/2545-05	069/2545-5999				50000000	50001502	BBK FILIALE FRANKFURT MAIN	50050201	608604	FRANKFURTER SPK FRANKFURT	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr Telefon Verwaltungsstelle: 069/30830-0	poststelle@Finanzamt-Frankfurt-5-Hoechst.de	www.Finanzamt-Frankfurt-am-Main.de	175
6	2616	Friedberg (Hessen) 	Leonhardstraße 10 - 12	61169	Friedberg	06031/49-1	06031/49-333		61143	100362	51300000	51301506	BBK GIESSEN	51850079	50000400	SPARKASSE WETTERAU	Di 8:00-12:00, Do 14:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Friedberg.de	www.Finanzamt-Friedberg.de	176
6	2617	Bensheim Außenstelle Fürth	Erbacher Straße 23	64658	Fürth	06253/206-0	06253/206-10		64654	1154	50800000	50801510	BBK DARMSTADT	50950068	1040005	SPARKASSE BENSHEIM		poststelle@Finanzamt-Bensheim.de	www.Finanzamt-Bensheim.de	177
6	2618	Fulda 	Königstraße 2	36037	Fulda	0661/924-01	0661/924-1606		36003	1346	53000000	53001500	BBK KASSEL EH FULDA	53050180	49009	SPARKASSE FULDA	Mo-Mi 8:00-15:30, Do 14:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Fulda.de	www.Finanzamt-Fulda.de	178
6	2619	Gelnhausen 	Frankfurter Straße 14	63571	Gelnhausen	06051/86-0	06051/86-299	63569	63552	1262	50600000	50601502	BBK FRANKFURT EH HANAU	50750094	2008	KREISSPARKASSE GELNHAUSEN	Mo u. Mi 8:00-12:00, Do 14:30-18:00 Uhr	poststelle@Finanzamt-Gelnhausen.de	www.Finanzamt-Gelnhausen.de	179
6	2620	Gießen 	Schubertstraße 60	35392	Gießen	0641/4800-100	0641/4800-1590	35387	35349	110440				51300000	51301500	BBK GIESSEN	Mo-Mi 8:00-15:30,Do 14:00-18:00, Fr 8:00-12:00 Uhr	info@Finanzamt-Giessen.de	www.Finanzamt-Giessen.de	180
6	2621	Groß-Gerau 	Europaring 11-13	64521	Groß-Gerau	06152/170-01	06152/170-601	64518	64502	1262	50800000	50801502	BBK DARMSTADT	50852553	1685	KR SPK GROSS-GERAU	Mo-Mi 8:00-15.30, Do 14:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Gross-Gerau.de	www.Finanzamt-Gross-Gerau.de	181
6	2622	Hanau 	Am Freiheitsplatz 2	63450	Hanau	06181/101-1	06181/101-501	63446	63404	1452	50600000	50601500	BBK FRANKFURT EH HANAU	50650023	50104	SPARKASSE HANAU	Mo u. Mi 7:30-12:00, Do 14:30-18:00 Uhr	poststelle@Finanzamt-Hanau.de	www.Finanzamt-Hanau.de	182
6	2623	Kassel-Hofgeismar Verwaltungsstelle Hofgeismar	Altstädter Kirchplatz 10	34369	Hofgeismar	0561/7207-0	0561/7207-2500				52000000	52001501	BBK KASSEL	52050353	100009202	KASSELER SPARKASSE	Di, Mi u. Fr 8:00-12:00, Do 15:00-18:00 Uhr Telefon Verwaltungsstelle: 05671/8004-0	poststelle@Finanzamt-Kassel-Hofgeismar.de	www.Finanzamt-Kassel.de	183
6	2624	Schwalm-Eder Verwaltungsstelle Fritzlar	Georgengasse 5	34560	Fritzlar	05622/805-0	05622/805-111		34551	1161	52000000	52001502	BBK KASSEL	52052154	110007507	KREISSPARKASSE SCHWALM-EDER	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr	poststelle@Finanzamt-Schwalm-Eder.de	www.Finanzamt-Schwalm-Eder.de	184
6	2625	Kassel-Spohrstraße 	Spohrstraße 7	34117	Kassel	0561/7208-0	0561/7208-408	34111	34012	101249	52000000	52001500	BBK KASSEL	52050000	4091300006	LANDESKREDITKASSE KASSEL	Mo u. Fr 7:30-12:00, Mi 14:00-18:00 Uhr	poststelle@Finanzamt-Kassel-Spohrstrasse.de	www.Finanzamt-Kassel.de	185
6	2626	Kassel-Hofgeismar Verwaltungsstelle Kassel	Goethestraße 43	34119	Kassel	0561/7207-0	0561/7207-2500	34111	34012	101229	52000000	52001500	BBK KASSEL	52050000	4091300006	LANDESKREDITKASSE KASSEL	Mo, Mi u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr	poststelle@Finanzamt-Kassel-Hofgeismar.de	www.Finanzamt-Kassel.de	186
6	2627	Korbach-Frankenberg Verwaltungsstelle Korbach	Medebacher Landstraße 29	34497	Korbach	05631/563-0	05631/563-888	34495	34482	1240	52000000	52001509	BBK KASSEL	52350005	19588	SPK WALDECK-FRANKENBERG	Mo, Mi u. Fr 8:00-12:00, Do 15:30-18:00 Uhr	poststelle@Finanzamt-Korbach-Frankenberg.de	www.Finanzamt-Korbach-Frankenberg.de	187
6	2628	Langen 	Zimmerstraße 27	63225	Langen	06103/591-01	06103/591-285	63222	63202	1280	50000000	50001511	BBK FILIALE FRANKFURT MAIN	50592200	31500	VB DREIEICH	Mo, Mi u. Do 8:00-15:30, Di 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Langen.de	www.Finanzamt-Langen.de	188
6	2629	Alsfeld-Lauterbach Verwaltungsstelle Lauterbach	Bahnhofstraße 69	36341	Lauterbach	06631/790-0	06631/790-555	36339			53000000	53001501	BBK KASSEL EH FULDA	53051130	60100509	SPARKASSE VOGELSBERGKREIS	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr Telefon Verwaltungsstelle: 06641/188-0	poststelle@Finanzamt-Alsfeld-Lauterbach.de	www.Finanzamt-Alsfeld-Lauterbach.de	189
6	2630	Limburg-Weilburg Verwaltungsstelle Limburg	Walderdorffstraße 11	65549	Limburg	06431/208-1	06431/208-294	65547	65534	1465	51000000	51001507	BBK WIESBADEN	51050015	535054800	NASS SPK WIESBADEN	Mo-Mi 8:00-15:30, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Limburg-Weilburg.de	www.Finanzamt-Limburg-Weilburg.de	190
6	2631	Marburg-Biedenkopf Verwaltungsstelle Marburg	Robert-Koch-Straße 7	35037	Marburg	06421/698-0	06421/698-109	35034	35004	1469	51300000	51301512	BBK GIESSEN	53350000	11517	SPK MARBURG-BIEDENKOPF	Mo-Mi 8:00-15:30, Do 14:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Marburg-Biedenkopf.de	www.Finanzamt-Marburg-Biedenkopf.de	191
6	2632	Schwalm-Eder Verwaltungsstelle Melsungen	Kasseler Straße 31 (Schloß)	34212	Melsungen	05622/805-0	05622/805-111				52000000	52001503	BBK KASSEL	52052154	10060002	KREISSPARKASSE SCHWALM-EDER	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr Telefon Verwaltungsstelle: 05661/706-0	poststelle@Finanzamt-Schwalm-Eder.de	www.Finanzamt-Schwalm-Eder.de	192
6	2633	Michelstadt 	Erbacher Straße 48	64720	Michelstadt	06061/78-0	06061/78-100		64712	3180	50800000	50801503	BBK DARMSTADT	50851952	40041451	SPK ODENWALDKREIS ERBACH	Mo, Di u. Do 8:00-15:30, Mi 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Michelstadt.de	www.Finanzamt-Michelstadt.de	193
6	2634	Nidda 	Schillerstraße 38	63667	Nidda	06043/805-0	06043/805-159		63658	1180	50600000	50601501	BBK FRANKFURT EH HANAU	51850079	150003652	SPARKASSE WETTERAU	Mo, Di u. Do 7:30-16:00, Mi 13:30-18:00, Fr 7:00-12:00 Uhr	poststelle@Finanzamt-Nidda.de	www.Finanzamt-Nidda.de	194
6	2635	Offenbach am Main-Stadt 	Bieberer Straße 59	63065	Offenbach	069/8091-1	069/8091-2400	63063	63005	100563	50000000	50001500	BBK FILIALE FRANKFURT MAIN	50550020	493	STE SPK OFFENBACH	Mo, Di u. Do 7:30-15:30, Mi 13:00-18:00, Fr 7:30-12:00 Uhr	poststelle@Finanzamt-Offenbach-Stadt.de	www.Finanzamt-Offenbach.de	195
6	2636	Hersfeld-Rotenburg Verwaltungsstelle Rotenburg	Dickenrücker Straße 12	36199	Rotenburg	06621/933-0	06621/933-333				52000000	52001504	BBK KASSEL	53250000	50000012	SPK BAD HERSFELD-ROTENBURG	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr Telefon Verwaltungsstelle: 06623/816-0	poststelle@Finanzamt-Hersfeld-Rotenburg.de	www.Finanzamt-Hersfeld-Rotenburg.de	196
6	2637	Rheingau-Taunus Verwaltungsstelle Rüdesheim	Hugo-Asbach-Straße 3 - 7	65385	Rüdesheim	06124/705-0	06124/705-400				51000000	51001501	BBK WIESBADEN	51050015	455022800	NASS SPK WIESBADEN	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr Telefon Verwaltungsstelle: 06722/405-0	poststelle@Finanzamt-Rheingau-Taunus.de	www.Finanzamt-Rheingau-Taunus.de	197
6	2638	Limburg-Weilburg Verwaltungsstelle Weilburg	Kruppstraße 1	35781	Weilburg	06431/208-1	06431/208-294	35779			51000000	51001511	BBK WIESBADEN	51151919	100000843	KR SPK WEILBURG	Mo-Mi 8:00-16:00, Do 14:00-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Limburg-Weilburg.de	www.Finanzamt-Limburg-Weilburg.de	198
6	2640	Wiesbaden I 	Dostojewskistraße 8	65187	Wiesbaden	0611/813-0	0611/813-1000	65173	65014	2469	51000000	51001500	BBK WIESBADEN	51050015	100061600	NASS SPK WIESBADEN	Mo, Di u. Do 8:00-15:30, Mi 13:30-18:00, Fr 7:00-12:00 Uhr	poststelle@Finanzamt-Wiesbaden-1.de	www.Finanzamt-Wiesbaden.de	200
6	2641	Eschwege-Witzenhausen Verwaltungsstelle Witzenhausen	Südbahnhofstraße 37	37213	Witzenhausen	05651/926-5	05651/926-720				52000000	52001505	BBK KASSEL	52250030	50000991	SPARKASSE WERRA-MEISSNER	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr Telefon Verwaltungsstelle: 05542/602-0	poststelle@Finanzamt-Eschwege-Witzenhausen.de	www.Finanzamt-Eschwege-Witzenhausen.de	201
6	2642	Schwalm-Eder Verwaltungsstelle Schwalmstadt	Landgraf-Philipp-Straße 15	34613	Schwalmstadt	05622/805-0	05622/805-111				52000000	52001506	BBK KASSEL	52052154	200006641	KREISSPARKASSE SCHWALM-EDER	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr Telefon Verwaltungsstelle: 06691/738-0	poststelle@Finanzamt-Schwalm-Eder.de	www.Finanzamt-Schwalm-Eder.de	202
6	2643	Wiesbaden II 	Dostojewskistraße 8	65187	Wiesbaden	0611/813-0	0611/813-2000	65173	65014	2469	51000000	51001500	BBK WIESBADEN	51050015	100061600	NASS SPK WIESBADEN	Mo, Di u. Do 8:00-15:30, Mi 13:30-18:00, Fr 7:00-12:00 Uhr	poststelle@Finanzamt-Wiesbaden-2.de	www.Finanzamt-Wiesbaden.de	203
6	2644	Offenbach am Main-Land 	Bieberer Straße 59	63065	Offenbach	069/8091-1	069/8091-3400	63063	63005	100552	50000000	50001500	BBK FILIALE FRANKFURT MAIN	50550020	493	STE SPK OFFENBACH	Mo, Di u. Do 7:30-15:30, Mi 13:00-18:00, Fr 7:30-12:00 Uhr	poststelle@Finanzamt-Offenbach-Land.de	www.Finanzamt-Offenbach.de	204
6	2645	Frankfurt am Main III 	Gutleutstraße 120	60327	Frankfurt	069/2545-03	069/2545-3999		60305	110863	50000000	50001504	BBK FILIALE FRANKFURT MAIN	50050000	1600006	LD BK HESS-THUER GZ FFM	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr	poststelle@Finanzamt-Frankfurt-3.de	wwww.Finanzamt-Frankfurt-am-Main.de	205
6	2646	Hofheim am Taunus 	Nordring 4 - 10	65719	Hofheim	06192/960-0	06192/960-412	65717	65703	1380	50000000	50001503	BBK FILIALE FRANKFURT MAIN	51250000	2000008	TAUNUS-SPARKASSE BAD HOMBG	Mo-Mi 8:00-15:30, Do 13:30-18:00, Fr 8:00-12:00 Uhr	poststelle@Finanzamt-Hofheim-am-Taunus.de	www.Finanzamt-Hofheim-am-Taunus.de	206
6	2647	Frankfurt/M. V-Höchst Verwaltungsstelle Frankfurt	Gutleutstraße 116	60327	Frankfurt	069/2545-05	069/2545-5999		60305	110865	50000000	50001504	BBK FILIALE FRANKFURT MAIN	50050000	1600006	LD BK HESS-THUER GZ FFM	Mo u. Mi 8:00-12:00, Do 14:00-18:00 Uhr	poststelle@Finanzamt-Frankfurt-5-Hoechst.de	www.Finanzamt-Frankfurt-am-Main.de	207
7	2701	Bad Neuenahr-Ahrweiler 	Römerstr. 5	53474	Bad Neuenahr-Ahrweiler	02641/3820	02641/38212000		53457	1209	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-aw.fin-rlp.de		208
7	2702	Altenkirchen-Hachenburg 	Frankfurter Str. 21	57610	Altenkirchen	02681/860	02681/8610090	57609	57602	1260	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ak.fin-rlp.de	www.finanzamt-altenkirchen-hachenburg.de	209
7	2703	Bingen-Alzey Aussenstelle Alzey	Rochusallee 10	55411	Bingen	06721/7060	06721/70614080	55409	55382		55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06731/4000	Poststelle@fa-bi.fin-rlp.de	www.finanzamt-bingen-alzey.de	210
7	2706	Bad Kreuznach 	Ringstr. 10	55543	Bad Kreuznach	0671/7000	0671/70011702	55541	55505	1552	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-kh.fin-rlp.de	www.finanzamt-bad-kreuznach.de	211
7	2707	Bernkastel-Wittlich Aussenstelle Bernkastel-Kues	Unterer Sehlemet 15	54516	Wittlich	06571/95360	06571/953613400		54502	1240	55050000	902	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06531/5060	Poststelle@fa-wi.fin-rlp.de	www.finanzamt-bernkastel-wittlich.de	212
7	2708	Bingen-Alzey 	Rochusallee 10	55411	Bingen	06721/7060	06721/70614080	55409	55382		55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-bi.fin-rlp.de	www.finanzamt-bingen-alzey.de	213
7	2709	Idar-Oberstein 	Hauptstraße 199	55743	Idar-Oberstein	06781/680	06781/6818333		55708	11820	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-io.fin-rlp.de	www.finanzamt-idar-oberstein.de	214
7	2710	Bitburg-Prüm 	Kölner Straße 20	54634	Bitburg	06561/6030	06561/60315090		54622	1252	55050000	902	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-bt.fin-rlp.de	www.finanzamt-bitburg-pruem.de	215
7	2713	Daun 	Berliner Straße 1	54550	Daun	06592/95790	06592/957916175		54542	1160	55050000	902	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-da.fin-rlp.de	www.finanzamt-daun.de	216
7	2714	Montabaur-Diez Aussenstelle Diez	Koblenzer Str. 15	56410	Montabaur	02602/1210	02602/12127099	56409	56404	1461	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06432/5040	Poststelle@fa-mt.fin-rlp.de	www.finanzamt-montabaur-diez.de	217
7	2715	Frankenthal 	Friedrich-Ebert-Straße 6	67227	Frankenthal	06233/49030	06233/490317082	67225	67203	1324	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ft.fin-rlp.de	www.finanzamt-frankenthal.de	218
7	2716	Speyer-Germersheim Aussenstelle Germersheim	Johannesstr. 9-12	67346	Speyer	06232/60170	06232/601733431	67343	67323	1309	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 07274/9500	Poststelle@fa-sp.fin-rlp.de	www.finanzamt-speyer-germersheim.de	219
7	2718	Altenkirchen-Hachenburg Aussenstelle Hachenburg	Frankfurter Str. 21	57610	Altenkirchen	02681/860	02681/8610090	57609	57602	1260	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 02662/94520	Poststelle@fa-ak.fin-rlp.de	www.finanzamt-altenkirchen-hachenburg.de	220
7	2719	Kaiserslautern 	Eisenbahnstr. 56	67655	Kaiserslautern	0631/36760	0631/367619500	67653	67621	3360	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-kl.fin-rlp.de	www.finanzamt-kaiserslautern.de	221
7	2721	Worms-Kirchheimbolanden Aussenstelle Kirchheimbolanden	Karlsplatz 6	67549	Worms	06241/30460	06241/304635060	67545			55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06352/4070	Poststelle@fa-wo.fin-rlp.de	www.finanzamt-worms-kirchheimbolanden.de	222
7	2722	Koblenz 	Ferdinand-Sauerbruch-Str. 19	56073	Koblenz	0261/49310	0261/493120090	56060	56007	709	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ko.fin-rlp.de	www.finanzamt-koblenz.de	223
7	2723	Kusel-Landstuhl 	Trierer Str. 46	66869	Kusel	06381/99670	06381/996721060		66864	1251	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ku.fin-rlp.de	www.finanzamt-kusel-landstuhl.de	224
7	2724	Landau 	Weißquartierstr. 13	76829	Landau	06341/9130	06341/91322100	76825	76807	1760u.1780	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ld.fin-rlp.de		225
7	2725	Kusel-Landstuhl Aussenstelle Landstuhl	Trierer Str. 46	66869	Kusel	06381/99670	06381/996721060		66864	1251	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06371/61730	Poststelle@fa-ku.fin-rlp.de	www.finanzamt-kusel-landstuhl.de	226
7	2726	Mainz-Mitte 	Schillerstr. 13	55116	Mainz	06131/2510	06131/25124090		55009	1980	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-mz.fin-rlp.de	www.finanzamt-mainz-mitte.de	227
7	2727	Ludwigshafen 	Bayernstr. 39	67061	Ludwigshafen	0621/56140	0621/561423051		67005	210507	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-lu.fin-rlp.de	www.finanzamt-ludwigshafen.de	228
7	2728	Mainz-Süd 	Emy-Roeder-Str. 3	55129	Mainz	06131/5520	06131/55225272		55071	421365	55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ms.fin-rlp.de	www.finanzamt-mainz-sued.de	229
7	2729	Mayen 	Westbahnhofstr. 11	56727	Mayen	02651/70260	02651/702626090		56703	1363	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-my.fin-rlp.de	www.finanzamt-mayen.de	230
7	2730	Montabaur-Diez 	Koblenzer Str. 15	56410	Montabaur	02602/1210	02602/12127099	56409	56404	1461	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-mt.fin-rlp.de	www.finanzamt-montabaur-diez.de	231
7	2731	Neustadt 	Konrad-Adenauer-Str. 26	67433	Neustadt	06321/9300	06321/93028600	67429	67404	100 465	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-nw.fin-rlp.de		232
7	2732	Neuwied 	Augustastr. 54	56564	Neuwied	02631/9100	02631/91029906	56562	56505	1561	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-nr.fin-rlp.de		233
7	2735	Pirmasens-Zweibrücken 	Kaiserstr. 2	66955	Pirmasens	06331/7110	06331/71130950	66950	66925	1662	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-ps.fin-rlp.de	www.finanzamt-pirmasens-zweibruecken.de	234
7	2736	Bitburg-Prüm Aussenstelle Prüm	Kölner Str. 20	54634	Bitburg	06561/6030	06561/60315093		54622	1252	55050000	902	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06551/9400	Poststelle@fa-bt.fin-rlp.de	www.finanzamt-bitburg-pruem.de	235
7	2738	Sankt Goarshausen-Sankt Goar Aussenstelle Sankt Goar	Wellmicher Str. 79	56346	St. Goarshausen	06771/95900	06771/959031090		56342		55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06741/98100	Poststelle@fa-gh.fin-rlp.de	www.finanzamt-sankt-goarshausen-sankt-goar.de	236
7	2739	Sankt Goarshausen-Sankt Goar 	Wellmicher Str. 79	56346	St. Goarshausen	06771/95900	06771/959031090		56342		55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-gh.fin-rlp.de	www.finanzamt-sankt-goarshausen-sankt-goar.de	237
7	2740	Simmern-Zell 	Brühlstraße 3	55469	Simmern	06761/8550	06761/85532053		55464	440	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-si.fin-rlp.de		238
7	2741	Speyer-Germersheim 	Johannesstr. 9-12	67346	Speyer	06232/60170	06232/601733431	67343	67323	1309	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-sp.fin-rlp.de	www.finanzamt-speyer-germersheim.de	239
7	2742	Trier 	Hubert-Neuerburg-Str. 1	54290	Trier	0651/93600	0651/936034900		54207	1750u.1760	55050000	902	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-tr.fin-rlp.de	www.finanzamt-trier.de	240
7	2743	Bernkastel-Wittlich 	Unterer Sehlemet 15	54516	Wittlich	06571/95360	06571/953613400		54502	1240	55050000	902	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-wi.fin-rlp.de	www.finanzamt-bernkastel-wittlich.de	241
7	2744	Worms-Kirchheimbolanden 	Karlsplatz 6	67549	Worms	06241/30460	06241/304635060	67545			55050000	901	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR	Poststelle@fa-wo.fin-rlp.de	www.finanzamt-worms-kirchheimbolanden.de	242
7	2745	Simmern-Zell Aussenstelle Zell	Brühlstr. 3	55469	Simmern	06761/8550	06761/85532053		55464	440	55050000	908	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06542/7090	Poststelle@fa-si.fin-rlp.de		243
7	2746	Pirmasens-Zweibrücken Aussenstelle Zweibrücken	Kaiserstr. 2	66955	Pirmasens	06331/7110	06331/71130950	66950	66925	1662	55050000	910	LRP GZ MAINZ				8.00-17.00 MO-MI 8.00-18.00 DO 8.00-13.00 FR Telefon-Nr. Aussenstelle: 06332/80680	Poststelle@fa-ps.fin-rlp.de	www.finanzamt-pirmasens-zweibruecken.de	244
8	2801	Achern 	Allerheiligenstr. 10	77855	Achern	07841/6940	07841/694136	77843	77843	1260	66000000	66001518	BBK KARLSRUHE	66450050	88013009	SPARKASSE OFFENBURG-ORTENAU	MO-DO 8-12.30+13.30-15.30,DO-17.30,FR 8-12 H	poststelle@fa-achern.fv.bwl.de		245
8	2804	Donaueschingen 	Käferstr. 25	78166	Donaueschingen	0771/8080	0771/808359	78153	78153	1269	69400000	694 01501	BBK VILLINGEN-SCHWENNINGEN	69421020	6204700600	BW BANK DONAUESCHINGEN	MO-MI 8-16 UHR, DO 8-17.30 UHR, FR 8-12 UHR	poststelle@fa-donaueschingen.fv.bwl.de		246
12	3057	Calau 	Springteichallee 25	3205	Calau	03541 83-0	03541 83-100		3201	11 71	18000000	18001502	BBK COTTBUS				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Calau@fa.brandenburg.de		335
8	2805	Emmendingen 	Bahnhofstr. 3	79312	Emmendingen	07641/4500	07641/450350	79305	79305	1520	68000000	680 01507	BBK FREIBURG IM BREISGAU	68050101	20066684	SPK FREIBURG-NOERDL BREISGA	MO-MI 7:30-15:30,DO 7:30-17:00,FR 7:30-12:00	poststelle@fa-emmendingen.fv.bwl.de		247
8	2806	Freiburg-Stadt 	Sautierstr. 24	79104	Freiburg	0761/2040	0761/2043295	79079			68000000	680 01501	BBK FREIBURG IM BREISGAU	68020020	4402818100	BW BANK FREIBURG BREISGAU	MO, DI, DO 7.30-16,MI 7.30-17.30, FR 7.30-12	poststelle@fa-freiburg-stadt.fv.bwl.de		248
8	2808	Kehl 	Ludwig-Trick-Str. 1	77694	Kehl	07851/8640	07851/864108	77676	77676	1640	66400000	664 01501	BBK FREIBURG EH OFFENBURG	66451862	-6008	SPK HANAUERLAND KEHL	MO,DI,MI 7.45-15.30, DO -17.30, FR -12.00UHR	poststelle@fa-kehl.fv.bwl.de		249
8	2809	Konstanz 	Bahnhofplatz 12	78462	Konstanz	07531/2890	07531/289312	78459			69400000	69001500	BBK VILLINGEN-SCHWENNINGEN	69020020	6604947900	BW BANK KONSTANZ	MO,DI,DO 7.30-15.30,MI 7.30-17.00,FR 7.30-12	poststelle@fa-konstanz.fv.bwl.de		250
8	2810	Lahr 	Gerichtstr. 5	77933	Lahr	07821/2830	07821/283100		77904	1466	66000000	66001527	BBK KARLSRUHE	66450050	76103333	SPARKASSE OFFENBURG-ORTENAU	MO,DI,DO 7:30-16:00, MI 7:30-17:30, FR 7:30-12:00	poststelle@fa-lahr.fv.bwl.de		251
8	2811	Lörrach 	Luisenstr. 10 a	79539	Lörrach	07621/1730	07621/173245	79537			68000000	68301500	BBK FREIBURG IM BREISGAU	68320020	4602600100	BW BANK LOERRACH	MO-MI 7.00-15.30/DO 7.00-17.30/FR 7.00-12.00	poststelle@fa-loerrach.fv.bwl.de		252
8	2812	Müllheim 	Goethestr. 11	79379	Müllheim	07631/18900	(07631)189-190	79374	79374	1461	68000000	680 01511	BBK FREIBURG IM BREISGAU	68351865	802 888 8	SPARKASSE MARKGRAEFLERLAND	MO-MI 7,30-15,30 DO 7,30-17,30 FR 7,30-12,00	poststelle@fa-muellheim.fv.bwl.de		253
8	2813	Titisee-Neustadt 	Goethestr. 5	79812	Titisee-Neustadt	07651/2030	07651/203110		79812	12 69	68000000	680 015 10	BBK FREIBURG IM BREISGAU	68051004	4040408	SPK HOCHSCHWARZWALD T-NEUST	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.30	poststelle@fa-titisee-neustadt.fv.bwl.de		254
8	2814	Offenburg 	Zeller Str. 1- 3	77654	Offenburg	0781/9330	0781/9332444	77604	77604	1440	68000000	664 01500	BBK FREIBURG IM BREISGAU	66420020	4500000700	BW BANK OFFENBURG	MO-DO 7.30-15.30 DURCHGEHEND,MI -18.00,FR-12	poststelle@fa-offenburg.fv.bwl.de		255
8	2815	Oberndorf 	Brandeckerstr. 4	78727	Oberndorf	07423/8150	07423/815107	78721	78721	1240	69400000	694 01506	BBK VILLINGEN-SCHWENNINGEN	64250040	813 015	KR SPK ROTTWEIL	ZIA:MO,DI,DO 8-16,MI 8-17:30,FR 8-12 UHR	poststelle@fa-oberndorf.fv.bwl.de		256
8	2816	Bad Säckingen 	Werderstr. 5	79713	Bad Säckingen	07761/5660	07761/566126	79702	79702	1148	68000000	683 015 02	BBK FREIBURG IM BREISGAU				MO,DI,DO 8-15.30, MI 8-17.30, FR 8-12 UHR	poststelle@fa-badsaeckingen.fv.bwl.de		257
8	2818	Singen 	Alpenstr. 9	78224	Singen	07731/8230	07731/823650		78221	380	69000000	69001507	BBK VILL-SCHWEN EH KONSTANZ	69220020	6402000100	BW BANK SINGEN	MO-DO 7:30-15:30, MI bis 17:30, FR 7:30-12:00	poststelle@fa-singen.fv.bwl.de		258
8	2819	Rottweil 	Körnerstr. 28	78628	Rottweil	0741/2430	0741/2432194	78612	78612	1252	69400000	69401505	BBK VILLINGEN-SCHWENNINGEN	64250040	136503	KR SPK ROTTWEIL	MO-MI 8-16, DO 8-18, FR 8-12 UHR	poststelle@fa-rottweil.fv.bwl.de		259
8	2820	Waldshut-Tiengen 	Bahnhofstr. 11	79761	Waldshut-Tiengen	07741/6030	07741/603213	79753	79753	201360	68000000	68301501	BBK FREIBURG IM BREISGAU	68452290	14449	SPARKASSE HOCHRHEIN	MO-MI 8-15.30,DO 8-17.30,FR 8-12 UHR	poststelle@fa-waldshut-tiengen.fv.bwl.de		260
8	2821	Tuttlingen 	Zeughausstr. 91	78532	Tuttlingen	07461/980	07461/98303		78502	180	69400000	69401502	BBK VILLINGEN-SCHWENNINGEN	64350070	251	KR SPK TUTTLINGEN	MO-MI8-15.30,DO8-17.30,FR8-12.00UHR	poststelle@fa-tuttlingen.fv.bwl.de		261
8	2822	Villingen-Schwenningen 	Weiherstr. 7	78050	Villingen-Schwenningen	07721/923-0	07721/923-100	78045			69400000	69401500	BBK VILLINGEN-SCHWENNINGEN				MO-MI 8-16UHR,DO 8-17.30UHR,FR 8-12UHR	poststelle@fa-villingen-schwenningen.fv.bwl.de		262
8	2823	Wolfach 	Hauptstr. 55	77709	Wolfach	07834/9770	07834/977-169	77705	77705	1160	66400000	664 01502	BBK FREIBURG EH OFFENBURG	66452776	-31956	SPK WOLFACH	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.00	poststelle@fa-wolfach.fv.bwl.de		263
8	2830	Bruchsal 	Schönbornstr. 1-5	76646	Bruchsal	07251/740	07251/742111	76643	76643	3021	66000000	66001512	BBK KARLSRUHE	66350036	50	SPK KRAICHGAU	SERVICEZENTRUM:MO-MI8-15:30DO8-17:30FR8-1200	poststelle@fa-bruchsal.fv.bwl.de		264
8	2831	Ettlingen 	Pforzheimer Str. 16	76275	Ettlingen	07243/5080	07243/508295	76257	76257	363	66000000	66001502	BBK KARLSRUHE	66051220	1043009	SPARKASSE ETTLINGEN	MO+DI 8-15.30,MI 7-15.30,DO 8-17.30,FR 8-12	poststelle@fa-ettlingen.fv.bwl.de		265
8	2832	Heidelberg 	Kurfürsten-Anlage 15-17	69115	Heidelberg	06221/590	06221/592355	69111			67000000	67001510	BBK MANNHEIM	67220020	5302059000	BW BANK HEIDELBERG	ZIA:MO-DO 7.30-15.30, MI - 17.30, FR - 12.00	poststelle@fa-heidelberg.fv.bwl.de		266
8	2833	Baden-Baden 	Stephanienstr. 13 + 15	76530	Baden-Baden	07221/3590	07221/359320	76520			66000000	66001516	BBK KARLSRUHE	66220020	4301111300	BW BANK BADEN-BADEN	MO,DI,DO 8-16 UHR,MI 8-17.30 UHR,FR 8-12 UHR	poststelle@fa-baden-baden.fv.bwl.de		267
8	2834	Karlsruhe-Durlach 	Prinzessenstr. 2	76227	Karlsruhe	0721/9940	0721/9941235	76225	76203	410326	66000000	66001503	BBK KARLSRUHE				MO-DO 8-15.30,MI 8-17.30,FR 8-12	poststelle@fa-karlsruhe-durlach.fv.bwl.de		268
8	2835	Karlsruhe-Stadt 	Schlossplatz 14	76131	Karlsruhe	0721/1560	(0721) 156-1000				66000000	66001501	BBK KARLSRUHE	66020020	4002020800	BW BANK KARLSRUHE	MO-DO 7.30-15.30 MI -17.30 FR 7.30-12.00	poststelle@fa-karlsruhe-stadt.fv.bwl.de		269
8	2836	Bühl 	Alban-Stolz-Str. 8	77815	Bühl	07223/8030	07223/3625	77815			66000000	66001525	BBK KARLSRUHE	66220020	4301111300	BW BANK BADEN-BADEN	MO,DI,DO=8-16UHR, MI=8-17.30UHR,FR=8-12UHR	poststelle@fa-buehl.fv.bwl.de		270
8	2837	Mannheim-Neckarstadt 	L3, 10	68161	Mannheim	0621/2920	0621/292-1010	68150			67000000	67001500	BBK MANNHEIM	67020020	5104719900	BW BANK MANNHEIM	MO,DI,DO7.30-15.30,MI7.30-17.30,FR7.30-12.00	poststelle@fa-mannheim-neckarstadt.fv.bwl.de		271
8	2838	Mannheim-Stadt 	L3, 10	68161	Mannheim	0621/2920	2923640	68150			67000000	670 01500	BBK MANNHEIM	67020020	5104719900	BW BANK MANNHEIM	MO,DI,DO7.30-15.30,MI7.30.17.30,FR7.30-12.00	poststelle@fa-mannheim-stadt.fv.bwl.de		272
8	2839	Rastatt 	An der Ludwigsfeste 3	76437	Rastatt	07222/9780	07222/978330	76404	76404	1465	66000000	66001519	BBK KARLSRUHE	66020020	4150199000	BW BANK KARLSRUHE	MO-MI 8-15:30 UHR,DO 8-17:30 UHR,FR 8-12 UHR	poststelle@fa-rastatt.fv.bwl.de		273
8	2840	Mosbach 	Pfalzgraf-Otto-Str. 5	74821	Mosbach	06261/8070	06261/807200	74819			62000000	62001502	BBK HEILBRONN, NECKAR	62030050	5501964000	BW BANK HEILBRONN	MO-DO 08.00-16.00 UHR, DO-17.30,FR-12.00 UHR	poststelle@fa-mosbach.fv.bwl.de		274
8	2841	Pforzheim 	Moltkestr. 8	75179	Pforzheim	07231/1830	(07231)183-1111	75090			66000000	66001520	BBK KARLSRUHE	66620020	4812000000	BW BANK PFORZHEIM	MO-DO 7:30-15:30, DO bis 17:30, FR 7:30-12:00	poststelle@fa-pforzheim.fv.bwl.de		275
8	2842	Freudenstadt 	Musbacher Str. 33	72250	Freudenstadt	07441/560	07441/561011				66000000	66001510	BBK KARLSRUHE	64251060	19565	KR SPK FREUDENSTADT	MO-MI 8.00-16.00,DO 8.00-17.30,FR 8.00-12.00	poststelle@fa-freudenstadt.fv.bwl.de		276
8	2843	Schwetzingen 	Schloss	68723	Schwetzingen	06202/810	(06202) 81298	68721			67000000	67001501	BBK MANNHEIM	67250020	25008111	SPK HEIDELBERG	ZIA:MO-DO 7.30-15.30,MI-17.30,FR.7.30-12.00	poststelle@fa-schwetzingen.fv.bwl.de		277
8	2844	Sinsheim 	Bahnhofstr. 27	74889	Sinsheim	07261/6960	07261/696444	74887			67000000	67001511	BBK MANNHEIM				MO-DO 7:30-15:30, MI bis 17:30, FR 7:30-12 UHR	poststelle@fa-sinsheim.fv.bwl.de		278
8	2845	Calw 	Klosterhof 1	75365	Calw	07051/5870	07051/587111	75363			66000000	66001521	BBK KARLSRUHE	60651070	1996	SPARKASSE PFORZHEIM CALW	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.00	poststelle@fa-calw.fv.bwl.de		279
8	2846	Walldürn 	Albert-Schneider-Str. 1	74731	Walldürn	06282/7050	06282/705101	74723	74723	1162	62000000	62001509	BBK HEILBRONN, NECKAR	67450048	8102204	SPK NECKARTAL-ODENWALD	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.00	poststelle@fa-wallduern.fv.bwl.de		280
8	2847	Weinheim 	Weschnitzstr. 2	69469	Weinheim	06201/6050	(06201) 605-220/299 	69443	69443	100353	67000000	67001502	BBK MANNHEIM	67050505	63034444	SPK RHEIN NECKAR NORD	MO-MI 7.30-15.30 DO 7.30-17.30 FR 7.30-12	poststelle@fa-weinheim.fv.bwl.de		281
8	2848	Mühlacker 	Konrad-Adenauer-Platz 6	75417	Mühlacker	07041/8930	07041/893999		75415	1153	66000000	660 015 22	BBK KARLSRUHE	66650085	961 000	SPARKASSE PFORZHEIM CALW	ZIA:MO-DO 8-12:30 13:30-15:30 DO bis 17:30 FR 8-12	poststelle@fa-muehlacker.fv.bwl.de		282
16	4165	Pößneck 	Gerberstr. 65	7381	Pößneck	(03647)446-0	(03647)446430		7372	1253	82050000	3001111578	LD BK HESS-THUER GZ ERFURT				MO-FR 8-12 MO,MI,DO 13-15 UHR DI 13-18 UHR	poststelle@finanzamt-poessneck.thueringen.de		426
8	2849	Neuenbürg 	Wildbader Str. 107	75305	Neuenbürg	07082/7990	07082/799166	75301	75301	1165	66600000	66601503	BBK PFORZHEIM	66650085	998400	SPARKASSE PFORZHEIM CALW	MO-FR 7.30-12UHR,MO-MI 13-16UHR,DO 13-18UHR	poststelle@fa-neuenbuerg.fv.bwl.de		283
8	2850	Aalen / Württemberg 	Bleichgartenstr. 17	73431	Aalen	(07361) 9578-0	(07361)9578-440	73428			63000000	614 01500	BBK ULM, DONAU	61450050	110036902	KREISSPARKASSE OSTALB	MO-MI 7.30-16.00,DO 7.30-18.00,FR 7.30-12.00	poststelle@fa-aalen.fv.bwl.de		284
8	2851	Backnang 	Stiftshof 20	71522	Backnang	07191/120	07191/12221	71522			60000000	60201501	BBK STUTTGART	60250010	244	KR SPK WAIBLINGEN	MO,DI,DO7.30-16.00MI7.30-18.00FR7.30-12.00	poststelle@fa-backnang.fv.bwl.de		285
8	2852	Bad Mergentheim 	Schloss 7	97980	Bad Mergentheim	07931/5300	07931/530228	97962	97962	1233	62000000	620 01508	BBK HEILBRONN, NECKAR	67352565	25866	SPK TAUBERFRANKEN	MO-DO 7.30-15.30,MI-17.30 UHR,FR 7.30-12 UHR	poststelle@fa-badmergentheim.fv.bwl.de		286
8	2853	Balingen 	Jakob-Beutter-Str. 4	72336	Balingen	07433/970	07433/972099	72334			64000000	653 01500	BBK REUTLINGEN	65351260	24000110	SPK ZOLLERNALB	Mo-Mi 7:45-16:00,Do 7:45-17:30,Fr 7:45-12:30	poststelle@fa-balingen.fv.bwl.de		287
8	2854	Biberach 	Bahnhofstr. 11	88400	Biberach	07351/590	07351/59202	88396			63000000	63001508	BBK ULM, DONAU	65450070	17	KR SPK BIBERACH	MO,DI,DO 8-15.30, MI 8-17.30, FR 8-12 UHR	poststelle@fa-biberach.fv.bwl.de		288
8	2855	Bietigheim-Bissingen 	Kronenbergstr. 13	74321	Bietigheim-Bissingen	07142/5900	07142/590199	74319			60000000	604 01501	BBK STUTTGART	60490150	427500001	VOLKSBANK LUDWIGSBURG	MO-MI(DO)7.30-15.30(17.30),FR 7.30-12.00 UHR	poststelle@fa-bietigheim-bissingen.fv.bwl.de		289
8	2856	Böblingen 	Talstr. 46	71034	Böblingen	(07031)13-01	07031/13-3200	71003	71003	1307	60300000	603 01500	BBK STUTTGART EH SINDELFING	60350130	220	KR SPK BOEBLINGEN	MO-MI 7.30-15.30,DO7.30-17.30,FR7.30-12.30	poststelle@fa-boeblingen.fv.bwl.de		290
8	2857	Crailsheim 	Schillerstr. 1	74564	Crailsheim	07951/4010	07951/401220	74552	74552	1252	62000000	620 01506	BBK HEILBRONN, NECKAR	62250030	282	SPARKASSE SCHWAEBISCH HALL	MO-DO:7.45-16.00,MI:-17.30,FR:7.45-12.30	poststelle@fa-crailsheim.fv.bwl.de		291
8	2858	Ehingen 	Hehlestr. 19	89584	Ehingen	07391/5080	07391/508260	89572	89572	1251	63000000	630 01502	BBK ULM, DONAU	63050000	9 300 691	SPARKASSE ULM	Mo-Mi 7.30-15.30,Do 7.30-17.30,Fr 7.30-12.00	poststelle@fa-ehingen.fv.bwl.de		292
8	2859	Esslingen 	Entengrabenstr. 11	73728	Esslingen	0711/39721	0711/3972400	73726			61100000	61101500	BBK STUTTGART EH ESSLINGEN	61150020	902139	KR SPK ESSLINGEN-NUERTINGEN	Infothek Mo-Mi 7-15.30,Do-17.30, Fr 7-12 Uhr	poststelle@fa-esslingen.fv.bwl.de		293
8	2861	Friedrichshafen 	Ehlersstr. 13	88046	Friedrichshafen	07541/7060	07541/706111	88041			63000000	65001504	BBK ULM, DONAU				MO-MI 8-15.30, DO 8-17.30, FR 8-12.30 Uhr	poststelle@fa-friedrichshafen.fv.bwl.de		294
8	2862	Geislingen 	Schillerstr. 2	73312	Geislingen	07331/220	07331/22200	73302	73302	1253	60000000	61101504	BBK STUTTGART	61050000	6007203	KR SPK GOEPPINGEN	Mo-Mi 7-15:30, Do 7-17:30,Fr 7-12	poststelle@fa-geislingen.fv.bwl.de		295
8	2863	Göppingen 	Gartenstr. 42	73033	Göppingen	07161/63-0	07161/632935		73004	420	60000000	61101503	BBK STUTTGART	61050000	1 023	KR SPK GOEPPINGEN	MO-MI.7-15.30 Uhr,DO.7-17.30 Uhr,FR.7-12 Uhr	poststelle@fa-goeppingen.fv.bwl.de		296
8	2864	Heidenheim 	Marienstr. 15	89518	Heidenheim	07321/380	07321/381528	89503	89503	1320	63000000	61401505	BBK ULM, DONAU	63250030	880433	KR SPK HEIDENHEIM	Mo-Mi 7.30-15.30 Do 7.30-17.30 Fr 7.30-12.30	poststelle@fa-heidenheim.fv.bwl.de		297
8	2865	Heilbronn 	Moltkestr. 91	74076	Heilbronn	07131/1041	07131/1043000	74064			62000000	620 01500	BBK HEILBRONN, NECKAR	62050000	123925	KR SPK HEILBRONN	Mo,Di,Do7:30-15:30,Mi7:30-17:30,Fr7:30-12:00	poststelle@fa-heilbronn.fv.bwl.de		298
8	2869	Kirchheim 	Alleenstr. 120	73230	Kirchheim	07021/5750	575258	73220	73220	1241	61100000	61101501	BBK STUTTGART EH ESSLINGEN	61150020	48317054	KR SPK ESSLINGEN-NUERTINGEN	KUNDENCENTER MO-MI 8-15.30,DO 8-17.30,FR8-12	poststelle@fa-kirchheim.fv.bwl.de		299
8	2870	Leonberg 	Schlosshof 3	71229	Leonberg	(07152) 15-1	07152/15333	71226			60000000	60301501	BBK STUTTGART	60350130	8619864	KR SPK BOEBLINGEN	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.30	poststelle@fa-leonberg.fv.bwl.de		300
8	2871	Ludwigsburg 	Alt-Württ.-Allee 40 (Neubau)	71638	Ludwigsburg	07141/180	07141/182105	71631			60000000	604 01500	BBK STUTTGART	60450050	7 759	KREISSPARKASSE LUDWIGSBURG	MO-MI 8-15.30,DO 8-18.00,FR 8-12.00	poststelle@fa-ludwigsburg.fv.bwl.de		301
8	2874	Nürtingen 	Sigmaringer Str. 15	72622	Nürtingen	07022/7090	07022/709-120	72603	72603	1309	60000000	61101502	BBK STUTTGART				MO-Mi 7.30-15.30 Do 7.30-17.30 Fr 7.30-12.00	poststelle@fa-nuertingen.fv.bwl.de		302
8	2876	Öhringen 	Haagweg 39	74613	Öhringen	07941/6040	07941/604400	74611			62000000	62001501	BBK HEILBRONN, NECKAR	62251550	40008	SPARKASSE HOHENLOHEKREIS	MO-DO 7.30-16.00UhrFR 7.30-12.00 Uhr	poststelle@fa-oehringen.fv.bwl.de		303
8	2877	Ravensburg 	Broner Platz 12	88250	Weingarten	0751/4030	403-303	88248			65000000	650 015 00	BBK ULM EH RAVENSBURG	65050110	86 500 500	KR SPK RAVENSBURG	Mo,Di,Do 8-15.30Uhr,ZIA Mi 8-17.30,Fr8-12Uhr	poststelle@fa-ravensburg.fv.bwl.de		304
8	2878	Reutlingen 	Leonhardsplatz 1	72764	Reutlingen	07121/9400	07121/9401002	72705	72705	1543	64000000	64001500	BBK REUTLINGEN	64050000	64 905	KR SPK REUTLINGEN	Mo-Mi 7-15.30, Do 7-17.30, Fr 7-12.00 Uhr	poststelle@fa-reutlingen.fv.bwl.de		305
8	2879	Riedlingen 	Kirchstr. 30	88499	Riedlingen	07371/1870	07371/1871000	88491	88491	1164	63000000	63001509	BBK ULM, DONAU	65450070	400 600	KR SPK BIBERACH	INFOST. MO-MI 7.30-15.30,DO-17.30,FR-12 UHR	poststelle@fa-riedlingen.fv.bwl.de		306
8	2880	Tauberbischofsheim 	Dr.-Burger-Str. 1	97941	Tauberbischofsheim	09341/8040	09341/804244	97933	97933	1340	62000000	620 01507	BBK HEILBRONN, NECKAR	67332551	8282661100	BW BANK TAUBERBISCHOFSHEIM	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.00	poststelle@fa-tauberbischofsheim.fv.bwl.de		307
8	2881	Bad Saulgau 	Schulstr. 5	88348	Bad Saulgau	07581/504-0	07581/504499	88341	88341	1255	65000000	650 01501	BBK ULM EH RAVENSBURG	65351050	210058	LD BK KR SPK SIGMARINGEN	MO,DO,FR 8-12,DO 13.30-15.30UHR	poststelle@fa-badsaulgau.fv.bwl.de		308
8	2882	Schorndorf 	Johann-Philipp-Palm-Str. 28	73614	Schorndorf	07181/6010	07181/601499	73603	73603	1320	60000000	60201502	BBK STUTTGART	60250010	5014008	KR SPK WAIBLINGEN	MO,DI,DO 8-15.30,MI 8-17.30,FR 8-12.00	poststelle@fa-schorndorf.fv.bwl.de		309
8	2883	Schwäbisch Gmünd 	Augustinerstr. 6	73525	Schwäbisch Gmünd	(07171) 602-0	07171/602266	73522			63000000	61401501	BBK ULM, DONAU	61450050	440066604	KREISSPARKASSE OSTALB	MO,DI,DO 8-15.30 MI 8-17.30 FR 8-12.00 UHR	poststelle@fa-schwaebischgmuend.fv.bwl.de		310
8	2884	Schwäbisch Hall 	Bahnhofstr. 25	74523	Schwäbisch Hall	0791/752-0	0791/7521115	74502	74502	100260	62000000	62001503	BBK HEILBRONN, NECKAR	62250030	5070 011	SPARKASSE SCHWAEBISCH HALL	MO-MI 7.30-16.00 DO 7.30-17.30 FR 7.30-12.00	poststelle@fa-schwaebischhall.fv.bwl.de		311
8	2885	Sigmaringen 	Karlstr. 31	72488	Sigmaringen	07571/1010	07571/101300	72481	72481	1250	65300000	653 01501	BBK REUTLINGEN EH ALBSTADT	65351050	808 408	LD BK KR SPK SIGMARINGEN	MO-MI 7.45-15.30,DO 7.45-17.30,FR 7.45-12.00	poststelle@fa-sigmaringen.fv.bwl.de		312
8	2886	Tübingen 	Steinlachallee 6 - 8	72072	Tübingen	07071/7570	07071/7574500	72005	72005	1520	64000000	64001505	BBK REUTLINGEN				Mo-Do 7.30-15.30,Mi -17.30,Fr 7.30-13.00 Uhr	poststelle@fa-tuebingen.fv.bwl.de		313
8	2887	Überlingen (Bodensee) 	Mühlenstr. 28	88662	Überlingen	07551/8360	07551/836299	88660			69400000	69001501	BBK VILLINGEN-SCHWENNINGEN	69220020	6426155500	BW BANK SINGEN	Mo-Mi 8.00-15.30,Do 8.00-17.30,Fr 8.00-12.00	poststelle@fa-ueberlingen.fv.bwl.de		314
8	2888	Ulm 	Wagnerstr. 2	89077	Ulm	0731/1030	0731/103800		89008	1860	63000000	63001500	BBK ULM, DONAU	63050000	30001	SPARKASSE ULM	MO-MI 7.30-15.30,DO 7.30-17.30,FR 7.30-12.00	poststelle@fa-ulm.fv.bwl.de		315
8	2889	Bad Urach 	Graf-Eberhard-Platz 7	72574	Bad Urach	07125/1580	(07125)158-300	72562	72562	1149	64000000	640 01501	BBK REUTLINGEN	64050000	300 346	KR SPK REUTLINGEN	MO-MI 7.30-15.30 DO 7.30-17.30 FR 7.30-12.00	poststelle@fa-badurach.fv.bwl.de		316
8	2890	Waiblingen 	Fronackerstr. 77	71332	Waiblingen	07151/9550	07151/955200	71328			60000000	602 01500	BBK STUTTGART	60250010	200 398	KR SPK WAIBLINGEN	INFOTHEK MO-DO 7.30-15.30,MI-17.30,FR-12.00	poststelle@fa-waiblingen.fv.bwl.de		317
8	2891	Wangen 	Lindauer Str.37	88239	Wangen	07522/710	07522(714000)	88228	88228	1262	63000000	650 01502	BBK ULM, DONAU	65050110	218 153	KR SPK RAVENSBURG	MO-MI 8-15.30, DO 8-17.30, FR 8-12 UHR	poststelle@fa-wangen.fv.bwl.de		318
8	2892	Stuttgart IV 	Seidenstr.23	70174	Stuttgart	0711/66730	0711/66736060	70049	70049	106052	60000000	600 01503	BBK STUTTGART	60050101	2 065 854	LANDESBANK BADEN-WUERTT	MO,MI,FR 8-12,MI 13.30-16 UHR	poststelle@fa-stuttgart4.fv.bwl.de		319
8	2893	Stuttgart I 	Rotebühlplatz 30	70173	Stuttgart	0711/66730	6673 - 5010	70049	70049	106055	60000000	600 01503	BBK STUTTGART	60050101	2 065 854	LANDESBANK BADEN-WUERTT	Mo,Die,Do: 8-15.30, Mi: 8-17.30, Fr: 8-12.00	poststelle@fa-stuttgart1.fv.bwl.de		320
8	2895	Stuttgart II 	Rotebühlstr. 40	70178	Stuttgart	0711/66730	0711/66735610				60000000	60001503	BBK STUTTGART	60050101	2065854	LANDESBANK BADEN-WUERTT	MO-DO:8-15.30 FR:8-12 MI:15.30-17.30	poststelle@fa-stuttgart2.fv.bwl.de		321
8	2896	Stuttgart Zentrales Konzernprüfungsamt	Hackstr. 86	70190	Stuttgart	0711/9251-6	0711/9251706											poststelle@zbp-stuttgart.fv.bwl.de		322
8	2897	Stuttgart III 	Rotebühlplatz 30	70173	Stuttgart	0711/66730	0711/66735710		70049	106053	60000000	600 01503	BBK STUTTGART	60050101	2 065 854	LANDESBANK BADEN-WUERTT	Mo-Do:8-15.30 Mi:8-17.30 Fr:8-12.00 Uhr	poststelle@fa-stuttgart3.fv.bwl.de		323
8	2899	Stuttgart-Körpersch. 	Paulinenstr. 44	70178	Stuttgart	0711/66730	0711/66736525	70049	70049	106051	60000000	600 01503	BBK STUTTGART	60050101	2 065 854	LANDESBANK BADEN-WUERTT	MO-FR 8:00-12:00, MO-DO 13:00-15:30 Uhr	poststelle@fa-stuttgart-koerperschaften.fv.bwl.de		324
12	3046	Potsdam-Stadt 	Am Bürohochhaus 2	14478	Potsdam	0331 287-0	0331 287-1515		14429	80 03 22	16000000	16001501	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Potsdam-Stadt@fa.brandenburg.de		325
12	3047	Potsdam-Land 	Steinstr. 104 - 106	14480	Potsdam	0331 6469-0	0331 6469-200		14437	90 01 45	16000000	16001502	BBK POTSDAM				täglich außer Mi: 08:00-12:30 Uhr, zusätzlich Di: 14:00-17:00 Uhr	poststelle.FA-Potsdam-Land@fa.brandenburg.de		326
12	3048	Brandenburg 	Magdeburger Straße 46	14770	Brandenburg	03381 397-100	03381 397-200				16000000	16001503	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Brandenburg@fa.brandenburg.de		327
12	3049	Königs Wusterhausen 	Weg am Kreisgericht 9	15711	Königs Wusterhausen	03375 275-0	03375 275-103				16000000	16001505	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Koenigs-Wusterhausen@fa.brandenburg.de		328
12	3050	Luckenwalde 	Industriestraße 2	14943	Luckenwalde	03371 606-0	03371 606-200				16000000	16001504	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Luckenwalde@fa.brandenburg.de		329
12	3051	Nauen 	Ketziner Straße 3	14641	Nauen	03321 412-0	03321 412-888		14631	11 61	16000000	16001509	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Nauen@fa.brandenburg.de		330
12	3052	Kyritz 	Perleberger Straße 1 - 2	16866	Kyritz	033971 65-0	033971 65-200				16000000	16001507	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Kyritz@fa.brandenburg.de		331
12	3053	Oranienburg 	Heinrich-Grüber-Platz 3	16515	Oranienburg	03301 857-0	03301 857-334				16000000	16001508	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Oranienburg@fa.brandenburg.de		332
12	3054	Pritzwalk 	Freyensteiner Chaussee 10	16928	Pritzwalk	03395 757-0	03395 302110				16000000	16001506	BBK POTSDAM				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Pritzwalk@fa.brandenburg.de		333
12	3056	Cottbus 	Vom-Stein-Straße 29	3050	Cottbus	0355 4991-4100	0355 4991-4150		3004	10 04 53	18000000	18001501	BBK COTTBUS				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Cottbus@fa.brandenburg.de		334
12	3058	Finsterwalde 	Leipziger Straße 61 - 67	3238	Finsterwalde	03531 54-0	03531 54-180		3231	11 50	18000000	18001503	BBK COTTBUS				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Finsterwalde@fa.brandenburg.de		336
12	3061	Frankfurt (Oder) 	Müllroser Chaussee 53	15236	Frankfurt (Oder)	0335 560-1399	0335 560-1202				17000000	17001502	BBK FRANKFURT (ODER)				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Frankfurt-Oder@fa.brandenburg.de		337
12	3062	Angermünde 	Jahnstraße 49	16278	Angermünde	03331 267-0	03331 267-200				17000000	17001500	BBK FRANKFURT (ODER)				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Angermuende@fa.brandenburg.de		338
12	3063	Fürstenwalde 	Beeskower Chaussee 12	15517	Fürstenwalde	03361 595-0	03361 2198				17000000	17001503	BBK FRANKFURT (ODER)				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Fuerstenwalde@fa.brandenburg.de		339
12	3064	Strausberg 	Prötzeler Chaussee 12 A	15344	Strausberg	03341 342-0	03341 342-127				17000000	17001504	BBK FRANKFURT (ODER)				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Strausberg@fa.brandenburg.de		340
12	3065	Eberswalde 	Tramper Chaussee 5	16225	Eberswalde	03334 66-2000	03334 66-2001				17000000	17001501	BBK FRANKFURT (ODER)				Mo, Mi, Do: 08:00-15:00 Uhr, Di: 08:00-17:00 Uhr, Fr: 08:00-13:30 Uhr	poststelle.FA-Eberswalde@fa.brandenburg.de		341
15	3101	Magdeburg I 	Tessenowstraße 10	39114	Magdeburg	0391 885-29	0391 885-1400		39014	39 62	81000000	810 015 06	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-md1.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	342
15	3102	Magdeburg II 	Tessenowstraße 6	39114	Magdeburg	0391 885-12	0391 885-1000		39006	16 63	81000000	810 015 07	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-md2.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	343
15	3103	Genthin 	Berliner Chaussee 29 b	39307	Genthin	03933 908-0	03933 908-499		39302	13 41	81000000	810 015 08	BBK MAGDEBURG				Mo., Di., Do., Fr.: 09.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-gtn.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	344
15	3104	Halberstadt 	R.-Wagner-Straße 51	38820	Halberstadt	03941 33-0	03941 33-199		38805	15 26	81000000	268 015 01	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-hbs.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	345
15	3105	Haldensleben 	Jungfernstieg 37	39340	Haldensleben	03904 482-0	03904 482-200		39332	10 02 09	81000000	810 015 10	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-hdl.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	346
15	3106	Salzwedel 	Buchenallee 2	29410	Salzwedel	03901 857-0	03901 857-100		29403	21 51	81000000	810 015 05	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-saw.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	347
15	3107	Staßfurt 	Atzendorfer Straße 20	39418	Staßfurt	03925 980-0	03925 980-101		39404	13 55	81000000	810 015 12	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.30 - 18.00 Uhr	poststelle@fa-sft.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	348
15	3108	Stendal 	Scharnhorststraße 87	39576	Stendal	03931 57-1000	03931 57-2000		39551	10 11 31	81000000	810 015 13	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-sdl.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	349
15	3109	Wernigerode 	Gustav-Petri-Straße 14	38855	Wernigerode	03943 657-0	03943 657-150		38842	10 12 51	81000000	268 015 03	BBK MAGDEBURG				Mo., Di., Do., Fr.: 09.00 - 12.00 Uhr, Do.: 14.00 - 18.00 Uhr	poststelle@fa-wrg.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	350
15	3110	Halle-Süd 	Blücherstraße 1	6122	Halle	0345 6923-5	0345 6923-600	6103			80000000	800 015 02	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr, Do.: 14.00	poststelle@fa-ha-s.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	351
15	3111	Halle-Nord 	Blücherstraße 1	6122	Halle	0345 6924-0	0345 6924-400	6103			80000000	800 015 01	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr, Do.: 14.00	poststelle@fa-ha-n.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	352
15	3112	Merseburg 	Bahnhofstraße 10	6217	Merseburg	03461 282-0	03461 282-199		6203	13 51	80000000	800 015 09	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-msb.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	353
15	3113	Bitterfeld 	Röhrenstraße 33	6749	Bitterfeld	03493 347-0	03493 347-247		6732	12 64	80000000	805 015 05	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-btf.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	354
15	3114	Dessau 	Kühnauer Straße 166	6846	Dessau	0340 6513-0	0340 6513-403		6815	18 25	80000000	805 015 26	BBK HALLE				Mo. - Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-des.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	355
15	3115	Wittenberg 	Dresdener Straße 40	6886	Wittenberg	03491 430-0	03491 430-113		6872	10 02 54	80000000	805 015 07	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-wbg.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	356
15	3116	Köthen 	Zeppelinstraße 15	6366	Köthen	03496 44-0	03496 44-2900		6354	14 52	80000000	805 015 06	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr	poststelle@fa-kot.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	357
15	3117	Quedlinburg 	Adelheidstraße 2	6484	Quedlinburg	03946 976-0	03946 976-400		6472	14 20	81000000	268 015 02	BBK MAGDEBURG				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 17.30 Uhr	poststelle@fa-qlb.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	358
15	3118	Eisleben 	Bahnhofsring 10 a	6295	Eisleben	03475 725-0	03475 725-109	6291			80000000	800 015 08	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-eil.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	359
15	3119	Naumburg 	Oststraße 26/26 a	6618	Naumburg	03445 753-0	03445 753-999		6602	12 51	80000000	800 015 27	BBK HALLE				Mo., Di., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 13.00 - 18.00 Uhr	poststelle@fa-nbg.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	360
15	3120	Zeitz 	Friedensstraße 80	6712	Zeitz	03441 864-0	03441 864-480		6692	12 08	80000000	800 015 04	BBK HALLE				Mo., Do., Fr.: 08.00 - 12.00 Uhr, Di.: 08.00 - 18.00 Uhr	poststelle@fa-ztz.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	361
15	3121	Sangerhausen 	Alte Promenade 27	6526	Sangerhausen	03464 539-0	03464 539-539		6512	10 12 24	80000000	800 015 25	BBK HALLE				Di., Do., Fr.: 09.00 - 12.00 Uhr, Di.: 14.00 - 18.00 Uhr, Do.: 14.00 -	poststelle@fa-sgh.ofd.mf.lsa-net.de	http://www.finanzamt.sachsen-anhalt.de	362
14	3201	Dresden I 	Lauensteiner Str. 37	1277	Dresden	0351 2567-0	0351 2567-111	1264			85000000	85001502	BBK DRESDEN				Mo 8:00-15:00, Di 8:00-18:00, Mi 8:00-15:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-dresden1.smf.sachsen.de	http://www.Finanzamt-Dresden-I.de	363
14	3202	Dresden II 	Gutzkowstraße 10	1069	Dresden	0351 4655-0	0351 4655-269	1056			85000000	85001503	BBK DRESDEN				Mo - Fr 8:00-12:00 Uhr, Di 14:00-18:00, Do 14:00-18:00 Uhr	poststelle@fa-dresden2.smf.sachsen.de	http://www.Finanzamt-Dresden-II.de	364
14	3203	Dresden III 	Rabenerstr.1	1069	Dresden	0351 4691-0	0351 4717 369		1007	120641	85000000	85001504	BBK DRESDEN				Mo 8:00-15:00, Di 8:00-18:00, Mi 8:00-15:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-dresden3.smf.sachsen.de	http://www.Finanzamt-Dresden-III.de	365
14	3204	Bautzen 	Wendischer Graben 3	2625	Bautzen	03591 488-0	03591 488-888	2621			85000000	85001505	BBK DRESDEN				Mo 8:00-15:30, Di 8:00-17:00, Mi 8:00-15:30, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-bautzen.smf.sachsen.de	http://www.Finanzamt-Bautzen.de	366
14	3205	Bischofswerda 	Kirchstraße 25	1877	Bischofswerda	03594 754-0	03594 754-444		1871	1111	85000000	85001506	BBK DRESDEN				Mo 8:00-15:30, Di 8:00-17:00, Mi 8:00-15:30, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-bischofswerda.smf.sachsen.de	http://www.Finanzamt-Bischofswerda.de	367
14	3206	Freital 	Coschützer Straße 8-10	1705	Freital	0351 6478-0	0351 6478-428		1691	1560	85000000	85001507	BBK DRESDEN				Mo 8:00-15:00, Di 8:00-18:00, Mi 8:00-15:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-freital.smf.sachsen.de	http://www.Finanzamt-Freital.de	368
14	3207	Görlitz 	Sonnenstraße 7	2826	Görlitz	03581 875-0	03581 875-100		2807	300235	85000000	85001512	BBK DRESDEN				Mo 8:00-15:30, Di 8:00-18:00, Mi 8:00-15:30, Do 8:00-17:00, Fr 8:00-12:00 Uhr	poststelle@fa-goerlitz.smf.sachsen.de	http://www.Finanzamt-Goerlitz.de	369
14	3208	Löbau 	Georgewitzer Str.40	2708	Löbau	03585 455-0	03585 455-100		2701	1165	85000000	85001509	BBK DRESDEN				Mo 8:00-15:30, Di 8:00-18:00, Mi 8:00-15:30, Do 8:00-17:00, Fr 8:00-12:00 Uhr	poststelle@fa-loebau.smf.sachsen.de	http://www.Finanzamt-Loebau.de	370
14	3209	Meißen 	Hermann-Grafe-Str.30	1662	Meißen	03521 745-30	03521 745-450		1651	100151	85000000	85001508	BBK DRESDEN				Mo - Fr 8:00-12:00 Uhr Di 13:00-18:00, Do 13:00-17:00 Uhr	poststelle@fa-meissen.smf.sachsen.de	http://www.Finanzamt-Meissen.de	371
14	3210	Pirna 	Emil-Schlegel-Str. 11	1796	Pirna	03501 551-0	03501 551-201		1781	100143	85000000	85001510	BBK DRESDEN				Mo - Fr 8:00-12:00 Uhr, Di 13:30-18:00, Do 13:30-17:00 Uhr	poststelle@fa-pirna.smf.sachsen.de	http://www.Finanzamt-Pirna.de	372
14	3211	Riesa 	Stahlwerkerstr.3	1591	Riesa	03525 714-0	03525 714-133		1571	24	85000000	85001511	BBK DRESDEN				Mo 8:00-15:30, Di 8:00-18:00, Mi 8:00-15:30, Do 8:00-17:00 , Fr 8:00-12:00 Uhr	poststelle@fa-riesa.smf.sachsen.de	http://www.Finanzamt-Riesa.de	373
14	3213	Hoyerswerda 	Pforzheimer Platz 1	2977	Hoyerswerda	03571 460-0	03571 460-115		2961	1161/1162 	85000000	85001527	BBK DRESDEN				Mo 7:30-15:30, Di 7:30-17:00, Mi 7:30-13:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-hoyerswerda.smf.sachsen.de	http://www.Finanzamt-Hoyerswerda.de	374
14	3214	Chemnitz-Süd 	Paul-Bertz-Str. 1	9120	Chemnitz	0371 279-0	0371 227065	9097			87000000	87001501	BBK CHEMNITZ				Mo 8:00-16:00, Di 8:00-18:00, Mi 8:00-13:00, Do 8:00-18:00, Fr 8:00-13:00 Uhr	poststelle@fa-chemnitz-sued.smf.sachsen.de	http://www.Finanzamt-Chemnitz-Sued.de	375
14	3215	Chemnitz-Mitte 	August-Bebel-Str. 11/13	9113	Chemnitz	0371 467-0	0371 415830	9097			87000000	87001502	BBK CHEMNITZ				Mo 8:00-16:00, Di 8:00-18:00, Mi 8:00-14:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-chemnitz-mitte.smf.sachsen.de	http://www.Finanzamt-Chemnitz-Mitte.de	376
14	3216	Chemnitz-Land 	Reichenhainer Str. 31-33	9126	Chemnitz	0371 5360-0	0371 5360-317	9097			87000000	87001503	BBK CHEMNITZ				täglich 8:00-12:00, Di 13:30-17.00, Do 13:30-18:00 Uhr	poststelle@fa-chemnitz-land.smf.sachsen.de	http://www.Finanzamt-Chemnitz-Land.de	377
14	3217	Annaberg 	Magazingasse 16	9456	Annaberg-B.	03733 4270	03733 427-217		9453	100631	87000000	87001504	BBK CHEMNITZ				Mo 8:00-15:30, Di 8:00-18:00, Mi 8:00-15:30, Do 8:00-17:00, Fr 8:00-12:00 Uhr	poststelle@fa-annaberg.smf.sachsen.de	http://www.Finanzamt-Annaberg.de	378
14	3218	Schwarzenberg 	Karlsbader Str.23	8340	Schwarzenberg	03774 161-0	03774 161-100		8332	1209	87000000	87001505	BBK CHEMNITZ				Mo 8:00-15:30, Di 8:00-18:00, Mi 8:00-15:30, Do 8:00-17:00, Fr 8:00-12:00 Uhr	poststelle@fa-schwarzenberg.smf.sachsen.de	http://www.Finanzamt-Schwarzenberg.de	379
14	3219	Auerbach 	Schulstraße 3, Haus 1	8209	Auerbach	03744 824-0	03744 824-200		8202	10132	87000000	87001506	BBK CHEMNITZ				Mo 7:30-15:30, Di 7:30-18:00, Mi 7:30-12:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-aucherbach.smf.sachsen.de	http://www.Finanzamt-Auerbach.de	380
14	3220	Freiberg 	Brückenstr.1	9599	Freiberg	03731 379-0	03731 379-999	9596			87000000	87001507	BBK CHEMNITZ				Mo - Fr 7:30-12:30, Mo 13:30-15:30, Di 13:00-18:00, Mi 13:30-15:30, Do 13:00-17:00 Uhr	poststelle@fa-freiberg.smf.sachsen.de	http://www.Finanzamt-Freiberg.de	381
14	3221	Hohenstein-Ernstthal 	Schulstraße 34	9337	Hohenstein-E.	03723 745-0	03723 745-399		9332	1246	87000000	87001510	BBK CHEMNITZ				Mo - Fr 8:00-12:00, Mo 12:30-15:30, Di 12:30-18:00, Do 12:30-17:00	poststelle@fa-hohenstein-ernstthal.smf.sachsen.de	http://www.Finanzamt-Hohenstein-Ernstthal.de	382
14	3222	Mittweida 	Robert-Koch-Str. 17	9648	Mittweida	03727 987-0	03727 987-333		9641	1157	87000000	87001509	BBK CHEMNITZ				Mo 7:30-15:00, Di 7:30-18:00, Mi 7:30-13:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-mittweida.smf.sachsen.de	http://www.Finanzamt-Mittweida.de	383
14	3223	Plauen 	Europaratstraße 17	8523	Plauen	03741 10-0	03741 10-2000		8507	100384	87000000	87001512	BBK CHEMNITZ				Mo 7:30-14:00, Di 7:30-18:00, Mi 7:30-14:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-plauen.smf.sachsen.de	http://www.Finanzamt-Plauen.de	384
14	3224	Stollberg 	HOHENSTEINER STRASSE 54	9366	Stollberg	037296 522-0	037296 522-199		9361	1107	87000000	87001508	BBK CHEMNITZ				Mo 7:30-15:30, Di 7:30-17:00, Mi 7:30-13:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-stollberg.smf.sachsen.de	http://www.Finanzamt-Stollberg.de	385
14	3226	Zwickau-Stadt 	Dr.-Friedrichs-Ring 21	8056	Zwickau	0375 3529-0	0375 3529-444		8070	100452	87000000	87001513	BBK CHEMNITZ				Mo 7:30-15:30, Di 7:30-18:00, Mi 7:30-12:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-zwickau-stadt.smf.sachsen.de	http://www.Finanzamt-Zwickau-Stadt.de	386
14	3227	Zwickau-Land 	Äußere Schneeberger Str. 62	8056	Zwickau	0375 4440-0	0375 4440-222		8067	100150	87000000	87001514	BBK CHEMNITZ				Mo 8:00-15:30, Di 8:00-18:00, Mi 8:00-15:30, Do 8:00-17:00, Fr 8:00-12:00 Uhr	poststelle@fa-zwickau-land.smf.sachsen.de	http://www.Finanzamt-Zwickau-Land.de	387
14	3228	Zschopau 	August-Bebel-Str.17	9405	Zschopau	03725 293-0	03725 293-111		9402	58	87000000	87001515	BBK CHEMNITZ				Mo7:30-12:00/13:00-16:30,Di 7:30-12:00/13:00-18:00Mi u. Fr 7:30-13:00, Do 7:30-12:00/13:00-18:00 Uhr	poststelle@fa-zschopau.smf.sachsen.de	http://www.Finanzamt-Zschopau.de	388
14	3230	Leipzig I 	Wilhelm-Liebknecht-Platz 3/4	4105	Leipzig	0341 559-0	0341 559-1540		4001	100105	86000000	86001501	BBK LEIPZIG				Mo 7:30-14:00, Di 7:30-18:00, Mi 7:30-14:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-leipzig1.smf.sachsen.de	http://www.Finanzamt-Leipzig-I.de	389
14	3231	Leipzig II 	Erich-Weinert-Str. 20	4105	Leipzig	0341 559-0	0341 559-2505		4001	100145	86000000	86001502	BBK LEIPZIG				Mo 7:30-14:00, Di 7:30-18:00, Mi 7:30-14:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-leipzig2.smf.sachsen.de	http://www.Finanzamt-Leipzig-II.de	390
14	3232	Leipzig III 	Wilhelm-Liebknecht-Platz 3/4	4105	Leipzig	0341 559-0	0341 559-3640		4002	100226	86000000	86001503	BBK LEIPZIG				Mo 7:30-14:00, Di 7:30-18:00, Mi 7:30-14:00, Do 7:30-18:00, Fr 7:30-12:00 Uhr	poststelle@fa-leipzig3.smf.sachsen.de	http://www.Finanzamt-Leipzig-III.de	391
14	3235	Borna 	Brauhausstr.8	4552	Borna	03433 872-0	03433 872-255		4541	1325	86000000	86001509	BBK LEIPZIG				Mo 8:00-15:00, Di 8:00-18:00, Mi 8:00-15:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-borna.smf.sachsen.de	http://www.Finanzamt-Borna.de	392
14	3236	Döbeln 	Burgstr.31	4720	Döbeln	03431 653-30	03431 653-444		4713	2346	86000000	86001507	BBK LEIPZIG				Mo 7:30-15:30, Di 7:30-18:00, Mi 7:30-13:00, Do 7:30-17:00, Fr 7:30-12:00 Uhr	poststelle@fa-doebeln.smf.sachsen.de	http://www.Finanzamt-Doebeln.de	393
14	3237	Eilenburg 	Walther-Rathenau-Straße 8	4838	Eilenburg	03423 660-0	03423 660-460		4831	1133	86000000	86001506	BBK LEIPZIG				Mo 8:00-16:00, Di 8:00-18:00, Mi 8:00-14:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-eilenburg.smf.sachsen.de	http://www.Finanzamt-Eilenburg.de	394
14	3238	Grimma 	Lausicker Straße 2	4668	Grimma	03437 940-0	03437 940-500		4661	1126	86000000	86001508	BBK LEIPZIG				Mo 7:30-15:00, Di 7:30-18:00, Mi 7:30-13:30, Do 7:30-17:00, Fr 7:30-12:00 Uhr	poststelle@fa-grimma.smf.sachsen.de	http://www.Finanzamt-Grimma.de	395
14	3239	Oschatz 	Dresdener Str.77	4758	Oschatz	03435 978-0	03435 978-366		4752	1265	86000000	86001511	BBK LEIPZIG				Mo 8:00-16:00, Di 8:00-17:00, Mi 8:00-15:00, Do 8:00-18:00, Fr 8:00-12:00 Uhr	poststelle@fa-oschatz.smf.sachsen.de	http://www.Finanzamt-Oschatz.de	396
13	4071	Malchin 	Schratweg 33	17139	Malchin	03994/6340	03994/634322		17131	1101	15000000	15001511	BBK NEUBRANDENBURG				Mo Di Fr 08-12 Uhr Di 13-17 Uhr und Do 13-16 UhrMittwoch geschlossen	poststelle@fa-mc.ofd-hro.de		397
13	4072	Neubrandenburg 	Neustrelitzer Str. 120	17033	Neubrandenburg	0395/380 1000	0395/3801059		17041	110164	15000000	15001518	BBK NEUBRANDENBURG				Mo Di Do Fr 08-12 Uhr und Di 13.00-17.30 Uhr Mittwoch geschlossen	poststelle@fa-nb.ofd-hro.de		398
13	4074	Pasewalk 	Torgelower Str. 32	17309	Pasewalk	(03973) 224-0	03973/2241199		17301	1102	15000000	15001512	BBK NEUBRANDENBURG				Mo bis Fr 09.00-12.00 Uhr Di 14.00-18.00 Uhr	poststelle@fa-pw.ofd-hro.de		399
13	4075	Waren 	Einsteinstr. 15	17192	Waren (Müritz)	03991/1740	(03991)174499		17183	3154	15000000	15001515	BBK NEUBRANDENBURG				Mo-Mi 08.00-16.00 Uhr Do 08.00-18.00 Uhr Fr 08.-13.00 Uhr	poststelle@fa-wrn.ofd-hro.de		400
13	4079	Rostock 	Möllner Str. 13	18109	Rostock	(0381)7000-0	(0381)7000444		18071	201062	13000000	13001508	BBK ROSTOCK				Mo Di Fr 8.30-12.00 Di 13.30-17.00 Do 13.30-16.00	poststelle@fa-hro.ofd-hro.de		401
13	4080	Wismar 	Philosophenweg 1	23970	Wismar	03841444-0	03841/444222				14000000	14001516	BBK SCHWERIN				Mo Di Fr 08.00-12.00 Uhr Di Do 14.00-17.00 Uhr Mittwoch geschlossen	poststelle@fa-wis.ofd-hro.de		402
13	4081	Ribnitz-Damgarten 	Sandhufe 3	18311	Ribnitz-Damgarten	(03821)884-0	(03821)884140		18301	1061	13000000	13001510	BBK ROSTOCK				MO Di Mi DO 08.30-12.00 UHR DI 13.00-17.00 UHR Freitag geschlossen	poststelle@fa-rdg.ofd-hro.de		403
13	4082	Stralsund 	Lindenstraße 136	18435	Stralsund	03831/3660	(03831)366245 / 188 		18409	2241	13000000	13001513	BBK ROSTOCK				Mo Di Do Fr 08.00-12.00 Uhr Di 14.00 - 18.00 UhrMittwoch geschlossen	poststelle@fa-hst.ofd-hro.de		404
13	4083	Bergen 	Wasserstr. 15 d	18528	Bergen (Rügen)	03838/4000	03838/22217	18522	18522	1242	13000000	13001512	BBK ROSTOCK				Mo Di Do Fr 8.30-12.00 Di 13.00-18.00 Mittwoch geschlossen	poststelle@fa-brg.ofd-hro.de		405
13	4084	Greifswald 	Am Gorzberg Haus 11	17489	Greifswald	03834/5590	03834-559315/316	17462	17462	3254	15000000	15001528	BBK NEUBRANDENBURG				Mo Di Do Fr 8.30-12.00 Uhr Di 13.00-17.30 Uhr Mittwoch geschlossen	poststelle@fa-hgw.ofd-hro.de		406
13	4085	Wolgast 	Pestalozzistr. 45	17438	Wolgast	03836/254-0	03836/254300 /254100		17431	1139	15000000	15001529	BBK NEUBRANDENBURG				Mo Di Mi Do Fr 08.00-12.00 Uhr	poststelle@fa-wlg.ofd-hro.de		407
13	4086	Güstrow 	Klosterhof 1	18273	Güstrow	03843/2620	03843/262111	18271			13000000	13001501	BBK ROSTOCK				Mo-Do 09.00-12.00 Uhr Do 13.00-18.00 Uhr Freitag geschlossen	poststelle@fa-gue.ofd-hro.de		408
13	4087	Hagenow 	Steegener Chaussee 8	19230	Hagenow	03883/6700	03883 670216 /670217		19222	1242	14000000	14001504	BBK SCHWERIN				Mo Di Do Fr 08.30-12.00 Di 13.00-17.30 Mittwoch geschlossen	poststelle@fa-hgn.ofd-hro.de		409
13	4089	Parchim 	Ludwigsluster Chaussee 5	19370	Parchim	03871/4650	03871/443131		19363	1351	14000000	14001506	BBK SCHWERIN				Mo Di Mi 08.30-15.00 Uhr Do 08.30-18.00 Uhr Fr 08.30-13.00 Uhr	poststelle@fa-pch.ofd-hro.de		410
13	4090	Schwerin 	Johannes-Stelling-Str.9-11	19053	Schwerin	0385/54000	0385/5400300		19091	160131	14000000	14001502	BBK SCHWERIN				 Di Do Fr 08.30 - 12.00 Uhr Mo 13.00 - 16.00 Uhr Do 14.00	poststelle@fa-sn.ofd-hro.de		411
16	4151	Erfurt 	Mittelhäuser Str. 64f	99091	Erfurt	(0361)378-00	0361/3782800		99001	100121	82050000	3001111586	LD BK HESS-THUER GZ ERFURT				DI. 8- 12/ 13.30 -18 MI./FR. 8 - 12 UHR	poststelle@finanzamt-erfurt.thueringen.de		412
16	4152	Sömmerda 	Uhlandstrasse 3	99610	Sömmerda	03634/363-0	03634/363200		99609	100	82050000	3001111628	LD BK HESS-THUER GZ ERFURT				MO/MI/DO 8-16 UHR DI 8-18,FR 8-12 UHR	poststelle@finanzamt-soemmerda.thueringen.de		413
16	4153	Weimar 	Jenaer Str.2a	99425	Weimar	03643/5500	(03643)903811		99421	3676	82050000	3001111586	LD BK HESS-THUER GZ ERFURT				MO,MI,DO 8-15.30 UHR DI 8-18,FR 8-12 UHR	poststelle@finanzamt-weimar.thueringen.de		414
16	4154	Ilmenau 	Wallgraben 1	98693	Ilmenau	(03677) 861-0	03677/861111		98686	100754	82050000	3001111685	LD BK HESS-THUER GZ ERFURT				MO,MI 8-15.30 UHR, DI 8-18 UHR DO 8-16 UHR, FR 8-12 UHR	poststelle@finanzamt-ilmenau.thueringen.de		415
16	4155	Eisenach 	Ernst-Thaelmann-Str. 70	99817	Eisenach	03691/687-0	03691/687250		99804	101454	82050000	3001111586	LD BK HESS-THUER GZ ERFURT				MO-FR: 8-12 UHR, MO-MI: 13-16 UHR, DO: 13-18 UHR	poststelle@finanzamt-eisenach.thueringen.de		416
16	4156	Gotha 	Reuterstr. 2a	99867	Gotha	(03621)33-0	03621/332000		99853	100301	82050000	3001111586	LD BK HESS-THUER GZ ERFURT				MO - MI 8-15.30 UHR DO 8-18,FR 8-12 UHR	poststelle@finanzamt-gotha.thueringen.de		417
16	4157	Mühlhausen 	Martinistr. 22	99974	Mühlhausen	(03601)456-0	03601/456100		99961	1155	82050000	3001111628	LD BK HESS-THUER GZ ERFURT				MO/MI/DO 7.30-15 UHR DI.7.30-18,FR.7.30-12	poststelle@finanzamt-muehlhausen.thueringen.de		418
16	4158	Nordhausen 	Gerhart-Hauptmann-Str. 3	99734	Nordhausen	03631/427-0	03631/427174		99729	1120	82050000	3001111628	LD BK HESS-THUER GZ ERFURT				MO,DI,MI 8-12, 13.30-16 UHR DO 8-12,14-18 FR 8-12 UHR	poststelle@finanzamt-nordhausen.thueringen.de		419
16	4159	Sondershausen 	Schillerstraße 6	99706	Sondershausen	(03632)742-0	03632/742555		99702	1265	82050000	3001111628	LD BK HESS-THUER GZ ERFURT				MO/MI/DO 8-15.30 UHR DI 8-18, FR 8-12 UHR	poststelle@finanzamt-sondershausen.thueringen.de		420
16	4160	Worbis 	Bahnhofstr. 18	37339	Worbis	036074/37-0	036074/37219		37334	173	82050000	3001111628	LD BK HESS-THUER GZ ERFURT				MO-MI 7.30-15 UHR DO 7.30-18,FR 7.30-12	poststelle@finanzamt-worbis.thueringen.de		421
16	4161	Gera 	Hermann-Drechsler-Str.1	7548	Gera	0365/639-0	0365/6391491		7490	3044	82050000	3001111578	LD BK HESS-THUER GZ ERFURT				MO,MI 7.30-15 DI,DO 7.30- 18 UHR FR 7.30-12 UHR	poststelle@finanzamt-gera.thueringen.de		422
16	4162	Jena 	Leutragraben 8	7743	Jena	(03641)378-0	03641/378653		7740	500	82050000	3001111602	LD BK HESS-THUER GZ ERFURT				MO-MI 8-15.30 DO 8-18 FR 8-12.00UHR	poststelle@finanzamt-jena.thueringen.de		423
16	4163	Rudolstadt 	Mörlaer Str. 2	7407	Rudolstadt	(03672)443-0	(03672)443100		7391	100155	82050000	3001111578	LD BK HESS-THUER GZ ERFURT				MO-MI 7.30-12, 13-15 DO 7.30-12, 13-18 UHR FR 7.30-12 UHR	poststelle@finanzamt-rudolstadt.thueringen.de		424
16	4164	Greiz 	Rosa-Luxemburg-Str. 23	7973	Greiz	03661/700-0	03661/700300		7962	1365	82050000	3001111578	LD BK HESS-THUER GZ ERFURT				MO/DI/MI 8-16UHR DO 8-18,FR 8-12UHR	poststelle@finanzamt-greiz.thueringen.de		425
16	4166	Altenburg 	Wenzelstr. 45	4600	Altenburg	03447/593-0	03447/593200		4582	1251	82050000	3001111511	LD BK HESS-THUER GZ ERFURT				MO,MI,DO 7.30-15.30 DI 7.30-18 UHR FR 7.30-12 UHR	poststelle@finanzamt-altenburg.thueringen.de		427
16	4168	Bad Salzungen 	August-Bebel-Str.2	36433	Bad Salzungen	(03695)668-0	03695/622496		36421	1153	82050000	3001111586	LD BK HESS-THUER GZ ERFURT				MO-MI 7.30-15 UHR DO 7.30-18,FR 7.30-12	poststelle@finanzamt-badsalzungen.thueringen.de		428
16	4169	Meiningen 	Charlottenstr. 2	98617	Meiningen	03693/461-0	(03693)461322		98606	100661	82050000	3001111610	LD BK HESS-THUER GZ ERFURT				MO-MI 7.30-15 UHR DO 7.30-18,FR 7.30-12	poststelle@finanzamt-meiningen.thueringen.de		429
16	4170	Sonneberg 	Köppelsdorfer Str.86	96515	Sonneberg	03675/884-0	03675/884254		96502	100241	82050000	3001111685	LD BK HESS-THUER GZ ERFURT				MO-MI 7.30-15.00 UHR DO 7.30-18 FR 7.30-12	poststelle@finanzamt-sonneberg.thueringen.de		430
16	4171	Suhl 	Karl-Liebknecht-Str. 4	98527	Suhl	03681/73-0	03681/733512		98490	100153	82050000	3001111685	LD BK HESS-THUER GZ ERFURT				MO - MI 8-16 UHR, DO 8-13 u. 14-18 UHR , FR 8-12 UHR	poststelle@finanzamt-suhl.thueringen.de		431
5	5101	Dinslaken 	Schillerstr. 71	46535	Dinslaken	02064/445-0	0800 10092675101		46522	100220	35000000	35201501	BBK DUISBURG	35251000	100123	SPK DINSLAKEN-VOERDE-HUENXE	Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5101.fin-nrw.de	www.finanzamt-Dinslaken.de	432
5	5102	Viersen 	Eindhovener Str. 71	41751	Viersen	02162/955-0	0800 10092675102		41726	110263	31000000	31001503	BBK MOENCHENGLADBACH	32050000	59203406	SPARKASSE KREFELD	Mo-Fr 8:30 bis 12:00 Uhr,Di auch 13:30 bis 15:00 Uhr,und nach Vereinbarung	Service@FA-5102.fin-nrw.de	www.finanzamt-Viersen.de	433
5	5103	Düsseldorf-Altstadt 	Kaiserstr. 52	40479	Düsseldorf	0211/4974-0	0800 10092675103		40001	101021	30000000	30001504	BBK DUESSELDORF	30050110	10124006	ST SPK DUESSELDORF	Mo-Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5103.fin-nrw.de	www.finanzamt-Duesseldorf-Altstadt.de	434
5	5105	Düsseldorf-Nord 	Roßstr. 68	40476	Düsseldorf	0211/4496-0	0800 10092675105		40403	300314	30000000	30001501	BBK DUESSELDORF	30050110	10124501	ST SPK DUESSELDORF	Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5105.fin-nrw.de	www.finanzamt-Duesseldorf-Nord.de	435
5	5106	Düsseldorf-Süd 	Kruppstr.110- 112	40227	Düsseldorf	0211/779-9	0800 10092675106		40001	101025	30000000	30001502	BBK DUESSELDORF	30050110	10125003	ST SPK DUESSELDORF	Mo-Fr 8.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5106.fin-nrw.de	www.finanzamt-Duesseldorf-Sued.de	436
5	5107	Duisburg-Hamborn 	Hufstr. 25	47166	Duisburg	0203/5445-0	0800 10092675107		47142	110264	35000000	35001502	BBK DUISBURG				Mo-Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5107.fin-nrw.de	www.finanzamt-Duisburg-Hamborn.de	437
5	5109	Duisburg-Süd 	Landfermannstr 25	47051	Duisburg	0203/3001-0	0800 10092675109		47015	101502	35000000	35001500	BBK DUISBURG	35050000	200403020	SPK DUISBURG	Mo-Fr 08:30 Uhr - 12:00 Uhr,Di auch 13:30 Uhr - 15:00 Uhr	Service@FA-5109.fin-nrw.de	www.finanzamt-Duisburg-Sued.de	438
5	5110	Essen-Nord 	Altendorfer Str. 129	45143	Essen	0201/1894-0	0800 10092675110		45011	101155	36000000	36001500	BBK ESSEN	36050105	275008	SPARKASSE ESSEN	Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5110.fin-nrw.de	www.finanzamt-Essen-Nord.de	439
5	5111	Essen-Ost 	Altendorfer Str. 129	45143	Essen	0201/1894-0	0800 10092675111	45116	45012	101262	36000000	36001501	BBK ESSEN	36050105	261800	SPARKASSE ESSEN	Mo-Fr,Di	Service@FA-5111.fin-nrw.de	www.finanzamt-Essen-Ost.de	440
5	5112	Essen-Süd 	Altendorfer Str. 129	45143	Essen	0201/1894-0	0800 10092675112		45011	101145	36000000	36001502	BBK ESSEN	36050105	203000	SPARKASSE ESSEN	Mo-Fr 08.30-12.00 Uhr, Di auch 13.30-15.00 Uhr, und nach Vereinbarung	Service@FA-5112.fin-nrw.de	www.finanzamt-Essen-Sued.de	441
5	5113	Geldern 	Gelderstr 32	47608	Geldern	02831/127-0	0800 10092675113		47591	1163	32000000	32001502	BBK MOENCHENGLADBACH EH KRE	32051370	112011	SPARKASSE GELDERN	Montag - Freitag 8:30 - 12:00,Uhr,Dienstag auch 13:00 - 15:00 U,hr und nach Vereinbarung	Service@FA-5113.fin-nrw.de	www.finanzamt-Geldern.de	442
5	5114	Grevenbroich 	Erckensstr. 2	41515	Grevenbroich	02181/607-0	0800 10092675114		41486	100264	30000000	30001507	BBK DUESSELDORF	30550000	101683	SPARKASSE NEUSS	Mo-Fr 8:30-12:00 Uhr,Di auch 13:30-15:00 Uhr,und nach Vereinbarung	Service@FA-5114.fin-nrw.de	www.finanzamt-Grevenbroich.de	443
5	5115	Kempen 	Arnoldstr 13	47906	Kempen	02152/919-0	0800 10092675115		47880	100329	31000000	32001501	BBK MOENCHENGLADBACH				MO.-DO. 8.30-12.00 UHR,FREITAGS GESCHLOSSEN	Service@FA-5115.fin-nrw.de	www.finanzamt-Kempen.de	444
5	5116	Kleve 	Emmericher Str. 182	47533	Kleve	02821/803-1	0800 10092675116		47512	1251	35000000	32401501	BBK DUISBURG	32450000	5013628	SPARKASSE KLEVE	Mo - Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr	Service@FA-5116.fin-nrw.de	www.finanzamt-Kleve.de	445
5	5117	Krefeld 	Grenzstr 100	47799	Krefeld	02151/854-0	0800 10092675117		47706	100665	31000000	32001500	BBK MOENCHENGLADBACH				Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5117.fin-nrw.de	www.finanzamt-Krefeld.de	446
5	5119	Moers 	Unterwallstr 1	47441	Moers	02841/208-0	0800 10092675119	47439	47405	101520	35000000	35001505	BBK DUISBURG	35450000	1101000121	SPARKASSE MOERS	Montag-Freitag von 8.30-12.00,Dienstag von 13.30-15.00	Service@FA-5119.fin-nrw.de	www.finanzamt-Moers.de	447
5	5120	Mülheim an der Ruhr 	Wilhelmstr 7	45468	Mülheim an der Ruhr	0208/3001-1	0800 10092675120		45405	100551	36000000	36201500	BBK ESSEN	36250000	300007007	SPK MUELHEIM AN DER RUHR	Mo-Fr,Di auch 13:30-15:00 Uhr,und nach Vereinbarung	Service@FA-5120.fin-nrw.de	www.finanzamt-Muelheim-Ruhr.de	448
5	5121	Mönchengladbach-Mitte 	Kleiststr. 1	41061	Mönchengladbach	02161/189-0	0800 10092675121		41008	100813	31000000	31001500	BBK MOENCHENGLADBACH	31050000	8888	ST SPK MOENCHENGLADBACH	Mo - Fr,Di auch,und nach Vereinbarung	Service@FA-5121.fin-nrw.de	www.finanzamt-Moenchengladbach-Mitte.de	449
5	5122	Neuss II 	Hammfelddamm 9	41460	Neuss	02131/6656-0	0800 10092675122		41405	100502	30000000	30001509	BBK DUESSELDORF	30550000	123000	SPARKASSE NEUSS	Mo,Di,Do,Fr von 8.30-12.00,Di von 13.30-15.00	Service@FA-5122.fin-nrw.de	www.finanzamt-Neuss2.de	450
5	5123	Oberhausen-Nord 	Gymnasialstr. 16	46145	Oberhausen	0208/6499-0	0800 10092675123		46122	110220	36000000	36501501	BBK ESSEN	36550000	260125	ST SPK OBERHAUSEN	Mo-Fr 08:30-12:00 Uhr,Di auch 13:30-15:00 Uhr,und nach Vereinbarung	Service@FA-5123.fin-nrw.de	www.finanzamt-Oberhausen-Nord.de	451
5	5124	Oberhausen-Süd 	Schwartzstr. 7-9	46045	Oberhausen	0208/8504-0	0800 10092675124		46004	100447	36000000	36501500	BBK ESSEN	36550000	138156	ST SPK OBERHAUSEN	Mo - Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5124.fin-nrw.de	www.finanzamt-Oberhausen-Sued.de	452
5	5125	Neuss I 	Schillerstr 80	41464	Neuss	02131/943-0	0800 10092675125	41456	41405	100501	30000000	30001508	BBK DUESSELDORF	30550000	129999	SPARKASSE NEUSS	Mo-Fr 08.30-12.00 Uhr,Mo auch 13.30-15.00 Uhr	Service@FA-5125.fin-nrw.de	www.finanzamt-Neuss1.de	453
5	5126	Remscheid 	Wupperstr 10	42897	Remscheid	02191/961-0	0800 10092675126		42862	110269	33000000	33001505	BBK WUPPERTAL	34050000	113001	ST SPK REMSCHEID	Mo-Fr 08.30-12.00Uhr,Di auch 13.30-15.00Uhr,und nach Vereinbarung	Service@FA-5126.fin-nrw.de	www.finanzamt-Remscheid.de	454
5	5127	Mönchengladbach-Rheydt 	Wilhelm-Strauß-Str. 50	41236	Mönchengladbach	02166/450-0	0800 10092675127		41204	200442	31000000	31001502	BBK MOENCHENGLADBACH	31050000	295600	ST SPK MOENCHENGLADBACH	MO - FR 08.30 - 12.00 Uhr,DI auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5127.fin-nrw.de	www.finanzamt-Moenchengladbach-Rheydt.de	455
5	5128	Solingen-Ost 	Goerdelerstr.24- 26	42651	Solingen	0212/282-1	0800 10092675128	42648	42609	100984	33000000	33001503	BBK WUPPERTAL	34250000	22707	ST SPK SOLINGEN	Mo.-Fr.,Mo. auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5128.fin-nrw.de	www.finanzamt-Solingen-Ost.de	456
5	5129	Solingen-West 	Merscheider Busch 23	42699	Solingen	0212/2351-0	0800 10092675129		42663	110340	33000000	33001501	BBK WUPPERTAL	34250000	130005	ST SPK SOLINGEN	MO-FR 08.30 - 12.00 Uhr,und nach Vereinbarung	Service@FA-5129.fin-nrw.de	www.finanzamt-Solingen-West.de	457
5	5130	Wesel 	Poppelbaumstr. 5-7	46483	Wesel	0281/105-0	0800 10092675130		46461	100136	35000000	35601500	BBK DUISBURG	35650000	208660	VERB SPK WESEL	Mo-Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5130.fin-nrw.de	www.finanzamt-Wesel.de	458
5	5131	Wuppertal-Barmen 	Unterdörnen 96	42283	Wuppertal	0202/9543-0	0800 10092675131	42271	42208	200853	33000000	33001502	BBK WUPPERTAL				Mo - Fr,Do auch,und nach Vereinbarung	Service@FA-5131.fin-nrw.de	www.finanzamt-Wuppertal-Barmen.de	459
5	5132	Wuppertal-Elberfeld 	Kasinostr. 12	42103	Wuppertal	0202/489-0	0800 10092675132		42002	100209	33000000	33001500	BBK WUPPERTAL				Mo-Fr 08.30-12.00 Uhr,Do auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5132.fin-nrw.de	www.finanzamt-Wuppertal-Elberfeld.de	460
5	5133	Düsseldorf-Mitte 	Kruppstr. 110	40227	Düsseldorf	0211/779-9	0800 10092675133		40001	101024	30000000	30001505	BBK DUESSELDORF	30050110	10123008	ST SPK DUESSELDORF		Service@FA-5133.fin-nrw.de	www.finanzamt-Duesseldorf-Mitte.de	461
5	5134	Duisburg-West 	Friedrich-Ebert-Str 133	47226	Duisburg	02065/307-0	0800 10092675134		47203	141355	35000000	35001503	BBK DUISBURG				Mo - Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5134.fin-nrw.de	www.finanzamt-Duisburg-West.de	462
5	5135	Hilden 	Neustr. 60	40721	Hilden	02103/917-0	0800 10092675135		40710	101046	30000000	30001506	BBK DUESSELDORF				Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5135.fin-nrw.de	www.finanzamt-Hilden.de	463
5	5139	Velbert 	Nedderstraße 38	42549	Velbert	02051/47-0	0800 10092675139		42513	101310	33000000	33001504	BBK WUPPERTAL	33450000	26205500	SPARKASSE HRV	Mo-Fr 08.30-12.00 Uhr,Mo auch 13.30-15.00 Uhr	Service@FA-5139.fin-nrw.de	www.finanzamt-Velbert.de	464
5	5147	Düsseldorf-Mettmann 	Harkortstr. 2-4	40210	Düsseldorf	0211/3804-0	0800 10092675147		40001	101023	30000000	30001500	BBK DUESSELDORF	30050000	4051017	WESTLB DUESSELDORF	Montag bis Freitag,08.30 bis 12.00 Uhr,und nach Vereinbarung	Service@FA-5147.fin-nrw.de	www.finanzamt-Duesseldorf-Mettmann.de	465
5	5149	Rechenzentrum d. FinVew NRW 	Roßstraße 131	40476	Düsseldorf	0211/4572-0	0211/4572-302		40408	300864								Service@FA-5149.fin-nrw.de		466
5	5170	Düsseldorf I für Groß- und Konzernbetriebsprüfung	Werftstr. 16	40549	Düsseldorf	0211/56354-01	0800 10092675170		40525	270264								Service@FA-5170.fin-nrw.de		467
5	5171	Düsseldorf II für Groß- und Konzernbetriebsprüfung	Werftstr. 16	40549	Düsseldorf	0211/56354-0	0800 10092675171		40525	270264								Service@FA-5171.fin-nrw.de		468
5	5172	Essen für Groß- und Konzernbetriebsprüfung	In der Hagenbeck 64	45143	Essen	0201/6300-1	0800 10092675172		45011	101155								Service@FA-5172.fin-nrw.de		469
5	5173	Krefeld für Groß- und Konzernbetriebsprüfung	Steinstr. 137	47798	Krefeld	02151/8418-0	0800 10092675173											Service@FA-5173.fin-nrw.de		470
5	5174	Berg. Land für Groß- und Konzernbetriebsprüfung	Bendahler Str. 29	42285	Wuppertal	0202/2832-0	0800 10092675174	42271										Service@FA-5174.fin-nrw.de		471
5	5176	Mönchengladbach für Groß- und  Konzernbetriebsprüfung	Aachener Str. 114	41061	Mönchengladbach	02161/3535-0	0800 10092675176		41017	101715								Service@FA-5176.fin-nrw.de		472
5	5181	Düsseldorf f. Steuerfahndung und Steuerstrafsachen	Kruppstr.110 -112	40227	Düsseldorf	0211/779-9	0800 10092675181		40001	101024	30000000	30001502	BBK DUESSELDORF	30050110	10125003	ST SPK DUESSELDORF	Mo - Di 07.30 - 16.30 Uhr,Mi - Fr 07.30 - 16.00 Uhr	Service@FA-5181.fin-nrw.de		473
5	5182	Essen f. Steuerfahndung und Steuerstrafsachen	In der Hagenbeck 64	45143	Essen	0201/6300-1	0800 10092675182		45011	101155	36000000	36001502	BBK ESSEN	36050105	203000	SPARKASSE ESSEN		Service@FA-5182.fin-nrw.de		474
5	5183	Wuppertal f. Steuerfahndung und Steuerstrafsachen	Unterdörnen 96	42283	Wuppertal	0202/9543-0	0800 10092675183		42205	200553	33000000	33001502	BBK WUPPERTAL	33050000	135004	ST SPK WUPPERTAL		Service@FA-5183.fin-nrw.de		475
5	5201	Aachen-Innenstadt 	Mozartstr 2-10	52064	Aachen	0241/469-0	0800 10092675201		52018	101833	39000000	39001501	BBK AACHEN	39050000	26	SPARKASSE AACHEN	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 -15.00 Uhr,und nach Vereinbarung	Service@FA-5201.fin-nrw.de	www.finanzamt-Aachen-Innenstadt.de	476
5	5202	Aachen-Kreis 	Beverstr 17	52066	Aachen	0241/940-0	0800 10092675202		52018	101829	39000000	39001500	BBK AACHEN	39050000	311118	SPARKASSE AACHEN	Mo.-Fr. 08.30 - 12.00 Uhr,Mo.,und nach Vereinbarung	Service@FA-5202.fin-nrw.de	www.finanzamt-Aachen-Kreis.de	477
5	5203	Bergheim 	Rathausstrasse 3	50126	Bergheim	02271/82-0	0800 10092675203		50101	1120	39500000	39501501	BBK AACHEN EH DUEREN				Mo-Fr 08:30-12:00 Uhr,Di 13:30-15:00 Uhr,und nach Vereinbarung	Service@FA-5203.fin-nrw.de	www.finanzamt-Bergheim.de	478
5	5204	Bergisch Gladbach 	Refrather Weg 35	51469	Bergisch Gladbach	02202/9342-0	0800 10092675204		51433	200380	37000000	37001508	BBK KOELN				Mo.-Fr. 8.30-12.00 Uhr	Service@FA-5204.fin-nrw.de	www.finanzamt-Bergisch-Gladbach.de	479
5	5302	Altena 	Winkelsen 11	58762	Altena	02352/917-0	0800 10092675302		58742	1253	45000000	45001501	BBK HAGEN	45851020	80020001	VER SPK PLETTENBERG	Mo,Di-Do,und nach Vereinbarung	Service@FA-5302.fin-nrw.de	www.finanzamt-Altena.de	480
5	5205	Bonn-Innenstadt 	Welschnonnenstr. 15	53111	Bonn	0228/718-0	0800 10092675205		53031	180120	38000000	38001500	BBK BONN	38050000	17079	SPARKASSE BONN	Mo-Mi 08.30-12.00 Uhr,Do 07.00-17.00 Uhr,Freitag geschlossen	Service@FA-5205.fin-nrw.de	www.finanzamt-Bonn-Innenstadt.de	481
5	5206	Bonn-Außenstadt 	Bachstr. 36	53115	Bonn	0228/7268-0	0800 10092675206		53005	1580	38000000	38001501	BBK BONN	38050000	22004	SPARKASSE BONN	Mo-Do,Do auch 13:30 bis 17:30 Uhr,Freitags geschlossen	Service@FA-5206.fin-nrw.de	www.finanzamt-Bonn-Aussenstadt.de	482
5	5207	Düren 	Goethestrasse 7	52349	Düren	02421/947-0	0800 10092675207		52306	100646	39500000	39501500	BBK AACHEN EH DUEREN	39550110	188300	SPARKASSE DUEREN	Mo-Fr 08:30 - 12:00 Uhr,Di auch 13:30 - 15:00 Uhr,und nach Vereinbarung	Service@FA-5207.fin-nrw.de	www.finanzamt-Dueren.de	483
5	5208	Erkelenz 	Südpromenade 37	41812	Erkelenz	02431/801-0	0800 10092675208		41806	1651	31000000	31001501	BBK MOENCHENGLADBACH	31251220	402800	KR SPK HEINSBERG ERKELENZ	Mo - Fr 8.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5208.fin-nrw.de	www.finanzamt-Erkelenz.de	484
5	5209	Euskirchen 	Thomas-Mann-Str. 2	53879	Euskirchen	02251/982-0	0800 10092675209		53864	1487	38000000	38001505	BBK BONN	38250110	1000330	KREISSPARKASSE EUSKIRCHEN	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5209.fin-nrw.de	www.finanzamt-Euskirchen.de	485
5	5210	Geilenkirchen 	H.-Wilh.-Str 45	52511	Geilenkirchen	02451/623-0	0800 10092675210		52501	1193	39000000	39001502	BBK AACHEN	31251220	5397	KR SPK HEINSBERG ERKELENZ	Mo.-Fr. 8.30 - 12.00 Uhr,nachmittags nur tel. von,13.30 - 15.00 Uhr	Service@FA-5210.fin-nrw.de	www.finanzamt-Geilenkirchen.de	486
5	5211	Schleiden 	Kurhausstr. 7	53937	Schleiden	02444/85-0	0800 10092675211		53929	1140	38000000	38001506	BBK BONN	38250110	3200235	KREISSPARKASSE EUSKIRCHEN	Mo-Fr 08.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,sowie nach Vereinbarung	Service@FA-5211.fin-nrw.de	www.finanzamt-Schleiden.de	487
5	5212	Gummersbach 	Mühlenbergweg 5	51645	Gummersbach	02261/86-0	0800 10092675212	51641			37000000	37001506	BBK KOELN				Mo - Fr 08.30-12.00 Uhr,Mo auch 13.30-15.00 Uhr	Service@FA-5212.fin-nrw.de	www.finanzamt-Gummersbach.de	488
5	5213	Jülich 	Wilhelmstr 5	52428	Jülich	02461/685-0	0800 10092675213		52403	2180	39000000	39701500	BBK AACHEN	39550110	25023	SPARKASSE DUEREN	Mo.-Fr. 08.00-12.00 Uhr,Di. 13.30-15.00 Uhr	Service@FA-5213.fin-nrw.de	www.finanzamt-Juelich.de	489
5	5214	Köln-Altstadt 	Am Weidenbach 2-4	50676	Köln	0221/2026-0	0800 10092675214		50517	250140	37000000	37001501	BBK KOELN	37050198	70052964	STADTSPARKASSE KOELN	Mo - Fr 8.30 - 12.00 Uhr,Di auch 13.00 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5214.fin-nrw.de	www.finanzamt-Koeln-Altstadt.de	490
5	5215	Köln-Mitte 	Blaubach 7	50676	Köln	0221/92400-0	0800 10092675215		50524	290208	37000000	37001505	BBK KOELN	37050198	70062963	STADTSPARKASSE KOELN	MO-FR 08.30 - 12.00 UHR	Service@FA-5215.fin-nrw.de	www.finanzamt-Koeln-Mitte.de	491
5	5216	Köln-Porz 	Klingerstr. 2-6	51143	Köln	02203/598-0	0800 10092675216		51114	900469	37000000	37001524	BBK KOELN				Mo-Fr08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5216.fin-nrw.de	www.finanzamt-Koeln-Porz.de	492
5	5217	Köln-Nord 	Innere Kanalstr. 214	50670	Köln	0221/97344-0	0800 10092675217		50495	130164	37000000	37001502	BBK KOELN	37050198	70102967	STADTSPARKASSE KOELN	Mo - Fr 8.30 - 12.00 Uhr,und nach Vereinbarung	Service@FA-5217.fin-nrw.de	www.finanzamt-Koeln-Nord.de	493
5	5218	Köln-Ost 	Siegesstrasse 1	50679	Köln	0221/9805-0	0800 10092675218		50529	210340	37000000	37001503	BBK KOELN	37050198	70082961	STADTSPARKASSE KOELN	Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5218.fin-nrw.de	www.finanzamt-Koeln-Ost.de	494
5	5219	Köln-Süd 	Am Weidenbach 6	50676	Köln	0221/2026-0	0800 10092675219		50517	250160	37000000	37001504	BBK KOELN	37050198	70032966	STADTSPARKASSE KOELN	Mo-Fr,Di auch 13.00-15.00 Uhr	Service@FA-5219.fin-nrw.de	www.finanzamt-Koeln-Sued.de	495
5	5220	Siegburg 	Mühlenstr 19	53721	Siegburg	02241/105-0	0800 10092675220		53703	1351	38000000	38001503	BBK BONN				Mo.-Fr. 08.30-12.00 Uhr,Mo. auch 13.30-17.00 Uhr,und nach Vereinbarung	Service@FA-5220.fin-nrw.de	www.finanzamt-Siegburg.de	496
5	5221	Wipperfürth 	Am Stauweiher 3	51688	Wipperfürth	02267/870-0	0800 10092675221		51676	1240	37000000	37001513	BBK KOELN				Mo-Fr 08.30-12.00 Uhr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5221.fin-nrw.de	www.finanzamt-Wipperfuerth.de	497
5	5222	Sankt Augustin 	Hubert-Minz-Str 10	53757	Sankt Augustin	02241/242-1	0800 10092675222		53730	1229	38000000	38001504	BBK BONN				Mo - Fr 8.30-12.00 Uhr,Di auch 13.30-15.00 Uhr	Service@FA-5222.fin-nrw.de	www.finanzamt-Sankt-Augustin.de	498
5	5223	Köln-West 	Haselbergstr 20	50931	Köln	0221/5734-0	0800 10092675223		50864	410469	37000000	37001523	BBK KOELN	37050198	70022967	STADTSPARKASSE KOELN		Service@FA-5223.fin-nrw.de	www.finanzamt-Koeln-West.de	499
5	5224	Brühl 	Kölnstr. 104	50321	Brühl	02232/703-0	0800 10092675224	50319			37000000	37001507	BBK KOELN				Mo-Fr 08.30 - 12.00,Die zusätzlich 13.30 - 15.00 ,und nach Vereinbarung	Service@FA-5224.fin-nrw.de	www.finanzamt-Bruehl.de	500
5	5225	Aachen-Außenstadt 	Beverstraße	52066	Aachen	0241/940-0	0800 10092675225		52018	101825	39000000	39001503	BBK AACHEN	39050000	1099	SPARKASSE AACHEN	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5225.fin-nrw.de	www.finanzamt-Aachen-Aussenstadt.de	501
5	5230	Leverkusen 	Haus-Vorster-Str 12	51379	Leverkusen	02171/407-0	0800 10092675230	51367			37000000	37001511	BBK KOELN	37551440	118318500	SPARKASSE LEVERKUSEN	Mo-Do 8.30 - 12.00 Uhr,Di.: 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5230.fin-nrw.de	www.finanzamt-Leverkusen.de	502
5	5270	KonzBP Köln für Groß- und Konzernbetriebsprüfung	Riehler Platz 2	50668	Köln	0221/2021-0	0800 10092675270											Service@FA-5270.fin-nrw.de		503
5	5272	Bonn für Groß- und Konzernbetriebsprüfung	Am Propsthof 17	53121	Bonn	0228/7223-0	0800 10092675272											Service@FA-5272.fin-nrw.de		505
5	5281	Aachen f. Steuerfahndung und Steuerstrafsachen	Beverstr 17	52066	Aachen	0241/940-0	0800 10092675281		52017	101722	39000000	39001500	BBK AACHEN	39050000	311118	SPARKASSE AACHEN		Service@FA-5281.fin-nrw.de		506
5	5282	Bonn f. Steuerfahndung und Steuerstrafsachen	Theaterstr. 1	53111	Bonn	0228/718-0	0800 10092675282				38000000	38001500	BBK BONN	38050000	17079	SPARKASSE BONN		Service@FA-5282.fin-nrw.de		507
5	5283	Köln f. Steuerfahndung und Steuerstrafsachen	Am Gleisdreieck 7- 9	50823	Köln	0221/5772-0	0800 10092675283		50774	300451	37000000	37001502	BBK KOELN	37050198	70102967	STADTSPARKASSE KOELN		Service@FA-5283.fin-nrw.de		508
5	5301	Ahaus 	Vredener Dyk 2	48683	Ahaus	02561/929-0	0800 10092675301		48662	1251	40000000	40001503	BBK MUENSTER, WESTF	40154530	51027902	SPARKASSE WESTMUENSTERLAND	Mo - Fr 08.30 - 12.00 Uhr,zudem Mo 13.30 - 15.00 Uhr,sowie Do 13.30 -	Service@FA-5301.fin-nrw.de	www.finanzamt-Ahaus.de	509
5	5303	Arnsberg 	Rumbecker Straße 36	59821	Arnsberg	02931/875-0	0800 10092675303	59818	59802	5245	41000000	46401501	BBK HAMM, WESTF	46650005	1020007	SPK ARNSBERG-SUNDERN	Mo-Mi 08.30 - 12.00 Uhr,Fr,und nach Vereinbarung	Service@FA-5303.fin-nrw.de	www.finanzamt-Arnsberg.de	510
5	5304	Beckum 	Elisabethstraße 19	59269	Beckum	02521/25-0	0800 10092675304	59267	59244	1452	41000000	41001501	BBK HAMM, WESTF	41250035	1000223	SPK BECKUM-WADERSLOH	MO-FR 08.30-12.00 UHR,MO AUCH 13.30-15.00 UHR,UND NACH VEREINBARUNG	Service@FA-5304.fin-nrw.de	www.finanzamt-Beckum.de	511
5	5305	Bielefeld-Innenstadt 	Ravensberger Straße 90	33607	Bielefeld	0521/548-0	0800 10092675305		33503	100371	48000000	48001500	BBK BIELEFELD	48050161	109	SPK BIELEFELD	Mo - Fr 8.30 - 12.00 Uhr,Di auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5305.fin-nrw.de	www.finanzamt-Bielefeld-Innenstadt.de	512
5	5306	Bochum-Mitte 	Castroper Str. 40 - 42	44791	Bochum	0234/514-0	0800 10092675306		44707	100729	43000000	43001500	BBK BOCHUM	43050001	1300011	SPARKASSE BOCHUM	Mo-Fr 08:30 - 12:00 Uhr,Di auch 13:30 - 15:00 Uhr,Individuelle Terminver-,einbarungen sind möglich	Service@FA-5306.fin-nrw.de	www.finanzamt-Bochum-Mitte.de	513
5	5307	Borken 	Nordring 184	46325	Borken	02861/938-0	0800 10092675307	46322	46302	1240	40000000	40001514	BBK MUENSTER, WESTF	40154530	51021137	SPARKASSE WESTMUENSTERLAND	Mo-Fr 8.30 - 12.00 Uhr,Mo 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5307.fin-nrw.de	www.finanzamt-Borken.de	514
5	5308	Bottrop 	Scharnhölzstraße 32	46236	Bottrop	02041/691-0	0800 10092675308		46205	100553	43000000	42401501	BBK BOCHUM	42451220	10009	SPK BOTTROP	Mo-Mi 08.00-12.00 Uhr,Do 07.30-12.00 u 13.30-15.00 ,Freitags geschlossen	Service@FA-5308.fin-nrw.de	www.finanzamt-Bottrop.de	515
5	5309	Brilon 	Steinweg 30	59929	Brilon	02961/788-0	0800 10092675309		59915	1260	48000000	47201502	BBK BIELEFELD	41651770	17004	SPK HOCHSAUERLAND BRILON	Mo - Fr 08:30 - 12:00 Uhr,Di auch 13:30 - 15:00 Uhr,und nach Vereinbarung	Service@FA-5309.fin-nrw.de	www.finanzamt-Brilon.de	516
5	5310	Bünde 	Lettow-Vorbeck-Str 2-10	32257	Bünde	05223/169-0	0800 10092675310		32216	1649	48000000	48001502	BBK BIELEFELD	49450120	210003000	SPARKASSE HERFORD		Service@FA-5310.fin-nrw.de	www.finanzamt-Buende.de	517
5	5311	Steinfurt 	Ochtruper Straße 2	48565	Steinfurt	02551/17-0	0800 10092675311	48563	48542	1260	40000000	40301500	BBK MUENSTER, WESTF				Mo-Fr 08.00-12.00 Uhr,Mo auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5311.fin-nrw.de	www.finanzamt-Steinfurt.de	518
5	5312	Coesfeld 	Friedrich-Ebert-Str. 8	48653	Coesfeld	02541/732-0	0800 10092675312		48633	1344	40000000	40001505	BBK MUENSTER, WESTF	40154530	59001644	SPARKASSE WESTMUENSTERLAND	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5312.fin-nrw.de	www.finanzamt-Coesfeld.de	519
5	5313	Detmold 	Wotanstraße 8	32756	Detmold	05231/972-0	0800 10092675313	32754	32706	1664	48000000	48001504	BBK BIELEFELD	47650130	4002	SPK DETMOLD	Mo. bis Fr.,Montags,und nach Vereinbarung	Service@FA-5313.fin-nrw.de	www.finanzamt-Detmold.de	520
5	5314	Dortmund-West 	Märkische Straße 124	44141	Dortmund	0231/9581-0	0800 10092675314		44047	105041	44000000	44001500	BBK DORTMUND	44050199	301001886	SPARKASSE DORTMUND	Montags geschlossen,Di - Fr 8.30 - 12.00,Do zusätzlich 13.30 - 15.00	Service@FA-5314.fin-nrw.de	www.finanzamt-Dortmund-West.de	521
5	5315	Dortmund-Hörde 	Niederhofener Str 3	44263	Dortmund	0231/4103-0	0800 10092675315		44232	300255	44000000	44001503	BBK DORTMUND	44050199	21003468	SPARKASSE DORTMUND	Mo-Do 8.30-12.00 Uhr,und nach Vereinbarung	Service@FA-5315.fin-nrw.de	www.finanzamt-Dortmund-Hoerde.de	522
5	5316	Dortmund-Unna 	Rennweg 1	44143	Dortmund	0231/5188-1	0800 10092675316		44047	105020	44000000	44001501	BBK DORTMUND	44050199	1060600	SPARKASSE DORTMUND	Mo-Fr 08.30-12.00 Uhr,und nach Vereinbarung	Service@FA-5316.fin-nrw.de	www.finanzamt-Dortmund-Unna.de	523
5	5317	Dortmund-Ost 	Nußbaumweg 210	44143	Dortmund	0231/5188-1	0800 10092675317		44047	105039	44000000	44001502	BBK DORTMUND	44050199	301001827	SPARKASSE DORTMUND	Mo - Fr 8.30 - 12.00 Uhr,und nach Vereinbarung	Service@FA-5317.fin-nrw.de	www.finanzamt-Dortmund-Ost.de	524
5	5318	Gelsenkirchen-Nord 	Rathausplatz 1	45894	Gelsenkirchen	0209/368-1	0800 10092675318		45838	200351	43000000	42001501	BBK BOCHUM	42050001	160012007	SPARKASSE GELSENKIRCHEN	Mo-Fr 08.30-12.00 Uhr,Mo auch 13.30-15.00Uhr	Service@FA-5318.fin-nrw.de	www.finanzamt-Gelsenkirchen-Nord.de	525
5	5319	Gelsenkirchen-Süd 	Zeppelinallee 9-13	45879	Gelsenkirchen	0209/173-1	0800 10092675319		45807	100753	43000000	42001500	BBK BOCHUM	42050001	101050003	SPARKASSE GELSENKIRCHEN	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr	Service@FA-5319.fin-nrw.de	www.finanzamt-Gelsenkirchen-Sued.de	526
5	5320	Gladbeck 	Jovyplatz 4	45964	Gladbeck	02043/270-1	0800 10092675320		45952	240	43000000	42401500	BBK BOCHUM	42450040	91	ST SPK GLADBECK	MO-FR 08.30-12.00 UHR,DO AUCH 13.30-15.00 UHR,UND NACH VEREINBARUNG	Service@FA-5320.fin-nrw.de	www.finanzamt-Gladbeck.de	527
5	5321	Hagen 	Schürmannstraße 7	58097	Hagen	02331/180-0	0800 10092675321		58041	4145	45000000	45001500	BBK HAGEN	45050001	100001580	SPARKASSE HAGEN	Mo-Fr,Mo auch 13.30-15.00 Uhr	Service@FA-5321.fin-nrw.de	www.finanzamt-Hagen.de	528
5	5322	Hamm 	Grünstraße 2	59065	Hamm	02381/918-0	0800 10092675322	59061	59004	1449	41000000	41001500	BBK HAMM, WESTF	41050095	90001	SPARKASSE HAMM	Mo-Do 8.30-12.00 Uhr,Mi auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5322.fin-nrw.de	www.finanzamt-Hamm.de	529
5	5323	Hattingen 	Rathausplatz 19	45525	Hattingen	02324/208-0	0800 10092675323		45502	800257	43000000	43001501	BBK BOCHUM				Mo-Fr,Di auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5323.fin-nrw.de	www.finanzamt-Hattingen.de	530
5	5324	Herford 	Wittekindstraße 5	32051	Herford	05221/188-0	0800 10092675324		32006	1642	48000000	48001503	BBK BIELEFELD	49450120	36004	SPARKASSE HERFORD	Mo,Di,Fr 7.30-12.00 Uhr,Do 7.30-17.00 Uhr,Mi geschlossen,und nach Vereinbarung	Service@FA-5324.fin-nrw.de	www.finanzamt-Herford.de	531
5	5325	Herne-Ost 	Markgrafenstraße 12	44623	Herne	02323/598-0	0800 10092675325		44602	101220	43000000	43001502	BBK BOCHUM	43250030	1012004	HERNER SPARKASSE	Rückfragen bitte nur,telefonisch oder nach,vorheriger Rücksprache mit,dem Bearbeiter	Service@FA-5325.fin-nrw.de	www.finanzamt-Herne-Ost.de	532
5	5326	Höxter 	Bismarckstraße 11	37671	Höxter	05271/969-0	0800 10092675326	37669	37652	100239	48000000	47201501	BBK BIELEFELD	47251550	3008521	SPK HOEXTER BRAKEL	Mo - Do,Do auch,und nach Vereinbarung	Service@FA-5326.fin-nrw.de	www.finanzamt-Hoexter.de	533
5	5327	Ibbenbüren 	Uphof 10	49477	Ibbenbüren	05451/920-0	0800 10092675327		49462	1263	40000000	40301501	BBK MUENSTER, WESTF	40351060	2469	KR SPK STEINFURT	Mo - Fr,Di auch	Service@FA-5327.fin-nrw.de	www.finanzamt-Ibbenbueren.de	534
5	5328	Iserlohn 	Zollernstraße 16	58636	Iserlohn	02371/969-0	0800 10092675328	58634	58585	1554	45000000	45001503	BBK HAGEN	44550045	44008	SPK DER STADT ISERLOHN	Mo - Do 08.30 - 12.00 Uhr,Do auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5328.fin-nrw.de	www.finanzamt-Iserlohn.de	535
5	5376	Münster für Groß- und Konzernbetriebsprüfung	Andreas-Hofer-Straße 50	48145	Münster	0251/934-2115	0800 10092675376											Service@FA-5376.fin-nrw.de		536
5	5329	Lemgo 	Engelb.-Kämpfer Str. 18	32657	Lemgo	05261/253-1	0800 10092675329		32632	240	48000000	48001505	BBK BIELEFELD	48250110	45005	SPARKASSE LEMGO	Mo - Fr,Do auch,und nach Vereinbarung	Service@FA-5329.fin-nrw.de	www.finanzamt-Lemgo.de	537
5	5330	Lippstadt 	Im Grünen Winkel 3	59555	Lippstadt	02941/982-0	0800 10092675330		59525	1580	41000000	46401505	BBK HAMM, WESTF	41650001	15008	ST SPK LIPPSTADT	Mo - Fr 08.30 - 12.00,Do zusätzlich 13.30 - 15.00	Service@FA-5330.fin-nrw.de	www.finanzamt-Lippstadt.de	538
5	5331	Lübbecke 	Bohlenstraße 102	32312	Lübbecke	05741/334-0	0800 10092675331		32292	1244	49000000	49001501	BBK MINDEN, WESTF	49050101	141	SPARKASSE MINDEN-LUEBBECKE	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5331.fin-nrw.de	www.finanzamt-Luebbecke.de	539
5	5332	Lüdenscheid 	Bahnhofsallee 16	58507	Lüdenscheid	02351/155-0	0800 10092675332	58505	58465	1589	45000000	45001502	BBK HAGEN	45850005	18	SPK LUEDENSCHEID	Mo-Fr 08.30-12.00 Uhr,Do auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5332.fin-nrw.de	www.finanzamt-Luedenscheid.de	540
5	5333	Lüdinghausen 	Bahnhofstraße 32	59348	Lüdinghausen	02591/930-0	0800 10092675333		59332	1243	40000000	40001506	BBK MUENSTER, WESTF	40154530	1008	SPARKASSE WESTMUENSTERLAND	vormittags: Mo.-Fr.8.30-12.00,nachmittags: Di. 13.30-15.00	Service@FA-5333.fin-nrw.de	www.finanzamt-Luedinghausen.de	541
5	5334	Meschede 	Fritz-Honsel-Straße 4	59872	Meschede	0291/950-0	0800 10092675334		59852	1265	41000000	46401502	BBK HAMM, WESTF	46451012	13003	SPK MESCHEDE	Mo-Fr 08:30 - 12:00,und nach Vereinbarung	Service@FA-5334.fin-nrw.de	www.finanzamt-Meschede.de	542
5	5335	Minden 	Heidestraße 10	32427	Minden	0571/804-1	0800 10092675335		32380	2340	49000000	49001500	BBK MINDEN, WESTF	49050101	40018145	SPARKASSE MINDEN-LUEBBECKE	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5335.fin-nrw.de	www.finanzamt-Minden.de	543
5	5336	Münster-Außenstadt 	Friedrich-Ebert-Str. 46	48153	Münster	0251/9729-0	0800 10092675336		48136	6129	40000000	40001501	BBK MUENSTER, WESTF	40050150	95031001	SPK MUENSTERLAND OST	Mo-Fr 08.30-12.00 Uhr,Mo auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5336.fin-nrw.de	www.finanzamt-Muenster-Aussenstadt.de	544
5	5337	Münster-Innenstadt 	Münzstr. 10	48143	Münster	0251/416-1	0800 10092675337		48136	6103	40000000	40001502	BBK MUENSTER, WESTF	40050150	300004	SPK MUENSTERLAND OST		Service@FA-5337.fin-nrw.de	www.finanzamt-Muenster-Innenstadt.de	545
5	5338	Olpe 	Am Gallenberg 20	57462	Olpe	02761/963-0	0800 10092675338		57443	1320	45000000	46001501	BBK HAGEN				Mo-Do 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,Freitag keine Sprechzeit	Service@FA-5338.fin-nrw.de	www.finanzamt-Olpe.de	546
5	5339	Paderborn 	Bahnhofstraße 28	33102	Paderborn	05251/100-0	0800 10092675339		33045	1520	48000000	47201500	BBK BIELEFELD	47250101	1001353	SPARKASSE PADERBORN		Service@FA-5339.fin-nrw.de	www.finanzamt-Paderborn.de	547
5	5340	Recklinghausen 	Westerholter Weg 2	45657	Recklinghausen	02361/583-0	0800 10092675340		45605	100553	43000000	42601500	BBK BOCHUM	42650150	90034158	SPK RECKLINGHAUSEN	Mo - Fr 08:30 bis 12:00,Mi auch 13:30 bis 15:00,und nach Vereinbarung	Service@FA-5340.fin-nrw.de	www.finanzamt-Recklinghausen.de	548
5	5341	Schwelm 	Bahnhofplatz 6	58332	Schwelm	02336/803-0	0800 10092675341		58316	340	45000000	45001520	BBK HAGEN	45451555	80002	ST SPK SCHWELM	Mo-Fr 8.30-12.00 Uhr,Mo,und nach Vereinbarung	Service@FA-5341.fin-nrw.de	www.finanzamt-Schwelm.de	549
5	5342	Siegen 	Weidenauer Straße 207	57076	Siegen	0271/4890-0	0800 10092675342		57025	210148	45000000	46001500	BBK HAGEN	46050001	1100114	SPK SIEGEN	Mo-Fr,Do auch 13:30 - 17:00 Uhr,und nach Vereinbarung	Service@FA-5342.fin-nrw.de	www.finanzamt-Siegen.de	550
5	5343	Soest 	Waisenhausstraße 11	59494	Soest	02921/351-0	0800 10092675343	59491	59473	1364	41000000	46401504	BBK HAMM, WESTF	41450075	208	SPARKASSE SOEST	Mo-Fr 0830-1200Uhr,und nach Vereinbarung	Service@FA-5343.fin-nrw.de	www.finanzamt-Soest.de	551
5	5344	Herne-West 	Edmund-Weber-Str. 210	44651	Herne	02325/696-0	0800 10092675344		44632	200262	43000000	43001503	BBK BOCHUM	43250030	17004	HERNER SPARKASSE	Mo-Fr 08.30-12.00 Uhr,Mo 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5344.fin-nrw.de	www.finanzamt-Herne-West.de	552
5	5345	Warburg 	Sternstraße 33	34414	Warburg	05641/771-0	0800 10092675345		34402	1226	48000000	47201503	BBK BIELEFELD	47251550	25005521	SPK HOEXTER BRAKEL		Service@FA-5345.fin-nrw.de	www.finanzamt-Warburg.de	553
5	5346	Warendorf 	Düsternstraße 43	48231	Warendorf	02581/924-0	0800 10092675346		48205	110361	40000000	40001504	BBK MUENSTER, WESTF	40050150	182	SPK MUENSTERLAND OST	Mo-Fr 08.30-12.00 Uhr,Do auch 13.30-15.00 Uhr,und nach Vereinbarung	Service@FA-5346.fin-nrw.de	www.finanzamt-Warendorf.de	554
5	5347	Wiedenbrück 	Hauptstraße 34	33378	Rheda-Wiedenbrück	05242/934-0	0800 10092675347	33372	33342	1429	48000000	47801500	BBK BIELEFELD	47853520	5231	KREISSPARKASSE WIEDENBRUECK	Mo - Fr 08.30 - 12.00 Uhr,Do auch 13.30 - 14.30 Uhr	Service@FA-5347.fin-nrw.de	www.finanzamt-Wiedenbrueck.de	555
5	5348	Witten 	Ruhrstraße 43	58452	Witten	02302/921-0	0800 10092675348		58404	1420	43000000	43001505	BBK BOCHUM	45250035	6007	ST SPK WITTEN	Mo - Fr 08.30 - 12.00 Uhr,Mo auch 13.30 - 15.00 Uhr,und nach Vereinbarung	Service@FA-5348.fin-nrw.de	www.finanzamt-Witten.de	556
5	5349	Bielefeld-Außenstadt 	Ravensberger Straße 125	33607	Bielefeld	0521/548-0	0800 10092675349		33503	100331	48000000	48001501	BBK BIELEFELD	48050161	180000	SPK BIELEFELD	Mo - Fr 08:30 - 12:00 Uhr,Do auch 13:30 - 15:00 Uhr,und nach Vereinbarung	Service@FA-5349.fin-nrw.de	www.finanzamt-Bielefeld-Aussenstadt.de	557
5	5350	Bochum-Süd 	Königsallee 21	44789	Bochum	0234/3337-0	0800 10092675350		44707	100764	43000000	43001504	BBK BOCHUM	43050001	1307792	SPARKASSE BOCHUM	Mo-Fr 08:30-12:00 Uhr,Di auch 13:30-15:00 Uhr	Service@FA-5350.fin-nrw.de	www.finanzamt-Bochum-Sued.de	558
5	5351	Gütersloh 	Neuenkirchener Str. 86	33332	Gütersloh	05241/3071-0	0800 10092675351		33245	1565	48000000	48001506	BBK BIELEFELD				Mo - Fr 08.30 - 12.00 Uhr,Do auch 13.30 - 15.00 Uhr	Service@FA-5351.fin-nrw.de	www.finanzamt-Guetersloh.de	559
5	5359	Marl 	Brassertstraße 1	45768	Marl	02365/516-0	0800 10092675359	45765	45744	1420	43000000	42601501	BBK BOCHUM	42650150	40020000	SPK RECKLINGHAUSEN		Service@FA-5359.fin-nrw.de	www.finanzamt-Marl.de	560
5	5371	Bielefeld für Groß- und Konzernbetriebsprüfung	Ravensberger Str. 90	33607	Bielefeld	0521/548-0	0800 10092675371		33511	101150								Service@FA-5371.fin-nrw.de		561
5	5372	Herne für Groß- und Konzernbetriebsprüfung	Hauptstr. 123	44651	Herne	02325/693-0	0800 10092675372		44636	200620								Service@FA-5372.fin-nrw.de		562
5	5373	Detmold für Groß- und Konzernbetriebsprüfung	Richthofenstrasse 94	32756	Detmold	05231/974-300	0800 10092675373		32706	1664								Service@FA-5373.fin-nrw.de		563
5	5374	Dortmund für Groß- und Konzernbetriebsprüfung	Nußbaumweg 210	44143	Dortmund	0231/5188-8953	0800 10092675374		44047	105039								Service@FA-5374.fin-nrw.de		564
5	5375	Hagen für Groß- und Konzernbetriebsprüfung	Hochstr. 43 - 45	58095	Hagen	02331/3760-0	0800 10092675375											Service@FA-5375.fin-nrw.de		565
5	5381	Bielefeld f. Steuerfahndung und Steuerstrafsachen	Ravensberger Str. 90	33607	Bielefeld	0521/548-0	0800 10092675381		33511	101173	48000000	48001500	BBK BIELEFELD	48050161	109	SPK BIELEFELD		Service@FA-5381.fin-nrw.de		566
5	5382	Bochum f. Steuerfahndung und Steuerstrafsachen	Uhlandstr. 37	44791	Bochum	0234/5878-0	0800 10092675382		44707	100768	43000000	43001500	BBK BOCHUM	43050001	1300011	SPARKASSE BOCHUM		Service@FA-5382.fin-nrw.de		567
5	5383	Hagen f. Steuerfahndung und Steuerstrafsachen	Becheltestr. 32	58089	Hagen	02331/3089-0	0800 10092675383		58041	4143	45000000	145001500	BBK HAGEN	45050001	100001580	SPARKASSE HAGEN		Service@FA-5383.fin-nrw.de		568
5	5384	Münster f. Steuerfahndung und Steuerstrafsachen	Hohenzollernring 80	48145	Münster	0251/9370-0	0800 10092675384				40000000	40001501	BBK MUENSTER, WESTF	40050150	95031001	SPK MUENSTERLAND OST		Service@FA-5384.fin-nrw.de		569
9	9101	Augsburg-Stadt Arbeitnehmerbereich	Prinzregentenpl. 2	86150	Augsburg	0821 506-01	0821 506-2222		86135	10 00 65	72000000	72001500	BBK AUGSBURG	72050000	24109	ST SPK AUGSBURG	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-17:30 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-a-s.bayern.de	www.finanzamt-augsburg-stadt.de	570
9	9102	Augsburg-Land 	Peutingerstr. 25	86152	Augsburg	0821 506-02	0821 506-3270	86144	86031	11 06 69	72000000	72001501	BBK AUGSBURG	72050101	8003	KR SPK AUGSBURG	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-a-l.bayern.de	www.finanzamt-augsburg-land.de	571
9	9103	Augsburg-Stadt 	Prinzregentenpl. 2	86150	Augsburg	0821 506-01	0821 506-2222		86135	10 00 65	72000000	72001500	BBK AUGSBURG	72050000	24109	ST SPK AUGSBURG	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-17:30 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-a-s.bayern.de	www.finanzamt-augsburg-stadt.de	572
9	9104	Bad Tölz -Außenstelle des Finanzamts Wolfratshausen-	Prof.-Max-Lange-Platz 2	83646	Bad Tölz	08041 8005-0	08041 8005-185		83634	1420	70000000	70001505	BBK MUENCHEN	70054306	31054	SPK BAD TOELZ-WOLFRATSHAUSE	Servicezentrum: Mo 7:30-18:00 Uhr, Di-Do 7:30-13:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-toel.bayern.de	www.finanzamt-bad-toelz.de	573
9	9105	Berchtesgaden 	Salzburger Str. 6	83471	Berchtesgaden	08652 960-0	08652 960-100		83461	1154	71000000	71001500	BBK MUENCHEN EH B REICHENHA	71050000	350009	SPK BERCHTESGADENER LAND	Servicezentrum: Mo-Do 7:30-13:30 Uhr (Nov-Mai Do 7:30-18:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-bgd.bayern.de	www.finanzamt-berchtesgaden.de	574
9	9106	Burghausen 	Tittmoninger Str. 1	84489	Burghausen	08677 8706-0	08677 8706-100		84480	1257	71000000	71001501	BBK MUENCHEN EH B REICHENHA	71051010	250001	KR SPK ALTOETTING-BURGHAUSE	Servicezentrum: Mo-Mi 7:45-15:00 Uhr Do 7:45-17:00 Uhr, Fr 7:45-12:00 Uhr	poststelle@fa-burgh.bayern.de	www.finanzamt-burghausen.de	575
9	9107	Dachau 	Bürgermeister-Zauner-Ring 2	85221	Dachau	08131 701-0	08131 701-111	85219	85202	1280	70000000	70001507	BBK MUENCHEN	70051540	908327	SPARKASSE DACHAU	Servicezentrum: Mo, Di, Do 7:30-15:00 Uhr (Nov-Mai Do 7:30-18:00 Uhr), Mi,Fr 7:30-12:00 Uhr	poststelle@fa-dah.bayern.de	www.finanzamt-dachau.de	576
9	9108	Deggendorf 	Pfleggasse 18	94469	Deggendorf	0991 384-0	0991 384-150		94453	1355	75000000	75001506	BBK REGENSBURG	74150000	380019950	SPK DEGGENDORF	Servicezentrum: Mo, Di, Do 7:45-15:00 Uhr (Jan-Mai Do 7:45-18:00 Uhr), Mi, Fr 7:45-12:00 Uhr	poststelle@fa-deg.bayern.de	www.finanzamt-deggendorf.de	577
9	9109	Dillingen 	Schloßstr. 3	89407	Dillingen	09071 507-0	09071 507-300	89401			72000000	72001503	BBK AUGSBURG	72251520	24066	KR U ST SPK DILLINGEN	Servicezentrum: Mo, Di, Mi, Fr 7:30-13:00 Uhr, Do 7:30-13:00 Uhr u. 14:00-18:00 Uhr	poststelle@fa-dlg.bayern.de	www.finanzamt-dillingen.de	578
9	9110	Dingolfing 	Obere Stadt 44	84130	Dingolfing	08731 504-0	08731 504-190		84122	1156	74300000	74301501	BBK REGENSBURG EH LANDSHUT	74351310	100017805	SPK DINGOLFING-LANDAU	Servicezentrum: Mo-Di 7:30-15:00 Uhr, Mi, Fr 7:30-12:00 Uhr, Do 7:30-17:00 Uhr	poststelle@fa-dgf.bayern.de	www.finanzamt-dingolfing.de	579
9	9111	Donauwörth -Außenstelle des Finanzamts Nördlingen-	Sallingerstr. 2	86609	Donauwörth	0906 77-0	0906 77-150	86607			72000000	72001502	BBK AUGSBURG	70010080	1632-809	POSTBANK -GIRO- MUENCHEN	Servicezentrum: Mo-Mi 7:30-13:30 Uhr, Do 7:30-18:00 Uhr, Fr 7:30 -13:00 Uhr	poststelle@fa-don.bayern.de	www.finanzamt-donauwoerth.de	580
9	9112	Ebersberg 	Schloßplatz 1-3	85560	Ebersberg	08092 267-0	08092 267-102				70000000	70001508	BBK MUENCHEN	70051805	75	KR SPK EBERSBERG	Servicezentrum: Mo-Do 7:30-13:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-ebe.bayern.de	www.finanzamt-ebersberg.de	581
9	9113	Eggenfelden 	Pfarrkirchner Str. 71	84307	Eggenfelden	08721 981-0	08721 981-200		84301	1160	74300000	74301502	BBK REGENSBURG EH LANDSHUT	74351430	5603	SPK ROTTAL-INN EGGENFELDEN	Servicezentrum: Mo, Di, Do 7:45-15:00 Uhr (Jan-Mai Do 7:45-17:00 Uhr), Mi, Fr 7:30-12:00 Uhr	poststelle@fa-eg.bayern.de	www.finanzamt-eggenfelden.de	582
9	9114	Erding 	Münchener Str. 31	85435	Erding	08122 188-0	08122 188-150		85422	1262	70000000	70001509	BBK MUENCHEN	70051995	8003	SPK ERDING-DORFEN	Servicezentrum: Mo-Mi 7:30-14:00 Uhr Do 7:30-18:00 Uhr, Fr 7:30 -12:00 Uhr	poststelle@fa-ed.bayern.de	www.finanzamt-erding.de	583
9	9115	Freising 	Prinz-Ludwig-Str. 26	85354	Freising	08161 493-0	08161 493-106	85350	85313	1343	70000000	70001510	BBK MUENCHEN	70021180	4001010	HYPOVEREINSBK FREISING	Servicezentrum: Mo-Di 7:30-15:00 Uhr, Mi, Fr 7:30-12:00 Uhr, Do 7:30-18:00 Uhr	poststelle@fa-fs.bayern.de	www.finanzamt-freising.de	584
9	9117	Fürstenfeldbruck 	Münchner Str.36	82256	Fürstenfeldbruck	08141 60-0	08141 60-150		82242	1261	70000000	70001511	BBK MUENCHEN	70053070	8007221	SPK FUERSTENFELDBRUCK	Servicezentrum: Mo-Mi 7:30-14:30 Uhr, Do 7:30-17:30 Uhr, Fr 7:30 -12:30 Uhr	poststelle@fa-ffb.bayern.de	www.finanzamt-fuerstenfeldbruck.de	585
9	9118	Füssen -Außenstelle des Finanzamts Kaufbeuren-	Rupprechtstr. 1	87629	Füssen	08362 5056-0	08362 5056-290		87620	1460	73300000	73301510	BBK AUGSBURG EH KEMPTEN	73350000	310500525	SPARKASSE ALLGAEU	Servicezentrum: Mo-Mi 8:00-15:00 Uhr, Do 8:00-18:00 Uhr, Fr 8:00-13:00 Uhr	poststelle@fa-fues.bayern.de	www.finanzamt-fuessen.de	586
9	9119	Garmisch-Partenkirchen 	Von-Brug-Str. 5	82467	Garmisch-Partenkirchen	08821 700-0	08821 700-111		82453	1363	70000000	70001520	BBK MUENCHEN	70350000	505	KR SPK GARMISCH-PARTENKIRCH	Servicezentrum: Mo-Mi 7:30-14:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-gap.bayern.de	www.finanzamt-garmisch-partenkirchen.de	587
9	9120	Bad Griesbach -Außenstelle des Finanzamts Passau-	Schloßhof 5-6	94086	Bad Griesbach	0851 504-0	0851 504-2222		94083	1222	74000000	74001500	BBK REGENSBURG EH PASSAU	74050000	16170	SPK PASSAU	Servicezentrum: Mo-Mi 7:30-14:00 Uhr, Do 7:30-17:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-griesb.bayern.de	www.finanzamt-bad-griesbach.de	588
9	9121	Günzburg 	Schloßpl. 4	89312	Günzburg	08221 902-0	08221 902-209		89302	1241	72000000	72001505	BBK AUGSBURG	72051840	18	SPK GUENZBURG-KRUMBACH	Servicezentrum: Mo-Di 7:45-12:30 u. 13:30-15:30, Mi, Fr 7:45-12:30, Do 7:45-12:30 u. 13:30-18:00	poststelle@fa-gz.bayern.de	www.finanzamt-guenzburg.de	589
9	9153	Passau mit Außenstellen 	Innstr. 36	94032	Passau	0851 504-0	0851 504-1410		94030	1450	74000000	740 01500	BBK REGENSBURG EH PASSAU	74050000	16170	SPK PASSAU	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-17:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-pa.bayern.de	www.finanzamt-passau.de	590
9	9123	Immenstadt -Außenstelle des Finanzamts Kempten-	Rothenfelsstr. 18	87509	Immenstadt	08323 801-0	08323 801-235		87502	1251	73300000	73301520	BBK AUGSBURG EH KEMPTEN	73350000	113464	SPARKASSE ALLGAEU	Servicezentrum: Mo-Do 7:30-14:00 Uhr (Okt-Mai Do 7:30-18:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-immen.bayern.de	www.finanzamt-immenstadt.de	591
9	9124	Ingolstadt 	Esplanade 38	85049	Ingolstadt	0841 311-0	0841 311-133		85019	210451	72100000	72101500	BBK MUENCHEN EH INGOLSTADT	72150000	25 080	SPARKASSE INGOLSTADT	Servicezentrum: Mo-Di 7:15-13:30, Mi 7:15-12:30, Do 7:15-17:30, Fr 7:15-12:00	poststelle@fa-in.bayern.de	www.finanzamt-ingolstadt.de	592
9	9125	Kaufbeuren 	Remboldstr. 21	87600	Kaufbeuren	08341 802-0	08341 802-221		87572	1260	73300000	73401500	BBK AUGSBURG EH KEMPTEN	73450000	25700	KR U ST SPK KAUFBEUREN	Servicezentrum: Mo-Mi 7:30-14:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-kf.bayern.de	www.finanzamt-kaufbeuren.de	593
9	9126	Kelheim 	Klosterstr. 1	93309	Kelheim	09441 201-0	09441 201-201		93302	1252	75000000	75001501	BBK REGENSBURG	75051565	190201301	KREISSPARKASSE KELHEIM	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-17:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-keh.bayern.de	www.finanzamt-kelheim.de	594
9	9127	Kempten (Allgäu) 	Am Stadtpark 3	87435	Kempten	0831 256-0	0831 256-260		87405	1520	73300000	73301500	BBK AUGSBURG EH KEMPTEN	73350000	117	SPARKASSE ALLGAEU	Servicezentrum: Mo-Do 7:30-14:30 Uhr (Nov-Mai Do 7:20-17:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-ke.bayern.de	www.finanzamt-kempten.de	595
9	9131	Landsberg 	Israel-Beker-Str. 20	86899	Landsberg	08191 332-0	08191 332-108	86896			72000000	72001504	BBK AUGSBURG	70052060	158	SPK LANDSBERG-DIESSEN	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-16:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-ll.bayern.de	www.finanzamt-landsberg.de	596
9	9132	Landshut 	Maximilianstr. 21	84028	Landshut	0871 8529-000	0871 8529-360				74300000	74301500	BBK REGENSBURG EH LANDSHUT	74350000	10111	SPK LANDSHUT	Servicezentrum: Mo-Di 8:00-15:00 Uhr, Mi, Fr 8:00-12:00 Uhr, Do 8:00-18:00 Uhr	poststelle@fa-la.bayern.de	www.finanzamt-landshut.de	597
9	9133	Laufen - Außenstelle des Finanzamts Berchtesgaden-	Rottmayrstr. 13	83410	Laufen	08682 918-0	08682 918-100		83406	1251	71000000	71001502	BBK MUENCHEN EH B REICHENHA	71050000	59998	SPK BERCHTESGADENER LAND	Servicezentrum: Mo-Do 7:30-13:30 Uhr (Nov-Mai Do 7:30-18:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-lauf.bayern.de	www.finanzamt-laufen.de	598
9	9134	Lindau 	Brettermarkt 4	88131	Lindau	08382 916-0	08382 916-100		88103	1320	73300000	73501500	BBK AUGSBURG EH KEMPTEN	73150000	620018333	SPK MEMMINGEN-LINDAU-MINDEL	Servicezentrum: Mo-Do 7:30-14:00 Uhr (Nov-Mai Do 7:30-18:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-li.bayern.de	www.finanzamt-lindau.de	599
9	9138	Memmingen 	Bodenseestr. 6	87700	Memmingen	08331 608-0	08331 608-165		87683	1345	73100000	73101500	BBK AUGSBURG EH MEMMINGEN	73150000	210005	SPK MEMMINGEN-LINDAU-MINDEL	Servicezentrum: Mo-Do 7:30-14:00 Uhr, (Nov-Mai Do 7:30-18:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-mm.bayern.de	www.finanzamt-memmingen.de	600
9	9139	Miesbach 	Schlierseer Str. 5	83714	Miesbach	08025 709-0	08025 709-500		83711	302	70000000	70001512	BBK MUENCHEN	71152570	4002	KR SPK MIESBACH-TEGERNSEE	Servicezentrum: Mo, Di, Mi, Fr 7:30-14:00 Uhr, Do 7:30-18:00 Uhr	poststelle@fa-mb.bayern.de	www.finanzamt-miesbach.de	601
9	9140	Mindelheim -Außenstelle des Finanzamts Memmingen-	Bahnhofstr. 16	87719	Mindelheim	08261 9912-0	08261 9912-300		87711	1165	73100000	73101502	BBK AUGSBURG EH MEMMINGEN	73150000	810004788	SPK MEMMINGEN-LINDAU-MINDEL	Servicezentrum: Mo-Mi 7:30-12:00 u. 13:30-15:30, Do 7:30-12:00 u. 13:30-17:30, Fr 7:30-12:00	poststelle@fa-mn.bayern.de	www.finanzamt-mindelheim.de	602
9	9141	Mühldorf 	Katharinenplatz 16	84453	Mühldorf	08631 616-0	08631 616-100		84445	1369	71100000	71101501	BBK MUENCHEN EH ROSENHEIM	71151020	885	KR SPK MUEHLDORF	Servicezentrum: Mo-Mi 7:30-14:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-mue.bayern.de	www.finanzamt-muehldorf.de	603
9	9142	München f. Körpersch. Bewertung des Grundbesitzes	Meiserstr. 4	80333	München	089 1252-0	089 1252-7777	80275	80008	20 09 26	70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-m-koe.bayern.de	www.finanzamt-muenchen-koerperschaften.de	604
9	9143	München f. Körpersch. Körperschaftsteuer	Meiserstr. 4	80333	München	089 1252-0	089 1252-7777	80275	80008	20 09 26	70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-m-koe.bayern.de	www.finanzamt-muenchen-koerperschaften.de	605
9	9144	München I 	Karlstr. 9-11	80333	München	089 1252-0	089 1252-1111	80276	80008	20 09 05	70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	poststelle@fa-m1.bayern.de	www.finanzamt-muenchen-I.de	606
9	9145	München III 	Deroystr. 18	80335	München	089 1252-0	089 1252-3333	80301			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	poststelle@fa-m3.bayern.de	www.finanzamt-muenchen-III.de	607
9	9146	München IV 	Deroystr. 4 Aufgang I	80335	München	089 1252-0	089 1252-4000	80302			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	poststelle@fa-m4.bayern.de	www.finanzamt-muenchen-IV.de	608
9	9147	München II 	Deroystr. 20	80335	München	089 1252-0	089 1252-2222	80269			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	poststelle@fa-m2.bayern.de	www.finanzamt-muenchen-II.de	609
9	9148	München V 	Deroystr. 4 Aufgang II	80335	München	089 1252-0	089 1252-5281	80303			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	poststelle@fa-m5.bayern.de	www.finanzamt-muenchen-V.de	610
9	9149	München-Zentral Erhebung, Vollstreckung	Winzererstr. 47a	80797	München	089 3065-0	089 3065-1900	80784			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-m-zfa.bayern.de	www.finanzamt-muenchen-zentral.de	611
9	9150	Neuburg -Außenstelle des Finanzamts Schrobenhausen-	Fünfzehnerstr. 7	86633	Neuburg	08252 918-0	08252 918-222		86618	1320	72100000	72101505	BBK MUENCHEN EH INGOLSTADT	72151880	104000	ST SPK SCHROBENHAUSEN	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-12:30 Uhr	poststelle@fa-nd.bayern.de	www.finanzamt-neuburg.de	612
9	9151	Neu-Ulm 	Nelsonallee 5	89231	Neu-Ulm	0731 7045-0	0731 7045-500	89229	89204	1460	63000000	63001501	BBK ULM, DONAU	73050000	430008425	SPK NEU-ULM ILLERTISSEN	Servicezentrum: Mo, Di, Mi, Fr 8:00-13:00 Uhr, Do 8:00-13:00 Uhr u. 14:00-18:00 Uhr	poststelle@fa-nu.bayern.de	www.finanzamt-neu-ulm.de	613
9	9152	Nördlingen 	Tändelmarkt 1	86720	Nördlingen	09081 215-0	09081 215-100		86715	1521	72000000	72001506	BBK AUGSBURG	72250000	111500	SPARKASSE NOERDLINGEN	Servicezentrum: Mo, Di, Mi, Fr 7:30-13:00 Uhr, Do 7:30-13:00 Uhr u. 14:00-18:00 Uhr	poststelle@fa-noe.bayern.de	www.finanzamt-noerdlingen.de	614
9	9154	Pfaffenhofen 	Schirmbeckstr. 5	85276	Pfaffenhofen a. d. Ilm	08441 77-0	08441 77-199		85265	1543	72100000	72101504	BBK MUENCHEN EH INGOLSTADT	72151650	7302	VER SPK PFAFFENHOFEN	Servicezentrum: Mo-Mi 7:30-14:30 Uhr, Do 7:30-17:30 Uhr, Fr 7:30-12:30 Uhr	poststelle@fa-paf.bayern.de	www.finanzamt-pfaffenhofen.de	615
9	9156	Rosenheim m. ASt Wasserburg 	Wittelsbacherstr. 25	83022	Rosenheim	08031 201-0	08031 201-222		83002	100255	71100000	71101500	BBK MUENCHEN EH ROSENHEIM	71150000	34462	SPK ROSENHEIM	Servicezentrum: Mo-Do 7:30-14:00 Uhr, (Okt-Mai Do 7:30-17:00 Uhr), Fr 7:30-12.00 Uhr	poststelle@fa-ro.bayern.de	www.finanzamt-rosenheim.de	616
9	9157	Grafenau 	Friedhofstr. 1	94481	Grafenau	08552 423-0	08552 423-170				75000000	75001507	BBK REGENSBURG	70010080	1621-806	POSTBANK -GIRO- MUENCHEN	Servicezentrum: Mo, Di 7:30-15:00 Uhr, Mi, Fr 7:30-12:00 Uhr, Do 7:30-18:00 Uhr	poststelle@fa-gra.bayern.de	www.finanzamt-grafenau.de	617
9	9158	Schongau - Außenstelle des Finanzamts Weilheim-Schongau -	Rentamtstr. 1	86956	Schongau	0881 184-0	0881 184-373		86951	1147	70000000	70001521	BBK MUENCHEN	70351030	20149	VER SPK WEILHEIM	Servicezentrum: Mo-Do 7:30-14:00 Uhr (Okt-Jun Do 7:30-17:30 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-sog.bayern.de	www.finanzamt-schongau.de	618
9	9159	Schrobenhausen m. ASt Neuburg  	Rot-Kreuz-Str. 2	86529	Schrobenhausen	08252 918-0	08252 918-430		86522	1269	72100000	72101505	BBK MUENCHEN EH INGOLSTADT	72151880	104000	ST SPK SCHROBENHAUSEN	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-12:30 Uhr	poststelle@fa-sob.bayern.de	www.finanzamt-schrobenhausen.de	619
9	9161	Starnberg 	Schloßbergstr.	82319	Starnberg	08151 778-0	08151 778-250		82317	1251	70000000	70001513	BBK MUENCHEN	70250150	430064295	KR SPK MUENCHEN STARNBERG	Servicezentrum: Mo-Mi 7:30-15:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-13:00 Uhr	poststelle@fa-sta.bayern.de	www.finanzamt-starnberg.de	620
9	9162	Straubing 	Fürstenstr. 9	94315	Straubing	09421 941-0	09421 941-272		94301	151	75000000	75001502	BBK REGENSBURG	74250000	240017707	SPK STRAUBING-BOGEN	Servicezentrum: Mo, Di, Mi, Fr 7:30-13:00 Uhr, Do 7:30-18:00 Uhr	poststelle@fa-sr.bayern.de	www.finanzamt-straubing.de	621
9	9163	Traunstein 	Herzog-Otto-Str. 6	83278	Traunstein	0861 701-0	0861 701-338	83276	83263	1309	71000000	71001503	BBK MUENCHEN EH B REICHENHA	71052050	7070	KR SPK TRAUNSTEIN-TROSTBERG	Servicezentrum: Mo-Do 7:30-14:00 Uhr (Okt.-Mai Do 7:30-18:00 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-ts.bayern.de	www.finanzamt-traunstein.de	622
9	9164	Viechtach -Außenstelle des Finanzamts Zwiesel-	Mönchshofstr. 27	94234	Viechtach	09922 507-0	09922 507-399		94228	1162	75000000	75001508	BBK REGENSBURG	74151450	240001008	SPARKASSE REGEN-VIECHTACH	Servicezentrum: Mo-Di 7:45-15:00 Uhr, Mi, Fr 7:45-12:00 Uhr, Do 7:45-18:00 Uhr	poststelle@fa-viech.bayern.de	www.finanzamt-viechtach.de	623
9	9166	Vilshofen -Außenstelle des Finanzamts Passau-	Kapuzinerstr. 36	94474	Vilshofen	0851 504-0	0851 504-2465				74000000	74001500	BBK REGENSBURG EH PASSAU	74050000	16170	SPK PASSAU	Servicezentrum: Mo-Mi 7:30-14:00 Uhr, Do 7:30-17:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-vof.bayern.de	www.finanzamt-vilshofen.de	624
9	9167	Wasserburg -Außenstelle des Finanzamts Rosenheim-	Rosenheimer Str. 16	83512	Wasserburg	08037 201-0	08037 201-150		83502	1280	71100000	71101500	BBK MUENCHEN EH ROSENHEIM	71150000	34462	SPK ROSENHEIM	Servicezentrum: Mo-Do 7:30-14:00 Uhr, (Okt-Mai Do 7:30-17:00 Uhr), Fr 7:30-12.00 Uhr	poststelle@fa-ws.bayern.de	www.finanzamt-wasserburg.de	625
9	9168	Weilheim-Schongau 	Hofstr. 23	82362	Weilheim	0881 184-0	0881 184-500		82352	1264	70000000	70001521	BBK MUENCHEN	70351030	20149	VER SPK WEILHEIM	Servicezentrum: Mo-Do 7:30-14:00 Uhr (Okt-Jun Do 7:30-17:30 Uhr), Fr 7:30-12:00 Uhr	poststelle@fa-wm.bayern.de	www.finanzamt-weilheim.de	626
9	9169	Wolfratshausen 	Heimgartenstr. 5	82515	Wolfratshausen	08171 25-0	08171 25-150		82504	1444	70000000	70001514	BBK MUENCHEN	70054306	505	SPK BAD TOELZ-WOLFRATSHAUSE	Servicezentrum: Mo-MI 7:30-14:00 Uhr, Do 7:30-17:00 Uhr, Fr 7:30-12:30 Uhr	poststelle@fa-wor.bayern.de	www.finanzamt-wolfratshausen.de	627
9	9170	Zwiesel m. ASt Viechtach 	Stadtplatz 16	94227	Zwiesel	09922 507-0	09922 507-200		94221	1262	75000000	75001508	BBK REGENSBURG	74151450	240001008	SPARKASSE REGEN-VIECHTACH	Servicezentrum: Mo-Di 7:45-15:00 Uhr, Mi, Fr 7:45-12:00 Uhr, Do 7:45-18:00 Uhr	poststelle@fa-zwi.bayern.de	www.finanzamt-zwiesel.de	628
9	9171	Eichstätt 	Residenzplatz 8	85072	Eichstätt	08421 6007-0	08421 6007-400	85071	85065	1163	72100000	72101501	BBK MUENCHEN EH INGOLSTADT	72151340	1214	SPARKASSE EICHSTAETT	Servicezentrum: Mo, Di, Mi 7:30-14:00 Uhr, Do 7:30-18:00 Uhr, Fr 7:30-12:00 Uhr	poststelle@fa-ei.bayern.de	www.finanzamt-eichstaett.de	629
9	9180	München f. Körpersch. 	Meiserstr. 4	80333	München	089 1252-0	089 1252-7777	80275	80008	20 09 26	70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-m-koe.bayern.de	www.finanzamt-muenchen-koerperschaften.de	630
9	9181	München I Arbeitnehmerbereich	Karlstr. 9/11	80333	München	089 1252-0	089 1252-1111	80276	80008	20 09 05	70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	Poststelle@fa-m1-BS.bayern.de	www.finanzamt-muenchen-I.de	631
9	9182	München II Arbeitnehmerbereich	Deroystr. 20	80335	München	089 1252-0	089 1252-2888	80269			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	Poststelle@fa-m2-BS.bayern.de	www.finanzamt-muenchen-II.de	632
9	9183	München III Arbeitnehmerbereich	Deroystr. 18	80335	München	089 1252-0	089 1252-3788	80301			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	Poststelle@fa-m3-BS.bayern.de	www.finanzamt-muenchen-III.de	633
9	9184	München IV Arbeitnehmerbereich	Deroystr. 4 Aufgang I	80335	München	089 1252-0	089 1252-4820	80302			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	Poststelle@fa-m4-BS.bayern.de	www.finanzamt-muenchen-IV.de	634
9	9185	München V Arbeitnehmerbereich	Deroystr. 4 Aufgang II	80335	München	089 1252-0	089 1252-5799	80303			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Servicezentrum Deroystr. 6: Mo-Mi 7:30-16:00, Do 7:30-18:00, Fr 7:30-12:30 (i. Ü. nach Vereinb.)	Poststelle@fa-m5-BS.bayern.de	www.finanzamt-muenchen-V.de	635
9	9187	München f. Körpersch. 	Meiserstr. 4	80333	München	089 1252-0	089 1252-7777	80275	80008	20 09 26	70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-m-koe.bayern.de	www.finanzamt-muenchen-koerperschaften.de	636
9	9189	München-Zentral Kraftfahrzeugsteuer	Winzererstr. 47a	80797	München	089 3065-0	089 3065-1900	80784			70050000	24962	BAYERNLB MUENCHEN	70000000	70001506	BBK MUENCHEN	Mo, Di, Do, Fr 8:00-12:00 Uhr, Mi geschlossen	poststelle@fa-m-zfa.bayern.de	www.finanzamt-muenchen-zentral.de	637
9	9201	Amberg 	Kirchensteig 2	92224	Amberg	09621 36-0	09621 36-413		92204	1452	75300000	75301503	BBK REGENSBURG EH WEIDEN	75250000	190011122	SPARKASSE AMBERG-SULZBACH	Servicezentrum: Mo, Die, Mi, Fr: 07:30 - 12:00 UhrDo: 07:30 - 17:30 Uhr	poststelle@fa-am.bayern.de	www.finanzamt-amberg.de	638
9	9202	Obernburg a. Main mit Außenstelle Amorbach	Schneeberger Str. 1	63916	Amorbach	09373 202-0	09373 202-100		63912	1160	79500000	79501502	BBK WUERZBURG EH ASCHAFFENB	79650000	620300111	SPK MILTENBERG-OBERNBURG	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-amorb.bayern.de	www.finanzamt-amorbach.de	639
9	9203	Ansbach mit Außenstellen	Mozartstr. 25	91522	Ansbach	0981 16-0	0981 16-333		91511	608	76500000	76501500	BBK NUERNBERG EH ANSBACH	76550000	215004	VER SPK ANSBACH	Servicezentrum: Mo - Mi: 08:00 - 14:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-an.bayern.de	www.finanzamt-ansbach.de	640
9	9204	Aschaffenburg 	Auhofstr. 13	63741	Aschaffenburg	06021 492-0	06021 492-1000	63736			79500000	79501500	BBK WUERZBURG EH ASCHAFFENB	79550000	8375	SPK ASCHAFFENBURG ALZENAU	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 8:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-ab.bayern.de	www.finanzamt-aschaffenburg.de	641
9	9205	Bad Kissingen 	Bibrastr. 10	97688	Bad Kissingen	0971 8021-0	0971 8021-200		97663	1360	79300000	79301501	BBK WUERZBURG EH SCHWEINFUR	79351010	10009	SPK BAD KISSINGEN	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-kg.bayern.de	/www.finanzamt-bad-kissingen.de	642
9	9206	Bad Neustadt a.d.S. 	Meininger Str. 39	97616	Bad Neustadt	09771 9104-0	09771 9104-444	97615			79300000	79301502	BBK WUERZBURG EH SCHWEINFUR	79353090	7005	SPK BAD NEUSTADT A D SAALE	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-nes.bayern.de	www.finanzamt-bad-neustadt.de	643
9	9207	Bamberg 	Martin-Luther-Str. 1	96050	Bamberg	0951 84-0	0951 84-230	96045			77000000	77001500	BBK NUERNBERG EH BAMBERG	77050000	30700	SPK BAMBERG	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-ba.bayern.de	www.finanzamt-bamberg.de	644
9	9208	Bayreuth 	Maximilianstr. 12/14	95444	Bayreuth	0921 609-0	0921 609-254		95422	110361	77300000	773 01500	BBK BAYREUTH	77350110	9033333	SPARKASSE BAYREUTH	Servicezentrum: Mo - Mi: 07:30 - 14:00 Uhr, Do: 07:30 - 17:00 Uhr, Fr: 07:30	poststelle@fa-bt.bayern.de	www.finanzamt-bayreuth.de	645
9	9211	Cham mit Außenstellen 	Reberstr. 2	93413	Cham	09971 488-0	09971 488-199		93402	1253	74221170	344 755 205	HYPOVEREINSBK CHAM, OBERPF	76010085	1735-858	POSTBANK NUERNBERG	Servicezentrum: Mo - Mi: 07:30 - 15:00 Uhr, Do: 07:30 - 18:00 Uhr, Fr: 07:30	poststelle@fa-cha.bayern.de	www.finanzamt-cham.de	646
9	9212	Coburg 	Rodacher Straße 4	96450	Coburg	09561 646-0	09561 646-130		96406	1653	77000000	78301500	BBK NUERNBERG EH BAMBERG	78350000	7450	VER SPK COBURG	Servicezentrum: Mo - Fr: 08:00 - 13:00 Uhr, Do: 14:00 - 18:00 Uhr	poststelle@fa-co.bayern.de	www.finanzamt-coburg.de	647
9	9213	Dinkelsbühl - Außenstelle des  Finanzamts Ansbach -	Föhrenberggasse 30	91550	Dinkelsbühl	0981 16-0	09851 5737-607				76500000	76501500	BBK NUERNBERG EH ANSBACH	76550000	215004	VER SPK ANSBACH	Servicezentrum: Mo - Mi: 08:00 - 14:00, Do: 08:00 - 18:00 Uhr, Fr: 08:00 -	poststelle@fa-dkb.bayern.de	www.finanzamt-dinkelsbuehl.de	648
9	9214	Ebern - Außenstelle des Finanzamts Zeil -	Rittergasse 1	96104	Ebern	09524 824-0	09524 824-225				79300000	79301505	BBK WUERZBURG EH SCHWEINFUR	79351730	500900	SPK OSTUNTERFRANKEN	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-ebn.bayern.de	www.finanzamt-ebern.de	649
9	9216	Erlangen 	Schubertstr 10	91052	Erlangen	09131 121-0	09131 121-369	91051			76000000	76001507	BBK NUERNBERG	76350000	2929	ST U KR SPK ERLANGEN	Servicezentrum: Mo - Mi: 08:00 - 14:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-er.bayern.de	www.finanzamt-erlangen.de	650
9	9217	Forchheim 	Dechant-Reuder-Str. 6	91301	Forchheim	09191 626-0	09191 626-200	91299			76000000	76001508	BBK NUERNBERG	76351040	91	SPARKASSE FORCHHEIM	Servicezentrum: Mo - Mi: 08:00 - 13:00 Uhr, Do: 08:00 - 17:30, Fr: 08:00 -	poststelle@fa-fo.bayern.de	www.finanzamt-forchheim.de	651
9	9218	Fürth 	Herrnstraße 69	90763	Fürth	0911 7435-0	0911 7435-350	90744			76000000	76201500	BBK NUERNBERG	76250000	18200	SPK FUERTH	Servicezentrum: Mo - Mi: 08:00 - 14:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-fue.bayern.de	www.finanzamt-fuerth.de	652
9	9220	Gunzenhausen 	Hindenburgplatz 1	91710	Gunzenhausen	09831 8009-0	09831 8009-77	91709			76500000	76501502	BBK NUERNBERG EH ANSBACH	76551540	109785	VER SPK GUNZENHAUSEN	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-gun.bayern.de	www.finanzamt-gunzenhausen.de	653
9	9221	Hersbruck 	Amberger Str. 76 (Haus B)	91217	Hersbruck	09151 731-0	09151 731-200		91211	273	76000000	76001505	BBK NUERNBERG	76050101	190016618	SPARKASSE NUERNBERG	Servicezentrum: Mo - Mi: 08:00 - 15:30 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-heb.bayern.de	www.finanzamt-hersbruck.de	654
9	9222	Hilpoltstein 	Spitalwinkel 3	91161	Hilpoltstein	09174 469-0	09174 469-100		91155	1180	76000000	76401520	BBK NUERNBERG	76450000	240000026	SPK MITTELFRANKEN-SUED	Servicezentrum: Mo - Fr: 08:00 - 12:30 Uhr, Do: 14:00 - 18:00 Uhr	poststelle@fa-hip.bayern.de	www.finanzamt-hilpoltstein.de	655
9	9223	Hof mit Außenstellen 	Ernst-Reuter-Str. 60	95030	Hof	09281 929-0	09281 929-1500		95012	1368	78000000	78001500	BBK BAYREUTH EH HOF	78050000	380020750	KR U ST SPK HOF	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-ho.bayern.de	www.finanzamt-hof.de	656
9	9224	Hofheim - Außenstelle des Finanzamts Zeil -	Marktplatz 1	97457	Hofheim	09524 824-0	09524 824-250				79300000	79301505	BBK WUERZBURG EH SCHWEINFUR	79351730	500900	SPK OSTUNTERFRANKEN	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-hoh.bayern.de	www.finanzamt-hofheim.de	657
9	9225	Karlstadt - Außenstelle des Finanzamts Lohr -	Gemündener Str. 3	97753	Karlstadt	09353 949-0	09353 949-2250				79000000	79001504	BBK WUERZBURG	79050000	2246	SPK MAINFRANKEN WUERZBURG	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-kar.bayern.de	www.finanzamt-karlstadt.de	658
9	9227	Kitzingen 	Moltkestr. 24	97318	Kitzingen	09321 703-0	09321 703-444		97308	660	79000000	79101500	BBK WUERZBURG	79050000	42070557	SPK MAINFRANKEN WUERZBURG	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-kt.bayern.de	www.finanzamt-kitzingen.de	659
9	9228	Kronach 	Amtsgerichtsstr. 13	96317	Kronach	09261 510-0	09261 510-199		96302	1262	77300000	77101501	BBK BAYREUTH	77151640	240006007	SPK KRONACH-LUDWIGSSTADT	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08.00 - 17:30 Uhr, Fr: 08:00	poststelle@fa-kc.bayern.de	www.finanzamt-kronach.de	660
9	9229	Kulmbach 	Georg-Hagen-Str. 17	95326	Kulmbach	09221 650-0	09221 650-283		95304	1420	77300000	77101500	BBK BAYREUTH	77150000	105445	SPARKASSE KULMBACH	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08.00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-ku.bayern.de	www.finanzamt-kulmbach.de	661
9	9230	Lichtenfels 	Kronacher Str. 39	96215	Lichtenfels	09571 764-0	09571 764-420		96206	1680	77000000	77001502	BBK NUERNBERG EH BAMBERG	77051860	2345	KR SPK LICHTENFELS	Servicezentrum: Mo - Fr: 08:00 - 13:00 Uhr, Do: 14:00 - 17:00 Uhr	poststelle@fa-lif.bayern.de	www.finanzamt-lichtenfels.de	662
9	9231	Lohr a. Main mit Außenstellen  	Rexrothstr. 14	97816	Lohr	09352 850-0	09352 850-1300		97804	1465	79000000	79001504	BBK WUERZBURG	79050000	2246	SPK MAINFRANKEN WUERZBURG	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-loh.bayern.de	www.finanzamt-lohr.de	663
9	9232	Marktheidenfeld - Außenstelle  des Finanzamts Lohr -	Ringstr. 24/26	97828	Marktheidenfeld	09391 506-0	09391 506-3299				79000000	79001504	BBK WUERZBURG	79050000	2246	SPK MAINFRANKEN WUERZBURG	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-mar.bayern.de	www.finanzamt-marktheidenfeld.de	664
9	9233	Münchberg - Außenstelle des Finanzamts Hof -	Hofer Str. 1	95213	Münchberg	09281 929-0	09281 929-3505				78000000	78001500	BBK BAYREUTH EH HOF	78050000	380020750	KR U ST SPK HOF	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-mueb.bayern.de	www.finanzamt-muenchberg.de	665
9	9234	Naila - Außenstelle des Finanzamts Hof -	Carl-Seyffert-Str. 3	95119	Naila	09281 929-0	09281 929-2506				78000000	78001500	BBK BAYREUTH EH HOF	78050000	380020750	KR U ST SPK HOF	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-nai.bayern.de	www.finanzamt-naila.de	666
9	9235	Neumarkt i.d.Opf. 	Ingolstädter Str. 3	92318	Neumarkt	09181 692-0	09181 692-1200				76000000	76001506	BBK NUERNBERG	76052080	6296	SPK NEUMARKT I D OPF-PARSBG	Servicezentrum: Mo - Do: 07:30 - 15:00 Uhr, Fr: 07:30 - 12:00 Uhr	poststelle@fa-nm.bayern.de	/www.finanzamt-neumarkt.de	667
9	9236	Neunburg v. W. - Außenstelle des Finanzamts Schwandorf -	Krankenhausstr. 6	92431	Neunburg vorm Wald	09431 382-0	09431 382-539		92428	1000	75300000	75301502	BBK REGENSBURG EH WEIDEN	75051040	380019000	SPK IM LANDKREIS SCHWANDORF	Servicezentrum: Mo-Mi: 07:30-12:30 u. 13:30-15:30,Do: 07:30-12:30 u. 13:30-17:00, Fr: 07:30-12:30 h 	poststelle@fa-nen.bayern.de	www.finanzamt-neunburg.de	668
9	9238	Nürnberg-Nord 	Kirchenweg 10	90419	Nürnberg	0911 3998-0	0911 3998-296	90340			76000000	76001502	BBK NUERNBERG	76050000	20161	BAYERNLB NUERNBERG	Servicezentrum: Mo - Mi: 08:00 - 14:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-n-n.bayern.de	www.finanzamt-nuernberg-nord.de	669
9	9240	Nürnberg-Süd 	Sandstr. 20	90443	Nürnberg	0911 248-0	0911 248-2299/2599	90339			76000000	76001503	BBK NUERNBERG	76050101	3648043	SPARKASSE NUERNBERG	Servicezentrum: Mo - Mi: 08:00 - 14:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-n-s.bayern.de	www.finanzamt-nuernberg-sued.de	670
9	9241	Nürnberg-Zentral 	Voigtländerstr. 7/9	90489	Nürnberg	0911 5393-0	0911 5393-2000				76000000	76001501	BBK NUERNBERG	76050101	1025008	SPARKASSE NUERNBERG	Servicezentrum: Mo - Do: 08:00 - 12:30 h, Di und Do: 13:30 - 15:00 h,	poststelle@fa-n-zfa.bayern.de	www.zentralfinanzamt-nuernberg.de	671
9	9242	Ochsenfurt - Außenstelle des Finanzamts Würzburg -	Völkstr.1	97199	Ochsenfurt	09331 904-0	09331 904-200		97196	1263	79000000	79001500	BBK WUERZBURG	79020076	801283	HYPOVEREINSBK WUERZBURG	Servicezentrum: Mo - Mi: 07:30 - 13:00 Uhr, Do: 07:30 - 17:00 uhr, Fr: 07:30	poststelle@fa-och.bayern.de	www.finanzamt-ochsenfurt.de	672
9	9244	Regensburg 	Landshuter Str. 4	93047	Regensburg	0941 5024-0	0941 5024-1199	93042			75000000	75001500	BBK REGENSBURG	75050000	111500	SPK REGENSBURG	Servicezentrum: Mo - Mi: 07:30 - 15:00 Uhr, Do: 07:30 - 17:00 Uhr, Fr: 07:30	poststelle@fa-r.bayern.de	www.finanzamt-regensburg.de	673
9	9246	Rothenburg - Außenstelle des Finanzamts Ansbach -	Ludwig-Siebert-Str. 31	91541	Rothenburg o.d.T.	0981 16-0	09861 706-511				76500000	76501500	BBK NUERNBERG EH ANSBACH	76550000	215004	VER SPK ANSBACH	Servicezentrum: Mo - Mi: 08:00 - 14:00 Uhr, Do: 08:00 - 18:00 Uhr, Fr: 08:00	poststelle@fa-rot.bayern.de	www.finanzamt-rothenburg.de	674
9	9247	Schwabach 	Theodor-Heuss-Str. 63	91126	Schwabach	09122 928-0	09122 928-100	91124			76000000	76401500	BBK NUERNBERG	76450000	55533	SPK MITTELFRANKEN-SUED	Servicezentrum: Mo - Mi: 08:00 - 13:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-sc.bayern.de	www.finanzamt-schwabach.de	675
9	9248	Schwandorf mit Außenstelle Neunburg v. W.	Friedrich-Ebert-Str.59	92421	Schwandorf	09431 382-0	09431 382-111	92419			75300000	75301502	BBK REGENSBURG EH WEIDEN	75051040	380019000	SPK IM LANDKREIS SCHWANDORF	Servicezentrum: Mo-Mi: 07:30-12:30 u. 13:30-15:30,Do: 07:30-12:30 u. 13:30-17:00, Fr: 07:30-12:30 h 	poststelle@fa-sad.bayern.de	www.finanzamt-schwandorf.de	676
9	9249	Schweinfurt 	Schrammstr. 3	97421	Schweinfurt	09721 2911-0	09721 2911-5070	97420			79300000	79301500	BBK WUERZBURG EH SCHWEINFUR	79350101	15800	KR SPK SCHWEINFURT	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-sw.bayern.de	www.finanzamt-schweinfurt.de	677
9	9250	Selb - Außenstelle des Finanzamts Wunsiedel -	Wittelsbacher Str. 8	95100	Selb	09232 607-0	09232 607-300				78000000	78101512	BBK BAYREUTH EH HOF	78055050	620006254	SPK FICHTELGEBIRGE	Servicezentrum: Mo-Mi: 07:30-12:30 u. 13:30-15:00,Do: 07:30-12:30 und 13:30-17:00, Fr: 07:30-12:00 h	poststelle@fa-sel.bayern.de	www.finanzamt-selb.de	678
9	9252	Uffenheim 	Schloßpl.	97215	Uffenheim	09842 200-0	09842 200-345		97211	1240	76500000	76501504	BBK NUERNBERG EH ANSBACH	76251020	620002006	SPK I LANDKREIS NEUSTADT	Servicezentrum: Mo-Mi: 08:00-12:00 u. 13:00-15:00,Do: 08:00-12:00 u. 13:00-17:00, Fr: 08:00-12:00 h 	poststelle@fa-uff.bayern.de	www.finanzamt-uffenheim.de	679
9	9253	Waldmünchen - Außenstelle des  Finanzamts Cham -	Bahnhofstr. 10	93449	Waldmünchen	09971 488-0	09971 488-550				74221170	344 755 205	HYPOVEREINSBK CHAM, OBERPF	76010085	1735-858	POSTBANK NUERNBERG	Servicezentrum: Mo - Mi: 07:30 - 15:00 Uhr, Do: 07:30 - 17:00 Uhr, Fr: 07:30	poststelle@fa-wuem.bayern.de	www.finanzamt-waldmuenchen.de	680
9	9254	Waldsassen 	Johannisplatz 13	95652	Waldsassen	09632 847-0	09632 847-199		95646	1329	75300000	75301511	BBK REGENSBURG EH WEIDEN	78151080	32367	SPK TIRSCHENREUTH	Servicezentrum: Mo - Fr: 07:30 - 12:30 Uhr, Mo - Mi: 13:30 - 15:30 Uhr,	poststelle@fa-wasa.bayern.de	www.finanzamt-waldsassen.de	681
9	9255	Weiden i.d.Opf. 	Schlörpl. 2 u. 4	92637	Weiden	0961 301-0	0961 32600		92604	1460	75300000	75301500	BBK REGENSBURG EH WEIDEN	75350000	172700	ST SPK WEIDEN	Servicezentrum: Mo - Fr: 07:30 - 12:30 Uhr, Mo - Mi: 13:30 - 15:30 Uhr,	poststelle@fa-wen.bayern.de	www.finanzamt-weiden.de	682
9	9257	Würzburg mit Außenstelle Ochsenfurt	Ludwigstr. 25	97070	Würzburg	0931 387-0	0931 387-4444	97064			79000000	79001500	BBK WUERZBURG	79020076	801283	HYPOVEREINSBK WUERZBURG	Servicezentrum: Mo - Mi: 07:30 - 15:00 Uhr, Do: 07:30 - 17:00 Uhr, Fr: 07:30	poststelle@fa-wue.bayern.de	www.finanzamt-wuerzburg.de	683
9	9258	Wunsiedel mit Außenstelle Selb	Sonnenstr. 11	95632	Wunsiedel	09232 607-0	09232 607-200	95631			78000000	78101512	BBK BAYREUTH EH HOF	78055050	620006254	SPK FICHTELGEBIRGE	Servicezentrum: Mo-Mi: 07:30-12:30 u 13:30-15:00, Do: 07:30-12:30 und 13:30-17:00, Fr: 07:30-12:00 h	poststelle@fa-wun.bayern.de	www.finanzamt-wunsiedel.de	684
9	9259	Zeil a. Main mit Außenstellen  	Obere Torstr. 9	97475	Zeil	09524 824-0	09524 824-100		97470	1160	79300000	79301505	BBK WUERZBURG EH SCHWEINFUR	79351730	500900	SPK OSTUNTERFRANKEN	Servicezentrum: Mo - Mi: 08:00 - 15:00 Uhr, Do: 08:00 - 17:00 Uhr, Fr: 08:00	poststelle@fa-zei.bayern.de	www.finanzamt-zeil.de	685
9	9260	Kötzting - Außenstelle des Finanzamts Cham -	Bahnhofstr. 3	93444	Kötzting	09971 488-0	09971 488-450				74221170	344 755 205	HYPOVEREINSBK CHAM, OBERPF	76010085	1735-858	POSTBANK NUERNBERG	Servicezentrum: Mo - Mi: 07:30 - 15:00 Uhr, Do: 07:30 - 18:00 Uhr, Fr: 07:30	poststelle@fa-koez.bayern.de	www.finanzamt-koetzting.de	686
2	2241	Hamburg-Altona 	Gr. Bergstr. 264/266	22767	Hamburg	040/42811-02	040/42811-2871		22704	500471	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgAltona@finanzamt.hamburg.de		58
2	2242	Hamburg-Am Tierpark 	Hugh-Greene-Weg 6	22529	Hamburg				22520		20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgAmTierpark@finanzamt.hamburg.de		77
2	2243	Hamburg-Barmbek-Uhlenhorst 	Lübecker Str. 101-109	22087	Hamburg	040/42860-0	040/42860-730		22053	760360	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FABarmbekUhlenhorst@finanzamt.hamburg.de		78
2	2243	Hamburg-Barmbek-Uhlenhorst 15  	Lübecker Str. 101-109	22087	Hamburg	040/42860-0	040/42860-730		22053	760360	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgBarmbekUhlenhorst@finanzamt.hamburg.de		64
2	2244	Hamburg-Bergedorf 	Ludwig-Rosenberg-Ring 41	21031	Hamburg	040/42891-0	040/42891-2243		21003	800360	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		FAHamburgBergedorf@finanzamt.hamburg.de		59
2	2245	Hamburg-Eimsbüttel 	Stresemannstraße 23	22769	Hamburg	040/42807-0	040/42807-220		22770	570110	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgEimsbuettel@finanzamt.hamburg.de		76
2	2246	Hamburg-Hansa 	Steinstraße 10	20095	Hamburg	040/42853-01	040/42853-2064		20015	102244	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		FAHamburgHansa@finanzamt.hamburg.de		68
2	2247	Hamburg-Harburg 	Harburger Ring 40	21073	Hamburg	040/42871-0	040/42871-2215		21043	900352	20000000	200 015 30	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgHarburg@finanzamt.hamburg.de		60
2	2249	Hamburg-Nord 	Borsteler Chaussee 45	22453	Hamburg	040/42806-0	040/42806-220		22207	600707	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		FAHamburgNord@finanzamt.hamburg.de		71
2	2250	Hamburg-Oberalster 	Hachmannplatz 2	20099	Hamburg	040/42854-90	040/42854-4960		20015	102248	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgOberalster@finanzamt.hamburg.de		62
2	2251	Hamburg-Wandsbek 	Schloßstr.107	22041	Hamburg	040/42881-0	040/42881-2888		22006	700660	20000000	20001530	BBK HAMBURG	21050000	101444000	HSH NORDBANK KIEL		 FAHamburgWandsbek@finanzamt.hamburg.de		61
6	2603	Bad Homburg v.d. Höhe 	Kaiser-Friedr.-Promenade 8-10 	61348	Bad Homburg	06172/107-0	06172/107-317	61343	61284	1445	50050000	1000124	Landesbank Hessen-Thüringen	50000000	50001501	DT BBK Filiale Frankfurt am Main	Mo u. Fr 8:00-12:00, Mi 14:00-18:00 Uhr	poststelle@Finanzamt-Bad-Homburg.de	www.Finanzamt-Bad-Homburg.de	162
\.


--
-- Data for Name: follow_up_access; Type: TABLE DATA; Schema: public; Owner: -
--

COPY follow_up_access (who, what, id) FROM stdin;
\.


--
-- Data for Name: follow_up_links; Type: TABLE DATA; Schema: public; Owner: -
--

COPY follow_up_links (id, follow_up_id, trans_id, trans_type, trans_info, itime, mtime) FROM stdin;
\.


--
-- Data for Name: follow_ups; Type: TABLE DATA; Schema: public; Owner: -
--

COPY follow_ups (id, follow_up_date, created_for_user, done, note_id, created_by, itime, mtime) FROM stdin;
\.


--
-- Data for Name: generic_translations; Type: TABLE DATA; Schema: public; Owner: -
--

COPY generic_translations (id, language_id, translation_type, translation_id, translation) FROM stdin;
\.


--
-- Data for Name: gl; Type: TABLE DATA; Schema: public; Owner: -
--

COPY gl (id, reference, description, transdate, gldate, employee_id, notes, department_id, taxincluded, itime, mtime, type, ob_transaction, cb_transaction, storno, storno_id) FROM stdin;
57	Reinigung Dezember	Reinigung	2012-01-02	2012-01-02	1213	\N	\N	t	2012-08-30 14:16:53.838506	2014-03-03 15:32:17.873781	\N	f	f	f	\N
2	Kredit Sparkasse	Kredit Sparkasse	2012-01-03	2012-01-03	938	\N	\N	f	2012-08-30 11:07:21.63752	2014-03-03 15:32:17.873781	\N	f	f	f	\N
3	Eröffnungsbuchung Bank	Eröffnungsbuchung Bank	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 12:37:59.674835	2014-03-03 15:32:17.873781	\N	t	f	f	\N
4	Eröffnungsbuchung Kasse	Eröffnungsbuchung Kasse	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 12:39:53.166922	2014-03-03 15:32:17.873781	\N	t	f	f	\N
6	Eröffnungsbuchung Grundstücke, Bauten	Eröffnungsbuchung Grundstücke, Bauten	2012-01-01	2012-01-01	938	\N	\N	f	2012-08-30 12:49:30.509822	2014-03-03 15:32:17.873781	\N	t	f	f	\N
7	Eröffnungsbuchung Betriebsausstattung	Eröffnungsbuchung Betriebsausstattung	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 12:50:35.740764	2014-03-03 15:32:17.873781	\N	t	f	f	\N
8	Eröffnungsbuchung Maschinen	Eröffnungsbuchung Maschinen	2012-01-01	2012-01-01	938	\N	\N	f	2012-08-30 12:52:44.225147	2014-03-03 15:32:17.873781	\N	t	f	f	\N
9	Eröffnungsbuchung Rohstoffe	Eröffnungsbuchung Rohstoffe	2012-01-01	2012-01-01	938	\N	\N	f	2012-08-30 12:54:32.928509	2014-03-03 15:32:17.873781	\N	t	f	f	\N
10	Eröffnungsbuchung gezeichnetes Kapital	Eröffnungsbuchung gezeichnetes Kapital	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 13:24:23.521796	2014-03-03 15:32:17.873781	\N	t	f	f	\N
11	Eröffnungsbuchung Konzernbilanzgewinn	Eröffnungsbuchung Konzernbilanzgewinn	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 13:25:40.212878	2014-03-03 15:32:17.873781	\N	t	f	f	\N
131	Leasingrate August	Leasingrate	2012-09-03	2012-09-03	938	\N	\N	t	2012-09-04 11:19:58.528336	2014-03-03 15:32:17.873781	\N	f	f	f	\N
12	Eröffnungsbuchung Verbindlichkeit gegenüber Kreditinstitut	Eröffnungsbuchung Verbindlichkeit gegenüber Kreditinstitut	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 13:27:10.303141	2014-03-03 15:32:17.873781	\N	t	f	f	\N
13	Eröffnungsbuchung Finanzamt	Eröffnungsbuchung Finanzamt	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 13:28:11.552002	2014-03-03 15:32:17.873781	\N	t	f	f	\N
14	Eröffnungsbuchung Anzahlungen	Eröffnungsbuchung Anzahlungen	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 13:29:02.562595	2014-03-03 15:32:17.873781	\N	t	f	f	\N
15	Telefon Januar	Telefon Januar	2012-02-02	2012-02-02	938	\N	\N	t	2012-08-30 13:57:08.242206	2014-03-03 15:32:17.873781	\N	f	f	f	\N
16	ZeitungsAbo 2012	ZeitungsAbo	2012-01-01	2012-01-01	1213	\N	\N	t	2012-08-30 13:57:10.113343	2014-03-03 15:32:17.873781	\N	f	f	f	\N
17	Versicherungen 2012	Versicherungen	2012-01-01	2012-01-01	1213	\N	\N	f	2012-08-30 13:57:41.638499	2014-03-03 15:32:17.873781	\N	f	f	f	\N
18	Heizung Januar	Heizung	2012-02-02	2012-02-02	1213	\N	\N	t	2012-08-30 13:58:35.010203	2014-03-03 15:32:17.873781	\N	f	f	f	\N
19	Telefon Februar	Telefon Februar	2012-03-02	2012-03-02	938	\N	\N	t	2012-08-30 13:58:42.785234	2014-03-03 15:32:17.873781	\N	f	f	f	\N
20	Heizung Februar	Heizung	2012-03-02	2012-03-02	1213	\N	\N	t	2012-08-30 13:59:12.001294	2014-03-03 15:32:17.873781	\N	f	f	f	\N
21	Telefon März	Telefon März	2012-04-02	2012-04-02	938	\N	\N	t	2012-08-30 13:59:13.571963	2014-03-03 15:32:17.873781	\N	f	f	f	\N
22	Heizung März	Heizung	2012-04-02	2012-04-02	1213	\N	\N	t	2012-08-30 14:00:11.608811	2014-03-03 15:32:17.873781	\N	f	f	f	\N
227	Anzahlung Rechnung 11	Gegenbuchung schon gezahlter Anzahlung	2012-11-23	2012-11-23	1473	\N	\N	f	2012-10-08 15:56:31.038748	2014-03-03 15:32:17.873781	\N	f	f	t	\N
48	Telefon Dezember	Telefon Dezember	2012-01-02	2012-01-02	938	\N	\N	t	2012-08-30 14:14:34.736875	2014-03-03 15:32:17.873781	\N	f	f	f	\N
23	Telefon April	Telefon April	2012-05-02	2012-05-02	938	\N	\N	t	2012-08-30 14:00:23.879965	2014-03-03 15:32:17.873781	\N	f	f	f	\N
24	Heizung April	Heizung	2012-05-02	2012-05-02	1213	\N	\N	t	2012-08-30 14:00:39.503505	2014-03-03 15:32:17.873781	\N	f	f	f	\N
25	Telefon Mai	Telefon Mai	2012-06-04	2012-06-04	938	\N	\N	t	2012-08-30 14:01:01.68727	2014-03-03 15:32:17.873781	\N	f	f	f	\N
143	GEZ August	GEZ	2012-09-03	2012-09-03	938	\N	\N	t	2012-09-04 11:24:10.009285	2014-03-03 15:32:17.873781	\N	f	f	f	\N
26	Heizung Mai	Heizung	2012-06-04	2012-06-04	1213	\N	\N	t	2012-08-30 14:01:26.509661	2014-03-03 15:32:17.873781	\N	f	f	f	\N
27	Telefon Juni	Telefon Juni	2012-07-02	2012-07-02	938	\N	\N	t	2012-08-30 14:01:39.489868	2014-03-03 15:32:17.873781	\N	f	f	f	\N
29	Telefon Juli	Telefon Juli	2012-08-02	2012-08-02	938	\N	\N	t	2012-08-30 14:02:41.459301	2014-03-03 15:32:17.873781	\N	f	f	f	\N
30	Heizung Juni	Heizung	2012-07-02	2012-07-02	1213	\N	\N	t	2012-08-30 14:05:11.020766	2014-03-03 15:32:17.873781	\N	f	f	f	\N
31	Heizung Juli	Heizung	2012-08-02	2012-08-02	1213	\N	\N	t	2012-08-30 14:05:45.396049	2014-03-03 15:32:17.873781	\N	f	f	f	\N
32	GEZ Januar	GEZ	2012-02-02	2012-02-02	938	\N	\N	t	2012-08-30 14:07:59.966575	2014-03-03 15:32:17.873781	\N	f	f	f	\N
33	Gas, Wasser, Strom Januar	Gas, Wasser, Strom	2012-02-02	2012-02-02	1213	\N	\N	t	2012-08-30 14:08:17.739565	2014-03-03 15:32:17.873781	\N	f	f	f	\N
34	GEZ Februar	GEZ	2012-03-02	2012-03-02	938	\N	\N	t	2012-08-30 14:08:29.678496	2014-03-03 15:32:17.873781	\N	f	f	f	\N
35	Gas, Wasser, Strom Februar	Gas, Wasser, Strom	2012-03-02	2012-03-02	1213	\N	\N	t	2012-08-30 14:08:58.811817	2014-03-03 15:32:17.873781	\N	f	f	f	\N
36	GEZ März	GEZ	2012-04-02	2012-04-02	938	\N	\N	t	2012-08-30 14:09:00.348871	2014-03-03 15:32:17.873781	\N	f	f	f	\N
37	GEZ April	GEZ	2012-05-02	2012-05-02	938	\N	\N	t	2012-08-30 14:09:33.388886	2014-03-03 15:32:17.873781	\N	f	f	f	\N
38	Gas, Wasser, Strom März	Gas, Wasser, Strom	2012-04-02	2012-04-02	1213	\N	\N	t	2012-08-30 14:09:41.483389	2014-03-03 15:32:17.873781	\N	f	f	f	\N
39	GEZ Mai	GEZ	2012-06-04	2012-06-04	938	\N	\N	t	2012-08-30 14:09:50.809317	2014-03-03 15:32:17.873781	\N	f	f	f	\N
40	GEZ Juni	GEZ	2012-07-02	2012-07-02	938	\N	\N	t	2012-08-30 14:10:10.039075	2014-03-03 15:32:17.873781	\N	f	f	f	\N
41	GEZ Juli	GEZ	2012-08-02	2012-08-02	938	\N	\N	t	2012-08-30 14:10:25.370291	2014-03-03 15:32:17.873781	\N	f	f	f	\N
42	Gas, Wasser, Strom April	Gas, Wasser, Strom	2012-05-02	2012-05-02	1213	\N	\N	t	2012-08-30 14:10:28.969769	2014-03-03 15:32:17.873781	\N	f	f	f	\N
43	Gas, Wasser, Strom Mai	Gas, Wasser, Strom	2012-06-04	2012-06-04	1213	\N	\N	t	2012-08-30 14:12:02.996916	2014-03-03 15:32:17.873781	\N	f	f	f	\N
44	Gas, Wasser, Strom Juni	Gas, Wasser, Strom	2012-07-02	2012-07-02	1213	\N	\N	t	2012-08-30 14:12:55.60813	2014-03-03 15:32:17.873781	\N	f	f	f	\N
45	GehälterA Dezember	GehälterA	2012-01-02	2012-01-02	938	\N	\N	f	2012-08-30 14:13:30.796015	2014-03-03 15:32:17.873781	\N	f	f	f	\N
46	Gas, Wasser, Strom Juli	Gas, Wasser, Strom	2012-08-02	2012-08-02	1213	\N	\N	t	2012-08-30 14:13:54.080095	2014-03-03 15:32:17.873781	\N	f	f	f	\N
47	GehälterA Januar	GehälterA	2012-02-02	2012-02-02	938	\N	\N	f	2012-08-30 14:13:55.34856	2014-03-03 15:32:17.873781	\N	f	f	f	\N
187	Zoll und Einfuhrumsatzsteuer / Anti-Piracy System XT4000	Zoll und Einfuhrumsatzsteuer / Anti-Piracy System XT4000	2012-06-01	2012-06-01	1213	\N	\N	f	2012-09-14 16:01:30.340884	2014-03-03 15:32:17.873781	\N	f	f	f	\N
188	innergemeinschaftlicher Erwerb Rettungsboote	zu RB485373	2012-06-01	2012-06-01	938	\N	\N	f	2012-09-17 10:49:21.617425	2014-03-03 15:32:17.873781	\N	f	f	f	\N
190	Bankgebühren Dezember	Bankgebühren	2012-01-06	2012-01-06	938	\N	\N	f	2012-09-17 13:54:38.544742	2014-03-03 15:32:17.873781	\N	f	f	f	\N
191	Bankgebühren Januar	Bankgebühren	2012-02-03	2012-02-03	938	\N	\N	f	2012-09-17 13:55:40.08567	2014-03-03 15:32:17.873781	\N	f	f	f	\N
192	Bankgebühren Februar	Bankgebühren	2012-03-02	2012-03-02	938	\N	\N	f	2012-09-17 13:56:16.130118	2014-03-03 15:32:17.873781	\N	f	f	f	\N
193	Bankgebühren März	Bankgebühren	2012-04-06	2012-04-06	938	\N	\N	f	2012-09-17 13:56:47.06526	2014-03-03 15:32:17.873781	\N	f	f	f	\N
194	Bankgebühren April	Bankgebühren	2012-05-04	2012-05-04	938	\N	\N	f	2012-09-17 13:57:25.354312	2014-03-03 15:32:17.873781	\N	f	f	f	\N
195	Bankgebühren Mai	Bankgebühren	2012-06-01	2012-06-01	938	\N	\N	f	2012-09-17 13:57:57.706063	2014-03-03 15:32:17.873781	\N	f	f	f	\N
196	Bankgebühren Juni	Bankgebühren	2012-07-06	2012-07-06	938	\N	\N	f	2012-09-17 13:58:19.052965	2014-03-03 15:32:17.873781	\N	f	f	f	\N
197	Bankgebühren Juli	Bankgebühren	2012-08-03	2012-08-03	938	\N	\N	f	2012-09-17 13:58:54.160665	2014-03-03 15:32:17.873781	\N	f	f	f	\N
49	GEZ Dezember	GEZ	2012-01-02	2012-01-02	938	\N	\N	t	2012-08-30 14:14:55.695843	2014-03-03 15:32:17.873781	\N	f	f	f	\N
50	Heizung Dezember	Heizung	2012-01-02	2012-01-02	1213	\N	\N	t	2012-08-30 14:15:06.672014	2014-03-03 15:32:17.873781	\N	f	f	f	\N
51	GehälterA Februar	GehälterA	2012-03-02	2012-03-02	938	\N	\N	f	2012-08-30 14:15:18.22019	2014-03-03 15:32:17.873781	\N	f	f	f	\N
52	GehälterA März	GehälterA	2012-04-02	2012-04-02	938	\N	\N	f	2012-08-30 14:15:40.726513	2014-03-03 15:32:17.873781	\N	f	f	f	\N
53	Gas, Wasser, Strom Dezember	Gas, Wasser, Strom	2012-01-02	2012-01-02	1213	\N	\N	t	2012-08-30 14:15:43.953206	2014-03-03 15:32:17.873781	\N	f	f	f	\N
54	GehälterA April	GehälterA	2012-05-02	2012-05-02	938	\N	\N	f	2012-08-30 14:15:58.219481	2014-03-03 15:32:17.873781	\N	f	f	f	\N
55	GehälterA Mai	GehälterA	2012-06-04	2012-06-04	938	\N	\N	f	2012-08-30 14:16:28.400973	2014-03-03 15:32:17.873781	\N	f	f	f	\N
56	GehälterA Juni	GehälterA	2012-07-02	2012-07-02	938	\N	\N	f	2012-08-30 14:16:51.326535	2014-03-03 15:32:17.873781	\N	f	f	f	\N
58	GehälterA Juli	GehälterA	2012-08-02	2012-08-02	938	\N	\N	f	2012-08-30 14:17:12.83903	2014-03-03 15:32:17.873781	\N	f	f	f	\N
59	Reinigung Januar	Reinigung	2012-02-02	2012-02-02	1213	\N	\N	t	2012-08-30 14:17:18.968113	2014-03-03 15:32:17.873781	\N	f	f	f	\N
60	Reinigung Februar	Reinigung	2012-03-02	2012-03-02	1213	\N	\N	t	2012-08-30 14:17:41.512612	2014-03-03 15:32:17.873781	\N	f	f	f	\N
61	GehälterMitarbeiterB Dezember	GehälterMitarbeiterB	2012-01-02	2012-01-02	938	\N	\N	f	2012-08-30 14:17:50.203132	2014-03-03 15:32:17.873781	\N	f	f	f	\N
62	Reinigung März	Reinigung	2012-04-03	2012-04-03	1213	\N	\N	t	2012-08-30 14:18:11.107015	2014-03-03 15:32:17.873781	\N	f	f	f	\N
63	GehälterMitarbeiterB Januar	GehälterMitarbeiterB	2012-02-02	2012-02-02	938	\N	\N	f	2012-08-30 14:18:11.475386	2014-03-03 15:32:17.873781	\N	f	f	f	\N
64	GehälterMitarbeiterB Februar	GehälterMitarbeiterB	2012-03-02	2012-03-02	938	\N	\N	f	2012-08-30 14:18:35.235861	2014-03-03 15:32:17.873781	\N	f	f	f	\N
65	Reinigung April	Reinigung	2012-05-02	2012-05-02	1213	\N	\N	t	2012-08-30 14:18:42.077607	2014-03-03 15:32:17.873781	\N	f	f	f	\N
66	GehälterMitarbeiterB März	GehälterMitarbeiterB	2012-04-02	2012-04-02	938	\N	\N	f	2012-08-30 14:18:53.182157	2014-03-03 15:32:17.873781	\N	f	f	f	\N
67	Reinigung Mai	Reinigung	2012-06-04	2012-06-04	1213	\N	\N	t	2012-08-30 14:19:10.765487	2014-03-03 15:32:17.873781	\N	f	f	f	\N
78	AbführungKrankenkassePersonal Januar	AbführungKrankenkassePersonal	2012-02-02	2012-02-02	938	\N	\N	f	2012-08-30 14:23:10.990421	2014-03-03 15:32:17.873781	\N	f	f	f	\N
68	Reinigung Juni	Reinigung	2012-07-02	2012-07-02	1213	\N	\N	t	2012-08-30 14:19:37.9525	2014-03-03 15:32:17.873781	\N	f	f	f	\N
69	Reinigung Juli	Reinigung	2012-08-02	2012-08-02	1213	\N	\N	t	2012-08-30 14:19:59.928917	2014-03-03 15:32:17.873781	\N	f	f	f	\N
79	Leasingrate März	Leasingrate	2012-04-02	2012-04-02	1213	\N	\N	t	2012-08-30 14:23:14.920897	2014-03-03 15:32:17.873781	\N	f	f	f	\N
70	GehälterMitarbeiterB April	GehälterMitarbeiterB	2012-05-02	2012-05-02	938	\N	\N	f	2012-08-30 14:20:39.046737	2014-03-03 15:32:17.873781	\N	f	f	f	\N
71	GehälterMitarbeiterB Mai	GehälterMitarbeiterB	2012-06-04	2012-06-04	938	\N	\N	f	2012-08-30 14:20:58.928577	2014-03-03 15:32:17.873781	\N	f	f	f	\N
80	AbführungKrankenkassePersonal Februar	AbführungKrankenkassePersonal	2012-03-02	2012-03-02	938	\N	\N	f	2012-08-30 14:23:36.489436	2014-03-03 15:32:17.873781	\N	f	f	f	\N
72	GehälterMitarbeiterB Juni	GehälterMitarbeiterB	2012-07-02	2012-07-02	938	\N	\N	f	2012-08-30 14:21:24.091362	2014-03-03 15:32:17.873781	\N	f	f	f	\N
73	Leasingrate Dezember	Leasingrate	2012-01-02	2012-01-02	1213	\N	\N	t	2012-08-30 14:21:33.318243	2014-03-03 15:32:17.873781	\N	f	f	f	\N
81	Leasingrate April	Leasingrate	2012-05-02	2012-05-02	1213	\N	\N	t	2012-08-30 14:23:39.360874	2014-03-03 15:32:17.873781	\N	f	f	f	\N
74	GehälterMitarbeiterB Juli	GehälterMitarbeiterB	2012-08-02	2012-08-02	938	\N	\N	f	2012-08-30 14:21:40.580583	2014-03-03 15:32:17.873781	\N	f	f	f	\N
75	Leasingrate Januar	Leasingrate	2012-02-02	2012-02-02	1213	\N	\N	t	2012-08-30 14:22:26.592586	2014-03-03 15:32:17.873781	\N	f	f	f	\N
82	AbführungKrankenkassePersonal März	AbführungKrankenkassePersonal	2012-04-02	2012-04-02	938	\N	\N	f	2012-08-30 14:24:03.271422	2014-03-03 15:32:17.873781	\N	f	f	f	\N
76	AbführungKrankenkassePersonal Dezember	AbführungKrankenkassePersonal	2012-01-02	2012-01-02	938	\N	\N	f	2012-08-30 14:22:38.80826	2014-03-03 15:32:17.873781	\N	f	f	f	\N
77	Leasingrate Februar	Leasingrate	2012-03-02	2012-03-02	1213	\N	\N	t	2012-08-30 14:22:51.90226	2014-03-03 15:32:17.873781	\N	f	f	f	\N
83	Leasingrate Mai	Leasingrate	2012-06-04	2012-06-04	1213	\N	\N	t	2012-08-30 14:24:08.522961	2014-03-03 15:32:17.873781	\N	f	f	f	\N
84	AbführungKrankenkassePersonal April	AbführungKrankenkassePersonal	2012-05-02	2012-05-02	938	\N	\N	f	2012-08-30 14:24:21.167344	2014-03-03 15:32:17.873781	\N	f	f	f	\N
85	Leasingrate Juni	Leasingrate	2012-07-02	2012-07-02	1213	\N	\N	t	2012-08-30 14:24:32.565411	2014-03-03 15:32:17.873781	\N	f	f	f	\N
86	AbführungKrankenkassePersonal Mai	AbführungKrankenkassePersonal	2012-06-04	2012-06-04	938	\N	\N	f	2012-08-30 14:24:38.818809	2014-03-03 15:32:17.873781	\N	f	f	f	\N
87	AbführungKrankenkassePersonal Juni	AbführungKrankenkassePersonal	2012-07-02	2012-07-02	938	\N	\N	f	2012-08-30 14:24:56.488009	2014-03-03 15:32:17.873781	\N	f	f	f	\N
88	Leasingrate Juli	Leasingrate	2012-08-02	2012-08-02	1213	\N	\N	t	2012-08-30 14:24:56.6316	2014-03-03 15:32:17.873781	\N	f	f	f	\N
89	AbführungKrankenkassePersonal Juli	AbführungKrankenkassePersonal	2012-08-02	2012-08-02	938	\N	\N	f	2012-08-30 14:25:19.309855	2014-03-03 15:32:17.873781	\N	f	f	f	\N
90	AbführungFinanzamtPersonal Dezember	AbführungFinanzamtPersonal	2012-01-02	2012-01-02	1213	\N	\N	f	2012-08-30 14:26:28.74811	2014-03-03 15:32:17.873781	\N	f	f	f	\N
91	AbführungFinanzamtPersonal Januar	AbführungFinanzamtPersonal	2012-02-02	2012-02-02	1213	\N	\N	f	2012-08-30 14:26:51.298831	2014-03-03 15:32:17.873781	\N	f	f	f	\N
92	AbführungFinanzamtPersonal Februar	AbführungFinanzamtPersonal	2012-03-02	2012-03-02	1213	\N	\N	f	2012-08-30 14:27:15.375472	2014-03-03 15:32:17.873781	\N	f	f	f	\N
93	AbführungFinanzamtPersonal März	AbführungFinanzamtPersonal	2012-04-02	2012-04-02	1213	\N	\N	f	2012-08-30 14:27:40.506306	2014-03-03 15:32:17.873781	\N	f	f	f	\N
94	AbführungFinanzamtPersonal April	AbführungFinanzamtPersonal	2012-05-02	2012-05-02	1213	\N	\N	f	2012-08-30 14:28:01.807576	2014-03-03 15:32:17.873781	\N	f	f	f	\N
95	AbführungFinanzamtPersonal Mai	AbführungFinanzamtPersonal	2012-06-04	2012-06-04	1213	\N	\N	f	2012-08-30 14:28:30.459147	2014-03-03 15:32:17.873781	\N	f	f	f	\N
96	AbführungFinanzamtPersonal Juni	AbführungFinanzamtPersonal	2012-07-02	2012-07-02	1213	\N	\N	f	2012-08-30 14:28:55.727384	2014-03-03 15:32:17.873781	\N	f	f	f	\N
97	AbführungFinanzamtPersonal Juli	AbführungFinanzamtPersonal	2012-08-02	2012-08-02	1213	\N	\N	f	2012-08-30 14:29:14.554387	2014-03-03 15:32:17.873781	\N	f	f	f	\N
103	Trikotsponsoring FC Hansekogge Rostock	Trikotsponsoring FC Hansekogge Rostock	2012-07-20	2012-07-20	1213	\N	\N	f	2012-08-30 15:19:46.615715	2014-03-03 15:32:17.873781	\N	f	f	f	\N
109	STA849636j6567	Kugelschreiber 500 Stück	2012-01-03	2012-01-03	1213	\N	\N	t	2012-08-30 15:34:57.348977	2014-03-03 15:32:17.873781	\N	f	f	f	\N
111	Geschäftsessen Oida Auftrag	Geschäftsessen Oida, Herr Michael Augerer und Partner	2012-01-03	2012-01-03	938	\N	\N	f	2012-09-03 13:52:32.403679	2014-03-03 15:32:17.873781	\N	f	f	f	\N
112	Geschäftsessen Innenraumplanung	Geschäftsessen, Panthership Design und Vorarbeiter	2012-03-16	2012-03-16	938	\N	\N	f	2012-09-03 14:08:11.269131	2014-03-03 15:32:17.873781	\N	f	f	f	\N
113	Seminar München "Arbeiten ohne burnout"	Seminar München "Arbeiten ohne Burnout" Martin Steigmann, Hotel-, Bahn- und Seminarkosten 17.04 - 20.04	2012-04-09	2012-04-09	938	\N	\N	t	2012-09-03 15:41:51.843265	2014-03-03 15:32:17.873781	\N	f	f	f	\N
115	GehälterA August	GehälterA	2012-09-03	2012-09-03	938	\N	\N	f	2012-09-04 11:12:37.937712	2014-03-03 15:32:17.873781	\N	f	f	f	\N
116	GehälterA September	GehälterA	2012-10-02	2012-10-02	938	\N	\N	f	2012-09-04 11:13:13.572412	2014-03-03 15:32:17.873781	\N	f	f	f	\N
117	GehälterA Oktober	GehälterA	2012-11-02	2012-11-02	938	\N	\N	f	2012-09-04 11:13:38.838168	2014-03-03 15:32:17.873781	\N	f	f	f	\N
118	GehälterA November	GehälterA	2012-12-03	2012-12-03	938	\N	\N	f	2012-09-04 11:14:21.318575	2014-03-03 15:32:17.873781	\N	f	f	f	\N
119	GehälterMitarbeiterB August	GehälterMitarbeiterB	2012-09-03	2012-09-03	938	\N	\N	f	2012-09-04 11:15:04.011787	2014-03-03 15:32:17.873781	\N	f	f	f	\N
120	GehälterMitarbeiterB September	GehälterMitarbeiterB	2012-10-02	2012-10-02	938	\N	\N	f	2012-09-04 11:15:26.007829	2014-03-03 15:32:17.873781	\N	f	f	f	\N
121	GehälterMitarbeiterB Oktober	GehälterMitarbeiterB	2012-11-02	2012-11-02	938	\N	\N	f	2012-09-04 11:15:52.458026	2014-03-03 15:32:17.873781	\N	f	f	f	\N
122	GehälterMitarbeiterB November	GehälterMitarbeiterB	2012-12-03	2012-12-03	938	\N	\N	f	2012-09-04 11:16:13.747741	2014-03-03 15:32:17.873781	\N	f	f	f	\N
123	AbführungKrankenkassePersonal August	AbführungKrankenkassePersonal	2012-09-03	2012-09-03	938	\N	\N	f	2012-09-04 11:16:44.937331	2014-03-03 15:32:17.873781	\N	f	f	f	\N
124	AbführungKrankenkassePersonal September	AbführungKrankenkassePersonal	2012-10-02	2012-10-02	938	\N	\N	f	2012-09-04 11:17:09.017573	2014-03-03 15:32:17.873781	\N	f	f	f	\N
125	AbführungKrankenkassePersonal Oktober	AbführungKrankenkassePersonal	2012-11-02	2012-11-02	938	\N	\N	f	2012-09-04 11:17:32.185448	2014-03-03 15:32:17.873781	\N	f	f	f	\N
126	AbführungKrankenkassePersonal November	AbführungKrankenkassePersonal	2012-12-03	2012-12-03	938	\N	\N	f	2012-09-04 11:18:02.849303	2014-03-03 15:32:17.873781	\N	f	f	f	\N
127	AbführungFinanzamtPersonal August	AbführungFinanzamtPersonal	2012-09-03	2012-09-03	938	\N	\N	f	2012-09-04 11:18:29.044068	2014-03-03 15:32:17.873781	\N	f	f	f	\N
129	AbführungFinanzamtPersonal Oktober	AbführungFinanzamtPersonal	2012-11-02	2012-11-02	938	\N	\N	f	2012-09-04 11:19:15.533662	2014-03-03 15:32:17.873781	\N	f	f	f	\N
130	AbführungFinanzamtPersonal November	AbführungFinanzamtPersonal	2012-12-03	2012-12-03	938	\N	\N	f	2012-09-04 11:19:36.880097	2014-03-03 15:32:17.873781	\N	f	f	f	\N
132	Leasingrate September	Leasingrate	2012-10-02	2012-10-02	938	\N	\N	t	2012-09-04 11:20:23.165061	2014-03-03 15:32:17.873781	\N	f	f	f	\N
133	Leasingrate Oktober	Leasingrate	2012-11-02	2012-11-02	938	\N	\N	t	2012-09-04 11:20:47.521783	2014-03-03 15:32:17.873781	\N	f	f	f	\N
134	Leasingrate November	Leasingrate	2012-12-03	2012-12-03	938	\N	\N	t	2012-09-04 11:21:07.713027	2014-03-03 15:32:17.873781	\N	f	f	f	\N
135	Reinigung August	Reinigung	2012-09-03	2012-09-03	938	\N	\N	t	2012-09-04 11:21:29.099351	2014-03-03 15:32:17.873781	\N	f	f	f	\N
136	Reinigung September	Reinigung	2012-10-02	2012-10-02	938	\N	\N	t	2012-09-04 11:21:46.496475	2014-03-03 15:32:17.873781	\N	f	f	f	\N
137	Reinigung Oktober	Reinigung	2012-11-02	2012-11-02	938	\N	\N	t	2012-09-04 11:22:02.828217	2014-03-03 15:32:17.873781	\N	f	f	f	\N
138	Reinigung November	Reinigung	2012-12-03	2012-12-03	938	\N	\N	t	2012-09-04 11:22:29.777103	2014-03-03 15:32:17.873781	\N	f	f	f	\N
139	Telefon August	Telefon	2012-09-03	2012-09-03	938	\N	\N	t	2012-09-04 11:22:48.816382	2014-03-03 15:32:17.873781	\N	f	f	f	\N
140	Telefon September	Telefon	2012-10-02	2012-10-02	938	\N	\N	t	2012-09-04 11:23:12.940129	2014-03-03 15:32:17.873781	\N	f	f	f	\N
141	Telefon Oktober	Telefon	2012-11-02	2012-11-02	938	\N	\N	t	2012-09-04 11:23:28.769878	2014-03-03 15:32:17.873781	\N	f	f	f	\N
142	Telefon November	Telefon	2012-12-03	2012-12-03	938	\N	\N	t	2012-09-04 11:23:47.157906	2014-03-03 15:32:17.873781	\N	f	f	f	\N
144	GEZ September	GEZ	2012-10-02	2012-10-02	938	\N	\N	t	2012-09-04 11:24:33.718978	2014-03-03 15:32:17.873781	\N	f	f	f	\N
145	GEZ Oktober	GEZ	2012-11-02	2012-11-02	938	\N	\N	t	2012-09-04 11:24:55.528835	2014-03-03 15:32:17.873781	\N	f	f	f	\N
146	GEZ November	GEZ	2012-12-03	2012-12-03	938	\N	\N	t	2012-09-04 11:25:13.04833	2014-03-03 15:32:17.873781	\N	f	f	f	\N
147	Heizung August	Heizung	2012-09-03	2012-09-03	938	\N	\N	t	2012-09-04 11:25:55.905909	2014-03-03 15:32:17.873781	\N	f	f	f	\N
148	Heizung September	Heizung	2012-10-02	2012-10-02	938	\N	\N	t	2012-09-04 11:27:16.467774	2014-03-03 15:32:17.873781	\N	f	f	f	\N
149	Heizung Oktober	Heizung	2012-11-02	2012-11-02	938	\N	\N	t	2012-09-04 11:27:50.010807	2014-03-03 15:32:17.873781	\N	f	f	f	\N
150	Heizung November	Heizung	2012-12-03	2012-12-03	938	\N	\N	t	2012-09-04 11:28:33.222593	2014-03-03 15:32:17.873781	\N	f	f	f	\N
151	Gas, Wasser, Strom August	Gas, Wasser, Strom	2012-09-03	2012-09-03	938	\N	\N	t	2012-09-04 11:29:07.396039	2014-03-03 15:32:17.873781	\N	f	f	f	\N
152	Gas, Wasser, Strom September	Gas, Wasser, Strom	2012-10-02	2012-10-02	938	\N	\N	t	2012-09-04 11:29:34.190884	2014-03-03 15:32:17.873781	\N	f	f	f	\N
153	Gas, Wasser, Strom Oktober	Gas, Wasser, Strom	2012-11-02	2012-11-02	938	\N	\N	t	2012-09-04 11:30:02.925771	2014-03-03 15:32:17.873781	\N	f	f	f	\N
154	Gas, Wasser, Strom November	Gas, Wasser, Strom	2012-12-03	2012-12-03	938	\N	\N	t	2012-09-04 11:30:25.840343	2014-03-03 15:32:17.873781	\N	f	f	f	\N
155	AbführungFinanzamtPersonal September	AbführungFinanzamtPersonal	2012-10-02	2012-10-02	938	\N	\N	f	2012-09-04 11:42:50.790799	2014-03-03 15:32:17.873781	\N	f	f	f	\N
157	STA995412p5698	Kugelschreiber 1000 Stück	2012-10-12	2012-10-12	938	\N	\N	t	2012-09-04 12:00:21.679317	2014-03-03 15:32:17.873781	\N	f	f	f	\N
183	Steuern 2011 Nachzahlung	Steuern 2011 Nachzahlung	2012-01-18	2012-01-18	1213	\N	\N	f	2012-09-14 11:39:33.140067	2014-03-03 15:32:17.873781	\N	f	f	f	\N
184	Briefmarken 2012	Briefmarken 2012	2012-01-03	2012-01-03	1213	\N	\N	f	2012-09-14 11:43:46.20216	2014-03-03 15:32:17.873781	\N	f	f	f	\N
185	Abschreibung Gebäude	Abschreibung Gebäude	2012-12-31	2012-12-31	1213	\N	\N	f	2012-09-14 15:15:43.512224	2014-03-03 15:32:17.873781	\N	f	f	f	\N
186	Abschreibungen auf den Sammelposten Wirtschaftsgüter	Abschreibungen auf den Sammelposten Wirtschaftsgüter	2012-12-31	2012-12-31	1213	\N	\N	f	2012-09-14 15:39:03.186572	2014-03-03 15:32:17.873781	\N	f	f	f	\N
182	innergemeinschaftlicher erwerb anker	zu nsoy2314	2012-07-12	2012-07-12	1213	\N	\N	f	2012-09-12 16:56:01.548386	2014-03-03 15:32:17.873781	\N	f	f	f	\N
198	Bankgebühren August	Bankgebühren	2012-09-07	2012-09-07	938	\N	\N	f	2012-09-17 13:59:30.899808	2014-03-03 15:32:17.873781	\N	f	f	f	\N
199	Bankgebühren September	Bankgebühren	2012-10-05	2012-10-05	938	\N	\N	f	2012-09-17 14:00:08.471779	2014-03-03 15:32:17.873781	\N	f	f	f	\N
200	Bankgebühren Oktober	Bankgebühren	2012-11-02	2012-11-02	938	\N	\N	f	2012-09-17 14:00:39.482533	2014-03-03 15:32:17.873781	\N	f	f	f	\N
201	Bankgebühren November	Bankgebühren	2012-12-07	2012-12-07	938	\N	\N	f	2012-09-17 14:01:09.693627	2014-03-03 15:32:17.873781	\N	f	f	f	\N
218	Zinsen 2	Zinsen Kredit 2	2012-12-17	2012-12-17	938	\N	\N	f	2012-09-21 15:45:37.123643	2014-03-03 15:32:17.873781	\N	f	f	f	\N
219	Zinsen 1	Zinsen Kredit 1	2012-12-17	2012-12-17	938	\N	\N	f	2012-09-21 15:47:20.17199	2014-03-03 15:32:17.873781	\N	f	f	f	\N
220	Kreditrückzahlung 1	Kreditrückzahlung 1	2012-12-17	2012-12-17	938	\N	\N	f	2012-09-21 15:48:26.110156	2014-03-03 15:32:17.873781	\N	f	f	f	\N
221	Kreditrückzahlung 2	Kreditrückzahlung 2	2012-12-17	2012-12-17	938	\N	\N	f	2012-09-21 15:49:36.816497	2014-03-03 15:32:17.873781	\N	f	f	f	\N
233	Umbuchung Vorsteuer	Umbuchung Vorsteuer	2012-02-29	2012-02-29	938	\N	\N	f	2012-10-09 12:33:16.675643	2014-03-03 15:32:17.873781	\N	f	f	f	\N
234	Anzahlungen	Umbuchung Anzahlung 	2012-11-23	2012-11-23	1473	\N	\N	f	2012-10-09 15:35:42.440863	2014-03-03 15:32:17.873781	\N	f	f	f	\N
237	UStVa	UStVa-Januar	2012-02-13	2012-02-13	938	\N	\N	f	2012-10-09 16:53:05.064453	2014-03-03 15:32:17.873781	\N	f	f	f	\N
238	UStVa	UStVa-Februar	2012-03-12	2012-03-12	938	\N	\N	f	2012-10-09 16:55:22.095412	2014-03-03 15:32:17.873781	\N	f	f	f	\N
239	UStVa	UStVa-März	2012-04-16	2012-04-16	938	\N	\N	f	2012-10-09 16:56:19.153922	2014-03-03 15:32:17.873781	\N	f	f	f	\N
240	UStVa	UStVa-April	2012-05-14	2012-05-14	938	\N	\N	f	2012-10-09 16:57:23.354414	2014-03-03 15:32:17.873781	\N	f	f	f	\N
241	UStVa	UStVa-Mai	2012-06-18	2012-06-18	938	\N	\N	f	2012-10-09 16:58:47.50797	2014-03-03 15:32:17.873781	\N	f	f	f	\N
242	UStVa	UStVa-Juni	2012-07-16	2012-07-16	938	\N	\N	f	2012-10-09 16:59:54.002626	2014-03-03 15:32:17.873781	\N	f	f	f	\N
243	UStVa	UStVa-Juli	2012-08-13	2012-08-13	938	\N	\N	f	2012-10-09 17:01:15.212281	2014-03-03 15:32:17.873781	\N	f	f	f	\N
244	UStVa	UStVa-August	2012-09-17	2012-09-17	938	\N	\N	f	2012-10-09 17:02:19.987038	2014-03-03 15:32:17.873781	\N	f	f	f	\N
245	UStVa	UStVa-September	2012-10-15	2012-10-15	938	\N	\N	f	2012-10-09 17:03:28.013251	2014-03-03 15:32:17.873781	\N	f	f	f	\N
246	UStVa	UStVa-Oktober	2012-11-19	2012-11-19	938	\N	\N	f	2012-10-09 17:11:10.372906	2014-03-03 15:32:17.873781	\N	f	f	f	\N
247	UStVa	UStVa-November	2012-12-17	2012-12-17	938	\N	\N	f	2012-10-09 17:13:16.376938	2014-03-03 15:32:17.873781	\N	f	f	f	\N
248	Storno-Anzahlung Rechnung 11	Gegenbuchung schon gezahlter Anzahlung	2012-11-23	2012-11-23	1473	\N	\N	f	2012-10-09 21:06:02.040213	2014-03-03 15:32:17.873781	\N	f	f	t	227
\.


--
-- Data for Name: history_erp; Type: TABLE DATA; Schema: public; Owner: -
--

COPY history_erp (id, trans_id, employee_id, addition, what_done, itime, snumbers) FROM stdin;
1021	1020	938	SAVED	\N	2012-08-17 12:59:39.007856	projectnumber_01-2012
1023	1022	938	SAVED	\N	2012-08-17 13:03:43.327594	vendornumber_70000
1025	1024	938	SAVED	\N	2012-08-17 13:07:12.472687	vendornumber_70001
1026	1024	938	SAVED	\N	2012-08-17 13:07:36.350384	vendornumber_70001
1027	1024	938	SAVED	\N	2012-08-17 13:08:13.446427	vendornumber_70001
1029	1028	938	SAVED	\N	2012-08-17 13:10:07.955481	vendornumber_70003
1031	1030	938	SAVED	\N	2012-08-17 13:12:56.559407	vendornumber_70002
1033	1032	938	SAVED	\N	2012-08-20 10:25:33.706282	vendornumber_70004
1034	1032	938	SAVED	\N	2012-08-20 10:25:36.685666	vendornumber_70004
1036	1035	938	SAVED	\N	2012-08-20 10:27:08.885179	vendornumber_70005
1038	1037	938	SAVED	\N	2012-08-20 10:30:46.24932	customernumber_10000
1040	1039	938	SAVED	\N	2012-08-20 10:34:21.439688	vendornumber_70006
1042	1041	938	SAVED	\N	2012-08-20 10:37:50.31699	vendornumber_70007
1044	1043	938	SAVED	\N	2012-08-20 10:40:11.681982	vendornumber_70008
1045	1030	938	SAVED	\N	2012-08-20 10:41:36.905506	vendornumber_70002
1046	1041	938	SAVED	\N	2012-08-20 10:41:46.080562	vendornumber_70007
1047	1024	938	SAVED	\N	2012-08-20 10:42:00.618415	vendornumber_70001
1048	1032	938	SAVED	\N	2012-08-20 10:43:57.809945	vendornumber_70004
1049	1035	938	SAVED	\N	2012-08-20 10:45:32.398927	vendornumber_70005
1051	1050	938	SAVED	\N	2012-08-20 10:56:47.366991	vendornumber_70009
1053	1052	938	SAVED	\N	2012-08-20 11:07:09.643091	vendornumber_80000
1054	1039	938	SAVED	\N	2012-08-20 11:07:40.683956	vendornumber_70006
1055	1041	938	SAVED	\N	2012-08-20 11:07:51.657425	vendornumber_70007
1056	1052	938	SAVED	\N	2012-08-20 11:08:00.750317	vendornumber_80000
1057	1043	938	SAVED	\N	2012-08-20 11:08:13.34131	vendornumber_70008
1058	1050	938	SAVED	\N	2012-08-20 11:08:54.602511	vendornumber_70009
1060	1059	938	SAVED	\N	2012-08-20 11:13:19.814066	vendornumber_80001
1061	1059	938	SAVED	\N	2012-08-20 11:14:01.600967	vendornumber_80001
1063	1062	938	SAVED	\N	2012-08-20 11:17:59.518149	vendornumber_80002
1064	1052	938	SAVED	\N	2012-08-20 11:19:33.525696	vendornumber_80000
1065	1052	938	SAVED	\N	2012-08-20 11:20:20.883658	vendornumber_80000
1066	1035	938	SAVED	\N	2012-08-20 11:27:30.807472	vendornumber_80003
1067	1043	938	SAVED	\N	2012-08-20 11:27:40.115054	vendornumber_70004
1068	1043	938	SAVED	\N	2012-08-20 11:27:55.749415	vendornumber_70005
1069	1043	938	SAVED	\N	2012-08-20 11:28:14.698788	vendornumber_80005
1070	1039	938	SAVED	\N	2012-08-20 11:28:33.981506	vendornumber_80004
1071	1041	938	SAVED	\N	2012-08-20 11:28:49.506413	vendornumber_80006
1072	1050	938	SAVED	\N	2012-08-20 11:29:01.039837	vendornumber_80007
1073	1062	938	SAVED	\N	2012-08-20 11:29:20.422671	vendornumber_70005
1075	1074	938	SAVED	\N	2012-08-20 11:51:11.60173	vendornumber_70006
1077	1076	938	SAVED	\N	2012-08-20 11:54:38.072318	vendornumber_70007
1079	1078	938	SAVED	\N	2012-08-20 11:59:22.410589	vendornumber_80008
1081	1080	938	SAVED	\N	2012-08-20 12:06:58.966515	vendornumber_80009
1083	1082	938	SAVED	\N	2012-08-20 12:11:15.162054	vendornumber_70008
1084	1080	938	SAVED	\N	2012-08-20 12:11:23.942865	vendornumber_80009
1086	1085	938	SAVED	\N	2012-08-20 12:25:14.205708	vendornumber_70009
1088	1087	938	SAVED	\N	2012-08-20 12:25:28.174369	vendornumber_1
1089	1087	938	DELETED	\N	2012-08-20 12:26:07.05477	vendornumber_1
1090	1085	938	SAVED	\N	2012-08-20 12:26:55.056176	vendornumber_70009
1092	1091	938	SAVED	\N	2012-08-20 12:56:53.363287	partnumber_001
1094	1093	938	SAVED	\N	2012-08-20 13:02:15.08757	partnumber_002
1095	1091	938	SAVED	\N	2012-08-20 13:02:41.181786	partnumber_001
1096	1093	938	SAVED	\N	2012-08-20 13:03:08.411022	partnumber_002
1097	1093	938	SAVED	\N	2012-08-20 13:04:42.052752	partnumber_002
1099	1098	938	SAVED	\N	2012-08-20 13:10:52.409198	partnumber_003
1101	1100	938	SAVED	\N	2012-08-20 13:43:25.906289	partnumber_004
1102	1098	938	SAVED	\N	2012-08-20 13:43:44.248265	partnumber_003
1104	1103	938	SAVED	\N	2012-08-20 13:47:19.185145	partnumber_005
1106	1105	938	SAVED	\N	2012-08-20 13:51:17.041884	partnumber_006
1108	1107	938	SAVED	\N	2012-08-20 13:55:00.366591	partnumber_007
1109	1107	938	SAVED	\N	2012-08-20 14:01:27.784165	partnumber_007
1110	1105	938	SAVED	\N	2012-08-20 14:10:33.024761	partnumber_006
1112	1111	938	SAVED	\N	2012-08-20 14:13:43.29704	partnumber_008
1113	1098	938	SAVED	\N	2012-08-20 14:15:31.025988	partnumber_003
1114	1111	938	SAVED	\N	2012-08-20 14:16:01.43417	partnumber_008
1116	1115	938	SAVED	\N	2012-08-20 14:19:22.836735	partnumber_009
1118	1117	938	SAVED	\N	2012-08-20 14:19:52.335981	partnumber_010
1120	1119	938	SAVED	\N	2012-08-20 14:20:50.425995	partnumber_011
1122	1121	938	SAVED	\N	2012-08-20 14:21:25.959197	partnumber_012
1124	1123	938	SAVED	\N	2012-08-20 14:22:31.540693	partnumber_013
1125	1121	938	SAVED	\N	2012-08-20 14:36:30.046993	partnumber_ 012
1126	1115	938	SAVED	\N	2012-08-20 14:39:41.101776	partnumber_009
1127	1117	938	SAVED	\N	2012-08-20 14:40:23.814444	partnumber_010
1128	1119	938	SAVED	\N	2012-08-20 14:40:55.465463	partnumber_011
1129	1117	938	SAVED	\N	2012-08-20 14:41:04.333358	partnumber_010
1130	1121	938	SAVED	\N	2012-08-20 14:41:31.272833	partnumber_ 012
1131	1123	938	SAVED	\N	2012-08-20 14:42:02.565988	partnumber_013
1132	1115	938	SAVED	\N	2012-08-20 14:42:26.898843	partnumber_009
1134	1133	938	SAVED	\N	2012-08-20 14:48:59.823415	partnumber_014
1136	1135	938	SAVED	\N	2012-08-20 14:50:35.475035	partnumber_015
1138	1137	938	SAVED	\N	2012-08-20 15:11:15.10384	partnumber_016
1140	1139	938	SAVED	\N	2012-08-20 15:17:44.378326	vendornumber_70010
1141	1137	938	SAVED	\N	2012-08-20 15:18:31.303353	partnumber_016
1143	1142	938	SAVED	\N	2012-08-20 15:20:57.617348	partnumber_017
1145	1144	938	SAVED	\N	2012-08-20 15:28:54.687258	partnumber_018
1146	1144	938	SAVED	\N	2012-08-20 15:29:40.952865	partnumber_018
1148	1147	938	SAVED	\N	2012-08-20 15:35:12.28243	partnumber_019
1150	1149	938	SAVED	\N	2012-08-20 15:35:56.005909	partnumber_020
1151	1147	938	SAVED	\N	2012-08-20 15:36:09.642161	partnumber_019
1153	1152	938	SAVED	\N	2012-08-20 15:39:53.971593	partnumber_021
1155	1154	938	SAVED	\N	2012-08-20 15:50:07.393537	partnumber_101
1157	1156	938	SAVED	\N	2012-08-20 15:57:05.932634	partnumber_102
1159	1158	938	SAVED	\N	2012-08-20 16:03:28.756168	partnumber_103
1160	1158	938	SAVED	\N	2012-08-20 16:03:58.255059	partnumber_103
1162	1161	938	SAVED	\N	2012-08-21 10:20:40.372531	partnumber_104
1163	1161	938	SAVED	\N	2012-08-21 10:22:15.441403	partnumber_104
1165	1164	938	SAVED	\N	2012-08-21 10:26:47.706508	partnumber_105
1166	1161	938	SAVED	\N	2012-08-21 10:27:38.317584	partnumber_104
1168	1167	938	SAVED	\N	2012-08-21 10:32:10.378684	partnumber_106
1169	1164	938	SAVED	\N	2012-08-21 10:32:52.337187	partnumber_105
1170	1164	938	SAVED	\N	2012-08-21 10:33:11.061969	partnumber_105
1171	1167	938	SAVED	\N	2012-08-21 10:33:20.960757	partnumber_106
1172	1161	938	SAVED	\N	2012-08-21 10:33:28.652881	partnumber_104
1173	1167	938	SAVED	\N	2012-08-21 10:50:50.522705	partnumber_106
1175	1174	938	SAVED	\N	2012-08-21 10:54:30.142904	partnumber_022
1176	1147	938	SAVED	\N	2012-08-21 10:55:00.87459	partnumber_019
1177	1149	938	SAVED	\N	2012-08-21 10:55:11.093709	partnumber_020
1178	1152	938	SAVED	\N	2012-08-21 10:55:22.859818	partnumber_021
1179	1174	938	SAVED	\N	2012-08-21 10:56:16.707673	partnumber_022
1181	1180	938	SAVED	\N	2012-08-21 11:00:21.54107	partnumber_033
1182	1180	938	SAVED	\N	2012-08-21 11:00:34.144238	partnumber_023
1184	1183	938	SAVED	\N	2012-08-21 11:01:00.802611	partnumber_024
1186	1185	938	SAVED	\N	2012-08-21 11:04:04.671929	partnumber_107
1187	1078	938	SAVED	\N	2012-08-21 11:09:02.447993	vendornumber_70011
1188	1050	938	SAVED	\N	2012-08-21 11:09:16.264023	vendornumber_70012
1189	1080	938	SAVED	\N	2012-08-21 11:09:23.890905	vendornumber_80007
1191	1190	938	SAVED	\N	2012-08-21 11:12:12.042897	vendornumber_80008
1193	1192	938	SAVED	\N	2012-08-21 11:13:33.157059	partnumber_108
1194	1192	938	SAVED	\N	2012-08-21 11:13:58.240086	partnumber_108
1197	1161	938	SAVED	\N	2012-08-29 15:50:43.10712	partnumber_104
1210	1	938	SAVED	Buchungsnummer = 1	2012-08-30 11:04:36.331616	ordnumber_
1211	1	938	DELETED	\N	2012-08-30 11:05:12.224331	ordnumber_
1212	2	938	SAVED	Buchungsnummer = 2	2012-08-30 11:07:21.558859	ordnumber_
1214	3	1213	SAVED	Buchungsnummer = 3	2012-08-30 12:37:59.571587	ordnumber_
1215	4	1213	SAVED	Buchungsnummer = 4	2012-08-30 12:39:53.095223	ordnumber_
1216	5	1213	SAVED	Buchungsnummer = 5	2012-08-30 12:43:28.749144	ordnumber_
1221	6	938	SAVED	Buchungsnummer = 6	2012-08-30 12:49:30.458254	ordnumber_
1222	5	938	DELETED	\N	2012-08-30 12:49:57.574794	ordnumber_
1223	7	1213	SAVED	Buchungsnummer = 7	2012-08-30 12:50:35.638041	ordnumber_
1224	8	938	SAVED	Buchungsnummer = 8	2012-08-30 12:52:44.181581	ordnumber_
1225	9	938	SAVED	Buchungsnummer = 9	2012-08-30 12:54:32.836819	ordnumber_
1231	10	1213	SAVED	Buchungsnummer = 10	2012-08-30 13:24:23.460353	ordnumber_
1232	11	1213	SAVED	Buchungsnummer = 11	2012-08-30 13:25:40.159076	ordnumber_
1233	12	1213	SAVED	Buchungsnummer = 12	2012-08-30 13:27:10.230058	ordnumber_
1236	13	1213	SAVED	Buchungsnummer = 13	2012-08-30 13:28:11.476322	ordnumber_
1237	14	1213	SAVED	Buchungsnummer = 14	2012-08-30 13:29:02.486279	ordnumber_
1238	15	938	SAVED	Buchungsnummer = 15	2012-08-30 13:57:08.160868	ordnumber_
1239	16	1213	SAVED	Buchungsnummer = 16	2012-08-30 13:57:10.063124	ordnumber_
1240	17	1213	SAVED	Buchungsnummer = 17	2012-08-30 13:57:41.573583	ordnumber_
1241	18	1213	SAVED	Buchungsnummer = 18	2012-08-30 13:58:34.95785	ordnumber_
1242	19	938	SAVED	Buchungsnummer = 19	2012-08-30 13:58:42.716389	ordnumber_
1243	20	1213	SAVED	Buchungsnummer = 20	2012-08-30 13:59:11.937057	ordnumber_
1244	21	938	SAVED	Buchungsnummer = 21	2012-08-30 13:59:13.499188	ordnumber_
1245	22	1213	SAVED	Buchungsnummer = 22	2012-08-30 14:00:11.510545	ordnumber_
1246	23	938	SAVED	Buchungsnummer = 23	2012-08-30 14:00:23.80669	ordnumber_
1247	24	1213	SAVED	Buchungsnummer = 24	2012-08-30 14:00:39.390468	ordnumber_
1248	25	938	SAVED	Buchungsnummer = 25	2012-08-30 14:01:01.580004	ordnumber_
1249	26	1213	SAVED	Buchungsnummer = 26	2012-08-30 14:01:26.431948	ordnumber_
1250	27	938	SAVED	Buchungsnummer = 27	2012-08-30 14:01:39.429787	ordnumber_
1251	28	1213	SAVED	Buchungsnummer = 28	2012-08-30 14:01:59.940955	ordnumber_
1252	29	938	SAVED	Buchungsnummer = 29	2012-08-30 14:02:41.36279	ordnumber_
1253	28	938	DELETED	\N	2012-08-30 14:04:01.057007	ordnumber_
1254	30	1213	SAVED	Buchungsnummer = 30	2012-08-30 14:05:10.965191	ordnumber_
1255	31	1213	SAVED	Buchungsnummer = 31	2012-08-30 14:05:45.30982	ordnumber_
1256	32	938	SAVED	Buchungsnummer = 32	2012-08-30 14:07:59.882678	ordnumber_
1257	33	1213	SAVED	Buchungsnummer = 33	2012-08-30 14:08:17.659489	ordnumber_
1258	34	938	SAVED	Buchungsnummer = 34	2012-08-30 14:08:29.597855	ordnumber_
1259	35	1213	SAVED	Buchungsnummer = 35	2012-08-30 14:08:58.718595	ordnumber_
1260	36	938	SAVED	Buchungsnummer = 36	2012-08-30 14:09:00.265011	ordnumber_
1261	37	938	SAVED	Buchungsnummer = 37	2012-08-30 14:09:33.308	ordnumber_
1262	38	1213	SAVED	Buchungsnummer = 38	2012-08-30 14:09:41.372866	ordnumber_
1263	39	938	SAVED	Buchungsnummer = 39	2012-08-30 14:09:50.717824	ordnumber_
1264	40	938	SAVED	Buchungsnummer = 40	2012-08-30 14:10:09.951944	ordnumber_
1265	41	938	SAVED	Buchungsnummer = 41	2012-08-30 14:10:25.283603	ordnumber_
1266	42	1213	SAVED	Buchungsnummer = 42	2012-08-30 14:10:28.903911	ordnumber_
1267	43	1213	SAVED	Buchungsnummer = 43	2012-08-30 14:12:02.92511	ordnumber_
1268	44	1213	SAVED	Buchungsnummer = 44	2012-08-30 14:12:55.529892	ordnumber_
1269	45	938	SAVED	Buchungsnummer = 45	2012-08-30 14:13:30.740869	ordnumber_
1270	46	1213	SAVED	Buchungsnummer = 46	2012-08-30 14:13:54.006789	ordnumber_
1271	47	938	SAVED	Buchungsnummer = 47	2012-08-30 14:13:55.285877	ordnumber_
1272	48	938	SAVED	Buchungsnummer = 48	2012-08-30 14:14:34.66729	ordnumber_
1273	49	938	SAVED	Buchungsnummer = 49	2012-08-30 14:14:55.591459	ordnumber_
1274	50	1213	SAVED	Buchungsnummer = 50	2012-08-30 14:15:06.596851	ordnumber_
1275	51	938	SAVED	Buchungsnummer = 51	2012-08-30 14:15:18.144438	ordnumber_
1276	52	938	SAVED	Buchungsnummer = 52	2012-08-30 14:15:40.618474	ordnumber_
1277	53	1213	SAVED	Buchungsnummer = 53	2012-08-30 14:15:43.871034	ordnumber_
1278	54	938	SAVED	Buchungsnummer = 54	2012-08-30 14:15:58.138242	ordnumber_
1279	55	938	SAVED	Buchungsnummer = 55	2012-08-30 14:16:28.36114	ordnumber_
1280	56	938	SAVED	Buchungsnummer = 56	2012-08-30 14:16:51.269139	ordnumber_
1281	57	1213	SAVED	Buchungsnummer = 57	2012-08-30 14:16:53.75795	ordnumber_
1282	58	938	SAVED	Buchungsnummer = 58	2012-08-30 14:17:12.780997	ordnumber_
1283	59	1213	SAVED	Buchungsnummer = 59	2012-08-30 14:17:18.899765	ordnumber_
1284	60	1213	SAVED	Buchungsnummer = 60	2012-08-30 14:17:41.445445	ordnumber_
1285	61	938	SAVED	Buchungsnummer = 61	2012-08-30 14:17:50.148335	ordnumber_
1286	62	1213	SAVED	Buchungsnummer = 62	2012-08-30 14:18:11.05493	ordnumber_
1287	63	938	SAVED	Buchungsnummer = 63	2012-08-30 14:18:11.435933	ordnumber_
1288	64	938	SAVED	Buchungsnummer = 64	2012-08-30 14:18:35.139866	ordnumber_
1289	65	1213	SAVED	Buchungsnummer = 65	2012-08-30 14:18:42.012594	ordnumber_
1290	66	938	SAVED	Buchungsnummer = 66	2012-08-30 14:18:53.107621	ordnumber_
1291	67	1213	SAVED	Buchungsnummer = 67	2012-08-30 14:19:10.71179	ordnumber_
1292	68	1213	SAVED	Buchungsnummer = 68	2012-08-30 14:19:37.900034	ordnumber_
1293	69	1213	SAVED	Buchungsnummer = 69	2012-08-30 14:19:59.847872	ordnumber_
1294	70	938	SAVED	Buchungsnummer = 70	2012-08-30 14:20:38.992802	ordnumber_
1295	71	938	SAVED	Buchungsnummer = 71	2012-08-30 14:20:58.860283	ordnumber_
1296	72	938	SAVED	Buchungsnummer = 72	2012-08-30 14:21:23.98586	ordnumber_
1297	73	1213	SAVED	Buchungsnummer = 73	2012-08-30 14:21:33.230763	ordnumber_
1298	74	938	SAVED	Buchungsnummer = 74	2012-08-30 14:21:40.491186	ordnumber_
1299	75	1213	SAVED	Buchungsnummer = 75	2012-08-30 14:22:26.516604	ordnumber_
1300	76	938	SAVED	Buchungsnummer = 76	2012-08-30 14:22:38.741209	ordnumber_
1301	77	1213	SAVED	Buchungsnummer = 77	2012-08-30 14:22:51.826856	ordnumber_
1302	78	938	SAVED	Buchungsnummer = 78	2012-08-30 14:23:10.898298	ordnumber_
1303	79	1213	SAVED	Buchungsnummer = 79	2012-08-30 14:23:14.871768	ordnumber_
1304	80	938	SAVED	Buchungsnummer = 80	2012-08-30 14:23:36.406444	ordnumber_
1305	81	1213	SAVED	Buchungsnummer = 81	2012-08-30 14:23:39.282544	ordnumber_
1306	82	938	SAVED	Buchungsnummer = 82	2012-08-30 14:24:03.216367	ordnumber_
1307	83	1213	SAVED	Buchungsnummer = 83	2012-08-30 14:24:08.44006	ordnumber_
1308	84	938	SAVED	Buchungsnummer = 84	2012-08-30 14:24:21.077551	ordnumber_
1309	85	1213	SAVED	Buchungsnummer = 85	2012-08-30 14:24:32.508698	ordnumber_
1310	86	938	SAVED	Buchungsnummer = 86	2012-08-30 14:24:38.736698	ordnumber_
1311	87	938	SAVED	Buchungsnummer = 87	2012-08-30 14:24:56.389465	ordnumber_
1312	88	1213	SAVED	Buchungsnummer = 88	2012-08-30 14:24:56.585422	ordnumber_
1313	89	938	SAVED	Buchungsnummer = 89	2012-08-30 14:25:19.231848	ordnumber_
1314	90	1213	SAVED	Buchungsnummer = 90	2012-08-30 14:26:28.668336	ordnumber_
1315	91	1213	SAVED	Buchungsnummer = 91	2012-08-30 14:26:51.219272	ordnumber_
1316	92	1213	SAVED	Buchungsnummer = 92	2012-08-30 14:27:15.277978	ordnumber_
1317	93	1213	SAVED	Buchungsnummer = 93	2012-08-30 14:27:40.401398	ordnumber_
1318	94	1213	SAVED	Buchungsnummer = 94	2012-08-30 14:28:01.740255	ordnumber_
1319	95	1213	SAVED	Buchungsnummer = 95	2012-08-30 14:28:30.378935	ordnumber_
1320	96	1213	SAVED	Buchungsnummer = 96	2012-08-30 14:28:55.674848	ordnumber_
1321	97	1213	SAVED	Buchungsnummer = 97	2012-08-30 14:29:14.495637	ordnumber_
1322	98	1213	SAVED	Buchungsnummer = 98	2012-08-30 14:43:28.679546	ordnumber_
1324	1323	1213	SAVED	\N	2012-08-30 14:55:16.017717	vendornumber_70013
1326	1325	1213	SAVED	\N	2012-08-30 14:57:04.353306	partnumber_025
1327	99	1213	POSTED	\N	2012-08-30 15:02:56.101471	invnumber_99
1328	100	1213	SAVED	Buchungsnummer = 100	2012-08-30 15:12:06.694578	ordnumber_
1329	101	1213	POSTED	\N	2012-08-30 15:14:07.978541	invnumber_101
1330	102	1213	POSTED	\N	2012-08-30 15:15:11.217988	invnumber_102
1331	98	1213	DELETED	\N	2012-08-30 15:17:24.796377	ordnumber_
1332	103	1213	SAVED	Buchungsnummer = 103	2012-08-30 15:19:46.559066	ordnumber_
1333	99	1213	DELETED	\N	2012-08-30 15:22:01.165278	invnumber_99
1334	101	1213	DELETED	\N	2012-08-30 15:22:15.832	invnumber_101
1335	102	1213	DELETED	\N	2012-08-30 15:22:34.14114	invnumber_102
1336	105	1213	POSTED	\N	2012-08-30 15:26:07.725989	invnumber_29100
1337	106	1213	POSTED	\N	2012-08-30 15:27:17.410958	invnumber_35743
1338	107	1213	POSTED	\N	2012-08-30 15:28:13.15508	invnumber_107
1339	107	1213	DELETED	\N	2012-08-30 15:29:09.409699	invnumber_107
1340	100	1213	DELETED	\N	2012-08-30 15:30:44.344534	ordnumber_
1341	108	1213	POSTED	\N	2012-08-30 15:32:52.354029	invnumber_41568
1342	109	1213	SAVED	Buchungsnummer = 109	2012-08-30 15:34:57.301328	ordnumber_
1344	1343	938	SAVED	\N	2012-09-03 11:36:46.427488	vendornumber_70014
1345	110	938	POSTED	\N	2012-09-03 11:39:52.509144	invnumber_d201206400
1346	111	938	SAVED	Buchungsnummer = 111	2012-09-03 13:52:32.338043	ordnumber_
1347	112	938	SAVED	Buchungsnummer = 112	2012-09-03 14:08:11.17056	ordnumber_
1348	113	938	SAVED	Buchungsnummer = 113	2012-09-03 15:41:51.750099	ordnumber_
1350	1349	938	SAVED	\N	2012-09-03 15:44:02.633675	vendornumber_60000
1351	114	938	POSTED	\N	2012-09-03 15:52:54.828421	invnumber_114
1352	114	938	POSTED	\N	2012-09-03 15:53:54.237934	invnumber_114
1353	115	938	SAVED	Buchungsnummer = 115	2012-09-04 11:12:37.855457	ordnumber_
1354	116	938	SAVED	Buchungsnummer = 116	2012-09-04 11:13:13.522731	ordnumber_
1355	117	938	SAVED	Buchungsnummer = 117	2012-09-04 11:13:38.781412	ordnumber_
1356	118	938	SAVED	Buchungsnummer = 118	2012-09-04 11:14:21.263462	ordnumber_
1357	119	938	SAVED	Buchungsnummer = 119	2012-09-04 11:15:03.946437	ordnumber_
1358	120	938	SAVED	Buchungsnummer = 120	2012-09-04 11:15:25.930648	ordnumber_
1359	121	938	SAVED	Buchungsnummer = 121	2012-09-04 11:15:52.347299	ordnumber_
1360	122	938	SAVED	Buchungsnummer = 122	2012-09-04 11:16:13.679258	ordnumber_
1361	123	938	SAVED	Buchungsnummer = 123	2012-09-04 11:16:44.85213	ordnumber_
1362	124	938	SAVED	Buchungsnummer = 124	2012-09-04 11:17:08.913401	ordnumber_
1363	125	938	SAVED	Buchungsnummer = 125	2012-09-04 11:17:32.115751	ordnumber_
1364	126	938	SAVED	Buchungsnummer = 126	2012-09-04 11:18:02.763011	ordnumber_
1365	127	938	SAVED	Buchungsnummer = 127	2012-09-04 11:18:28.986439	ordnumber_
1366	128	938	SAVED	Buchungsnummer = 128	2012-09-04 11:18:49.587103	ordnumber_
1367	129	938	SAVED	Buchungsnummer = 129	2012-09-04 11:19:15.458266	ordnumber_
1368	130	938	SAVED	Buchungsnummer = 130	2012-09-04 11:19:36.795931	ordnumber_
1369	131	938	SAVED	Buchungsnummer = 131	2012-09-04 11:19:58.43124	ordnumber_
1370	132	938	SAVED	Buchungsnummer = 132	2012-09-04 11:20:23.057286	ordnumber_
1371	133	938	SAVED	Buchungsnummer = 133	2012-09-04 11:20:47.463455	ordnumber_
1372	134	938	SAVED	Buchungsnummer = 134	2012-09-04 11:21:07.652098	ordnumber_
1373	135	938	SAVED	Buchungsnummer = 135	2012-09-04 11:21:28.9985	ordnumber_
1374	136	938	SAVED	Buchungsnummer = 136	2012-09-04 11:21:46.433504	ordnumber_
1375	137	938	SAVED	Buchungsnummer = 137	2012-09-04 11:22:02.759594	ordnumber_
1376	138	938	SAVED	Buchungsnummer = 138	2012-09-04 11:22:29.69211	ordnumber_
1377	139	938	SAVED	Buchungsnummer = 139	2012-09-04 11:22:48.720183	ordnumber_
1378	140	938	SAVED	Buchungsnummer = 140	2012-09-04 11:23:12.849757	ordnumber_
1379	141	938	SAVED	Buchungsnummer = 141	2012-09-04 11:23:28.720363	ordnumber_
1380	142	938	SAVED	Buchungsnummer = 142	2012-09-04 11:23:47.058651	ordnumber_
1381	143	938	SAVED	Buchungsnummer = 143	2012-09-04 11:24:09.960125	ordnumber_
1382	144	938	SAVED	Buchungsnummer = 144	2012-09-04 11:24:33.628802	ordnumber_
1383	145	938	SAVED	Buchungsnummer = 145	2012-09-04 11:24:55.448091	ordnumber_
1384	146	938	SAVED	Buchungsnummer = 146	2012-09-04 11:25:12.97833	ordnumber_
1385	147	938	SAVED	Buchungsnummer = 147	2012-09-04 11:25:55.841419	ordnumber_
1386	148	938	SAVED	Buchungsnummer = 148	2012-09-04 11:27:16.363291	ordnumber_
1387	149	938	SAVED	Buchungsnummer = 149	2012-09-04 11:27:49.919985	ordnumber_
1388	150	938	SAVED	Buchungsnummer = 150	2012-09-04 11:28:33.161936	ordnumber_
1389	151	938	SAVED	Buchungsnummer = 151	2012-09-04 11:29:07.290039	ordnumber_
1390	152	938	SAVED	Buchungsnummer = 152	2012-09-04 11:29:34.090292	ordnumber_
1391	153	938	SAVED	Buchungsnummer = 153	2012-09-04 11:30:02.823245	ordnumber_
1392	154	938	SAVED	Buchungsnummer = 154	2012-09-04 11:30:25.75144	ordnumber_
1393	128	938	DELETED	\N	2012-09-04 11:42:19.750991	ordnumber_
1394	155	938	SAVED	Buchungsnummer = 155	2012-09-04 11:42:50.709418	ordnumber_
1395	156	938	POSTED	\N	2012-09-04 11:46:08.162109	invnumber_63415
1396	157	938	SAVED	Buchungsnummer = 157	2012-09-04 12:00:21.576719	ordnumber_
1398	1397	1213	SAVED	\N	2012-09-12 11:27:30.798719	vendornumber_80009
1400	1399	938	SAVED	\N	2012-09-12 11:29:38.540781	ordnumber_201201
1402	1401	1213	SAVED	\N	2012-09-12 11:30:23.087952	vendornumber_70015
1403	158	938	POSTED	\N	2012-09-12 11:31:38.232716	invnumber_201201
1405	1404	1213	SAVED	\N	2012-09-12 11:32:32.738011	partnumber_026
1407	1406	1213	SAVED	\N	2012-09-12 11:38:06.370088	partnumber_109
1408	1404	938	SAVED	\N	2012-09-12 11:40:07.012863	partnumber_026
1409	1406	1213	SAVED	\N	2012-09-12 11:40:41.570884	partnumber_109
1411	1410	938	SAVED	\N	2012-09-12 11:42:17.807996	ordnumber_201202
1414	1412	938	SAVED	\N	2012-09-12 11:44:32.818123	donumber_kr20120113
1417	1416	1213	SAVED	\N	2012-09-12 11:45:32.679146	ordnumber_201203
1418	159	938	POSTED	\N	2012-09-12 11:46:35.595859	invnumber_kr20120113
1425	1419	1213	SAVED	\N	2012-09-12 11:48:47.802102	donumber_R203913
1431	160	1213	POSTED	\N	2012-09-12 11:51:00.36267	invnumber_R201243
1433	1432	938	SAVED	\N	2012-09-12 11:51:52.488133	ordnumber_201204
1436	1434	938	SAVED	\N	2012-09-12 11:52:49.51403	donumber_i784363
1439	1438	1213	SAVED	\N	2012-09-12 11:55:04.017372	ordnumber_201205
1440	161	938	POSTED	\N	2012-09-12 11:55:20.968213	invnumber_i784363
1446	1441	1213	SAVED	\N	2012-09-12 11:57:39.928977	donumber_KBL49384
1451	1441	1213	SAVED	\N	2012-09-12 11:57:58.665569	donumber_KBL49384
1456	162	1213	POSTED	\N	2012-09-12 12:00:50.18701	invnumber_KBL42348
1458	1457	938	SAVED	\N	2012-09-12 12:07:37.41926	ordnumber_201206
1464	1459	938	SAVED	\N	2012-09-12 12:09:40.79508	donumber_dog13498
1470	1469	1213	SAVED	\N	2012-09-12 12:11:04.799032	ordnumber_201207
1471	1469	1213	SAVED	\N	2012-09-12 12:11:48.714555	ordnumber_201207
1472	163	938	POSTED	\N	2012-09-12 12:11:50.634562	invnumber_dog13498
1475	1474	938	SAVED	\N	2012-09-12 12:15:01.341987	ordnumber_201208
1480	1476	1213	SAVED	\N	2012-09-12 12:15:45.362962	donumber_PSR4352
1487	1484	938	SAVED	\N	2012-09-12 12:16:02.968857	donumber_siemann213
1490	164	1213	POSTED	\N	2012-09-12 12:16:58.234736	invnumber_PSR45325
1491	165	938	POSTED	\N	2012-09-12 12:17:13.695426	invnumber_siemann213
1493	1492	1213	SAVED	\N	2012-09-12 12:24:03.065433	ordnumber_201202-02
1496	1494	1213	SAVED	\N	2012-09-12 12:33:07.292747	donumber_KS3245549
1498	166	1213	POSTED	\N	2012-09-12 12:34:31.343353	invnumber_KS547843
1500	1499	938	SAVED	\N	2012-09-12 12:36:07.67861	ordnumber_201209
1502	1501	1213	SAVED	\N	2012-09-12 12:38:12.447104	ordnumber_201210
1506	1503	938	SAVED	\N	2012-09-12 12:39:22.769624	donumber_B123St
1509	167	938	POSTED	\N	2012-09-12 12:40:21.413496	invnumber_B123St
1511	1510	938	SAVED	\N	2012-09-12 12:47:57.300177	ordnumber_201211
1514	1512	938	SAVED	\N	2012-09-12 12:49:24.233013	donumber_nsoy2314
1516	168	938	POSTED	\N	2012-09-12 12:51:04.698806	invnumber_nsoy2314
1518	1517	1213	SAVED	\N	2012-09-12 14:02:22.572735	ordnumber_201212
1519	169	1213	POSTED	\N	2012-09-12 14:03:23.364572	invnumber_BC54895
1521	1520	938	SAVED	\N	2012-09-12 14:04:28.15692	ordnumber_201213
1523	1522	1213	SAVED	\N	2012-09-12 14:05:43.31042	ordnumber_201214
1524	1522	1213	SAVED	\N	2012-09-12 14:05:58.351697	ordnumber_201214
1527	1525	938	SAVED	\N	2012-09-12 14:06:01.216231	donumber_Kule14314
1531	1529	1213	SAVED	\N	2012-09-12 14:07:21.913236	donumber_UM58490578
1533	170	938	POSTED	\N	2012-09-12 14:07:26.614667	invnumber_Kule14314
1534	171	1213	POSTED	\N	2012-09-12 14:08:19.922754	invnumber_UM438947
1536	1535	1213	SAVED	\N	2012-09-12 14:10:55.875084	ordnumber_201215
1538	1537	938	SAVED	\N	2012-09-12 14:11:13.524832	ordnumber_201216
1539	172	938	POSTED	\N	2012-09-12 14:14:06.733301	invnumber_sbi542534
1546	1540	1213	SAVED	\N	2012-09-12 14:14:58.248978	donumber_PH34287
1552	173	1213	POSTED	\N	2012-09-12 14:16:01.154749	invnumber_PH480956
1554	1553	1213	SAVED	\N	2012-09-12 14:22:52.010953	ordnumber_201217
1556	1555	938	SAVED	\N	2012-09-12 14:23:50.055057	ordnumber_201218
1557	174	1213	POSTED	\N	2012-09-12 14:24:09.764645	invnumber_MA05987078
1558	175	938	POSTED	\N	2012-09-12 14:26:49.964807	invnumber_Reiter05543
1560	1559	1213	SAVED	\N	2012-09-12 14:28:53.814156	ordnumber_201219
1561	176	1213	POSTED	\N	2012-09-12 14:30:44.021759	invnumber_IPG38765
1562	174	1213	DELETED	\N	2012-09-12 14:31:25.737613	invnumber_MA05987078
1563	177	1213	POSTED	\N	2012-09-12 14:34:33.058089	invnumber_MA05987078
1565	1564	1213	SAVED	\N	2012-09-12 14:36:48.749562	ordnumber_201220
1566	178	1213	POSTED	\N	2012-09-12 14:38:20.573686	invnumber_ICL654667
1568	1567	1213	SAVED	\N	2012-09-12 14:39:35.55502	ordnumber_201221
1570	1569	938	SAVED	\N	2012-09-12 14:41:05.544591	ordnumber_201222
1571	179	1213	POSTED	\N	2012-09-12 14:41:19.701861	invnumber_BR54574567
1576	1572	938	SAVED	\N	2012-09-12 14:43:11.499422	donumber_fkidsg93
1580	180	938	POSTED	\N	2012-09-12 14:44:44.593937	invnumber_fkidsg93
1582	1581	1213	SAVED	\N	2012-09-12 14:48:17.062237	partnumber_027
1583	1581	1213	SAVED	\N	2012-09-12 14:48:43.835874	partnumber_027
1585	1584	1213	SAVED	\N	2012-09-12 14:51:37.789033	ordnumber_201203-01
1589	1586	1213	SAVED	\N	2012-09-12 14:54:45.524498	donumber_RB594573
1592	181	1213	POSTED	\N	2012-09-12 14:56:00.999972	invnumber_RB485373
1593	1111	938	SAVED	\N	2012-09-12 15:17:04.788775	partnumber_008
1594	1098	938	SAVED	\N	2012-09-12 15:17:22.182945	partnumber_003
1595	1142	938	SAVED	\N	2012-09-12 15:17:35.782925	partnumber_017
1596	1152	938	SAVED	\N	2012-09-12 15:17:48.593884	partnumber_021
1597	1100	938	SAVED	\N	2012-09-12 15:18:02.035538	partnumber_004
1598	1107	938	SAVED	\N	2012-09-12 15:18:36.090063	partnumber_007
1599	1103	938	SAVED	\N	2012-09-12 15:18:52.242343	partnumber_005
1600	1183	938	SAVED	\N	2012-09-12 15:19:14.873899	partnumber_024
1601	1174	938	SAVED	\N	2012-09-12 15:19:50.784913	partnumber_022
1602	1147	938	SAVED	\N	2012-09-12 15:20:05.316748	partnumber_019
1603	1137	938	SAVED	\N	2012-09-12 15:20:26.513591	partnumber_016
1604	1093	938	SAVED	\N	2012-09-12 15:20:50.192694	partnumber_002
1605	1180	938	SAVED	\N	2012-09-12 15:21:02.454648	partnumber_023
1606	1117	938	SAVED	\N	2012-09-12 15:21:14.907613	partnumber_010
1607	1123	938	SAVED	\N	2012-09-12 15:21:31.864563	partnumber_013
1608	1119	938	SAVED	\N	2012-09-12 15:21:45.452608	partnumber_011
1609	1115	938	SAVED	\N	2012-09-12 15:22:04.956508	partnumber_009
1610	1121	938	SAVED	\N	2012-09-12 15:22:16.579737	partnumber_ 012
1611	1133	938	SAVED	\N	2012-09-12 15:22:30.870685	partnumber_014
1612	1135	938	SAVED	\N	2012-09-12 15:22:43.562944	partnumber_015
1613	1105	938	SAVED	\N	2012-09-12 15:22:57.117422	partnumber_006
1614	1149	938	SAVED	\N	2012-09-12 15:23:08.46238	partnumber_020
1615	1144	938	SAVED	\N	2012-09-12 15:23:19.068764	partnumber_018
1616	1156	938	SAVED	\N	2012-09-12 15:23:52.044308	partnumber_102
1617	1192	938	SAVED	\N	2012-09-12 15:24:01.512608	partnumber_108
1618	1164	938	SAVED	\N	2012-09-12 15:24:16.907694	partnumber_105
1619	1167	938	SAVED	\N	2012-09-12 15:24:28.153676	partnumber_106
1620	1161	938	SAVED	\N	2012-09-12 15:24:37.653365	partnumber_104
1621	1154	938	SAVED	\N	2012-09-12 15:24:49.266984	partnumber_101
1622	1158	938	SAVED	\N	2012-09-12 15:25:04.100082	partnumber_103
1623	1185	938	SAVED	\N	2012-09-12 15:25:16.877581	partnumber_107
1624	1091	938	SAVED	\N	2012-09-12 15:35:50.354467	partnumber_001
1625	1093	938	SAVED	\N	2012-09-12 15:36:27.42399	partnumber_002
1626	1098	938	SAVED	\N	2012-09-12 15:37:10.231156	partnumber_003
1627	1100	938	SAVED	\N	2012-09-12 15:37:29.417258	partnumber_004
1628	1103	938	SAVED	\N	2012-09-12 15:37:49.486576	partnumber_005
1629	1105	938	SAVED	\N	2012-09-12 15:38:09.457247	partnumber_006
1630	1107	938	SAVED	\N	2012-09-12 15:38:33.002464	partnumber_007
1631	1111	938	SAVED	\N	2012-09-12 15:39:04.78835	partnumber_008
1632	1115	938	SAVED	\N	2012-09-12 15:39:26.185422	partnumber_009
1633	1117	938	SAVED	\N	2012-09-12 15:39:47.610081	partnumber_010
1634	1119	938	SAVED	\N	2012-09-12 15:40:01.609708	partnumber_011
1635	1121	938	SAVED	\N	2012-09-12 15:40:25.120468	partnumber_ 012
1636	1123	938	SAVED	\N	2012-09-12 15:40:39.188574	partnumber_013
1637	1133	938	SAVED	\N	2012-09-12 15:41:06.651481	partnumber_014
1638	1135	938	SAVED	\N	2012-09-12 15:41:31.768758	partnumber_015
1639	1137	938	SAVED	\N	2012-09-12 15:41:52.78489	partnumber_016
1640	1142	938	SAVED	\N	2012-09-12 15:42:22.156452	partnumber_017
1641	1144	938	SAVED	\N	2012-09-12 15:42:39.565029	partnumber_018
1642	1147	938	SAVED	\N	2012-09-12 15:42:59.176873	partnumber_019
1643	1149	938	SAVED	\N	2012-09-12 15:43:17.229227	partnumber_020
1644	1152	938	SAVED	\N	2012-09-12 15:43:34.873452	partnumber_021
1645	1174	938	SAVED	\N	2012-09-12 15:43:54.043854	partnumber_022
1646	1180	938	SAVED	\N	2012-09-12 15:44:19.017528	partnumber_023
1647	1183	938	SAVED	\N	2012-09-12 15:44:44.320677	partnumber_024
1648	1325	938	SAVED	\N	2012-09-12 15:45:14.175785	partnumber_025
1649	1154	938	SAVED	\N	2012-09-12 15:46:05.710804	partnumber_101
1650	1156	938	SAVED	\N	2012-09-12 15:46:27.247712	partnumber_102
1651	1158	938	SAVED	\N	2012-09-12 15:47:17.407238	partnumber_103
1652	1161	938	SAVED	\N	2012-09-12 15:47:55.289222	partnumber_104
1653	1164	938	SAVED	\N	2012-09-12 15:48:27.412783	partnumber_105
1654	1167	938	SAVED	\N	2012-09-12 15:49:06.665478	partnumber_106
1655	1185	938	SAVED	\N	2012-09-12 15:49:36.422154	partnumber_107
1656	1192	938	SAVED	\N	2012-09-12 15:50:24.405571	partnumber_108
1657	1147	938	SAVED	\N	2012-09-12 15:52:32.276214	partnumber_019
1658	1149	938	SAVED	\N	2012-09-12 15:53:14.015213	partnumber_020
1659	1152	938	SAVED	\N	2012-09-12 15:54:44.778452	partnumber_021
1660	182	1213	SAVED	Buchungsnummer = 182	2012-09-12 16:56:01.492263	ordnumber_
1661	183	1213	SAVED	Buchungsnummer = 183	2012-09-14 11:39:33.073531	ordnumber_
1662	184	1213	SAVED	Buchungsnummer = 184	2012-09-14 11:43:46.108002	ordnumber_
1663	185	1213	SAVED	Buchungsnummer = 185	2012-09-14 15:15:43.41789	ordnumber_
1666	186	1213	SAVED	Buchungsnummer = 186	2012-09-14 15:39:03.138745	ordnumber_
1667	187	1213	SAVED	Buchungsnummer = 187	2012-09-14 16:01:30.25267	ordnumber_
1668	188	938	SAVED	Buchungsnummer = 188	2012-09-17 10:49:21.55341	ordnumber_
1669	1121	938	SAVED	\N	2012-09-17 12:23:39.448354	partnumber_012
1728	189	938	SAVED	Buchungsnummer = 189	2012-09-17 13:53:51.604752	ordnumber_
1729	189	938	DELETED	\N	2012-09-17 13:54:24.951278	ordnumber_
1730	190	938	SAVED	Buchungsnummer = 190	2012-09-17 13:54:38.483875	ordnumber_
1731	191	938	SAVED	Buchungsnummer = 191	2012-09-17 13:55:39.974662	ordnumber_
1732	192	938	SAVED	Buchungsnummer = 192	2012-09-17 13:56:16.072844	ordnumber_
1733	193	938	SAVED	Buchungsnummer = 193	2012-09-17 13:56:47.003201	ordnumber_
1734	194	938	SAVED	Buchungsnummer = 194	2012-09-17 13:57:25.265643	ordnumber_
1735	195	938	SAVED	Buchungsnummer = 195	2012-09-17 13:57:57.625502	ordnumber_
1736	196	938	SAVED	Buchungsnummer = 196	2012-09-17 13:58:18.975179	ordnumber_
1737	197	938	SAVED	Buchungsnummer = 197	2012-09-17 13:58:54.094116	ordnumber_
1738	198	938	SAVED	Buchungsnummer = 198	2012-09-17 13:59:30.829386	ordnumber_
1739	199	938	SAVED	Buchungsnummer = 199	2012-09-17 14:00:08.386667	ordnumber_
1740	200	938	SAVED	Buchungsnummer = 200	2012-09-17 14:00:39.390914	ordnumber_
1741	201	938	SAVED	Buchungsnummer = 201	2012-09-17 14:01:09.60373	ordnumber_
1743	1742	1213	SAVED	\N	2012-09-21 14:32:13.140565	partnumber_028
1745	1744	1213	SAVED	\N	2012-09-21 14:34:23.954628	ordnumber_201210-1
1748	1746	1213	SAVED	\N	2012-09-21 14:35:56.397221	donumber_APSXT400012
1750	206	1213	POSTED	\N	2012-09-21 14:43:12.262715	invnumber_APSXT400012
1751	207	1213	POSTED	\N	2012-09-21 14:45:39.78317	invnumber_APSXT400012
1753	1752	1213	SAVED	\N	2012-09-21 15:10:16.972953	partnumber_110
1755	1754	938	SAVED	\N	2012-09-21 15:11:10.554524	customernumber_10001
1757	1756	938	SAVED	\N	2012-09-21 15:13:38.509452	ordnumber_022012
1759	1758	938	SAVED	\N	2012-09-21 15:16:58.348329	partnumber_000
1760	208	938	POSTED	\N	2012-09-21 15:31:42.532604	invnumber_1
1762	1756	938	SAVED	\N	2012-09-21 15:34:18.816125	ordnumber_022012
1763	1756	938	SAVED	\N	2012-09-21 15:35:56.177794	ordnumber_022012
1773	218	938	SAVED	Buchungsnummer = 218	2012-09-21 15:45:37.03024	ordnumber_
1774	219	938	SAVED	Buchungsnummer = 219	2012-09-21 15:47:20.077635	ordnumber_
1775	220	938	SAVED	Buchungsnummer = 220	2012-09-21 15:48:26.023771	ordnumber_
1776	221	938	SAVED	Buchungsnummer = 221	2012-09-21 15:49:36.699838	ordnumber_
1778	1035	938	SAVED	\N	2012-09-25 20:50:41.539949	vendornumber_80002
1779	1039	938	SAVED	\N	2012-09-25 20:50:49.373456	vendornumber_80003
1780	1043	938	SAVED	\N	2012-09-25 20:50:56.093344	vendornumber_80004
1781	1041	938	SAVED	\N	2012-09-25 20:51:03.873139	vendornumber_80005
1782	1080	938	SAVED	\N	2012-09-25 20:51:12.472802	vendornumber_80006
1783	1190	938	SAVED	\N	2012-09-25 20:51:19.605127	vendornumber_80007
1784	1397	938	SAVED	\N	2012-09-25 20:51:34.713878	vendornumber_80008
1785	1098	938	SAVED	\N	2012-09-25 20:52:37.755537	partnumber_003
1786	1098	938	SAVED	\N	2012-09-25 20:53:02.419498	partnumber_003
1787	1111	938	SAVED	\N	2012-09-25 20:53:30.831006	partnumber_008
1788	1185	938	SAVED	\N	2012-09-25 20:54:46.912187	partnumber_107
1789	1406	938	SAVED	\N	2012-09-25 20:55:38.540616	partnumber_1
1790	1752	938	SAVED	\N	2012-09-25 20:55:48.610658	partnumber_109
1791	1744	938	SAVED	\N	2012-09-25 21:00:20.79425	ordnumber_201210
1792	1492	938	SAVED	\N	2012-09-25 21:01:41.650176	ordnumber_201202
1793	1410	938	SAVED	\N	2012-09-25 21:01:52.30849	ordnumber_201203
1794	1416	938	SAVED	\N	2012-09-25 21:02:01.321087	ordnumber_201204
1795	1584	938	SAVED	\N	2012-09-25 21:02:12.449886	ordnumber_201205
1796	1432	938	SAVED	\N	2012-09-25 21:02:33.758198	ordnumber_201206
1797	1438	938	SAVED	\N	2012-09-25 21:02:41.999234	ordnumber_201207
1798	1469	938	SAVED	\N	2012-09-25 21:02:54.090968	ordnumber_201209
1799	1457	938	SAVED	\N	2012-09-25 21:03:02.59934	ordnumber_201210
1800	1744	938	SAVED	\N	2012-09-25 21:03:14.266069	ordnumber_201211
1801	1499	938	SAVED	\N	2012-09-25 21:03:21.740621	ordnumber_201212
1802	1501	938	SAVED	\N	2012-09-25 21:03:32.765812	ordnumber_--------
1803	1510	938	SAVED	\N	2012-09-25 21:03:41.265411	ordnumber_201213
1804	1517	938	SAVED	\N	2012-09-25 21:03:48.257039	ordnumber_201214
1805	1522	938	SAVED	\N	2012-09-25 21:03:55.07336	ordnumber_201215
1806	1520	938	SAVED	\N	2012-09-25 21:04:02.631726	ordnumber_201216
1807	1537	938	SAVED	\N	2012-09-25 21:04:10.973083	ordnumber_201217
1808	1535	938	SAVED	\N	2012-09-25 21:04:18.373034	ordnumber_201218
1809	1555	938	SAVED	\N	2012-09-25 21:04:29.28932	ordnumber_201219
1810	1559	938	SAVED	\N	2012-09-25 21:04:42.605702	ordnumber_201220
1811	1553	938	SAVED	\N	2012-09-25 21:05:01.749739	ordnumber_201221
1812	1567	938	SAVED	\N	2012-09-25 21:05:12.546787	ordnumber_201222
1813	1564	938	SAVED	\N	2012-09-25 21:05:23.704676	ordnumber_201223
1814	1569	938	SAVED	\N	2012-09-25 21:05:30.505181	ordnumber_201224
1815	1756	938	SAVED	\N	2012-09-25 21:06:18.845728	ordnumber_201126
1816	1406	938	SAVED	\N	2012-09-25 21:07:30.002003	partnumber_--------
1817	1133	938	SAVED	\N	2012-09-26 15:48:14.504714	partnumber_014
1818	1406	938	SAVED	\N	2012-09-26 15:49:48.723106	partnumber_--------
1820	\N	1473	SAVED	\N	2012-10-08 15:27:17.986033	invnumber_
1823	1822	1473	SAVED	\N	2012-10-08 15:28:06.598012	partnumber_23456754
1824	223	1473	POSTED	\N	2012-10-08 15:29:42.881502	invnumber_65780
1825	223	1473	CANCELED	\N	2012-10-08 15:30:57.406484	invnumber_65780
1826	225	1473	POSTED	\N	2012-10-08 15:34:13.849523	invnumber_12
1827	226	1473	STORNO	\N	2012-10-08 15:34:30.332789	invnumber_Storno zu 12
1828	209	1473	POSTED	\N	2012-10-08 15:36:40.710464	invnumber_1
1829	210	1473	POSTED	\N	2012-10-08 15:37:08.331213	invnumber_2
1830	211	1473	POSTED	\N	2012-10-08 15:38:38.723311	invnumber_3
1831	212	1473	POSTED	\N	2012-10-08 15:39:05.27886	invnumber_4
1832	213	1473	POSTED	\N	2012-10-08 15:39:43.644456	invnumber_5
1833	214	1473	POSTED	\N	2012-10-08 15:40:13.178872	invnumber_6
1834	215	1473	POSTED	\N	2012-10-08 15:40:41.014104	invnumber_7
1835	216	1473	POSTED	\N	2012-10-08 15:41:08.761687	invnumber_8
1836	217	1473	POSTED	\N	2012-10-08 15:41:36.868185	invnumber_9
1837	1821	1473	SAVED	\N	2012-10-08 15:43:51.519737	vendornumber_70016
1838	227	1473	SAVED	Buchungsnummer = 227	2012-10-08 15:56:30.921004	ordnumber_
1839	1822	1473	SAVED	\N	2012-10-08 16:04:41.010161	partnumber_029
1843	231	1473	STORNO	\N	2012-10-09 08:58:55.609316	invnumber_Storno zu 10
1844	228	938	POSTED	\N	2012-10-09 09:52:10.252905	invnumber_11
1845	229	938	POSTED	\N	2012-10-09 09:52:37.638362	invnumber_12
1846	230	938	POSTED	\N	2012-10-09 09:53:01.750669	invnumber_14
1847	232	938	POSTED	\N	2012-10-09 10:02:59.682861	invnumber_oat528
1848	232	938	POSTED	\N	2012-10-09 10:36:16.121183	invnumber_oat528
1849	233	938	SAVED	Buchungsnummer = 233	2012-10-09 12:33:16.615807	ordnumber_
1850	1501	1473	DELETED	\N	2012-10-09 14:46:53.408872	ordnumber_--------
1851	1406	1473	DELETED	\N	2012-10-09 14:47:39.268647	partnumber_--------
1852	1111	1473	SAVED	\N	2012-10-09 14:50:48.524102	partnumber_008
1853	1111	1473	SAVED	\N	2012-10-09 14:51:10.231629	partnumber_008
1854	1111	1473	SAVED	\N	2012-10-09 14:51:21.948288	partnumber_008
1856	234	1473	SAVED	Buchungsnummer = 234	2012-10-09 15:35:42.329581	ordnumber_
1857	235	938	SAVED	Buchungsnummer = 235	2012-10-09 16:09:28.449282	ordnumber_
1858	236	938	SAVED	Buchungsnummer = 236	2012-10-09 16:43:43.809249	ordnumber_
1859	237	938	SAVED	Buchungsnummer = 237	2012-10-09 16:53:04.983829	ordnumber_
1860	238	938	SAVED	Buchungsnummer = 238	2012-10-09 16:55:21.998685	ordnumber_
1861	239	938	SAVED	Buchungsnummer = 239	2012-10-09 16:56:19.107075	ordnumber_
1862	240	938	SAVED	Buchungsnummer = 240	2012-10-09 16:57:23.268956	ordnumber_
1863	241	938	SAVED	Buchungsnummer = 241	2012-10-09 16:58:47.44105	ordnumber_
1864	242	938	SAVED	Buchungsnummer = 242	2012-10-09 16:59:53.901046	ordnumber_
1865	243	938	SAVED	Buchungsnummer = 243	2012-10-09 17:01:15.1033	ordnumber_
1866	244	938	SAVED	Buchungsnummer = 244	2012-10-09 17:02:19.919289	ordnumber_
1867	245	938	SAVED	Buchungsnummer = 245	2012-10-09 17:03:27.957492	ordnumber_
1868	246	938	SAVED	Buchungsnummer = 246	2012-10-09 17:11:10.270535	ordnumber_
1869	247	938	SAVED	Buchungsnummer = 247	2012-10-09 17:13:16.249728	ordnumber_
1870	227	1473	STORNO	\N	2012-10-09 21:06:02.140822	ordnumber_
1873	1754	1871	SAVED	\N	2012-11-15 14:20:14.498979	customernumber_10001
1875	1752	1871	SAVED	\N	2012-11-15 14:25:11.271208	partnumber_109
1877	1876	1871	SAVED	\N	2012-11-15 14:28:56.065721	ordnumber_1
1878	1876	1871	SCREENED	sales_order	2012-11-15 14:28:59.867199	ordnumber_1
1879	1876	1871	SAVED	\N	2012-11-15 14:30:11.898787	ordnumber_1
1880	1876	1871	SCREENED	sales_order	2012-11-15 14:30:17.465226	ordnumber_1
1882	1881	1871	SAVED	\N	2012-11-15 14:31:04.368911	donumber_1
1883	1881	1871	SCREENED	sales_delivery_order	2012-11-15 14:31:09.497953	ordnumber_1
1884	249	1871	PRINTED AND POSTED	\N	2012-11-15 14:31:30.569249	invnumber_16
1885	249	1871	SCREENED	invoice	2012-11-15 14:31:49.774101	ordnumber_1
1889	1888	1871	SAVED	\N	2012-11-15 14:40:20.887094	partnumber_1
1892	1891	1871	SAVED	\N	2012-11-15 14:44:56.005868	ordnumber_2
1893	1891	1871	SCREENED	sales_order	2012-11-15 14:44:59.766183	ordnumber_2
1894	1891	1871	SAVED	\N	2012-11-15 14:46:21.683429	ordnumber_2
1895	1891	1871	SCREENED	sales_order	2012-11-15 14:46:23.794953	ordnumber_2
1897	1896	1871	SAVED	\N	2012-11-15 14:47:30.101532	donumber_2
1899	1896	1871	SAVED	\N	2012-11-15 14:48:01.469604	donumber_2
1901	1896	1871	SAVED	\N	2012-11-15 14:48:22.33699	donumber_2
1903	1896	1871	SCREENED	sales_delivery_order	2012-11-15 14:48:36.853602	ordnumber_
1904	\N	1871	SCREENED	invoice	2012-11-15 14:49:00.42511	ordnumber_
1905	\N	1871	SCREENED	invoice	2012-11-15 14:49:46.916333	ordnumber_
\.


--
-- Data for Name: inventory; Type: TABLE DATA; Schema: public; Owner: -
--

COPY inventory (warehouse_id, parts_id, oe_id, orderitems_id, shippingdate, employee_id, itime, mtime, bin_id, qty, trans_id, trans_type_id, project_id, chargenumber, comment, bestbefore, id) FROM stdin;
969	1107	1441	\N	2012-09-12	1213	2012-05-01 12:00:00	2012-10-08 15:01:59.878237	971	280.00000	1452	945	\N		eingelagert	\N	20
969	1100	1441	\N	2012-09-12	1213	2012-05-01 12:00:00	2012-10-08 15:01:59.878237	970	550000.00000	1453	945	\N		eingelagert	\N	21
969	1103	1441	\N	2012-09-12	1213	2012-05-01 12:00:00	2012-10-08 15:01:59.878237	972	530.00000	1454	945	\N		eingelagert	\N	22
969	1105	1441	\N	2012-09-12	1213	2012-05-01 12:00:00	2012-10-08 15:01:59.878237	973	180.00000	1455	945	\N		eingelagert	\N	23
969	1183	1503	\N	2012-09-12	938	2012-06-11 12:00:00	2012-10-08 15:01:59.878237	989	1.00000	1507	945	\N		eingelagert	\N	34
969	1180	1503	\N	2012-09-12	938	2012-06-11 12:00:00	2012-10-08 15:01:59.878237	990	1.00000	1508	945	\N		eingelagert	\N	35
969	1404	1512	\N	2012-09-12	938	2012-07-09 12:00:00	2012-10-08 15:01:59.878237	991	1.00000	1515	945	\N		eingelagert	\N	36
969	1174	1525	\N	2012-09-12	938	2012-08-13 12:00:00	2012-10-08 15:01:59.878237	992	1.00000	1528	945	\N		eingelagert	\N	37
969	1144	1529	\N	2012-09-12	1213	2012-08-13 12:00:00	2012-10-08 15:01:59.878237	974	330000.00000	1532	945	\N		eingelagert	\N	38
969	1117	1540	\N	2012-09-12	1213	2012-09-10 12:00:00	2012-10-08 15:01:59.878237	977	29.00000	1547	945	\N		eingelagert	\N	39
969	1123	1540	\N	2012-09-12	1213	2012-09-10 12:00:00	2012-10-08 15:01:59.878237	979	9.00000	1548	945	\N		eingelagert	\N	40
969	1119	1540	\N	2012-09-12	1213	2012-09-10 12:00:00	2012-10-08 15:01:59.878237	976	4.00000	1549	945	\N		eingelagert	\N	41
969	1121	1540	\N	2012-09-12	1213	2012-09-10 12:00:00	2012-10-08 15:01:59.878237	978	4.00000	1550	945	\N		eingelagert	\N	42
969	1115	1540	\N	2012-09-12	1213	2012-09-10 12:00:00	2012-10-08 15:01:59.878237	975	145.00000	1551	945	\N		eingelagert	\N	43
969	1147	1572	\N	2012-09-12	938	2012-11-30 12:00:00	2012-10-08 15:01:59.878237	993	70.00000	1577	945	\N		eingelagert	\N	44
969	1149	1572	\N	2012-09-12	938	2012-11-30 12:00:00	2012-10-08 15:01:59.878237	994	65.00000	1578	945	\N		eingelagert	\N	45
969	1152	1572	\N	2012-09-12	938	2012-11-30 12:00:00	2012-10-08 15:01:59.878237	995	260.00000	1579	945	\N		eingelagert	\N	46
969	1581	1586	\N	2012-09-12	1213	2012-09-12 12:00:00	2012-10-08 15:01:59.878237	996	6.00000	1590	945	\N		eingelagert	\N	47
969	1581	1586	\N	2012-09-12	1213	2012-09-12 12:00:00	2012-10-08 15:01:59.878237	997	6.00000	1591	945	\N		eingelagert	\N	48
969	1135	1476	\N	2012-09-12	1213	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	988	1.00000	1483	945	\N		eingelagert	\N	30
958	1098	1484	\N	2012-09-12	938	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	963	1.00000	1488	945	\N		eingelagert	\N	31
958	1098	1484	\N	2012-09-12	938	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	964	1.00000	1489	945	\N		eingelagert	\N	32
969	1742	1746	\N	2012-09-21	1213	2012-06-08 12:00:00	2012-10-08 15:23:44.408155	998	1.00000	1749	945	\N		eingelagert	\N	107
956	1093	1412	\N	2012-09-12	938	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	957	4500.00000	1415	945	\N		eingelagert	\N	13
969	1137	1419	\N	2012-09-12	1213	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	980	40.00000	1426	945	\N		eingelagert	\N	14
969	1137	1419	\N	2012-09-12	1213	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	982	40.00000	1428	945	\N		eingelagert	\N	16
969	1137	1419	\N	2012-09-12	1213	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	981	40.00000	1427	945	\N		eingelagert	\N	15
969	1137	1419	\N	2012-09-12	1213	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	983	40.00000	1429	945	\N		eingelagert	\N	17
969	1137	1419	\N	2012-09-12	1213	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	984	40.00000	1430	945	\N		eingelagert	\N	18
956	1093	1494	\N	2012-09-12	1213	2012-01-13 12:00:00	2012-10-08 15:01:59.878237	957	12000.00000	1497	945	\N		eingelagert	\N	33
969	1100	\N	\N	2012-08-30	938	2012-08-30 10:20:51.049728	2012-10-08 15:02:17.908092	970	50000.00000	1198	945	\N		eingelagert	\N	1
969	1107	\N	\N	2012-08-30	938	2012-08-30 10:24:45.342919	2012-10-08 15:02:17.908092	971	20.00000	1199	945	\N		eingelagert	\N	2
969	1103	\N	\N	2012-08-30	938	2012-08-30 10:25:13.748993	2012-10-08 15:02:17.908092	972	70.00000	1200	945	\N		eingelagert	\N	3
969	1105	\N	\N	2012-08-30	938	2012-08-30 10:25:38.107343	2012-10-08 15:02:17.908092	973	20.00000	1201	945	\N		eingelagert	\N	4
969	1144	\N	\N	2012-08-30	938	2012-08-30 10:26:38.270782	2012-10-08 15:02:17.908092	974	20000.00000	1202	945	\N		eingelagert	\N	5
956	1091	\N	\N	2012-08-30	938	2012-08-30 10:28:47.04193	2012-10-08 15:02:17.908092	957	3000.00000	1203	945	\N		eingelagert	\N	6
956	1093	\N	\N	2012-08-30	938	2012-08-30 10:28:59.508877	2012-10-08 15:02:17.908092	957	500.00000	1204	945	\N		eingelagert	\N	7
969	1115	\N	\N	2012-08-30	938	2012-08-30 10:30:16.154689	2012-10-08 15:02:17.908092	975	5.00000	1205	945	\N		eingelagert	\N	8
969	1119	\N	\N	2012-08-30	938	2012-08-30 10:30:39.865939	2012-10-08 15:02:17.908092	976	1.00000	1206	945	\N		eingelagert	\N	9
969	1117	\N	\N	2012-08-30	938	2012-08-30 10:31:10.054278	2012-10-08 15:02:17.908092	977	1.00000	1207	945	\N		eingelagert	\N	10
969	1121	\N	\N	2012-08-30	938	2012-08-30 10:31:27.06686	2012-10-08 15:02:17.908092	978	1.00000	1208	945	\N		eingelagert	\N	11
969	1123	\N	\N	2012-08-30	938	2012-08-30 10:31:41.707167	2012-10-08 15:02:17.908092	979	1.00000	1209	945	\N		eingelagert	\N	12
969	1742	\N	\N	2012-10-08	1473	2012-06-29 12:00:00	2012-10-08 15:22:34.698576	998	-1.00000	1819	948	\N		verbraucht Juni	\N	108
969	1137	\N	\N	2012-06-29	938	2012-02-29 12:00:00	2012-10-08 15:25:29.150539	981	-40.00000	1683	948	\N		verbraucht Februar	\N	62
956	1091	\N	\N	2012-04-30	938	2012-04-30 12:00:00	2012-10-08 14:46:43.407423	957	-600.00000	1673	948	\N		verbraucht April	\N	52
956	1091	\N	\N	2012-02-29	938	2012-02-29 12:00:00	2012-10-08 14:46:43.407423	957	-600.00000	1671	948	\N		verbraucht Februar	\N	50
956	1093	\N	\N	2012-04-30	938	2012-04-30 12:00:00	2012-10-08 14:46:43.407423	957	-3400.00000	1680	948	\N		verbraucht April	\N	59
969	1137	\N	\N	2012-04-30	938	2012-04-30 12:00:00	2012-10-08 14:46:43.407423	983	-40.00000	1685	948	\N		verbraucht April	\N	64
956	1091	\N	\N	2012-03-30	938	2012-03-30 12:00:00	2012-10-08 14:46:43.407423	957	-600.00000	1672	948	\N		verbraucht März	\N	51
956	1093	\N	\N	2012-03-30	938	2012-03-30 12:00:00	2012-10-08 14:46:43.407423	957	-3400.00000	1679	948	\N		verbraucht März	\N	58
969	1137	\N	\N	2012-03-30	938	2012-03-30 12:00:00	2012-10-08 14:46:43.407423	982	-40.00000	1684	948	\N		verbraucht März	\N	63
956	1091	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	957	-600.00000	1674	948	\N		verbraucht Mai	\N	53
956	1093	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	957	-3400.00000	1681	948	\N		verbraucht Mai	\N	60
969	1137	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	984	-40.00000	1686	948	\N		verbraucht Mai	\N	65
969	1100	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	970	-300000.00000	1692	948	\N		verbraucht Juni	\N	71
969	1103	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	972	-300.00000	1693	948	\N		verbraucht Juni	\N	72
969	1105	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	973	-100.00000	1694	948	\N		verbraucht Juni	\N	73
958	1098	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	964	-1.00000	1700	948	\N		verbraucht Juli	\N	79
958	1111	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	961	-1.00000	1701	948	\N		verbraucht Juli	\N	80
958	1111	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	962	-1.00000	1702	948	\N		verbraucht Juli	\N	81
969	1103	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	972	-300.00000	1689	948	\N		verbraucht Mai	\N	68
956	1093	\N	\N	2012-01-31	938	2012-01-31 12:00:00	2012-10-08 14:46:43.407423	957	-3.40000	1675	948	\N		verbraucht Januar	\N	54
956	1093	\N	\N	2012-02-29	938	2012-02-29 12:00:00	2012-10-08 14:46:43.407423	957	-3400.00000	1678	948	\N		verbraucht Februar	\N	57
969	1107	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	971	-150.00000	1695	948	\N		verbraucht Juni	\N	74
958	1098	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	963	-1.00000	1696	948	\N		verbraucht Juni	\N	75
958	1111	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	959	-1.00000	1697	948	\N		verbraucht Juni	\N	76
969	1117	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	977	-15.00000	1719	948	\N		verbraucht September	\N	98
969	1144	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	974	-200000.00000	1712	948	\N		verbraucht September	\N	91
969	1115	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	975	-0.07500	1713	948	\N		verbraucht September	\N	92
958	1111	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	960	-1.00000	1698	948	\N		verbraucht Juni	\N	77
969	1133	\N	\N	2012-06-29	938	2012-06-29 12:00:00	2012-10-08 14:46:43.407423	986	-1.00000	1699	948	\N		verbraucht Juni	\N	78
969	1119	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	976	-0.00250	1714	948	\N		verbraucht September	\N	93
969	1117	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	977	-0.01500	1715	948	\N		verbraucht September	\N	94
969	1121	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	978	-2.50000	1716	948	\N		verbraucht September	\N	95
969	1115	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	975	-75.00000	1717	948	\N		verbraucht September	\N	96
969	1119	\N	\N	2012-09-28	938	2012-09-28 12:00:00	2012-10-08 14:46:43.407423	976	-2.50000	1718	948	\N		verbraucht September	\N	97
969	1142	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	985	-1.00000	1687	948	\N		verbraucht Mai	\N	66
969	1100	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	970	-300000.00000	1688	948	\N		verbraucht Mai	\N	67
969	1105	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	973	-100.00000	1690	948	\N		verbraucht Mai	\N	69
956	1093	\N	\N	2012-01-31	938	2012-01-31 12:00:00	2012-10-08 14:46:43.407423	957	-3400.00000	1676	948	\N		verbraucht Januar	\N	55
956	1093	\N	\N	2012-01-31	938	2012-01-31 12:00:00	2012-10-08 14:46:43.407423	957	3.40000	1677	945	\N		Januar Korrektur	\N	56
969	1137	\N	\N	2012-01-31	938	2012-01-31 12:00:00	2012-10-08 14:46:43.407423	980	-40.00000	1682	948	\N		verbraucht Januar	\N	61
956	1091	\N	\N	2012-01-31	938	2012-01-31 12:00:00	2012-10-08 14:46:43.407423	957	-600.00000	1670	948	\N		verbraucht Januar	\N	49
969	1133	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	987	-1.00000	1703	948	\N		verbraucht Juli	\N	82
969	1183	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	989	-1.00000	1704	948	\N		verbraucht Juli	\N	83
969	1180	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	990	-1.00000	1705	948	\N		verbraucht Juli	\N	84
969	1135	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	988	-1.00000	1706	948	\N		verbraucht Juli	\N	85
969	1404	\N	\N	2012-07-31	938	2012-07-31 12:00:00	2012-10-08 14:46:43.407423	991	-1.00000	1707	948	\N		verbraucht Juli	\N	86
969	1174	\N	\N	2012-08-31	938	2012-08-31 12:00:00	2012-10-08 14:46:43.407423	992	-1.00000	1708	948	\N		verbraucht August	\N	87
969	1144	\N	\N	2012-08-31	938	2012-08-31 12:00:00	2012-10-08 14:46:43.407423	974	-150000.00000	1709	948	\N		verbraucht August	\N	88
969	1581	\N	\N	2012-08-31	938	2012-08-31 12:00:00	2012-10-08 14:46:43.407423	996	-6.00000	1710	948	\N		verbraucht August	\N	89
969	1581	\N	\N	2012-08-31	938	2012-08-31 12:00:00	2012-10-08 14:46:43.407423	997	-6.00000	1711	948	\N		verbraucht August	\N	90
969	1115	\N	\N	2012-10-31	938	2012-10-31 12:00:00	2012-10-08 14:46:43.407423	975	-74.92500	1720	948	\N		verbraucht Oktober	\N	99
969	1117	\N	\N	2012-10-31	938	2012-10-31 12:00:00	2012-10-08 14:46:43.407423	977	-14.98500	1721	948	\N		verbraucht Oktober	\N	100
969	1119	\N	\N	2012-10-31	938	2012-10-31 12:00:00	2012-10-08 14:46:43.407423	976	-2.49750	1722	948	\N		verbraucht Oktober	\N	101
969	1121	\N	\N	2012-10-31	938	2012-10-31 12:00:00	2012-10-08 14:46:43.407423	978	-2.50000	1723	948	\N		verbraucht Oktober	\N	102
969	1123	\N	\N	2012-10-31	938	2012-10-31 12:00:00	2012-10-08 14:46:43.407423	979	-10.00000	1724	948	\N		verbraucht Oktober	\N	103
969	1147	\N	\N	2012-11-30	938	2012-11-30 12:00:00	2012-10-08 14:46:43.407423	993	-70.00000	1725	948	\N		verbraucht November	\N	104
969	1149	\N	\N	2012-11-30	938	2012-11-30 12:00:00	2012-10-08 14:46:43.407423	994	-65.00000	1726	948	\N		verbraucht November	\N	105
969	1152	\N	\N	2012-11-30	938	2012-11-30 12:00:00	2012-10-08 14:46:43.407423	995	-260.00000	1727	948	\N		verbraucht November	\N	106
969	1107	\N	\N	2012-05-31	938	2012-05-31 12:00:00	2012-10-08 14:46:43.407423	971	-150.00000	1691	948	\N		verbraucht Mai	\N	70
958	1111	1459	\N	2012-09-12	938	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	959	1.00000	1465	945	\N		eingelagert	\N	24
958	1111	1459	\N	2012-09-12	938	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	960	1.00000	1466	945	\N		eingelagert	\N	25
958	1111	1459	\N	2012-09-12	938	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	961	1.00000	1467	945	\N		eingelagert	\N	26
958	1111	1459	\N	2012-09-12	938	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	962	1.00000	1468	945	\N		eingelagert	\N	27
969	1133	1476	\N	2012-09-12	1213	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	986	1.00000	1481	945	\N		eingelagert	\N	28
969	1133	1476	\N	2012-09-12	1213	2012-05-14 12:00:00	2012-10-08 15:01:59.878237	987	1.00000	1482	945	\N		eingelagert	\N	29
969	1142	1434	\N	2012-09-12	938	2012-05-01 12:00:00	2012-10-08 15:01:59.878237	985	1.00000	1437	945	\N		eingelagert	\N	19
958	1888	\N	\N	2012-11-15	1871	2012-11-15 14:42:37.855921	\N	959	100.00000	1890	945	\N			\N	109
958	1888	1896	\N	2012-11-15	1871	2012-11-15 14:48:22.490264	\N	959	-3.00000	1902	955	\N		\N	\N	110
\.


--
-- Data for Name: invoice; Type: TABLE DATA; Schema: public; Owner: -
--

COPY invoice (id, trans_id, parts_id, description, qty, allocated, sellprice, fxsellprice, discount, assemblyitem, project_id, deliverydate, serialnumber, itime, mtime, pricegroup_id, ordnumber, transdate, cusordnumber, unit, base_qty, subtotal, longdescription, marge_total, marge_percent, lastcost, price_factor_id, price_factor, marge_price_factor) WITH OIDS FROM stdin;
330278	1	158	1192	Design "OIDABLU"	-1	0	28037.38000	30000.00000	0	f	\N	\N		2012-09-12 11:31:38.368947	\N	\N	\N	\N	\N	psch	-1	f		\N	\N	\N	\N	\N	\N
330279	2	159	1093	Schiffbaustahl 2HGr50 (Qualitätstechnik)	-4500	0	420.17000	500.00000	0	f	1020	\N		2012-09-12 11:46:35.764079	\N	\N	\N	\N	\N	t	-4500	f	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	\N	\N	\N	\N	\N	\N
330280	3	160	1137	Rohrleitungen	-200	0	5882.35000	7000.00000	0	f	1020	\N		2012-09-12 11:51:00.529905	\N	\N	\N	\N	\N	km	-200	f	vorgefertigte Rohrleitungen	\N	\N	\N	\N	\N	\N
330281	4	161	1142	Elektronik-Pack OIDA/Igel	-1	0	823529.41000	980000.00000	0	f	1020	\N		2012-09-12 11:55:21.123487	\N	\N	\N	\N	\N	Stck	-1	f	Eigen in Auftrag gegebenes Produktpaket aus Kabelschächten, -führungen, Stecker und -leisten	\N	\N	\N	\N	\N	\N
330282	5	162	1107	Fernmelde-Schiffskabel FMKHC	-280	0	857.14000	1020.00000	0	f	\N	\N		2012-09-12 12:00:50.338662	\N	\N	\N	\N	\N	km	-280	f	Halogen geben, feuerbeständiges Marinekommunikationskabel mit screend Standard	\N	\N	\N	\N	\N	\N
330283	6	162	1100	Kabel und Leitungen H03VV-F	-550	0	336.13000	400.00000	0	f	\N	\N		2012-09-12 12:00:50.338662	\N	\N	\N	\N	\N	km	-550000	f	H03VV-F 3x0,75 - Leichte PVC-Schlauchleitung\r\nfeindrähtig, Ring 50 Meter\r\nFarbe: schwarz\r\nNach DIN VDE 0281\r\n	\N	\N	\N	\N	\N	\N
330284	7	162	1103	Kabel und Leitungen SiHF-J	-530	0	2016.81000	2400.00000	0	f	\N	\N		2012-09-12 12:00:50.338662	\N	\N	\N	\N	\N	km	-530	f	feindrähtiger Kupferlitzenleiter verzinnt, Farbe: rot-braun, Flammwidrig nach VDE 0472 Teil 804 Prüfart C	\N	\N	\N	\N	\N	\N
330285	8	162	1105	Starkstrom-Schiffskabel MPRXCX 	-180	0	4201.68000	5000.00000	0	f	\N	\N		2012-09-12 12:00:50.338662	\N	\N	\N	\N	\N	km	-180	f	Cu-Litze blank, Verlitzung nach Klasse 2\r\nIsolation aus vernetztem XLPE\r\nAußenmantel Polyolefin, Farbe Schwarz	\N	\N	\N	\N	\N	\N
330286	9	163	1111	Dieselmotor 9M43D	-4	0	4201680.67000	5000000.00000	0	f	1020	\N		2012-09-12 12:11:50.790617	\N	\N	\N	\N	\N	Stck	-4	f	9.000 kW (12237 PS)	\N	\N	\N	\N	\N	\N
330287	10	164	1133	SRP Propeller	-2	0	571428.57000	680000.00000	0	f	1020	\N		2012-09-12 12:16:58.361196	\N	\N	\N	\N	\N	Stck	-2	f	5-Blatt-Festpropeller, Balance-Ruder	\N	\N	\N	\N	\N	\N
330288	11	164	1135	SST Steuer und Regelsystem	-1	0	436974.79000	520000.00000	0	f	1020	\N		2012-09-12 12:16:58.361196	\N	\N	\N	\N	\N	Stck	-1	f	computerunterstütztes, ferngesteuertes Joystick-System	\N	\N	\N	\N	\N	\N
330289	12	165	1098	Elektrischer Propellermotor S-12/5	-2	0	6722689.08000	8000000.00000	0	f	\N	\N		2012-09-12 12:17:13.904978	\N	\N	\N	\N	\N	Stck	-2	f	12,5 MW; Wellenanlage\r\nMaschinenleistung: 12.500 kW (16996 PS)	\N	\N	\N	\N	\N	\N
330290	13	166	1093	Schiffbaustahl 2HGr50 (Qualitätstechnik)	-12000	0	353.08000	420.17000	0	f	1020	\N		2012-09-12 12:34:31.518335	\N	\N	\N	\N	\N	t	-12000	f	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	\N	\N	\N	\N	\N	\N
330291	14	167	1183	Lautsprecheranlage	-1	0	67226.89000	80000.00000	0	f	1020	\N		2012-09-12 12:40:21.584179	\N	\N	\N	\N	\N	Stck	-1	f		\N	\N	\N	\N	\N	\N
330292	15	167	1180	SecuritySystem	-1	0	126050.42000	150000.00000	0	f	1020	\N		2012-09-12 12:40:21.584179	\N	\N	\N	\N	\N	Stck	-1	f	Alarmanlagen, Messsensoren, Videoüberwachungsanlage	\N	\N	\N	\N	\N	\N
330293	16	168	1404	Anker	-1	0	70000.00000	70000.00000	0	f	1020	\N		2012-09-12 12:51:04.811484	\N	\N	\N	\N	\N	Stck	-1	f		\N	\N	\N	\N	\N	\N
330294	17	169	1156	B&C Glasprojekt "OIDAblu"	-1	0	294117.65000	350000.00000	0	f	1020	\N		2012-09-12 14:03:23.525778	\N	\N	\N	\N	\N	psch	-1	f	Außen und Innenverglasung komplett\r\ninsgesamt 4600 m² Glas (Dünn-, Float-, Panzer-, Weiß-, Spiegelglas)\r\nPlus Mitarbeiterkosten	\N	\N	\N	\N	\N	\N
330295	18	170	1174	Paket Schiffsinnenbau "Kule"	-1	0	840336.13000	1000000.00000	0	f	\N	\N		2012-09-12 14:07:26.811402	\N	\N	\N	\N	\N	psch	-1	f	Feuerschutztüren, Schichtstoffplatten HPL, Furniere MIneralwerkstoff, Wand- und Deckenpaneel	\N	\N	\N	\N	\N	\N
330296	19	171	1144	Ultimate Mineralwolle	-330000	0	2.44000	2.90000	0	f	1020	\N		2012-09-12 14:08:20.092458	\N	\N	\N	\N	\N	m²	-330000	f	Hochleistungsdämmstoff für Wärme- und Schalldämmung	\N	\N	\N	\N	\N	\N
330297	20	172	1158	Sanitäre Anlagen + Wellnessbereiche Rundum-Sorglos-Paket	-1	0	3907563.03000	4650000.00000	0	f	\N	\N		2012-09-12 14:14:06.926166	\N	\N	\N	\N	\N	psch	-1	f	1600 Toiletten, 1500 Duschen, 1700 Waschbecken, sanitäre Einrichtung für Luxussuiten, Saunabereiche, Wellnessbereiche	\N	\N	\N	\N	\N	\N
330298	21	173	1117	Siloblau Fassade AE 1730	-29	0	6672.27000	7940.00000	0	f	1020	\N		2012-09-12 14:16:01.336668	\N	\N	\N	\N	\N	t	-29	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	\N	\N	\N	\N	\N	\N
330299	22	173	1123	Silogelb Fassade AF 2550	-9	0	6672.27000	7940.00000	0	f	1020	\N		2012-09-12 14:16:01.336668	\N	\N	\N	\N	\N	t	-9	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	\N	\N	\N	\N	\N	\N
330300	23	173	1119	Silorot Fassade AF 2550	-4	0	6672.27000	7940.00000	0	f	1020	\N		2012-09-12 14:16:01.336668	\N	\N	\N	\N	\N	t	-4	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	\N	\N	\N	\N	\N	\N
330301	24	173	1121	Siloschwarz fassade A0 000	-4	0	6672.27000	7940.00000	0	f	1020	\N		2012-09-12 14:16:01.336668	\N	\N	\N	\N	\N	t	-4	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	\N	\N	\N	\N	\N	\N
330302	25	173	1115	Siloweiß Fassade AF 5040	-145	0	4453.78000	5300.00000	0	f	1020	\N		2012-09-12 14:16:01.336668	\N	\N	\N	\N	\N	t	-145	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	\N	\N	\N	\N	\N	\N
330303	27	175	1161	Innenausbau "Veranstaltungs- und Verpflegungsräumeräume"	-1	0	4453781.51000	5300000.00000	0	f	\N	\N		2012-09-12 14:26:50.138796	\N	\N	\N	\N	\N	psch	-1	f	Schiffsinnenbau der Veranstaltungsräume: 4D Kino, Casino, 4 Discotheken, 15 Restaurants, Crewkantine, Theatrium, Messehalle, 11 Bars	\N	\N	\N	\N	\N	\N
330304	28	176	1167	Innenausbau "Passagiere + Gänge"	-1	0	1764705.88000	2100000.00000	0	f	1020	\N		2012-09-12 14:30:44.163604	\N	\N	\N	\N	\N	psch	-1	f	Schiffsinnenbau: alle 1096 Passagierkabinen, Gänge und Treppenhäuser	\N	\N	\N	\N	\N	\N
330305	29	177	1154	Malerarbeiten	-50	0	1092.44000	1300.00000	0	f	1020	\N		2012-09-12 14:34:33.16189	\N	\N	\N	\N	\N	Tag	-50	f		\N	\N	\N	\N	\N	\N
330306	30	178	1164	Innenausbau "Crew und Luxus"	-1	0	1411764.71000	1680000.00000	0	f	\N	\N		2012-09-12 14:38:20.675653	\N	\N	\N	\N	\N	psch	-1	f	Schiffsinnenbau "Crew und Luxus": Ausbau des Crewbereichs mit 600 Crew Kabinen, 3 Kapitänskabinen, Eine Discothek und eine Bar extra für die Crew + Luxussuiten (23)	\N	\N	\N	\N	\N	\N
330307	31	179	1185	"schiffseigene Brauerei" + Einbau	-1	0	168067.23000	200000.00000	0	f	\N	\N		2012-09-12 14:41:19.85977	\N	\N	\N	\N	\N	psch	-1	f		\N	\N	\N	\N	\N	\N
330308	33	180	1149	Zypresse	-65	0	98.13000	105.00000	0	f	\N	\N		2012-09-12 14:44:44.722246	\N	\N	\N	\N	\N	Stck	-65	f	stabilisiert	\N	\N	\N	\N	\N	\N
330309	34	180	1152	Hecke	-260	0	3.36000	3.60000	0	f	\N	\N		2012-09-12 14:44:44.722246	\N	\N	\N	\N	\N	m²	-260	f	stabilisiert	\N	\N	\N	\N	\N	\N
330310	35	181	1581	Rettungsboot	-12	0	150000.00000	150000.00000	0	f	\N	\N		2012-09-12 14:56:01.117455	\N	\N	\N	\N	\N	Stck	-12	f		\N	\N	\N	\N	\N	\N
330311	40	206	1742	Anti-Piracy SystemXT 4000	-1	0	522730.00000	650000.00000	0	f	\N	\N		2012-09-21 14:43:12.462592	\N	\N	\N	\N	\N	Stck	-1	f		\N	\N	\N	\N	\N	\N
330316	32	180	1147	Palme	-70	0	234.11000	250.50000	0	f	\N	\N		2012-09-12 14:44:44.722246	2012-10-08 15:34:30.042286	\N	\N	\N	\N	Stck	-70	f	blaue Hesperidenpalme, stabilisiert	\N	\N	\N	\N	\N	\N
330324	53	223	1822	Kronleuchter Deluxe 4000	-1	0	120000.00000	120000.00000	0	f	\N	\N		2012-10-08 15:29:43.023031	\N	\N	\N	\N	\N	Stck	-1	f		\N	\N	\N	\N	\N	\N
330325	54	224	1822	Kronleuchter Deluxe 4000	1	0	120000.00000	120000.00000	0	f	\N	\N		2012-10-08 15:30:57.901724	\N	\N	\N	\N	\N	Stck	1	f		\N	\N	\N	\N	\N	\N
330312	42	208	1758	OIDABLU	1	0	350000000.00000	350000000.00000	0	f	\N	\N		2012-09-21 15:31:12.755264	2014-03-03 15:32:20.114896	\N		\N		Stck	1	f		350000000.00000	100.00000	0.00000	\N	\N	\N
330313	43	209	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:32.645385	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330314	44	210	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.068754	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330315	45	211	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.265917	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330317	46	212	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.365752	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330318	47	213	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.491077	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330319	48	214	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.596295	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330320	49	215	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.715663	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330321	50	216	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:33.819959	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330322	51	217	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 15:36:34.018694	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330323	52	222	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-09-21 16:20:17.548256	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330326	55	225	1147	Palme	1	-1	120.00000	120.00000	0	f	\N	\N		2012-10-08 15:34:13.374781	2014-03-03 15:32:20.114896	\N		\N		Stck	1	f	blaue Hesperidenpalme, stabilisiert	-114.11000	-95.09000	234.11000	\N	\N	\N
330327	56	226	1147	Palme	-1	1	120.00000	120.00000	0	f	\N	\N		2012-10-08 15:34:30.042286	2014-03-03 15:32:20.114896	\N		\N		Stck	-1	f	blaue Hesperidenpalme, stabilisiert	0.00000	0.00000	234.11000	\N	\N	\N
330328	57	228	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-10-09 08:49:39.436806	2014-03-03 15:32:20.114896	\N	022012	2011-12-02		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330329	58	229	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-12-12 12:48:18.476016	2014-03-03 15:32:20.114896	\N	022012	2011-12-02		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330330	59	230	1752	Vermietung Baudock A1	1	\N	20000.00000	20000.00000	0	f	\N	\N		2012-12-12 12:48:18.77791	2014-03-03 15:32:20.114896	\N	022012	2011-12-02		Monat	1	f		20000.00000	100.00000	0.00000	\N	1.00000	1.00000
330331	60	231	1752	Vermietung Baudock A1	-1	0	20000.00000	20000.00000	0	f	\N	\N		2012-10-09 08:58:55.226341	2014-03-03 15:32:20.114896	\N	022012	02.12.2011		Monat	-1	f		0.00000	0.00000	0.00000	\N	\N	1.00000
330332	61	249	1752	Vermietung Baudock A1	1	0	18000.00000	20000.00000	0.1	f	\N	\N		2012-11-15 14:31:30.163919	2014-03-03 15:32:20.114896	\N	1	15.11.2012		Monat	1	f		18000.00000	100.00000	0.00000	\N	\N	\N
\.


--
-- Data for Name: language; Type: TABLE DATA; Schema: public; Owner: -
--

COPY language (id, description, template_code, article_code, itime, mtime, output_numberformat, output_dateformat, output_longdates) FROM stdin;
\.


--
-- Data for Name: leads; Type: TABLE DATA; Schema: public; Owner: -
--

COPY leads (id, lead) FROM stdin;
\.


--
-- Data for Name: makemodel; Type: TABLE DATA; Schema: public; Owner: -
--

COPY makemodel (parts_id, model, itime, mtime, lastcost, lastupdate, sortorder, make, id) FROM stdin;
1325		2012-09-12 15:45:14.073777	\N	3.27000	2012-09-12	\N	1323	129
1154		2012-09-12 15:46:05.595233	\N	1008.40000	2012-09-12	\N	1052	130
1156		2012-09-12 15:46:27.153693	\N	294117.65000	2012-09-12	\N	1035	131
1158		2012-09-12 15:47:17.323244	\N	3907563.03000	2012-09-12	\N	1039	132
1161		2012-09-12 15:47:55.224391	\N	4453781.51000	2012-09-12	\N	1041	133
1164		2012-09-12 15:48:27.302392	\N	1411764.71000	2012-09-12	\N	1043	134
1167		2012-09-12 15:49:06.549545	\N	1764705.88000	2012-09-12	\N	1059	135
1192		2012-09-12 15:50:24.27276	\N	28037.38000	2012-09-12	\N	1190	137
1147		2012-09-12 15:52:32.22978	\N	234.11000	2012-09-12	\N	1085	138
1149		2012-09-12 15:53:13.913214	\N	98.13000	2012-09-12	\N	1085	139
1152		2012-09-12 15:54:44.682034	\N	3.36000	2012-09-12	\N	1085	140
1121		2012-09-17 12:23:39.351525	\N	6672.27000	2012-09-12	\N	1062	141
1404		2012-09-12 11:40:06.896653	\N	70000.00000	2012-09-12	\N	1401	68
1581		2012-09-12 14:48:43.764698	\N	150000.00000	2012-09-12	\N	1401	71
1091		2012-09-12 15:35:50.28489	\N	378.15000	2012-09-12	\N	1028	104
1093		2012-09-12 15:36:27.30896	\N	420.17000	2012-09-12	\N	1024	105
1093		2012-09-12 15:36:27.30896	\N	430.00000	2012-09-12	\N	1028	106
1100		2012-09-12 15:37:29.371667	\N	0.34000	2012-09-12	\N	1030	108
1103		2012-09-12 15:37:49.346964	\N	2016.81000	2012-09-12	\N	1030	109
1105		2012-09-12 15:38:09.336613	\N	4201.68000	2012-09-12	\N	1030	110
1107		2012-09-12 15:38:32.923024	\N	857.14000	2012-09-12	\N	1030	111
1115		2012-09-12 15:39:26.142799	\N	4453.78000	2012-09-12	\N	1062	113
1117		2012-09-12 15:39:47.543439	\N	6672.27000	2012-09-12	\N	1062	114
1119		2012-09-12 15:40:01.563961	\N	6672.27000	2012-09-12	\N	1062	115
1123		2012-09-12 15:40:39.068384	\N	6672.27000	2012-09-12	\N	1062	117
1135		2012-09-12 15:41:31.664517	\N	436974.79000	2012-09-12	\N	1074	119
1137		2012-09-12 15:41:52.665781	\N	5882.35000	2012-09-12	\N	1076	120
1142		2012-09-12 15:42:22.081404	\N	823529.41000	2012-09-12	\N	1139	121
1144		2012-09-12 15:42:39.474494	\N	2.44000	2012-09-12	\N	1082	122
1174		2012-09-12 15:43:53.978366	\N	840336.13000	2012-09-12	\N	1050	126
1180		2012-09-12 15:44:18.933991	\N	126050.42000	2012-09-12	\N	1078	127
1183	67226,89	2012-09-12 15:44:44.219142	\N	0.00000	2012-08-21	\N	1078	128
1742		2012-09-21 14:32:13.03265	\N	650000.00000	2012-09-21	\N	1397	142
1098		2012-09-25 20:53:02.354239	\N	6722689.08000	2012-09-12	\N	1022	145
1185		2012-09-25 20:54:46.818525	\N	168067.23000	2012-09-12	\N	1080	147
1133		2012-09-26 15:48:14.312329	\N	571428.57000	2012-09-12	\N	1074	151
1822		2012-10-08 16:04:40.898607	\N	0.00000	2012-10-08	\N	1821	153
1111		2012-10-09 14:51:21.834154	\N	4201680.67000	2012-10-09	\N	1032	156
1752		2012-11-15 14:25:11.163726	\N	15000.00000	2012-11-15	\N	1349	157
1888		2012-11-15 14:40:20.793225	\N	50.00000	2012-11-15	1	1078	158
1888		2012-11-15 14:40:20.793225	\N	51.00000	2012-11-15	2	1035	159
\.


--
-- Data for Name: notes; Type: TABLE DATA; Schema: public; Owner: -
--

COPY notes (id, subject, body, created_by, trans_id, trans_module, itime, mtime) FROM stdin;
\.


--
-- Data for Name: oe; Type: TABLE DATA; Schema: public; Owner: -
--

COPY oe (id, ordnumber, transdate, vendor_id, customer_id, amount, netamount, reqdate, taxincluded, shippingpoint, notes, employee_id, closed, quotation, quonumber, cusordnumber, intnotes, department_id, itime, mtime, shipvia, cp_id, language_id, payment_id, delivery_customer_id, delivery_vendor_id, taxzone_id, proforma, shipto_id, globalproject_id, delivered, salesman_id, marge_total, marge_percent, transaction_description, delivery_term_id, currency_id) FROM stdin;
1399	201201	2011-12-19	1190	\N	30000.00000	28037.38000	2012-01-02	t			938	t	f				\N	2012-09-12 11:29:38.282667	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1474	201208	2012-05-07	1022	\N	16000000.00000	13445378.15000	2012-05-14	t			938	t	f				\N	2012-09-12 12:15:01.242133	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1535	201218	2012-09-03	1062	\N	1133740.00000	952722.69000	2012-09-10	t			1213	t	f				\N	2012-09-12 14:10:55.722844	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1555	201219	2012-09-03	1041	\N	5300000.00000	4453781.51000	2012-10-01	t			938	t	f				\N	2012-09-12 14:23:49.864891	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1559	201220	2012-09-03	1059	\N	2100000.00000	1764705.88000	2012-10-29	t			1213	t	f				\N	2012-09-12 14:28:53.72387	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1553	201221	2012-09-12	1052	\N	65000.00000	54621.85000	2012-09-17	t			1213	t	f				\N	2012-09-12 14:22:51.838575	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1492	201202	2012-01-04	1028	\N	5042040.00000	4237008.40000	2012-01-13	t			1213	t	f				\N	2012-09-12 12:24:02.918401	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1410	201203	2012-01-04	1024	\N	2250000.00000	1890756.30000	2012-01-13	t			938	t	f				\N	2012-09-12 11:42:17.714318	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1416	201204	2012-01-04	1076	\N	1400000.00000	1176470.59000	2012-01-13	t			1213	t	f				\N	2012-09-12 11:45:32.462157	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1584	201205	2012-04-11	1401	\N	1800000.00000	1800000.00000	2012-06-12	f			1213	t	f				\N	2012-09-12 14:51:37.70705	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	1	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1432	201206	2012-04-23	1139	\N	980000.00000	823529.41000	2012-05-01	t			938	t	f				\N	2012-09-12 11:51:52.333051	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1438	201207	2012-04-23	1030	\N	2677600.00000	2250084.03000	2012-05-01	t			1213	t	f				\N	2012-09-12 11:55:03.786392	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1469	201209	2012-05-07	1074	\N	1880000.00000	1579831.93000	2012-05-14	t			1213	t	f				\N	2012-09-12 12:11:04.578595	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1457	201210	2012-05-07	1032	\N	20000000.00000	16806722.69000	2012-05-14	t			938	t	f				\N	2012-09-12 12:07:37.21772	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1744	201211	2012-05-18	1397	\N	650000.00000	650000.00000	2012-06-01	f			1213	t	f				\N	2012-09-21 14:34:23.851411	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	3	f	\N	1020	t	\N	0.00000	0.00000		\N	2
1499	201212	2012-06-01	1078	\N	230000.00000	193277.31000	2012-06-11	t			938	t	f				\N	2012-09-12 12:36:07.551556	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1510	201213	2012-07-02	1401	\N	70000.00000	70000.00000	2012-07-09	f			938	t	f				\N	2012-09-12 12:47:57.191845	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	1	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1517	201214	2012-08-01	1035	\N	350000.00000	294117.65000	2012-08-08	t			1213	t	f				\N	2012-09-12 14:02:22.377664	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1522	201215	2012-08-06	1082	\N	957000.00000	804201.68000	2012-08-13	t			1213	t	f				\N	2012-09-12 14:05:43.130271	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1520	201216	2012-08-06	1050	\N	1000000.00000	840336.13000	2012-08-13	t			938	t	f				\N	2012-09-12 14:04:27.997387	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1537	201217	2012-08-27	1082	\N	4650000.00000	3907563.03000	2012-09-10	t			938	t	f				\N	2012-09-12 14:11:13.342638	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1567	201222	2012-09-27	1080	\N	200000.00000	168067.23000	2012-10-08	t			1213	t	f				\N	2012-09-12 14:39:35.392365	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1564	201223	2012-09-27	1043	\N	1680000.00000	1411764.71000	2012-10-17	t			1213	t	f				\N	2012-09-12 14:36:48.56306	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	f	\N	0.00000	0.00000		\N	1
1569	201224	2012-11-15	1085	\N	25296.00000	23641.12000	2012-11-30	t			938	t	f				\N	2012-09-12 14:41:05.435676	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	1020	t	\N	0.00000	0.00000		\N	1
1756	201126	2011-12-02	\N	1754	23800.00000	20000.00000	2012-01-02	f		Für den Bau ihre neuen Flusskreutzfahrtsflotte vermieten wir Ihnen das Baudock A1 für einen monatlichen Betrag von 23830 €.	938	f	f				\N	2012-09-21 15:13:38.233557	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	\N	f	938	20000.00000	100.00000		\N	1
1876	1	2012-11-15	\N	1754	21420.00000	18000.00000	2012-11-16	f			1871	t	f				\N	2012-11-15 14:28:55.898208	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	\N	t	1871	18000.00000	100.00000		\N	1
1891	2	2012-11-15	\N	1754	192.78000	162.00000	2012-11-16	f			1871	f	f				\N	2012-11-15 14:44:55.775298	2014-03-03 15:32:20.898927		\N	\N	\N	\N	\N	0	f	\N	\N	f	1871	62.00000	38.27160		\N	1
\.


--
-- Data for Name: orderitems; Type: TABLE DATA; Schema: public; Owner: -
--

COPY orderitems (trans_id, parts_id, description, qty, sellprice, discount, project_id, reqdate, ship, serialnumber, id, itime, mtime, pricegroup_id, ordnumber, transdate, cusordnumber, unit, base_qty, subtotal, longdescription, marge_total, marge_percent, lastcost, price_factor_id, price_factor, marge_price_factor) WITH OIDS FROM stdin;
330370	1891	1888	Musterartikel 1	2	90.00000	0.1	\N	\N	0		82	2012-11-15 14:46:21.487196	\N	1874	2	15.11.2012		Stck	2	f		62.00000	38.27000	50.00000	\N	\N	\N
330333	1399	1192	Design "OIDABLU"	1	30000.00000	0	\N	\N	0		1	2012-09-12 11:29:38.282667	2014-03-03 15:32:20.114896	\N		2011-12-19		psch	1	f		28037.38000	100.00000	0.00000	\N	\N	\N
330334	1474	1098	Elektrischer Propellermotor S-12/5	2	8000000.00000	0	\N	\N	0		14	2012-09-12 12:15:01.242133	2014-03-03 15:32:20.114896	\N		2012-05-07		Stck	2	f	12,5 MW; Wellenanlage\r\nMaschinenleistung: 12.500 kW (16996 PS)	13445378.15000	100.00000	0.00000	\N	\N	\N
330335	1492	1093	Schiffbaustahl 2HGr50 (Qualitätstechnik)	12000	420.17000	0	1020	\N	0		44	2012-09-25 21:01:41.487014	2014-03-03 15:32:20.114896	\N	201202-02	2012-01-04		t	12000	f	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	4237008.40000	100.00000	0.00000	\N	\N	\N
330336	1410	1093	Schiffbaustahl 2HGr50 (Qualitätstechnik)	4500	500.00000	0	1020	\N	0		45	2012-09-25 21:01:52.212281	2014-03-03 15:32:20.114896	\N	201202	2012-01-04		t	4500	f	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	1890756.30000	100.00000	0.00000	\N	\N	\N
330337	1416	1137	Rohrleitungen	200	7000.00000	0	1020	\N	0		46	2012-09-25 21:02:01.089967	2014-03-03 15:32:20.114896	\N	201203	2012-01-04		km	200	f	vorgefertigte Rohrleitungen	1176470.59000	100.00000	0.00000	\N	\N	\N
330338	1584	1581	Rettungsboot	12	150000.00000	0	\N	\N	0		47	2012-09-25 21:02:12.260568	2014-03-03 15:32:20.114896	\N	201203-01	2012-04-11		Stck	12	f		1800000.00000	100.00000	0.00000	\N	\N	\N
330339	1432	1142	Elektronik-Pack OIDA/Igel	1	980000.00000	0	1020	\N	0		48	2012-09-25 21:02:33.577472	2014-03-03 15:32:20.114896	\N	201204	2012-04-23		Stck	1	f	Eigen in Auftrag gegebenes Produktpaket aus Kabelschächten, -führungen, Stecker und -leisten	823529.41000	100.00000	0.00000	\N	\N	\N
330340	1438	1107	Fernmelde-Schiffskabel FMKHC	280	1020.00000	0	\N	\N	0		49	2012-09-25 21:02:41.719718	2014-03-03 15:32:20.114896	\N	201205	2012-04-23		km	280	f	Halogen geben, feuerbeständiges Marinekommunikationskabel mit screend Standard	240000.00000	100.00000	0.00000	\N	\N	\N
330341	1438	1100	Kabel und Leitungen H03VV-F	550	400.00000	0	\N	\N	0		50	2012-09-25 21:02:41.719718	2014-03-03 15:32:20.114896	\N	201205	2012-04-23		km	550000	f	H03VV-F 3x0,75 - Leichte PVC-Schlauchleitung\r\nfeindrähtig, Ring 50 Meter\r\nFarbe: schwarz\r\nNach DIN VDE 0281\r\n	184873.95000	100.00000	0.00000	\N	\N	\N
330342	1438	1103	Kabel und Leitungen SiHF-J	530	2400.00000	0	\N	\N	0		51	2012-09-25 21:02:41.719718	2014-03-03 15:32:20.114896	\N	201205	2012-04-23		km	530	f	feindrähtiger Kupferlitzenleiter verzinnt, Farbe: rot-braun, Flammwidrig nach VDE 0472 Teil 804 Prüfart C	1068907.56000	100.00000	0.00000	\N	\N	\N
330343	1438	1105	Starkstrom-Schiffskabel MPRXCX 	180	5000.00000	0	\N	\N	0		52	2012-09-25 21:02:41.719718	2014-03-03 15:32:20.114896	\N	201205	2012-04-23		km	180	f	Cu-Litze blank, Verlitzung nach Klasse 2\r\nIsolation aus vernetztem XLPE\r\nAußenmantel Polyolefin, Farbe Schwarz	756302.52000	100.00000	0.00000	\N	\N	\N
330344	1469	1133	SRP Propeller	2	680000.00000	0	1020	\N	0		53	2012-09-25 21:02:53.935249	2014-03-03 15:32:20.114896	\N	201207	2012-05-07		Stck	2	f	5-Blatt-Festpropeller, Balance-Ruder	1142857.14000	100.00000	0.00000	\N	\N	\N
330345	1469	1135	SST Steuer und Regelsystem	1	520000.00000	0	1020	\N	0		54	2012-09-25 21:02:53.935249	2014-03-03 15:32:20.114896	\N	201207	2012-05-07		Stck	1	f	computerunterstütztes, ferngesteuertes Joystick-System	436974.79000	100.00000	0.00000	\N	\N	\N
330346	1457	1111	Dieselmotor 9M43D	4	5000000.00000	0	1020	\N	0		55	2012-09-25 21:03:02.398126	2014-03-03 15:32:20.114896	\N	201206	2012-05-07		Stck	4	f	9.000 kW (12237 PS)	16806722.69000	100.00000	0.00000	\N	\N	\N
330347	1744	1742	Anti-Piracy SystemXT 4000	1	650000.00000	0	\N	\N	0		56	2012-09-25 21:03:14.070606	2014-03-03 15:32:20.114896	\N	201210-1	2012-05-18		Stck	1	f		650000.00000	100.00000	0.00000	\N	\N	\N
330348	1499	1183	Lautsprecheranlage	1	80000.00000	0	1020	\N	0		57	2012-09-25 21:03:21.533773	2014-03-03 15:32:20.114896	\N	201209	2012-06-01		Stck	1	f		67226.89000	100.00000	0.00000	\N	\N	\N
330349	1499	1180	SecuritySystem	1	150000.00000	0	1020	\N	0		58	2012-09-25 21:03:21.533773	2014-03-03 15:32:20.114896	\N	201209	2012-06-01		Stck	1	f	Alarmanlagen, Messsensoren, Videoüberwachungsanlage	126050.42000	100.00000	0.00000	\N	\N	\N
330350	1510	1404	Anker	1	70000.00000	0	1020	\N	0		60	2012-09-25 21:03:41.034932	2014-03-03 15:32:20.114896	\N	201211	2012-07-02		Stck	1	f		70000.00000	100.00000	0.00000	\N	\N	\N
330351	1517	1156	B&C Glasprojekt "OIDAblu"	1	350000.00000	0	1020	\N	0		61	2012-09-25 21:03:48.06259	2014-03-03 15:32:20.114896	\N	201212	2012-08-01		psch	1	f	Außen und Innenverglasung komplett\r\ninsgesamt 4600 m² Glas (Dünn-, Float-, Panzer-, Weiß-, Spiegelglas)\r\nPlus Mitarbeiterkosten	294117.65000	100.00000	0.00000	\N	\N	\N
330352	1522	1144	Ultimate Mineralwolle	330000	2.90000	0	1020	\N	0		62	2012-09-25 21:03:54.888483	2014-03-03 15:32:20.114896	\N	201214	2012-08-06		m²	330000	f	Hochleistungsdämmstoff für Wärme- und Schalldämmung	804201.68000	100.00000	0.00000	\N	\N	\N
330353	1520	1174	Paket Schiffsinnenbau "Kule"	1	1000000.00000	0	\N	\N	0		63	2012-09-25 21:04:02.440945	2014-03-03 15:32:20.114896	\N	201213	2012-08-06		psch	1	f	Feuerschutztüren, Schichtstoffplatten HPL, Furniere MIneralwerkstoff, Wand- und Deckenpaneel	840336.13000	100.00000	0.00000	\N	\N	\N
330354	1537	1158	Sanitäre Anlagen + Wellnessbereiche Rundum-Sorglos-Paket	1	4650000.00000	0	\N	\N	0		64	2012-09-25 21:04:10.771975	2014-03-03 15:32:20.114896	\N	201216	2012-08-27		psch	1	f	1600 Toiletten, 1500 Duschen, 1700 Waschbecken, sanitäre Einrichtung für Luxussuiten, Saunabereiche, Wellnessbereiche	3907563.03000	100.00000	0.00000	\N	\N	\N
330355	1535	1117	Siloblau Fassade AE 1730	29	7940.00000	0	1020	\N	0		65	2012-09-25 21:04:18.128304	2014-03-03 15:32:20.114896	\N	201215	2012-09-03		t	29	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	193495.80000	100.00000	0.00000	\N	\N	\N
330356	1535	1123	Silogelb Fassade AF 2550	9	7940.00000	0	1020	\N	0		66	2012-09-25 21:04:18.128304	2014-03-03 15:32:20.114896	\N	201215	2012-09-03		t	9	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	60050.42000	100.00000	0.00000	\N	\N	\N
330357	1535	1119	Silorot Fassade AF 2550	4	7940.00000	0	1020	\N	0		67	2012-09-25 21:04:18.128304	2014-03-03 15:32:20.114896	\N	201215	2012-09-03		t	4	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	26689.08000	100.00000	0.00000	\N	\N	\N
330358	1535	1121	Siloschwarz fassade A0 000	4	7940.00000	0	1020	\N	0		68	2012-09-25 21:04:18.128304	2014-03-03 15:32:20.114896	\N	201215	2012-09-03		t	4	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	26689.08000	100.00000	0.00000	\N	\N	\N
330359	1535	1115	Siloweiß Fassade AF 5040	145	5300.00000	0	1020	\N	0		69	2012-09-25 21:04:18.128304	2014-03-03 15:32:20.114896	\N	201215	2012-09-03		t	145	f	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	645798.32000	100.00000	0.00000	\N	\N	\N
330360	1555	1161	Innenausbau "Veranstaltungs- und Verpflegungsräumeräume"	1	5300000.00000	0	\N	\N	0		70	2012-09-25 21:04:29.064092	2014-03-03 15:32:20.114896	\N	201218	2012-09-03		psch	1	f	Schiffsinnenbau der Veranstaltungsräume: 4D Kino, Casino, 4 Discotheken, 15 Restaurants, Crewkantine, Theatrium, Messehalle, 11 Bars	4453781.51000	100.00000	0.00000	\N	\N	\N
330361	1559	1167	Innenausbau "Passagiere + Gänge"	1	2100000.00000	0	1020	\N	0		71	2012-09-25 21:04:42.413443	2014-03-03 15:32:20.114896	\N	201219	2012-09-03		psch	1	f	Schiffsinnenbau: alle 1096 Passagierkabinen, Gänge und Treppenhäuser	1764705.88000	100.00000	0.00000	\N	\N	\N
330362	1553	1154	Malerarbeiten	50	1300.00000	0	1020	\N	0		72	2012-09-25 21:05:01.551838	2014-03-03 15:32:20.114896	\N	201217	2012-09-12		Tag	50	f		54621.85000	100.00000	0.00000	\N	\N	\N
330363	1567	1185	"schiffseigene Brauerei" + Einbau	1	200000.00000	0	\N	\N	0		73	2012-09-25 21:05:12.417623	2014-03-03 15:32:20.114896	\N	201221	2012-09-27		psch	1	f		168067.23000	100.00000	0.00000	\N	\N	\N
330364	1564	1164	Innenausbau "Crew und Luxus"	1	1680000.00000	0	\N	\N	0		74	2012-09-25 21:05:23.511389	2014-03-03 15:32:20.114896	\N	201220	2012-09-27		psch	1	f	Schiffsinnenbau "Crew und Luxus": Ausbau des Crewbereichs mit 600 Crew Kabinen, 3 Kapitänskabinen, Eine Discothek und eine Bar extra für die Crew + Luxussuiten (23)	1411764.71000	100.00000	0.00000	\N	\N	\N
330365	1569	1147	Palme	70	250.50000	0	\N	\N	0		75	2012-09-25 21:05:30.225665	2014-03-03 15:32:20.114896	\N	201222	2012-11-15		Stck	70	f	blaue Hesperidenpalme, stabilisiert	16387.85000	100.00000	0.00000	\N	\N	\N
330366	1569	1149	Zypresse	65	105.00000	0	\N	\N	0		76	2012-09-25 21:05:30.225665	2014-03-03 15:32:20.114896	\N	201222	2012-11-15		Stck	65	f	stabilisiert	6378.50000	100.00000	0.00000	\N	\N	\N
330367	1569	1152	Hecke	260	3.60000	0	\N	\N	0		77	2012-09-25 21:05:30.225665	2014-03-03 15:32:20.114896	\N	201222	2012-11-15		m²	260	f	stabilisiert	874.77000	100.00000	0.00000	\N	\N	\N
330368	1756	1752	Vermietung Baudock A1	1	20000.00000	0	\N	\N	0		78	2012-09-25 21:06:18.720727	2014-03-03 15:32:20.114896	\N	022012	2011-12-02		Monat	1	f		20000.00000	100.00000	0.00000	\N	\N	\N
330369	1876	1752	Vermietung Baudock A1	1	20000.00000	0.1	\N	\N	0		80	2012-11-15 14:30:11.652828	2014-03-03 15:32:20.114896	\N	1	15.11.2012		Monat	1	f		18000.00000	100.00000	0.00000	\N	\N	\N
\.


--
-- Data for Name: parts; Type: TABLE DATA; Schema: public; Owner: -
--

COPY parts (id, partnumber, description, listprice, sellprice, lastcost, priceupdate, weight, notes, makemodel, assembly, alternate, rop, inventory_accno_id, income_accno_id, expense_accno_id, shop, obsolete, bom, image, drawing, microfiche, partsgroup_id, ve, gv, itime, mtime, unit, formel, not_discountable, buchungsgruppen_id, payment_id, ean, price_factor_id, onhand, stockable, has_sernumber, warehouse_id, bin_id) WITH OIDS FROM stdin;
330371	1192	108	Design "OIDABLU"	0.00000	0.00000	28037.38000	2012-09-12	0		t	f	f	0	\N	84	167	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-21 11:13:33.094868	2014-03-03 15:32:20.148754	psch	\N	f	937	\N		\N	0.00000	f	f	\N	\N
330410	1888	1	Musterartikel 1	100.00000	100.00000	50.00000	2012-11-15	0		t	f	f	0	16	90	168	f	f	f				1887	\N	0.00000	2012-11-15 14:40:20.793225	2012-11-15 14:48:22.490264	Stck		f	936	\N		\N	97.00000	f	f	\N	\N
330372	1161	104	Innenausbau "Veranstaltungs- und Verpflegungsräumeräume"	0.00000	0.00000	4453781.51000	2012-09-12	0	Schiffsinnenbau der Veranstaltungsräume: 4D Kino, Casino, 4 Discotheken, 15 Restaurants, Crewkantine, Theatrium, Messehalle, 11 Bars	t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-21 10:20:40.287588	2014-03-03 15:32:20.148754	psch	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330373	1164	105	Innenausbau "Crew und Luxus"	0.00000	0.00000	1411764.71000	2012-09-12	0	Schiffsinnenbau "Crew und Luxus": Ausbau des Crewbereichs mit 600 Crew Kabinen, 3 Kapitänskabinen, Eine Discothek und eine Bar extra für die Crew + Luxussuiten (23)	t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-21 10:26:47.581527	2014-03-03 15:32:20.148754	psch	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330374	1167	106	Innenausbau "Passagiere + Gänge"	0.00000	0.00000	1764705.88000	2012-09-12	0	Schiffsinnenbau: alle 1096 Passagierkabinen, Gänge und Treppenhäuser	t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-21 10:32:10.246608	2014-03-03 15:32:20.148754	psch	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330375	1325	025	Kopierpapier weiß A4 Paket	0.00000	0.00000	3.27000	2012-09-12	0	500 Blatt	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-30 14:57:04.311798	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330376	1154	101	Malerarbeiten	0.00000	0.00000	1008.40000	2012-09-12	0		t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-20 15:50:07.318925	2014-03-03 15:32:20.148754	Tag	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330377	1158	103	Sanitäre Anlagen + Wellnessbereiche Rundum-Sorglos-Paket	0.00000	0.00000	3907563.03000	2012-09-12	0	1600 Toiletten, 1500 Duschen, 1700 Waschbecken, sanitäre Einrichtung für Luxussuiten, Saunabereiche, Wellnessbereiche	t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-20 16:03:28.613749	2014-03-03 15:32:20.148754	psch	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330378	1156	102	B&C Glasprojekt "OIDAblu"	0.00000	0.00000	294117.65000	2012-09-12	0	Außen und Innenverglasung komplett\r\ninsgesamt 4600 m² Glas (Dünn-, Float-, Panzer-, Weiß-, Spiegelglas)\r\nPlus Mitarbeiterkosten	t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-20 15:57:05.848953	2014-03-03 15:32:20.148754	psch	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330379	1581	027	Rettungsboot	0.00000	0.00000	150000.00000	2012-09-12	0		t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-09-12 14:48:16.971483	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330380	1185	107	"Schiffseigene Brauerei" + Einbau	0.00000	0.00000	168067.23000	2012-09-12	0		t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-08-21 11:04:04.539082	2014-03-03 15:32:20.148754	psch	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330381	1758	000	OIDABLU	0.00000	350000000.00000	0.00000	2012-09-21	0		f	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-09-21 15:16:58.235275	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330382	1822	029	Kronleuchter Deluxe 4000	100000.00000	0.00000	120000.00000	2012-10-08	0		t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-10-08 15:28:06.467019	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330383	1103	005	Kabel und Leitungen SiHF-J	0.00000	0.00000	2016.81000	2012-09-12	0	feindrähtiger Kupferlitzenleiter verzinnt, Farbe: rot-braun, Flammwidrig nach VDE 0472 Teil 804 Prüfart C	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 13:47:19.108004	2014-03-03 15:32:20.148754	km		f	936	\N		\N	0.00000	f	f	\N	\N
330384	1100	004	Kabel und Leitungen H03VV-F	0.00000	0.00000	0.34000	2012-09-12	0	H03VV-F 3x0,75 - Leichte PVC-Schlauchleitung\r\nfeindrähtig, Ring 50 Meter\r\nFarbe: schwarz\r\nNach DIN VDE 0281\r\n	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 13:43:25.816279	2014-03-03 15:32:20.148754	m		f	936	\N		\N	0.00000	f	f	\N	\N
330385	1105	006	Starkstrom-Schiffskabel MPRXCX 	0.00000	0.00000	4201.68000	2012-09-12	0	Cu-Litze blank, Verlitzung nach Klasse 2\r\nIsolation aus vernetztem XLPE\r\nAußenmantel Polyolefin, Farbe Schwarz	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 13:51:16.937606	2014-03-03 15:32:20.148754	km		f	936	\N		\N	0.00000	f	f	\N	\N
330386	1144	018	Ultimate Mineralwolle	0.00000	0.00000	2.44000	2012-09-12	0	Hochleistungsdämmstoff für Wärme- und Schalldämmung	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 15:28:54.604842	2014-03-03 15:32:20.148754	m²		f	936	\N		\N	0.00000	f	f	\N	\N
330387	1091	001	Schiffbaustahl Marine 33	0.00000	0.00000	378.15000	2012-09-12	0	Höherfester Schiffbaustahl, thermomechanisch gewalzt\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 12:56:53.176655	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
330388	1093	002	Schiffbaustahl 2HGr50 (Qualitätstechnik)	0.00000	0.00000	420.17000	2012-09-12	0	Höherfester Schiffbaustahl, thermomechanisch gewalzt, besonders feinkörnig geschmolzen\r\nAbnahmeprüfzeugnis 3.1 nach EN 10204	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 13:02:15.003315	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
330389	1133	014	SRP Propeller	0.00000	0.00000	571428.57000	2012-09-12	0	5-Blatt-Festpropeller, Balance-Ruder	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:48:59.763934	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330390	1137	016	Rohrleitungen	0.00000	0.00000	5882.35000	2012-09-12	0	vorgefertigte Rohrleitungen	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 15:11:15.017645	2014-03-03 15:32:20.148754	km		f	936	\N		\N	0.00000	f	f	\N	\N
330391	1142	017	Elektronik-Pack OIDA/Igel	0.00000	0.00000	823529.41000	2012-09-12	0	Eigen in Auftrag gegebenes Produktpaket aus Kabelschächten, -führungen, Stecker und -leisten	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 15:20:57.505582	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330392	1183	024	Lautsprecheranlage	0.00000	0.00000	67226.89000	2012-09-12	0		t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-21 11:01:00.742146	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330393	1180	023	SecuritySystem	0.00000	0.00000	126050.42000	2012-09-12	0	Alarmanlagen, Messsensoren, Videoüberwachungsanlage	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-21 11:00:21.459352	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330394	1404	026	Anker	0.00000	0.00000	70000.00000	2012-09-12	0		t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-09-12 11:32:32.619868	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330395	1174	022	Paket Schiffsinnenbau "Kule"	0.00000	0.00000	840336.13000	2012-09-12	0	Feuerschutztüren, Schichtstoffplatten HPL, Furniere MIneralwerkstoff, Wand- und Deckenpaneel	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-21 10:54:30.032013	2014-03-03 15:32:20.148754	psch		f	936	\N		\N	0.00000	f	f	\N	\N
330396	1123	013	Silogelb Fassade AF 2550	0.00000	0.00000	6672.27000	2012-09-12	0	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:22:31.479228	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
330397	1147	019	Palme	0.00000	0.00000	234.11000	2012-09-12	0	blaue Hesperidenpalme, stabilisiert	t	f	f	0	16	84	167	f	f	f				\N	\N	0.00000	2012-08-20 15:35:12.188018	2014-03-03 15:32:20.148754	Stck		f	937	\N		\N	0.00000	f	f	\N	\N
330398	1149	020	Zypresse	0.00000	0.00000	98.13000	2012-09-12	0	stabilisiert	t	f	f	0	16	84	167	f	f	f				\N	\N	0.00000	2012-08-20 15:35:55.945238	2014-03-03 15:32:20.148754	Stck		f	937	\N		\N	0.00000	f	f	\N	\N
330399	1152	021	Hecke	0.00000	0.00000	3.36000	2012-09-12	0	stabilisiert	t	f	f	0	16	84	167	f	f	f				\N	\N	0.00000	2012-08-20 15:39:53.929915	2014-03-03 15:32:20.148754	m²		f	937	\N		\N	0.00000	f	f	\N	\N
330409	1742	028	Anti-Piracy SystemXT 4000	0.00000	0.00000	522730.00000	2012-09-21	0		t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-09-21 14:32:13.03265	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330400	1135	015	SST Steuer und Regelsystem	520000.00000	0.00000	436974.79000	2012-09-12	0	computerunterstütztes, ferngesteuertes Joystick-System	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:50:35.379669	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330401	1098	003	Elektrischer Propellermotor S-12/5	0.00000	0.00000	6722689.08000	2012-09-12	0	12,5 MW; Wellenanlage\r\nMaschinenleistung: 12.500 kW (16996 PS)	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 13:10:52.296787	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330402	1107	007	Fernmelde-Schiffskabel FMKHC	0.00000	0.00000	857.14000	2012-09-12	0	Halogen geben, feuerbeständiges Marinekommunikationskabel mit screend Standard	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 13:55:00.268379	2014-03-03 15:32:20.148754	km		f	936	\N		\N	0.00000	f	f	\N	\N
330403	1111	008	Dieselmotor 9M43D	0.00000	0.00000	4201680.67000	2012-09-12	0	9.000 kW (12237 PS)	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:13:43.168342	2014-03-03 15:32:20.148754	Stck		f	936	\N		\N	0.00000	f	f	\N	\N
330404	1752	109	Vermietung Baudock A1	0.00000	20000.00000	0.00000	2012-09-21	0		t	f	f	0	\N	90	168	f	f	f	\N	\N	\N	\N	\N	0.00000	2012-09-21 15:10:16.867724	2014-03-03 15:32:20.148754	Monat	\N	f	936	\N		\N	0.00000	f	f	\N	\N
330405	1115	009	Siloweiß Fassade AF 5040	0.00000	0.00000	4453.78000	2012-09-12	0	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:19:22.739692	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
330406	1119	011	Silorot Fassade AF 2550	0.00000	0.00000	6672.27000	2012-09-12	0	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:20:50.332679	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
330407	1117	010	Siloblau Fassade AE 1730	0.00000	0.00000	6672.27000	2012-09-12	0	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:19:52.233552	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
330408	1121	012	Siloschwarz Fassade A0 000	0.00000	0.00000	6672.27000	2012-09-12	0	Hochdiffusionsfähige, wasserabweisend eingestellte Silikonharzfassadenfarbe,\r\nAlgen- und Pilzbefallschutz	t	f	f	0	16	90	168	f	f	f				\N	\N	0.00000	2012-08-20 14:21:25.808958	2014-03-03 15:32:20.148754	t		f	936	\N		\N	0.00000	f	f	\N	\N
\.


--
-- Data for Name: partsgroup; Type: TABLE DATA; Schema: public; Owner: -
--

COPY partsgroup (id, partsgroup, itime, mtime) WITH OIDS FROM stdin;
330412	1887	Musterwarengruppe 1	2012-11-15 14:37:48.493322	\N
\.


--
-- Data for Name: payment_terms; Type: TABLE DATA; Schema: public; Owner: -
--

COPY payment_terms (id, description, description_long, terms_netto, terms_skonto, percent_skonto, itime, mtime, ranking, sortkey) FROM stdin;
\.


--
-- Data for Name: periodic_invoices; Type: TABLE DATA; Schema: public; Owner: -
--

COPY periodic_invoices (id, config_id, ar_id, period_start_date, itime) FROM stdin;
1764	1761	209	2012-01-02	2012-09-21 15:36:32.645385
1765	1761	210	2012-02-02	2012-09-21 15:36:33.068754
1766	1761	211	2012-03-02	2012-09-21 15:36:33.265917
1767	1761	212	2012-04-02	2012-09-21 15:36:33.365752
1768	1761	213	2012-05-02	2012-09-21 15:36:33.491077
1769	1761	214	2012-06-02	2012-09-21 15:36:33.596295
1770	1761	215	2012-07-02	2012-09-21 15:36:33.715663
1771	1761	216	2012-08-02	2012-09-21 15:36:33.819959
1772	1761	217	2012-09-02	2012-09-21 15:36:34.018694
1777	1761	222	2012-09-02	2012-09-21 16:20:17.548256
1840	1761	228	2012-10-02	2012-10-09 08:49:39.436806
1841	1761	229	2012-11-02	2012-12-12 12:48:18.476016
1842	1761	230	2012-12-02	2012-12-12 12:48:18.77791
\.


--
-- Data for Name: periodic_invoices_configs; Type: TABLE DATA; Schema: public; Owner: -
--

COPY periodic_invoices_configs (id, oe_id, periodicity, print, printer_id, copies, active, terminated, start_date, end_date, ar_chart_id, extend_automatically_by) FROM stdin;
1761	1756	m	f	\N	1	t	f	2012-01-02	2013-01-03	17	1
\.


--
-- Data for Name: price_factors; Type: TABLE DATA; Schema: public; Owner: -
--

COPY price_factors (id, description, factor, sortkey) FROM stdin;
942	pro 10	10.00000	1
943	pro 100	100.00000	2
944	pro 1.000	1000.00000	3
\.


--
-- Data for Name: pricegroup; Type: TABLE DATA; Schema: public; Owner: -
--

COPY pricegroup (id, pricegroup) FROM stdin;
1874	Grosskunde
1886	Musterfirma
\.


--
-- Data for Name: prices; Type: TABLE DATA; Schema: public; Owner: -
--

COPY prices (parts_id, pricegroup_id, price, id) FROM stdin;
1752	1874	17000.00000	1
1888	1874	90.00000	2
1888	1886	80.00000	3
\.


--
-- Data for Name: printers; Type: TABLE DATA; Schema: public; Owner: -
--

COPY printers (id, printer_description, printer_command, template_code) FROM stdin;
\.


--
-- Data for Name: project; Type: TABLE DATA; Schema: public; Owner: -
--

COPY project (id, projectnumber, description, itime, mtime, active, customer_id, valid, project_type_id) FROM stdin;
1020	01-2012	OIDAGreen - Kreutzfahrtschiff	2012-08-17 12:59:38.920804	\N	t	\N	t	1
\.


--
-- Data for Name: project_types; Type: TABLE DATA; Schema: public; Owner: -
--

COPY project_types (id, "position", description) FROM stdin;
1	1	Standard
2	2	Festpreis
3	3	Support
\.


--
-- Data for Name: record_links; Type: TABLE DATA; Schema: public; Owner: -
--

COPY record_links (from_table, from_id, to_table, to_id, itime, id) FROM stdin;
oe	1399	ap	158	2012-09-12 11:31:38.368947	1
oe	1410	delivery_orders	1412	2012-09-12 11:44:32.579899	2
delivery_orders	1412	ap	159	2012-09-12 11:46:35.764079	3
oe	1416	delivery_orders	1419	2012-09-12 11:48:47.582506	4
delivery_orders	1419	ap	160	2012-09-12 11:51:00.529905	5
oe	1432	delivery_orders	1434	2012-09-12 11:52:49.302474	6
delivery_orders	1434	ap	161	2012-09-12 11:55:21.123487	7
oe	1438	delivery_orders	1441	2012-09-12 11:57:39.670908	8
delivery_orders	1441	ap	162	2012-09-12 12:00:50.338662	9
oe	1457	delivery_orders	1459	2012-09-12 12:09:40.663072	10
delivery_orders	1459	ap	163	2012-09-12 12:11:50.790617	11
oe	1469	delivery_orders	1476	2012-09-12 12:15:45.170959	12
oe	1474	delivery_orders	1484	2012-09-12 12:16:02.876219	13
delivery_orders	1476	ap	164	2012-09-12 12:16:58.361196	14
delivery_orders	1484	ap	165	2012-09-12 12:17:13.904978	15
oe	1492	delivery_orders	1494	2012-09-12 12:33:07.170286	16
delivery_orders	1494	ap	166	2012-09-12 12:34:31.518335	17
oe	1499	delivery_orders	1503	2012-09-12 12:39:22.659153	18
delivery_orders	1503	ap	167	2012-09-12 12:40:21.584179	19
oe	1510	delivery_orders	1512	2012-09-12 12:49:24.103479	20
delivery_orders	1512	ap	168	2012-09-12 12:51:04.811484	21
oe	1517	ap	169	2012-09-12 14:03:23.525778	22
oe	1520	delivery_orders	1525	2012-09-12 14:06:01.064826	23
oe	1522	delivery_orders	1529	2012-09-12 14:07:21.77179	24
delivery_orders	1525	ap	170	2012-09-12 14:07:26.811402	25
delivery_orders	1529	ap	171	2012-09-12 14:08:20.092458	26
oe	1537	ap	172	2012-09-12 14:14:06.926166	27
oe	1535	delivery_orders	1540	2012-09-12 14:14:57.960114	28
delivery_orders	1540	ap	173	2012-09-12 14:16:01.336668	29
oe	1555	ap	175	2012-09-12 14:26:50.138796	31
oe	1559	ap	176	2012-09-12 14:30:44.163604	32
oe	1553	ap	177	2012-09-12 14:34:33.16189	33
oe	1564	ap	178	2012-09-12 14:38:20.675653	34
oe	1567	ap	179	2012-09-12 14:41:19.85977	35
oe	1569	delivery_orders	1572	2012-09-12 14:43:11.233866	36
delivery_orders	1572	ap	180	2012-09-12 14:44:44.722246	37
oe	1584	delivery_orders	1586	2012-09-12 14:54:45.296188	38
delivery_orders	1586	ap	181	2012-09-12 14:56:01.117455	39
oe	1744	delivery_orders	1746	2012-09-21 14:35:56.192082	40
delivery_orders	1746	ap	206	2012-09-21 14:43:12.462592	41
oe	1756	ar	209	2012-09-21 15:36:32.645385	43
oe	1756	ar	210	2012-09-21 15:36:33.068754	44
oe	1756	ar	211	2012-09-21 15:36:33.265917	45
oe	1756	ar	212	2012-09-21 15:36:33.365752	46
oe	1756	ar	213	2012-09-21 15:36:33.491077	47
oe	1756	ar	214	2012-09-21 15:36:33.596295	48
oe	1756	ar	215	2012-09-21 15:36:33.715663	49
oe	1756	ar	216	2012-09-21 15:36:33.819959	50
oe	1756	ar	217	2012-09-21 15:36:34.018694	51
oe	1756	ar	222	2012-09-21 16:20:17.548256	52
oe	1756	ar	228	2012-10-09 08:49:39.436806	53
oe	1756	ar	229	2012-12-12 12:48:18.476016	54
oe	1756	ar	230	2012-12-12 12:48:18.77791	55
oe	1876	delivery_orders	1881	2012-11-15 14:31:04.146554	56
delivery_orders	1881	ar	249	2012-11-15 14:31:30.163919	57
\.


--
-- Data for Name: schema_info; Type: TABLE DATA; Schema: public; Owner: -
--

COPY schema_info (tag, login, itime) FROM stdin;
SKR04-3804-addition	martin	2012-08-17 12:52:13.153228
chart_category_to_sgn	martin	2012-08-17 12:52:13.188319
chart_names	martin	2012-08-17 12:52:13.211102
chart_names2	martin	2012-08-17 12:52:13.253717
customer_vendor_ustid_length	martin	2012-08-17 12:52:13.286788
language_output_formatting	martin	2012-08-17 12:52:13.330413
rename_buchungsgruppen_accounts_16_19_percent	martin	2012-08-17 12:52:13.354859
tax_id_if_taxkey_is_0	martin	2012-08-17 12:52:13.388683
units_translations_and_singular_plural_distinction	martin	2012-08-17 12:52:13.422654
tax_primary_key_taxkeys_foreign_keys	martin	2012-08-17 12:52:13.572486
invalid_taxkesy	martin	2012-08-17 12:52:13.664699
release_2_4_1	martin	2012-08-17 12:52:13.68934
PgCommaAggregateFunction	martin	2012-08-17 12:52:13.707651
ap_ar_orddate_quodate	martin	2012-08-17 12:52:13.72887
buchungsgruppen_sortkey	martin	2012-08-17 12:52:13.754054
customer_vendor_taxzone_id	martin	2012-08-17 12:52:13.79193
drafts	martin	2012-08-17 12:52:13.83079
employee_no_limits	martin	2012-08-17 12:52:14.039258
globalprojectnumber_ap_ar_oe	martin	2012-08-17 12:52:14.229025
oe_delivered	martin	2012-08-17 12:52:14.267241
oe_is_salesman	martin	2012-08-17 12:52:14.288545
parts_ean	martin	2012-08-17 12:52:14.31192
payment_terms_sortkey	martin	2012-08-17 12:52:14.326943
payment_terms_translation	martin	2012-08-17 12:52:14.346212
project	martin	2012-08-17 12:52:14.448428
status_history	martin	2012-08-17 12:52:14.476002
units_sortkey	martin	2012-08-17 12:52:14.517301
history_erp	martin	2012-08-17 12:52:14.55061
marge_initial	martin	2012-08-17 12:52:14.725702
ustva_setup_2007	martin	2012-08-17 12:52:14.768104
history_erp_snumbers	martin	2012-08-17 12:52:14.794956
tax_description_without_percentage_skr04	martin	2012-08-17 12:52:14.809788
ustva_setup_2007_update_chart_taxkeys_tax	martin	2012-08-17 12:52:14.847436
fix_taxdescription	martin	2012-08-17 12:52:14.915408
ustva_setup_2007_update_chart_taxkeys_tax_add_missing_tax_accounts	martin	2012-08-17 12:52:14.953417
tax_description_without_percentage	martin	2012-08-17 12:52:14.965569
release_2_4_2	martin	2012-08-17 12:52:14.996856
COA_Account_Settings001	martin	2012-08-17 12:52:15.010616
COA_Account_Settings002	martin	2012-08-17 12:52:15.025357
USTVA_abstraction	martin	2012-08-17 12:52:15.041337
ap_storno	martin	2012-08-17 12:52:15.455431
ar_storno	martin	2012-08-17 12:52:15.474631
cb_ob_transaction	martin	2012-08-17 12:52:15.495938
dunning_config_interest_rate	martin	2012-08-17 12:52:15.533536
dunning_dunning_id	martin	2012-08-17 12:52:15.57583
dunning_invoices_for_fees	martin	2012-08-17 12:52:15.605703
gl_storno	martin	2012-08-17 12:52:15.655669
invalid_taxkeys_2	martin	2012-08-17 12:52:15.718662
transaction_description	martin	2012-08-17 12:52:15.742981
USTVA_at	martin	2012-08-17 12:52:15.772648
ar_ap_storno_id	martin	2012-08-17 12:52:15.786337
dunning_invoices_per_dunning_level	martin	2012-08-17 12:52:15.804928
tax_report_table_name	martin	2012-08-17 12:52:15.827209
release_2_4_3	martin	2012-08-17 12:52:15.847508
acc_trans_without_oid	martin	2012-08-17 12:52:15.867129
bank_accounts	martin	2012-08-17 12:52:16.31438
change_makemodel_vendor_id	martin	2012-08-17 12:52:16.459988
custom_variables	martin	2012-08-17 12:52:16.483057
direct_debit	martin	2012-08-17 12:52:16.735244
follow_ups	martin	2012-08-17 12:52:16.759949
oe_employee_id_foreignkey	martin	2012-08-17 12:52:17.133878
price_factors	martin	2012-08-17 12:52:17.154771
sic_code	martin	2012-08-17 12:52:17.321373
todo_config	martin	2012-08-17 12:52:17.339665
trigger_assembly_update_lastcost	martin	2012-08-17 12:52:17.368149
units_no_type_distinction	martin	2012-08-17 12:52:17.403351
warehouse	martin	2012-08-17 12:52:17.421306
delivery_orders	martin	2012-08-17 12:52:17.781989
transfer_type_shipped	martin	2012-08-17 12:52:18.686577
warehouse2	martin	2012-08-17 12:52:18.708113
ar_add_donumber	martin	2012-08-17 12:52:18.727893
ar_add_invnumber_for_credit_note	martin	2012-08-17 12:52:18.747494
record_links	martin	2012-08-17 12:52:18.768749
transaction_description_not_null	martin	2012-08-17 12:52:19.030902
release_2_6_0	martin	2012-08-17 12:52:19.068249
auth_enable_sales_all_edit	martin	2012-08-17 12:52:19.092601
custom_variables_parts_services_assemblies	martin	2012-08-17 12:52:19.110388
custom_variables_valid	martin	2012-08-17 12:52:19.139995
delivery_orders_fields_for_invoices	martin	2012-08-17 12:52:19.22766
fix_acc_trans_ap_taxkey_bug	martin	2012-08-17 12:52:19.259947
fix_datepaid	martin	2012-08-17 12:52:19.290175
generic_translations	martin	2012-08-17 12:52:19.332369
has_sernumber	martin	2012-08-17 12:52:19.660979
rundungsfehler_korrigieren_BUG1328-2	martin	2012-08-17 12:52:19.697054
sepa	martin	2012-08-17 12:52:19.711158
update_date_paid	martin	2012-08-17 12:52:19.8824
warehouse3	martin	2012-08-17 12:52:19.912383
warehouse_add_bestbefore	martin	2012-08-17 12:52:19.931986
add_more_constraints_fibu_projekt_xplace3	martin	2012-08-17 12:52:19.987102
cp_greeting_migration	martin	2012-08-17 12:52:20.005819
release_2_6_1	martin	2012-08-17 12:52:20.030761
acc_trans_id_uniqueness	martin	2012-08-17 12:52:20.048754
add_ar_paid_defaults	martin	2012-08-17 12:52:20.06998
add_makemodel_prices	martin	2012-08-17 12:52:20.089302
csv_import_profiles	martin	2012-08-17 12:52:20.121816
customer_long_entries	martin	2012-08-17 12:52:20.496752
drop_yearend	martin	2012-08-17 12:52:22.665319
emmvee_background_jobs	martin	2012-08-17 12:52:22.679974
invalid_entries_in_custom_variables_validity	martin	2012-08-17 12:52:23.068301
payment_terms_translation2	martin	2012-08-17 12:52:23.090664
periodic_invoices	martin	2012-08-17 12:52:23.121729
schema_normalization_1	martin	2012-08-17 12:52:23.285752
sepa_in	martin	2012-08-17 12:52:23.577712
shipto_add_cp_gender	martin	2012-08-17 12:52:23.618499
skr03_04_bwa_zuordnung_konten_4250_4610	martin	2012-08-17 12:52:23.638063
skr04_fix_category_3151_3160_3170	martin	2012-08-17 12:52:23.675486
ustva_2010	martin	2012-08-17 12:52:23.700275
emmvee_background_jobs_2	martin	2012-08-17 12:52:23.93877
periodic_invoices_background_job	martin	2012-08-17 12:52:24.214245
schema_normalization_2	martin	2012-08-17 12:52:24.232433
schema_normalization_3	martin	2012-08-17 12:52:27.723338
release_2_6_2	martin	2012-08-17 12:52:27.824789
chart_taxkey_id_from_taxkeys	martin	2012-08-17 12:52:27.840827
custom_variables_indices	martin	2012-08-17 12:52:27.938035
custom_variables_indices_2	martin	2012-08-17 12:52:28.068536
units_id	martin	2012-08-17 12:52:28.133868
release_2_6_3	martin	2012-08-17 12:52:28.327471
auth_enable_ct_all_edit	martin	2012-08-17 12:52:28.352358
auth_enable_edit_prices	martin	2012-08-17 12:52:28.372009
customer_add_constraints	martin	2012-08-17 12:52:28.387706
customer_vendor_add_currency	martin	2012-08-17 12:52:28.42282
defaults_add_language_id	martin	2012-08-17 12:52:28.439622
delivery_order_items_add_pricegroup_id	martin	2012-08-17 12:52:28.455316
department_drop_role	martin	2012-08-17 12:52:28.468766
drop_datevexport	martin	2012-08-17 12:52:28.487185
employee_deleted	martin	2012-08-17 12:52:28.506819
license_invoice_drop	martin	2012-08-17 12:52:28.871894
oe_customer_vendor_fkeys	martin	2012-08-17 12:52:28.896887
parts_add_unit_foreign_key	martin	2012-08-17 12:52:28.916159
umstellung_eur	martin	2012-08-17 12:52:28.943665
ustva_2010_fixes	martin	2012-08-17 12:52:28.96873
vendor_add_constraints	martin	2012-08-17 12:52:28.988527
warehouse_alter_chargenumber	martin	2012-08-17 12:52:29.020954
release_2_7_0	martin	2012-08-17 12:52:29.038142
customer_vendor_phone_no_limits	martin	2012-08-17 12:52:29.049641
self_test_background_job	martin	2012-08-17 12:52:29.883556
contacts_add_street_and_zipcode_and_city	martin	2012-09-12 11:22:03.488002
custom_variables_sub_module_not_null	martin	2012-09-12 11:22:03.525921
customer_add_taxincluded_checked	martin	2012-09-12 11:22:03.550725
customer_add_taxincluded_checked_2	martin	2012-09-12 11:22:04.000061
record_links_post_delete_triggers	martin	2012-09-19 14:08:32.732266
buchungsgruppe_variable	geoff	2012-10-08 14:50:03.661907
schema_normalization_4	geoff	2012-10-08 14:50:03.689212
record_links_post_delete_triggers2	geoff	2012-10-09 14:46:30.450564
defaults_datev_check	steigmann	2012-11-11 16:38:33.768657
defaults_posting_config	steigmann	2012-11-11 16:38:34.63325
defaults_posting_records_config	steigmann	2012-11-11 16:38:34.819691
defaults_show_bestbefore	steigmann	2012-11-11 16:38:35.393329
defaults_show_delete_on_orders	steigmann	2012-11-11 16:38:35.563737
defaults_show_mark_as_paid_config	steigmann	2012-11-11 16:38:36.145241
chart_type_skonto	steigmann	2012-11-15 16:39:19.170385
contacts_convert_cp_birthday_to_date	steigmann	2012-11-15 16:39:19.261403
convert_curr_to_text	steigmann	2012-11-15 16:39:19.290553
finanzamt_update_fa_bufa_nr_hamburg	steigmann	2012-11-15 16:39:22.064261
rename_buchungsgruppe_16_19_to_19	steigmann	2012-11-22 21:19:01.237114
ustva_setup_2007_update_chart_taxkeys_tax_skr04	steigmann	2012-11-22 21:19:01.271533
release_3_0_0	steigmann	2013-04-04 10:28:18.307724
acc_trans_constraints	demo	2014-03-03 15:32:17.169906
add_depositor_for_customer_vendor	demo	2014-03-03 15:32:17.193842
csv_import_profiles_2	demo	2014-03-03 15:32:17.286176
delete_translations_on_payment_term_delete	demo	2014-03-03 15:32:17.294339
background_jobs_3	demo	2014-03-03 15:32:17.408904
csv_import_report_cache	demo	2014-03-03 15:32:17.419834
csv_import_reports_add_numheaders	demo	2014-03-03 15:32:17.778378
acc_trans_booleans_not_null	demo	2014-03-03 15:32:17.78625
accounts_tax_office_bad_homburg	demo	2014-03-03 15:32:17.803384
add_chart_link_to_acc_trans	demo	2014-03-03 15:32:17.811533
add_customer_mandator_id	demo	2014-03-03 15:32:17.856741
add_fk_to_gl	demo	2014-03-03 15:32:17.873781
add_warehouse_defaults	demo	2014-03-03 15:32:17.908091
ap_add_direct_debit	demo	2014-03-03 15:32:17.926014
ap_deliverydate	demo	2014-03-03 15:32:17.943131
ar_add_direct_debit	demo	2014-03-03 15:32:17.950984
ar_ap_foreign_keys	demo	2014-03-03 15:32:17.968321
ar_ap_gl_delete_triggers_deletion_from_acc_trans	demo	2014-03-03 15:32:18.018881
background_job_change_create_periodic_invoices_to_daily	demo	2014-03-03 15:32:18.058272
charts_without_taxkey	demo	2014-03-03 15:32:18.068842
cleanup_after_customer_vendor_deletion	demo	2014-03-03 15:32:18.085755
clients	demo	2014-03-03 15:32:18.093436
contacts_add_cp_position	demo	2014-03-03 15:32:18.10195
custom_variable_configs_column_type_text	demo	2014-03-03 15:32:18.110559
custom_variables_validity_index	demo	2014-03-03 15:32:18.386893
defaults_add_max_future_booking_intervall	demo	2014-03-03 15:32:18.518811
defaults_feature	demo	2014-03-03 15:32:18.66087
defaults_feature2	demo	2014-03-03 15:32:19.247398
del_exchangerate	demo	2014-03-03 15:32:19.447841
delete_close_follow_ups_when_order_is_deleted_closed_fkey_deletion	demo	2014-03-03 15:32:19.490525
delete_customertax_vendortax_partstax	demo	2014-03-03 15:32:19.530179
delete_translations_on_tax_delete	demo	2014-03-03 15:32:19.548408
delivery_terms	demo	2014-03-03 15:32:19.564287
drop_audittrail	demo	2014-03-03 15:32:19.713902
drop_dpt_trans	demo	2014-03-03 15:32:19.723169
drop_gifi	demo	2014-03-03 15:32:19.739485
drop_rma	demo	2014-03-03 15:32:19.756391
employee_drop_columns	demo	2014-03-03 15:32:19.773099
erzeugnisnummern	demo	2014-03-03 15:32:19.789676
fix_datepaid_for_sepa_transfers	demo	2014-03-03 15:32:19.881715
gewichte	demo	2014-03-03 15:32:19.889749
gl_add_employee_foreign_key	demo	2014-03-03 15:32:20.064936
oe_delivery_orders_foreign_keys	demo	2014-03-03 15:32:20.072621
orderitems_delivery_order_items_invoice_foreign_keys	demo	2014-03-03 15:32:20.114896
parts_translation_foreign_keys	demo	2014-03-03 15:32:20.148754
project_customer_type_valid	demo	2014-03-03 15:32:20.174044
project_types	demo	2014-03-03 15:32:20.199814
rm_whitespaces	demo	2014-03-03 15:32:20.33268
add_tax_id_to_acc_trans	demo	2014-03-03 15:32:20.425237
add_warehouse_client_config_default	demo	2014-03-03 15:32:20.570894
balance_startdate_method	demo	2014-03-03 15:32:20.889657
currencies	demo	2014-03-03 15:32:20.898927
custom_variables_delete_via_trigger	demo	2014-03-03 15:32:21.114791
default_bin_parts	demo	2014-03-03 15:32:21.132301
defaults_signature	demo	2014-03-03 15:32:21.148115
delete_close_follow_ups_when_order_is_deleted_closed	demo	2014-03-03 15:32:21.156029
delete_cust_vend_tax	demo	2014-03-03 15:32:21.181409
delete_translations_on_delivery_term_delete	demo	2014-03-03 15:32:21.189957
drop_gifi_2	demo	2014-03-03 15:32:21.19852
oe_do_delete_via_trigger	demo	2014-03-03 15:32:21.206457
remove_role_from_employee	demo	2014-03-03 15:32:21.282405
tax_constraints	demo	2014-03-03 15:32:21.291449
add_fkey_tax_id_to_acc_trans	demo	2014-03-03 15:32:21.474356
custom_variables_delete_via_trigger_2	demo	2014-03-03 15:32:21.482444
steuerfilterung	demo	2014-03-03 15:32:21.500176
release_3_1_0	demo	2014-03-03 15:32:21.524202
\.


--
-- Data for Name: sepa_export; Type: TABLE DATA; Schema: public; Owner: -
--

COPY sepa_export (id, employee_id, executed, closed, itime, vc) FROM stdin;
\.


--
-- Data for Name: sepa_export_items; Type: TABLE DATA; Schema: public; Owner: -
--

COPY sepa_export_items (id, sepa_export_id, ap_id, chart_id, amount, reference, requested_execution_date, executed, execution_date, our_iban, our_bic, vc_iban, vc_bic, end_to_end_id, ar_id, our_depositor, vc_depositor, vc_mandator_id, vc_mandate_date_of_signature) FROM stdin;
\.


--
-- Data for Name: shipto; Type: TABLE DATA; Schema: public; Owner: -
--

COPY shipto (trans_id, shiptoname, shiptodepartment_1, shiptodepartment_2, shiptostreet, shiptozipcode, shiptocity, shiptocountry, shiptocontact, shiptophone, shiptofax, shiptoemail, itime, mtime, module, shipto_id, shiptocp_gender) FROM stdin;
\.


--
-- Data for Name: status; Type: TABLE DATA; Schema: public; Owner: -
--

COPY status (trans_id, formname, printed, emailed, spoolfile, chart_id, itime, mtime, id) FROM stdin;
\.


--
-- Data for Name: tax; Type: TABLE DATA; Schema: public; Owner: -
--

COPY tax (chart_id, rate, taxnumber, taxkey, taxdescription, itime, mtime, id, chart_categories) FROM stdin;
\N	0.00000	\N	0	Keine Steuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	0	ALQCIE
\N	0.00000	\N	1	USt-frei	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	373	ALQCIE
61	0.07000	3801	2	Umsatzsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	374	I
66	0.19000	3806	3	Umsatzsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	388	I
66	0.19000	3806	3	Umsatzsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	375	I
65	0.16000	3805	5	Umsatzsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	376	I
32	0.16000	1405	7	Vorsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	378	E
28	0.07000	1401	8	Vorsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	377	E
33	0.19000	1406	9	Vorsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	379	E
33	0.19000	1406	9	Vorsteuer	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	389	E
\N	0.00000	\N	10	Im anderen EU-Staat steuerpflichtige Lieferung	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	380	I
\N	0.00000	\N	11	Steuerfreie innergem. Lieferung an Abnehmer mit Id.-Nr.	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	381	I
62	0.07000	3802	12	Steuerpflichtige EG-Lieferung zum ermäßigten Steuersatz	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	382	I
64	0.19000	3804	13	Steuerpflichtige EG-Lieferung zum vollen Steuersatz	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	383	I
63	0.16000	3803	15	Steuerpflicht. EG-Lieferungen%	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	384	I
30	0.16000	1403	17	Steuerpflicht. EG-Erwerb	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	386	E
29	0.07000	1402	18	Steuerpflichtiger innergem. Erwerb zum ermäßigten Steuersatz	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	385	E
31	0.19000	1404	19	Steuerpflichtiger innergem. Erwerb zum vollen Steuersatz	2012-08-17 12:51:15.918799	2014-03-03 15:32:21.500176	387	E
\.


--
-- Data for Name: tax_zones; Type: TABLE DATA; Schema: public; Owner: -
--

COPY tax_zones (id, description) FROM stdin;
0	Inland
1	EU mit USt-ID Nummer
2	EU ohne USt-ID Nummer
3	Außerhalb EU
\.


--
-- Data for Name: taxkeys; Type: TABLE DATA; Schema: public; Owner: -
--

COPY taxkeys (id, chart_id, tax_id, taxkey_id, pos_ustva, startdate) FROM stdin;
390	1	389	9	\N	1970-01-01
392	2	389	9	\N	1970-01-01
394	3	389	9	\N	1970-01-01
396	4	389	9	\N	1970-01-01
398	5	389	9	\N	1970-01-01
400	6	389	9	\N	1970-01-01
402	7	389	9	\N	1970-01-01
404	8	389	9	\N	1970-01-01
406	9	389	9	\N	1970-01-01
408	10	389	9	\N	1970-01-01
410	11	389	9	\N	1970-01-01
412	12	389	9	\N	1970-01-01
414	13	389	9	\N	1970-01-01
416	14	389	9	\N	1970-01-01
418	15	389	9	\N	1970-01-01
420	16	389	9	\N	1970-01-01
472	67	380	10	\N	1970-01-01
487	84	374	2	86	1970-01-01
488	85	382	12	86	1970-01-01
489	86	383	13	51	1970-01-01
490	87	380	10	\N	1970-01-01
491	88	383	13	51	1970-01-01
492	89	376	5	51	1970-01-01
495	91	388	3	51	1970-01-01
498	93	374	2	86	1970-01-01
499	94	376	5	51	1970-01-01
500	95	388	3	51	1970-01-01
502	96	388	3	\N	1970-01-01
504	97	388	3	51	1970-01-01
512	104	374	2	86	1970-01-01
514	106	388	3	51	1970-01-01
516	107	374	2	86	1970-01-01
518	109	388	3	51	1970-01-01
522	112	388	3	51	1970-01-01
524	113	374	2	86	1970-01-01
526	115	388	3	51	1970-01-01
528	116	388	3	51	1970-01-01
534	121	374	2	86	1970-01-01
535	122	388	3	51	1970-01-01
537	123	376	5	51	1970-01-01
538	124	382	12	86	1970-01-01
539	125	383	13	51	1970-01-01
542	128	374	2	86	1970-01-01
543	129	376	5	51	1970-01-01
544	130	388	3	51	1970-01-01
546	131	374	2	86	1970-01-01
547	132	388	3	51	1970-01-01
549	133	376	5	51	1970-01-01
550	134	374	2	86	1970-01-01
551	135	388	3	51	1970-01-01
553	136	376	5	51	1970-01-01
558	141	388	3	51	1970-01-01
561	143	388	3	51	1970-01-01
567	148	388	3	51	1970-01-01
569	149	388	3	51	1970-01-01
580	159	374	2	86	1970-01-01
581	160	388	3	51	1970-01-01
588	166	389	9	0	1970-01-01
590	167	377	8	\N	1970-01-01
591	168	389	9	\N	1970-01-01
593	169	385	18	93	1970-01-01
595	171	387	19	94	1970-01-01
605	181	377	8	\N	1970-01-01
606	182	378	7	\N	1970-01-01
609	184	377	8	\N	1970-01-01
610	185	389	9	\N	1970-01-01
612	186	378	7	\N	1970-01-01
613	187	377	8	\N	1970-01-01
614	188	389	9	\N	1970-01-01
616	189	378	7	\N	1970-01-01
622	195	389	9	\N	1970-01-01
624	196	385	18	\N	1970-01-01
625	197	387	19	\N	1970-01-01
661	234	374	2	86	1970-01-01
662	235	376	5	51	1970-01-01
663	236	388	3	51	1970-01-01
665	237	388	3	51	1970-01-01
667	238	389	9	\N	1970-01-01
670	240	389	9	\N	1970-01-01
672	241	389	9	\N	1970-01-01
674	242	389	9	\N	1970-01-01
677	244	389	9	\N	1970-01-01
679	245	389	9	\N	1970-01-01
681	246	389	9	\N	1970-01-01
683	247	389	9	\N	1970-01-01
685	248	389	9	\N	1970-01-01
689	251	389	9	\N	1970-01-01
699	260	389	9	\N	1970-01-01
701	261	389	9	\N	1970-01-01
703	262	389	9	\N	1970-01-01
705	263	389	9	\N	1970-01-01
710	267	389	9	\N	1970-01-01
712	268	389	9	\N	1970-01-01
716	271	389	9	\N	1970-01-01
594	170	387	19	89	1970-01-01
607	183	389	9	\N	1970-01-01
721	275	389	9	\N	1970-01-01
725	278	389	9	\N	1970-01-01
727	279	389	9	\N	1970-01-01
729	280	389	9	\N	1970-01-01
731	281	389	9	\N	1970-01-01
734	283	389	9	\N	1970-01-01
736	284	389	9	\N	1970-01-01
738	285	377	8	\N	1970-01-01
742	289	389	9	\N	1970-01-01
744	290	377	8	\N	1970-01-01
757	303	389	9	\N	1970-01-01
759	304	389	9	\N	1970-01-01
761	305	389	9	\N	1970-01-01
763	306	377	8	\N	1970-01-01
764	307	389	9	\N	1970-01-01
767	309	389	9	\N	1970-01-01
769	310	389	9	\N	1970-01-01
771	311	389	9	\N	1970-01-01
773	312	389	9	\N	1970-01-01
775	313	389	9	\N	1970-01-01
777	314	389	9	\N	1970-01-01
779	315	389	9	\N	1970-01-01
782	317	389	9	\N	1970-01-01
857	91	388	3	51	2007-01-01
858	95	388	3	51	2007-01-01
859	96	388	3	\N	2007-01-01
860	97	388	3	51	2007-01-01
861	106	388	3	51	2007-01-01
862	109	388	3	51	2007-01-01
863	112	388	3	51	2007-01-01
864	115	388	3	51	2007-01-01
865	116	388	3	51	2007-01-01
866	122	388	3	51	2007-01-01
867	130	388	3	51	2007-01-01
868	132	388	3	51	2007-01-01
869	135	388	3	51	2007-01-01
870	141	388	3	51	2007-01-01
871	143	388	3	51	2007-01-01
872	148	388	3	51	2007-01-01
873	149	388	3	51	2007-01-01
874	160	388	3	51	2007-01-01
875	236	388	3	51	2007-01-01
876	237	388	3	51	2007-01-01
877	1	389	9	\N	2007-01-01
878	2	389	9	\N	2007-01-01
879	3	389	9	\N	2007-01-01
880	4	389	9	\N	2007-01-01
881	5	389	9	\N	2007-01-01
882	6	389	9	\N	2007-01-01
883	7	389	9	\N	2007-01-01
884	8	389	9	\N	2007-01-01
885	9	389	9	\N	2007-01-01
886	10	389	9	\N	2007-01-01
887	11	389	9	\N	2007-01-01
888	12	389	9	\N	2007-01-01
889	13	389	9	\N	2007-01-01
890	14	389	9	\N	2007-01-01
891	15	389	9	\N	2007-01-01
892	16	389	9	\N	2007-01-01
893	166	389	9	0	2007-01-01
894	168	389	9	\N	2007-01-01
896	185	389	9	\N	2007-01-01
897	188	389	9	\N	2007-01-01
898	195	389	9	\N	2007-01-01
899	238	389	9	\N	2007-01-01
900	240	389	9	\N	2007-01-01
901	241	389	9	\N	2007-01-01
902	242	389	9	\N	2007-01-01
903	244	389	9	\N	2007-01-01
904	245	389	9	\N	2007-01-01
905	246	389	9	\N	2007-01-01
906	247	389	9	\N	2007-01-01
907	248	389	9	\N	2007-01-01
908	251	389	9	\N	2007-01-01
909	260	389	9	\N	2007-01-01
910	261	389	9	\N	2007-01-01
911	262	389	9	\N	2007-01-01
912	263	389	9	\N	2007-01-01
913	267	389	9	\N	2007-01-01
914	268	389	9	\N	2007-01-01
915	271	389	9	\N	2007-01-01
916	275	389	9	\N	2007-01-01
917	278	389	9	\N	2007-01-01
918	279	389	9	\N	2007-01-01
919	280	389	9	\N	2007-01-01
920	281	389	9	\N	2007-01-01
921	283	389	9	\N	2007-01-01
922	284	389	9	\N	2007-01-01
923	289	389	9	\N	2007-01-01
924	303	389	9	\N	2007-01-01
925	304	389	9	\N	2007-01-01
926	305	389	9	\N	2007-01-01
927	307	389	9	\N	2007-01-01
928	309	389	9	\N	2007-01-01
929	310	389	9	\N	2007-01-01
930	311	389	9	\N	2007-01-01
931	312	389	9	\N	2007-01-01
932	313	389	9	\N	2007-01-01
933	314	389	9	\N	2007-01-01
934	315	389	9	\N	2007-01-01
935	317	389	9	\N	2007-01-01
423	18	0	0	\N	1970-01-01
424	19	0	0	\N	1970-01-01
425	20	0	0	\N	1970-01-01
426	21	0	0	\N	1970-01-01
427	22	0	0	\N	1970-01-01
428	23	0	0	\N	1970-01-01
429	24	0	0	\N	1970-01-01
430	25	0	0	\N	1970-01-01
431	26	0	0	\N	1970-01-01
432	27	0	0	\N	1970-01-01
433	28	0	0	66	1970-01-01
434	29	0	0	61	1970-01-01
435	30	0	0	61	1970-01-01
437	32	0	0	66	1970-01-01
438	33	0	0	66	1970-01-01
439	34	0	0	\N	1970-01-01
436	31	0	0	61	1970-01-01
440	35	0	0	\N	1970-01-01
442	37	0	0	\N	1970-01-01
443	38	0	0	62	1970-01-01
444	39	0	0	\N	1970-01-01
445	40	0	0	\N	1970-01-01
446	41	0	0	\N	1970-01-01
447	42	0	0	\N	1970-01-01
448	43	0	0	\N	1970-01-01
449	44	0	0	\N	1970-01-01
451	46	0	0	\N	1970-01-01
452	47	0	0	\N	1970-01-01
453	48	0	0	\N	1970-01-01
454	49	0	0	\N	1970-01-01
455	50	0	0	\N	1970-01-01
456	51	0	0	\N	1970-01-01
457	52	0	0	\N	1970-01-01
458	53	0	0	\N	1970-01-01
459	54	0	0	\N	1970-01-01
460	55	0	0	\N	1970-01-01
462	57	0	0	\N	1970-01-01
463	58	0	0	\N	1970-01-01
464	59	0	0	\N	1970-01-01
465	60	0	0	\N	1970-01-01
466	61	0	0	\N	1970-01-01
467	62	0	0	\N	1970-01-01
468	63	0	0	\N	1970-01-01
470	65	0	0	\N	1970-01-01
473	68	0	0	\N	1970-01-01
474	69	0	0	\N	1970-01-01
475	70	0	0	\N	1970-01-01
476	71	0	0	\N	1970-01-01
477	72	0	0	\N	1970-01-01
478	73	0	0	\N	1970-01-01
479	74	0	0	\N	1970-01-01
480	75	0	0	\N	1970-01-01
481	76	0	0	48	1970-01-01
482	77	0	0	41	1970-01-01
483	78	0	0	\N	1970-01-01
484	79	0	0	\N	1970-01-01
485	80	0	0	\N	1970-01-01
486	83	0	0	\N	1970-01-01
497	92	0	0	0	1970-01-01
506	98	0	0	0	1970-01-01
507	99	0	0	0	1970-01-01
508	100	0	0	0	1970-01-01
509	101	0	0	\N	1970-01-01
510	102	0	0	\N	1970-01-01
511	103	0	0	\N	1970-01-01
513	105	0	0	\N	1970-01-01
517	108	0	0	\N	1970-01-01
520	110	0	0	0	1970-01-01
521	111	0	0	0	1970-01-01
525	114	0	0	\N	1970-01-01
530	117	0	0	\N	1970-01-01
531	118	0	0	\N	1970-01-01
532	119	0	0	\N	1970-01-01
533	120	0	0	\N	1970-01-01
540	126	0	0	\N	1970-01-01
541	127	0	0	\N	1970-01-01
554	137	0	0	0	1970-01-01
555	138	0	0	0	1970-01-01
556	139	0	0	0	1970-01-01
557	140	0	0	0	1970-01-01
560	142	0	0	\N	1970-01-01
563	144	0	0	\N	1970-01-01
564	145	0	0	\N	1970-01-01
565	146	0	0	\N	1970-01-01
566	147	0	0	\N	1970-01-01
571	150	0	0	\N	1970-01-01
572	151	0	0	\N	1970-01-01
573	152	0	0	\N	1970-01-01
574	153	0	0	\N	1970-01-01
575	154	0	0	\N	1970-01-01
576	155	0	0	\N	1970-01-01
577	156	0	0	\N	1970-01-01
578	157	0	0	\N	1970-01-01
579	158	0	0	\N	1970-01-01
583	161	0	0	0	1970-01-01
584	162	0	0	\N	1970-01-01
585	163	0	0	\N	1970-01-01
586	164	0	0	\N	1970-01-01
587	165	0	0	\N	1970-01-01
596	172	0	0	91	1970-01-01
598	174	0	0	0	1970-01-01
599	175	0	0	0	1970-01-01
600	176	0	0	0	1970-01-01
601	177	0	0	\N	1970-01-01
602	178	0	0	\N	1970-01-01
603	179	0	0	\N	1970-01-01
604	180	0	0	\N	1970-01-01
617	190	0	0	\N	1970-01-01
618	191	0	0	\N	1970-01-01
619	192	0	0	\N	1970-01-01
620	193	0	0	\N	1970-01-01
621	194	0	0	\N	1970-01-01
626	198	0	0	\N	1970-01-01
628	200	0	0	\N	1970-01-01
629	201	0	0	\N	1970-01-01
630	202	0	0	\N	1970-01-01
631	203	0	0	\N	1970-01-01
632	204	0	0	\N	1970-01-01
633	205	0	0	\N	1970-01-01
634	206	0	0	\N	1970-01-01
635	207	0	0	\N	1970-01-01
636	208	0	0	\N	1970-01-01
637	209	0	0	\N	1970-01-01
638	210	0	0	\N	1970-01-01
639	211	0	0	0	1970-01-01
640	212	0	0	\N	1970-01-01
641	213	0	0	\N	1970-01-01
642	214	0	0	\N	1970-01-01
643	215	0	0	\N	1970-01-01
644	216	0	0	\N	1970-01-01
645	217	0	0	\N	1970-01-01
646	218	0	0	\N	1970-01-01
647	219	0	0	\N	1970-01-01
648	220	0	0	\N	1970-01-01
649	221	0	0	\N	1970-01-01
650	222	0	0	\N	1970-01-01
651	223	0	0	\N	1970-01-01
652	224	0	0	\N	1970-01-01
653	225	0	0	\N	1970-01-01
654	226	0	0	\N	1970-01-01
655	227	0	0	\N	1970-01-01
656	228	0	0	\N	1970-01-01
657	229	0	0	\N	1970-01-01
658	230	0	0	\N	1970-01-01
659	232	0	0	\N	1970-01-01
660	233	0	0	\N	1970-01-01
669	239	0	0	\N	1970-01-01
676	243	0	0	\N	1970-01-01
687	249	0	0	\N	1970-01-01
688	250	0	0	0	1970-01-01
691	252	0	0	\N	1970-01-01
692	253	0	0	\N	1970-01-01
693	254	0	0	\N	1970-01-01
694	255	0	0	\N	1970-01-01
695	256	0	0	\N	1970-01-01
696	257	0	0	\N	1970-01-01
697	258	0	0	\N	1970-01-01
698	259	0	0	\N	1970-01-01
707	264	0	0	\N	1970-01-01
708	265	0	0	\N	1970-01-01
709	266	0	0	\N	1970-01-01
714	269	0	0	\N	1970-01-01
715	270	0	0	\N	1970-01-01
718	272	0	0	0	1970-01-01
719	273	0	0	\N	1970-01-01
720	274	0	0	\N	1970-01-01
723	276	0	0	\N	1970-01-01
461	56	0	0	\N	1970-01-01
724	277	0	0	\N	1970-01-01
733	282	0	0	\N	1970-01-01
739	286	0	0	\N	1970-01-01
471	66	0	0	811	1970-01-01
740	287	0	0	\N	1970-01-01
741	288	0	0	\N	1970-01-01
745	291	0	0	\N	1970-01-01
746	292	0	0	\N	1970-01-01
747	293	0	0	\N	1970-01-01
748	294	0	0	\N	1970-01-01
749	295	0	0	\N	1970-01-01
750	296	0	0	\N	1970-01-01
751	297	0	0	\N	1970-01-01
752	298	0	0	\N	1970-01-01
753	299	0	0	\N	1970-01-01
754	300	0	0	\N	1970-01-01
755	301	0	0	\N	1970-01-01
756	302	0	0	\N	1970-01-01
766	308	0	0	\N	1970-01-01
781	316	0	0	\N	1970-01-01
784	318	0	0	\N	1970-01-01
785	319	0	0	\N	1970-01-01
786	320	0	0	\N	1970-01-01
787	321	0	0	\N	1970-01-01
788	322	0	0	\N	1970-01-01
789	323	0	0	\N	1970-01-01
790	324	0	0	\N	1970-01-01
791	325	0	0	\N	1970-01-01
792	326	0	0	\N	1970-01-01
793	327	0	0	\N	1970-01-01
794	328	0	0	\N	1970-01-01
795	329	0	0	\N	1970-01-01
796	330	0	0	\N	1970-01-01
797	331	0	0	\N	1970-01-01
798	332	0	0	\N	1970-01-01
799	333	0	0	\N	1970-01-01
800	334	0	0	\N	1970-01-01
801	335	0	0	\N	1970-01-01
802	336	0	0	\N	1970-01-01
803	337	0	0	\N	1970-01-01
804	338	0	0	\N	1970-01-01
805	339	0	0	\N	1970-01-01
806	340	0	0	\N	1970-01-01
807	341	0	0	\N	1970-01-01
808	342	0	0	\N	1970-01-01
809	343	0	0	\N	1970-01-01
810	344	0	0	\N	1970-01-01
811	345	0	0	\N	1970-01-01
812	346	0	0	\N	1970-01-01
813	347	0	0	\N	1970-01-01
814	348	0	0	\N	1970-01-01
815	349	0	0	\N	1970-01-01
816	350	0	0	\N	1970-01-01
817	351	0	0	\N	1970-01-01
818	352	0	0	\N	1970-01-01
819	353	0	0	\N	1970-01-01
820	354	0	0	\N	1970-01-01
821	355	0	0	\N	1970-01-01
822	356	0	0	\N	1970-01-01
823	357	0	0	\N	1970-01-01
824	358	0	0	\N	1970-01-01
825	359	0	0	\N	1970-01-01
826	360	0	0	\N	1970-01-01
827	361	0	0	\N	1970-01-01
828	362	0	0	\N	1970-01-01
829	363	0	0	\N	1970-01-01
830	364	0	0	\N	1970-01-01
831	365	0	0	\N	1970-01-01
832	366	0	0	\N	1970-01-01
833	367	0	0	\N	1970-01-01
834	368	0	0	\N	1970-01-01
835	369	0	0	\N	1970-01-01
836	370	0	0	\N	1970-01-01
837	371	0	0	\N	1970-01-01
939	81	0	0	0	1970-01-01
940	82	0	0	0	1970-01-01
941	231	0	0	0	1970-01-01
1218	1217	389	9	\N	2007-01-01
1219	1217	389	9	\N	1970-01-01
1227	1226	0	0	\N	1970-01-01
1229	1228	0	0	\N	1970-01-01
1235	1234	0	0	\N	1970-01-01
450	45	0	0	\N	1970-01-01
627	199	0	0	\N	1970-01-01
422	17	0	0	\N	1970-01-01
1665	1664	0	0	\N	1970-01-01
441	36	0	0	\N	1970-01-01
856	90	388	3	81	2007-01-01
493	90	388	3	81	1970-01-01
895	183	389	9	\N	2007-01-01
597	173	0	0	\N	1970-01-01
469	64	0	0	891	1970-01-01
1910	1195	0	0	\N	1970-01-01
1911	1196	0	0	\N	1970-01-01
1912	1230	0	0	\N	1970-01-01
1913	1855	0	0	\N	1970-01-01
1906	66	0	0	811	2007-01-01
1908	61	0	0	861	2007-01-01
1909	64	0	0	891	2007-01-01
\.


--
-- Data for Name: todo_user_config; Type: TABLE DATA; Schema: public; Owner: -
--

COPY todo_user_config (employee_id, show_after_login, show_follow_ups, show_follow_ups_login, show_overdue_sales_quotations, show_overdue_sales_quotations_login, id) FROM stdin;
938	t	t	t	t	t	1
1473	t	t	t	t	t	2
1871	t	t	t	t	t	3
\.


--
-- Data for Name: transfer_type; Type: TABLE DATA; Schema: public; Owner: -
--

COPY transfer_type (id, direction, description, sortkey, itime, mtime) FROM stdin;
945	in	stock	1	2012-08-17 12:52:17.421306	\N
946	in	found	2	2012-08-17 12:52:17.421306	\N
947	in	correction	3	2012-08-17 12:52:17.421306	\N
948	out	used	4	2012-08-17 12:52:17.421306	\N
949	out	disposed	5	2012-08-17 12:52:17.421306	\N
950	out	back	6	2012-08-17 12:52:17.421306	\N
951	out	missing	7	2012-08-17 12:52:17.421306	\N
952	out	correction	9	2012-08-17 12:52:17.421306	\N
953	transfer	transfer	10	2012-08-17 12:52:17.421306	\N
954	transfer	correction	11	2012-08-17 12:52:17.421306	\N
955	out	shipped	12	2012-08-17 12:52:18.686577	\N
\.


--
-- Data for Name: translation; Type: TABLE DATA; Schema: public; Owner: -
--

COPY translation (parts_id, language_id, translation, itime, mtime, longdescription, id) FROM stdin;
\.


--
-- Data for Name: units; Type: TABLE DATA; Schema: public; Owner: -
--

COPY units (name, base_unit, factor, type, sortkey, id) FROM stdin;
Std	min	60.00000	service	4	4
min	\N	0.00000	service	5	5
kg	g	1000.00000	dimension	7	7
g	mg	1000.00000	dimension	8	8
mg	\N	\N	dimension	9	9
ml	\N	\N	dimension	11	11
m	\N	\N	\N	12	12
psch	\N	\N	service	2	2
Stck	\N	\N	dimension	1	1
km	m	1000.00000	\N	13	13
Tag	Std	8.00000	service	3	3
t	kg	1000.00000	dimension	6	6
m²	\N	\N	\N	14	14
L	ml	1000.00000	dimension	10	10
Monat	Tag	30.00000	\N	15	15
\.


--
-- Data for Name: units_language; Type: TABLE DATA; Schema: public; Owner: -
--

COPY units_language (unit, language_id, localized, localized_plural, id) FROM stdin;
\.


--
-- Data for Name: vendor; Type: TABLE DATA; Schema: public; Owner: -
--

COPY vendor (id, name, department_1, department_2, street, zipcode, city, country, contact, phone, fax, homepage, email, notes, terms, taxincluded, vendornumber, cc, bcc, business_id, taxnumber, discount, creditlimit, account_number, bank_code, bank, language, itime, mtime, obsolete, username, user_password, salesman_id, v_customer_id, language_id, payment_id, taxzone_id, greeting, ustid, iban, bic, direct_debit, depositor, delivery_term_id, currency_id) FROM stdin;
1022	Siemann AG			Siemanstraße 1	80333	München	Germany	Herr Walter Siemann	019055555	019055556	siemann.de	siemann@siemann.de		\N	\N	70000	\N		\N		0	0.00000				\N	2012-08-17 13:03:43.23901	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Siemann AG	\N	1
1028	Krapp Stahl AG			Krappstr. 1	44787	Bochum	Germany	Herr Karl Heinz Krapp	0180123456	0180123455	krapp.de	h.krapp@krapp.de		\N	\N	70003	\N		\N		0	0.00000				\N	2012-08-17 13:10:07.880346	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Krapp Stahl AG	\N	1
1030	E-M-O Kabel und Systeme GmbH & Co. KG			Rostockstraße 22	44866	Bochum	Germany	Herr Rüdiger Emolta	54554564645	54554564646	http://e-m-o.de	rue@e-m-o.de		\N	\N	70002	\N		\N		0	0.00000				\N	2012-08-17 13:12:56.467125	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	E-M-O Kabel und Systeme GmbH & Co. KG	\N	1
1024	Schuettstahl Hamburg GmbH			Reuterstraße 55	22113	Hamburg	Germany	Herr Heinrich Schuett	040040040	040040042	http://schuettstahl.de	h.schuett@schuettstahl.de		\N	\N	70001	\N		\N		0	0.00000				\N	2012-08-17 13:07:12.390341	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Schuettstahl Hamburg GmbH	\N	1
1032	Dogerpillar Inc.			Grafstraße 128	85748	Garching bei München	Germany	Herr Michael Zuchtmann	0180232225	0180232223	http://dogerpillar.de	zucht@dogerpillar.de		\N	\N	70004	\N		\N		0	0.00000				\N	2012-08-20 10:25:33.441571	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Dogerpillar Inc.	\N	1
1082	Saint-Bain Isoler G+H AG			Obermeister-Grünzweig-Straße 1	67059	Ludwigshafen	Germany	Herr Elmar Wiese	062105689414	062105689111	stbain.de	wiese@stbrain.de		\N	\N	70008	\N		\N		0	0.00000				\N	2012-08-20 12:11:15.098889	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Saint-Bain Isoler G+H AG	\N	1
1059	Pfeiferrer AG			Clintondamm 12	40476	Düsseldorf	Germany	Herr Elmar Geißrockerer	02116117891	02116111891	http://pfeiferrer-ag.de	verantwortung@pfeiferrer-ag.de		\N	\N	80001	\N		\N		0	0.00000				\N	2012-08-20 11:13:19.67183	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Pfeiferrer AG	\N	1
1052	Malermeister Schmidt			Siemensstraße 8	72766	Reutlingen	Germany	Frau Mandy Schmidt	07137418453	07137418455	http://malenschmidti.de	Schmidt@malenschmidti.de		\N	\N	80000	\N		\N		0	0.00000				\N	2012-08-20 11:07:09.555976	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Malermeister Schmidt	\N	1
1062	Phänocolor GmbH			in der Heinebeck 33	45143	Essen	Germany	Frau Hildegard Stahlbrecher	020156465456	020156465459	http://phaenomen.de	Brecher@phaenomen.de		\N	\N	70005	\N		\N		0	0.00000				\N	2012-08-20 11:17:59.488307	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Phänocolor GmbH	\N	1
1074	Schattel GmbH			Junstraße 99	56322	Spay/Rhein	Germany	Herr Prof. Dr.-Ing. Gerhard Jansen	026283654846	026283654848	schattel.de	info@schattel.de		\N	\N	70006	\N		\N		0	0.00000				\N	2012-08-20 11:51:11.511302	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Schattel GmbH	\N	1
1076	H. Bugging GmbH & Co. KG			Gifthorner Straße 59	29379	Knesebeck	Germany	Herr Herman Bugging	058345467468486	058345467468486100	bugging.de	geschaeftsführung@bugging.de		\N	\N	70007	\N		\N		0	0.00000				\N	2012-08-20 11:54:37.968103	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	H. Bugging GmbH & Co. KG	\N	1
1085	FKI- Florakonstant International GmbH			Moorfleeter Deich 165	22113	Hamburg	Germany	Frau Barbara Brennessel	0406794522	0406794510	http://fki.de	bb@fki.de		\N	\N	70009	\N		\N		0	0.00000				\N	2012-08-20 12:25:14.049899	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	FKI- Florakonstant International GmbH	\N	1
1139	Igel GmbH			Spicher Str. 100	51147	Köln	Germany	Herr Frank Luft	0220341687641	0220341687100	igel.de	luft@igel.de		\N	\N	70010	\N		\N		0	0.00000				\N	2012-08-20 15:17:44.304196	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Igel GmbH	\N	1
1078	Bellen Electronics GmbH			Im Gewerbepark 5	58579	Schalksmühle	Germany	Frau Gabriele Flusenleiter	071278865	07127886510	http://belelec.de	g.flusenlkeiter@belelec.de		\N	\N	70011	\N		\N		0	0.00000				\N	2012-08-20 11:59:22.300962	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Bellen Electronics GmbH	\N	1
1050	KULE Kurt Leisenschlager GmbH & Co. KG			Schmiedestraße 10	28870	Ottersberg	Germany	Herr Kurt Leisenschlager	042056714349449	042056714349500	http://kule.de	kule@kule.de		\N	\N	70012	\N		\N		0	0.00000				\N	2012-08-20 10:56:47.271233	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	KULE Kurt Leisenschlager GmbH & Co. KG	\N	1
1323	office aldi Vertrieb für Bürobedarf GmbH			Sesamstraße 2	85374	Neufahrn bei München 	Germany	Dr. Peter Fischbaum	0800 924678	0800 92467800	oaldi.de	Fischbaum@oaldi.de		\N	\N	70013	\N		\N		0	0.00000				\N	2012-08-30 14:55:15.873101	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	office aldi Vertrieb für Bürobedarf GmbH	\N	1
1343	Dill GmbH			Unterschweinstiege 12	60549	Frankfurt am Main	Germany	Frau Barabara Sommmann	069 5464814	069 5464816	dill.de	dill@dill.de		\N	\N	70014	\N		\N		0	0.00000				\N	2012-09-03 11:36:46.386404	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Dill GmbH	\N	1
1349	Martin Steigmann			Fritz-Reuter-Straße 5	19246	Zarrentin	Germany	Herr Martin Steigmann	038851 80193	038851 80190		msteigmann@steigmann.de		\N	\N	60000	\N		\N		0	0.00000				\N	2012-09-03 15:44:02.515112	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Martin Steigmann	\N	1
1401	Nordic Ship OY			Swensenstr. 2	84245	Helsinki	Finnland	Yorik Scjoredöv	00358 580934	00358 580934-8	http://nordic-ship.com	yorik.s@nordic-ship.com		\N	\N	70015	\N		\N		0	0.00000				\N	2012-09-12 11:30:23.037042	2014-03-03 15:32:20.898927	f			\N		\N	\N	1		FI3458357			f	Nordic Ship OY	\N	1
1035	Brombeere und Cess GmbH & Co. KG			Rehbergstraße 90	72336	Balingen	Germany	Herr Josef Brombeere	0215446531266	0215446531265	http://obst.de	brombeere@obst.de		\N	\N	80002	\N		\N		0	0.00000				\N	2012-08-20 10:27:08.746563	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Brombeere und Cess GmbH & Co. KG	\N	1
1039	Grohe Water GmbH			zur Porta 12	32457	Porta Westfalica	Germany	Herr Michael Reiterkuss	05716147518	05716147523	http://grothewater.de	impressum@grothewater.de		\N	\N	80003	\N		\N		0	0.00000				\N	2012-08-20 10:34:21.386444	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Grohe Water GmbH	\N	1
1043	Deken Innenausbau GmbH und Co.KG			Südring 30	49751	Sögel	Germany	Herr Hermann Deken	0595246541681	05952465416100	http://deken-gruppe.de	info@deken-gruppe.de		\N	\N	80004	\N		\N		0	0.00000				\N	2012-08-20 10:40:11.600645	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Deken Innenausbau GmbH und Co.KG	\N	1
1041	Reiter Innenausbau GmbH & Co.KG			Emdener Straße 12	26427	Esens	Germany	Herr Wolfram Reiter	0715461763831	0715461763352	http://reiter-innenausbau.de	verwaltung@reiter-innausbau.de		\N	\N	80005	\N		\N		0	0.00000				\N	2012-08-20 10:37:50.160316	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Reiter Innenausbau GmbH & Co.KG	\N	1
1080	K. Albrecht Brautechnik GmbH			Hans-Schwan-Str.4	81829	München	Germany	Herr Alexander Dem	08933433562	08933433565	http://kab.de	dem@kab.de		\N	\N	80006	\N		\N		0	0.00000				\N	2012-08-20 12:06:58.884776	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	K. Albrecht Brautechnik GmbH	\N	1
1190	Panther Ship Design, Siegfriegd Schiller und Kai Junge GbR			Trabantstr.36	20354	Hamburg	Germany	Herr Siegfried Schiller	040452369	040452368	http://pasd.de	design@pasd.de		\N	\N	80007	\N		\N		0	0.00000				\N	2012-08-21 11:12:12.00272	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Panther Ship Design, Siegfriegd Schiller und Kai Junge GbR	\N	1
1397	Big Boom Business LLC			Cowboystreet 14	94267	Texas	USA	Mr. Dwayne Smith	08765 804839	08765 804839-2	http://big-boom-business.com	Dwayne.S@BBB.com		\N	\N	80008	\N		\N		0	0.00000				\N	2012-09-12 11:27:30.706666	2014-03-03 15:32:20.898927	f			\N		\N	\N	3					f	Big Boom Business LLC	\N	2
1821	Kronleuchter United			Reuterstraße 13	19246	Zarrentin	Germany	Herr Walter Busch	038851 8461898	038851 84618112	krondeluxe.de	Busch@krondeluxe.de		\N	\N	70016	\N		\N		0	0.00000				\N	2012-10-08 15:27:18.079632	2014-03-03 15:32:20.898927	f			\N		\N	\N	0					f	Kronleuchter United	\N	1
\.


--
-- Data for Name: warehouse; Type: TABLE DATA; Schema: public; Owner: -
--

COPY warehouse (id, description, itime, mtime, sortkey, invalid) FROM stdin;
956	Stahllager Industriepark Gallin	2012-08-17 12:54:39.431761	2012-08-17 12:54:39.431761	1	f
958	Motorenlager Megapark Heisterbusch	2012-08-17 12:55:17.503286	2012-08-17 12:55:17.503286	2	f
969	Lagerhalle Fertigung	2012-08-17 12:55:48.385448	2012-08-17 12:55:48.385448	3	f
\.


SET search_path = tax, pg_catalog;

--
-- Data for Name: report_categories; Type: TABLE DATA; Schema: tax; Owner: -
--

COPY report_categories (id, description, subdescription) FROM stdin;
0		
1	Lieferungen und sonstige Leistungen	(einschließlich unentgeltlicher Wertabgaben)
2	Innergemeinschaftliche Erwerbe	
3	Ergänzende Angaben zu Umsätzen	
99	Summe	
\.


--
-- Data for Name: report_headings; Type: TABLE DATA; Schema: tax; Owner: -
--

COPY report_headings (id, category_id, type, description, subdescription) FROM stdin;
0	0			
1	1	received	Steuerfreie Umsätze mit Vorsteuerabzug	
2	1	recieved	Steuerfreie Umsätze ohne Vorsteuerabzug	
3	1	recieved	Steuerpflichtige Umsätze	(Lieferungen und sonstige Leistungen einschl. unentgeltlicher Wertabgaben)
4	2	recieved	Steuerfreie innergemeinschaftliche Erwerbe	
5	2	recieved	Steuerpflichtige innergemeinschaftliche Erwerbe	
6	3	recieved	Umsätze, für die als Leistungsempfänger die Steuer nach § 13b Abs. 2 UStG geschuldet wird	
66	3	recieved		
7	3	paied	Abziehbare Vorsteuerbeträge	
8	3	paied	Andere Steuerbeträge	
99	99		Summe	
\.


--
-- Data for Name: report_variables; Type: TABLE DATA; Schema: tax; Owner: -
--

COPY report_variables (id, "position", heading_id, description, taxbase, dec_places, valid_from) FROM stdin;
0	keine	0	< < < keine UStVa Position > > >			1970-01-01
1	41	1	Innergemeinschaftliche Lieferungen (§ 4 Nr. 1 Buchst. b UStG) an Abnehmer mit USt-IdNr.	0	0	1970-01-01
2	44	1	neuer Fahrzeuge an Abnehmer ohne USt-IdNr.	0	0	1970-01-01
3	49	1	neuer Fahrzeuge außerhalb eines Unternehmens (§ 2a UStG)	0	0	1970-01-01
4	43	1	Weitere steuerfreie Umsätze mit Vorsteuerabzug	0	0	1970-01-01
5	48	2	Umsätze nach § 4 Nr. 8 bis 28 UStG	0	0	1970-01-01
6	51	3	zum Steuersatz von 16 %	0	0	1970-01-01
7	511	3		6	2	1970-01-01
8	81	3	zum Steuersatz von 19 %	0	0	1970-01-01
9	811	3		8	2	1970-01-01
10	86	3	zum Steuersatz von 7 %	0	0	1970-01-01
11	861	3		10	2	1970-01-01
12	35	3	Umsätze, die anderen Steuersätzen unterliegen	0	0	1970-01-01
13	36	3		12	2	1970-01-01
14	77	3	Lieferungen in das übrige Gemeinschaftsgebiet an Abnehmer mit USt-IdNr.	0	0	1970-01-01
15	76	3	Umsätze, für die eine Steuer nach § 24 UStG zu entrichten ist	0	0	1970-01-01
16	80	3		15	2	1970-01-01
17	91	4	Erwerbe nach § 4b UStG	0	0	1970-01-01
18	97	5	zum Steuersatz von 16 %	0	0	1970-01-01
19	971	5		18	2	1970-01-01
20	89	5	zum Steuersatz von 19 %	0	0	1970-01-01
21	891	5		20	2	1970-01-01
22	93	5	zum Steuersatz von 7 %	0	0	1970-01-01
23	931	5		22	2	1970-01-01
24	95	5	zu anderen Steuersätzen	0	0	1970-01-01
25	98	5		24	2	1970-01-01
26	94	5	neuer Fahrzeuge von Lieferern ohne USt-IdNr. zum allgemeinen Steuersatz	0	0	1970-01-01
27	96	5		26	2	1970-01-01
28	42	66	Lieferungen des ersten Abnehmers bei innergemeinschaftlichen Dreiecksgeschäften (§ 25b Abs. 2 UStG)	0	0	1970-01-01
29	60	66	Steuerpflichtige Umsätze im Sinne des § 13b Abs. 1 Satz 1 Nr. 1 bis 5 UStG, für die der Leistungsempfänger die Steuer schuldet	0	0	1970-01-01
30	45	66	Nicht steuerbare Umsätze (Leistungsort nicht im Inland)	0	0	1970-01-01
31	52	6	Leistungen eines im Ausland ansässigen Unternehmers (§ 13b Abs. 1 Satz 1 Nr. 1 und 5 UStG)	0	0	1970-01-01
32	53	6		31	2	1970-01-01
33	73	6	Lieferungen sicherungsübereigneter Gegenstände und Umsätze, die unter das GrEStG fallen (§ 13b Abs. 1 Satz 1 Nr. 2 und 3 UStG)	0	0	1970-01-01
34	74	6		33	2	1970-01-01
35	84	6	Bauleistungen eines im Inland ansässigen Unternehmers (§ 13b Abs. 1 Satz 1 Nr. 4 UStG)	0	0	1970-01-01
36	85	6		35	2	1970-01-01
37	65	6	Steuer infolge Wechsels der Besteuerungsform sowie Nachsteuer auf versteuerte Anzahlungen u. ä. wegen Steuersatzänderung		2	1970-01-01
38	66	7	Vorsteuerbeträge aus Rechnungen von anderen Unternehmern (§ 15 Abs. 1 Satz 1 Nr. 1 UStG), aus Leistungen im Sinne des § 13a Abs. 1 Nr. 6 UStG (§ 15 Abs. 1 Satz 1 Nr. 5 UStG) und aus innergemeinschaftlichen Dreiecksgeschäften (§ 25b Abs. 5 UStG)		2	1970-01-01
39	61	7	Vorsteuerbeträge aus dem innergemeinschaftlichen Erwerb von Gegenständen (§ 15 Abs. 1 Satz 1 Nr. 3 UStG)		2	1970-01-01
40	62	7	Entrichtete Einfuhrumsatzsteuer (§ 15 Abs. 1 Satz 1 Nr. 2 UStG)		2	1970-01-01
41	67	7	Vorsteuerbeträge aus Leistungen im Sinne des § 13b Abs. 1 UStG (§ 15 Abs. 1 Satz 1 Nr. 4 UStG)		2	1970-01-01
42	63	7	Vorsteuerbeträge, die nach allgemeinen Durchschnittssätzen berechnet sind (§§ 23 und 23a UStG)		2	1970-01-01
43	64	7	Berichtigung des Vorsteuerabzugs (§ 15a UStG)		2	1970-01-01
44	59	7	Vorsteuerabzug für innergemeinschaftliche Lieferungen neuer Fahrzeuge außerhalb eines Unternehmens (§ 2a UStG) sowie von Kleinunternehmern im Sinne des § 19 Abs. 1 UStG (§ 15 Abs. 4a UStG)		2	1970-01-01
45	69	8	in Rechnungen unrichtig oder unberechtigt ausgewiesene Steuerbeträge (§ 14c UStG) sowie Steuerbeträge, die nach § 4 Nr. 4a Satz 1 Buchst. a Satz 2, § 6a Abs. 4 Satz 2, § 17 Abs. 1 Satz 6 oder § 25b Abs. 2 UStG geschuldet werden		2	1970-01-01
46	39	8	Anrechnung (Abzug) der festgesetzten Sondervorauszahlung für Dauerfristverlängerung (nur auszufüllen in der letzten Voranmeldung des Besteuerungszeitraums, in der Regel Dezember)		2	1970-01-01
47	21	66	Nicht steuerbare sonstige Leistungen gem. § 18b Satz 1 Nr. 2 UStG	0	0	2010-01-01
48	46	6	Im Inland steuerpflichtige sonstige Leistungen von im übrigen Gemeinschaftsgebiet ansässigen Unternehmen (§13b Abs. 1 UStG)	0	0	2010-01-01
49	47	6		49	2	2010-01-01
50	83	8	Verbleibender Überschuss - bitte dem Betrag ein Minuszeichen voranstellen -	0	2	2010-01-01
\.


SET search_path = public, pg_catalog;

--
-- Name: acc_trans_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY acc_trans
    ADD CONSTRAINT acc_trans_pkey PRIMARY KEY (acc_trans_id);


--
-- Name: ap_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_pkey PRIMARY KEY (id);


--
-- Name: ar_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_pkey PRIMARY KEY (id);


--
-- Name: assembly_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY assembly
    ADD CONSTRAINT assembly_pkey PRIMARY KEY (assembly_id);


--
-- Name: background_job_histories_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY background_job_histories
    ADD CONSTRAINT background_job_histories_pkey PRIMARY KEY (id);


--
-- Name: background_jobs_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY background_jobs
    ADD CONSTRAINT background_jobs_pkey PRIMARY KEY (id);


--
-- Name: bank_accounts_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY bank_accounts
    ADD CONSTRAINT bank_accounts_pkey PRIMARY KEY (id);


--
-- Name: bin_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY bin
    ADD CONSTRAINT bin_pkey PRIMARY KEY (id);


--
-- Name: buchungsgruppen_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY buchungsgruppen
    ADD CONSTRAINT buchungsgruppen_pkey PRIMARY KEY (id);


--
-- Name: business_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY business
    ADD CONSTRAINT business_pkey PRIMARY KEY (id);


--
-- Name: chart_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY chart
    ADD CONSTRAINT chart_pkey PRIMARY KEY (id);


--
-- Name: contacts_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY contacts
    ADD CONSTRAINT contacts_pkey PRIMARY KEY (cp_id);


--
-- Name: csv_import_profile_settings_csv_import_profile_id_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY csv_import_profile_settings
    ADD CONSTRAINT csv_import_profile_settings_csv_import_profile_id_key UNIQUE (csv_import_profile_id, key);


--
-- Name: csv_import_profile_settings_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY csv_import_profile_settings
    ADD CONSTRAINT csv_import_profile_settings_pkey PRIMARY KEY (id);


--
-- Name: csv_import_profiles_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY csv_import_profiles
    ADD CONSTRAINT csv_import_profiles_pkey PRIMARY KEY (id);


--
-- Name: csv_import_report_rows_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY csv_import_report_rows
    ADD CONSTRAINT csv_import_report_rows_pkey PRIMARY KEY (id);


--
-- Name: csv_import_report_status_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY csv_import_report_status
    ADD CONSTRAINT csv_import_report_status_pkey PRIMARY KEY (id);


--
-- Name: csv_import_reports_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY csv_import_reports
    ADD CONSTRAINT csv_import_reports_pkey PRIMARY KEY (id);


--
-- Name: currencies_name_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY currencies
    ADD CONSTRAINT currencies_name_key UNIQUE (name);


--
-- Name: currencies_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY currencies
    ADD CONSTRAINT currencies_pkey PRIMARY KEY (id);


--
-- Name: custom_variable_configs_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY custom_variable_configs
    ADD CONSTRAINT custom_variable_configs_pkey PRIMARY KEY (id);


--
-- Name: custom_variables_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY custom_variables
    ADD CONSTRAINT custom_variables_pkey PRIMARY KEY (id);


--
-- Name: custom_variables_validity_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY custom_variables_validity
    ADD CONSTRAINT custom_variables_validity_pkey PRIMARY KEY (id);


--
-- Name: customer_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_pkey PRIMARY KEY (id);


--
-- Name: datev_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY datev
    ADD CONSTRAINT datev_pkey PRIMARY KEY (id);


--
-- Name: defaults_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY defaults
    ADD CONSTRAINT defaults_pkey PRIMARY KEY (id);


--
-- Name: delivery_order_items_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY delivery_order_items
    ADD CONSTRAINT delivery_order_items_pkey PRIMARY KEY (id);


--
-- Name: delivery_order_items_stock_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY delivery_order_items_stock
    ADD CONSTRAINT delivery_order_items_stock_pkey PRIMARY KEY (id);


--
-- Name: delivery_orders_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_pkey PRIMARY KEY (id);


--
-- Name: delivery_terms_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY delivery_terms
    ADD CONSTRAINT delivery_terms_pkey PRIMARY KEY (id);


--
-- Name: department_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY department
    ADD CONSTRAINT department_pkey PRIMARY KEY (id);


--
-- Name: drafts_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY drafts
    ADD CONSTRAINT drafts_pkey PRIMARY KEY (id);


--
-- Name: dunning_config_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY dunning_config
    ADD CONSTRAINT dunning_config_pkey PRIMARY KEY (id);


--
-- Name: dunning_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY dunning
    ADD CONSTRAINT dunning_pkey PRIMARY KEY (id);


--
-- Name: employee_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY employee
    ADD CONSTRAINT employee_pkey PRIMARY KEY (id);


--
-- Name: exchangerate_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY exchangerate
    ADD CONSTRAINT exchangerate_pkey PRIMARY KEY (id);


--
-- Name: finanzamt_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY finanzamt
    ADD CONSTRAINT finanzamt_pkey PRIMARY KEY (id);


--
-- Name: follow_up_access_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY follow_up_access
    ADD CONSTRAINT follow_up_access_pkey PRIMARY KEY (id);


--
-- Name: follow_up_links_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY follow_up_links
    ADD CONSTRAINT follow_up_links_pkey PRIMARY KEY (id);


--
-- Name: follow_ups_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY follow_ups
    ADD CONSTRAINT follow_ups_pkey PRIMARY KEY (id);


--
-- Name: generic_translations_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY generic_translations
    ADD CONSTRAINT generic_translations_pkey PRIMARY KEY (id);


--
-- Name: gl_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY gl
    ADD CONSTRAINT gl_pkey PRIMARY KEY (id);


--
-- Name: history_erp_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY history_erp
    ADD CONSTRAINT history_erp_pkey PRIMARY KEY (id);


--
-- Name: inventory_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_pkey PRIMARY KEY (id);


--
-- Name: invoice_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY invoice
    ADD CONSTRAINT invoice_pkey PRIMARY KEY (id);


--
-- Name: language_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY language
    ADD CONSTRAINT language_pkey PRIMARY KEY (id);


--
-- Name: makemodel_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY makemodel
    ADD CONSTRAINT makemodel_pkey PRIMARY KEY (id);


--
-- Name: notes_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY notes
    ADD CONSTRAINT notes_pkey PRIMARY KEY (id);


--
-- Name: oe_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_pkey PRIMARY KEY (id);


--
-- Name: orderitems_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY orderitems
    ADD CONSTRAINT orderitems_pkey PRIMARY KEY (id);


--
-- Name: parts_partnumber_key1; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_partnumber_key1 UNIQUE (partnumber);


--
-- Name: parts_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_pkey PRIMARY KEY (id);


--
-- Name: partsgroup_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY partsgroup
    ADD CONSTRAINT partsgroup_pkey PRIMARY KEY (id);


--
-- Name: payment_terms_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY payment_terms
    ADD CONSTRAINT payment_terms_pkey PRIMARY KEY (id);


--
-- Name: periodic_invoices_configs_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY periodic_invoices_configs
    ADD CONSTRAINT periodic_invoices_configs_pkey PRIMARY KEY (id);


--
-- Name: periodic_invoices_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY periodic_invoices
    ADD CONSTRAINT periodic_invoices_pkey PRIMARY KEY (id);


--
-- Name: price_factors_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY price_factors
    ADD CONSTRAINT price_factors_pkey PRIMARY KEY (id);


--
-- Name: pricegroup_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY pricegroup
    ADD CONSTRAINT pricegroup_pkey PRIMARY KEY (id);


--
-- Name: prices_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY prices
    ADD CONSTRAINT prices_pkey PRIMARY KEY (id);


--
-- Name: printers_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY printers
    ADD CONSTRAINT printers_pkey PRIMARY KEY (id);


--
-- Name: project_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY project
    ADD CONSTRAINT project_pkey PRIMARY KEY (id);


--
-- Name: project_projectnumber_key; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY project
    ADD CONSTRAINT project_projectnumber_key UNIQUE (projectnumber);


--
-- Name: project_types_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY project_types
    ADD CONSTRAINT project_types_pkey PRIMARY KEY (id);


--
-- Name: record_links_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY record_links
    ADD CONSTRAINT record_links_pkey PRIMARY KEY (id);


--
-- Name: schema_info_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY schema_info
    ADD CONSTRAINT schema_info_pkey PRIMARY KEY (tag);


--
-- Name: sepa_export_items_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY sepa_export_items
    ADD CONSTRAINT sepa_export_items_pkey PRIMARY KEY (id);


--
-- Name: sepa_export_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY sepa_export
    ADD CONSTRAINT sepa_export_pkey PRIMARY KEY (id);


--
-- Name: shipto_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY shipto
    ADD CONSTRAINT shipto_pkey PRIMARY KEY (shipto_id);


--
-- Name: status_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY status
    ADD CONSTRAINT status_pkey PRIMARY KEY (id);


--
-- Name: tax_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY tax
    ADD CONSTRAINT tax_pkey PRIMARY KEY (id);


--
-- Name: tax_zones_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY tax_zones
    ADD CONSTRAINT tax_zones_pkey PRIMARY KEY (id);


--
-- Name: taxkeys_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY taxkeys
    ADD CONSTRAINT taxkeys_pkey PRIMARY KEY (id);


--
-- Name: todo_user_config_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY todo_user_config
    ADD CONSTRAINT todo_user_config_pkey PRIMARY KEY (id);


--
-- Name: transfer_type_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY transfer_type
    ADD CONSTRAINT transfer_type_pkey PRIMARY KEY (id);


--
-- Name: translation_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY translation
    ADD CONSTRAINT translation_pkey PRIMARY KEY (id);


--
-- Name: units_id_unique; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY units
    ADD CONSTRAINT units_id_unique UNIQUE (id);


--
-- Name: units_language_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY units_language
    ADD CONSTRAINT units_language_pkey PRIMARY KEY (id);


--
-- Name: units_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY units
    ADD CONSTRAINT units_pkey PRIMARY KEY (name);


--
-- Name: vendor_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY vendor
    ADD CONSTRAINT vendor_pkey PRIMARY KEY (id);


--
-- Name: warehouse_pkey; Type: CONSTRAINT; Schema: public; Owner: -; Tablespace: 
--

ALTER TABLE ONLY warehouse
    ADD CONSTRAINT warehouse_pkey PRIMARY KEY (id);


SET search_path = tax, pg_catalog;

--
-- Name: report_categorys_pkey; Type: CONSTRAINT; Schema: tax; Owner: -; Tablespace: 
--

ALTER TABLE ONLY report_categories
    ADD CONSTRAINT report_categorys_pkey PRIMARY KEY (id);


--
-- Name: report_headings_pkey; Type: CONSTRAINT; Schema: tax; Owner: -; Tablespace: 
--

ALTER TABLE ONLY report_headings
    ADD CONSTRAINT report_headings_pkey PRIMARY KEY (id);


--
-- Name: report_variables_pkey; Type: CONSTRAINT; Schema: tax; Owner: -; Tablespace: 
--

ALTER TABLE ONLY report_variables
    ADD CONSTRAINT report_variables_pkey PRIMARY KEY (id);


SET search_path = public, pg_catalog;

--
-- Name: acc_trans_chart_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX acc_trans_chart_id_key ON acc_trans USING btree (chart_id);


--
-- Name: acc_trans_source_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX acc_trans_source_key ON acc_trans USING btree (lower(source));


--
-- Name: acc_trans_trans_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX acc_trans_trans_id_key ON acc_trans USING btree (trans_id);


--
-- Name: acc_trans_transdate_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX acc_trans_transdate_key ON acc_trans USING btree (transdate);


--
-- Name: ap_employee_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_employee_id_key ON ap USING btree (employee_id);


--
-- Name: ap_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_id_key ON ap USING btree (id);


--
-- Name: ap_invnumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_invnumber_key ON ap USING btree (lower(invnumber));


--
-- Name: ap_ordnumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_ordnumber_key ON ap USING btree (lower(ordnumber));


--
-- Name: ap_quonumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_quonumber_key ON ap USING btree (lower(quonumber));


--
-- Name: ap_transdate_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_transdate_key ON ap USING btree (transdate);


--
-- Name: ap_vendor_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ap_vendor_id_key ON ap USING btree (vendor_id);


--
-- Name: ar_customer_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_customer_id_key ON ar USING btree (customer_id);


--
-- Name: ar_employee_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_employee_id_key ON ar USING btree (employee_id);


--
-- Name: ar_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_id_key ON ar USING btree (id);


--
-- Name: ar_invnumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_invnumber_key ON ar USING btree (lower(invnumber));


--
-- Name: ar_ordnumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_ordnumber_key ON ar USING btree (lower(ordnumber));


--
-- Name: ar_quonumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_quonumber_key ON ar USING btree (lower(quonumber));


--
-- Name: ar_transdate_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX ar_transdate_key ON ar USING btree (transdate);


--
-- Name: assembly_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX assembly_id_key ON assembly USING btree (id);


--
-- Name: chart_accno_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE UNIQUE INDEX chart_accno_key ON chart USING btree (accno);


--
-- Name: chart_category_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX chart_category_key ON chart USING btree (category);


--
-- Name: chart_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX chart_id_key ON chart USING btree (id);


--
-- Name: chart_link_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX chart_link_key ON chart USING btree (link);


--
-- Name: csv_import_report_rows_index_row; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX csv_import_report_rows_index_row ON csv_import_report_rows USING btree ("row");


--
-- Name: custom_variables_config_id_idx; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX custom_variables_config_id_idx ON custom_variables USING btree (config_id);


--
-- Name: custom_variables_sub_module_idx; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX custom_variables_sub_module_idx ON custom_variables USING btree (sub_module);


--
-- Name: custom_variables_trans_config_module_idx; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX custom_variables_trans_config_module_idx ON custom_variables USING btree (config_id, trans_id, sub_module);


--
-- Name: customer_contact_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX customer_contact_key ON customer USING btree (contact);


--
-- Name: customer_customernumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX customer_customernumber_key ON customer USING btree (customernumber);


--
-- Name: customer_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX customer_id_key ON customer USING btree (id);


--
-- Name: customer_name_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX customer_name_key ON customer USING btree (name);


--
-- Name: department_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX department_id_key ON department USING btree (id);


--
-- Name: employee_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX employee_id_key ON employee USING btree (id);


--
-- Name: employee_login_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE UNIQUE INDEX employee_login_key ON employee USING btree (login);


--
-- Name: employee_name_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX employee_name_key ON employee USING btree (name);


--
-- Name: generic_translations_type_id_idx; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX generic_translations_type_id_idx ON generic_translations USING btree (language_id, translation_type, translation_id);


--
-- Name: gl_description_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX gl_description_key ON gl USING btree (lower(description));


--
-- Name: gl_employee_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX gl_employee_id_key ON gl USING btree (employee_id);


--
-- Name: gl_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX gl_id_key ON gl USING btree (id);


--
-- Name: gl_reference_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX gl_reference_key ON gl USING btree (lower(reference));


--
-- Name: gl_transdate_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX gl_transdate_key ON gl USING btree (transdate);


--
-- Name: idx_custom_variables_validity_config_id_trans_id; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX idx_custom_variables_validity_config_id_trans_id ON custom_variables_validity USING btree (config_id, trans_id);


--
-- Name: idx_custom_variables_validity_trans_id; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX idx_custom_variables_validity_trans_id ON custom_variables_validity USING btree (trans_id);


--
-- Name: idx_record_links_from_id; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX idx_record_links_from_id ON record_links USING btree (from_id);


--
-- Name: idx_record_links_from_table; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX idx_record_links_from_table ON record_links USING btree (from_table);


--
-- Name: idx_record_links_to_id; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX idx_record_links_to_id ON record_links USING btree (to_id);


--
-- Name: idx_record_links_to_table; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX idx_record_links_to_table ON record_links USING btree (to_table);


--
-- Name: invoice_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX invoice_id_key ON invoice USING btree (id);


--
-- Name: invoice_trans_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX invoice_trans_id_key ON invoice USING btree (trans_id);


--
-- Name: makemodel_model_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX makemodel_model_key ON makemodel USING btree (lower(model));


--
-- Name: makemodel_parts_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX makemodel_parts_id_key ON makemodel USING btree (parts_id);


--
-- Name: oe_employee_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX oe_employee_id_key ON oe USING btree (employee_id);


--
-- Name: oe_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX oe_id_key ON oe USING btree (id);


--
-- Name: oe_ordnumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX oe_ordnumber_key ON oe USING btree (lower(ordnumber));


--
-- Name: oe_transdate_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX oe_transdate_key ON oe USING btree (transdate);


--
-- Name: orderitems_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX orderitems_id_key ON orderitems USING btree (id);


--
-- Name: orderitems_trans_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX orderitems_trans_id_key ON orderitems USING btree (trans_id);


--
-- Name: parts_description_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX parts_description_key ON parts USING btree (lower(description));


--
-- Name: parts_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX parts_id_key ON parts USING btree (id);


--
-- Name: parts_partnumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX parts_partnumber_key ON parts USING btree (lower(partnumber));


--
-- Name: project_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX project_id_key ON project USING btree (id);


--
-- Name: shipto_trans_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX shipto_trans_id_key ON shipto USING btree (trans_id);


--
-- Name: status_trans_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX status_trans_id_key ON status USING btree (trans_id);


--
-- Name: taxkeys_chartid_startdate; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE UNIQUE INDEX taxkeys_chartid_startdate ON taxkeys USING btree (chart_id, startdate);


--
-- Name: units_language_unit_idx; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX units_language_unit_idx ON units_language USING btree (unit);


--
-- Name: units_name_idx; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX units_name_idx ON units USING btree (name);


--
-- Name: vendor_contact_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX vendor_contact_key ON vendor USING btree (contact);


--
-- Name: vendor_id_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX vendor_id_key ON vendor USING btree (id);


--
-- Name: vendor_name_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX vendor_name_key ON vendor USING btree (name);


--
-- Name: vendor_vendornumber_key; Type: INDEX; Schema: public; Owner: -; Tablespace: 
--

CREATE INDEX vendor_vendornumber_key ON vendor USING btree (vendornumber);


--
-- Name: after_delete_ap_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_ap_trigger
    AFTER DELETE ON ap
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_acc_trans_after_ar_ap_gl_delete();


--
-- Name: after_delete_ar_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_ar_trigger
    AFTER DELETE ON ar
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_acc_trans_after_ar_ap_gl_delete();


--
-- Name: after_delete_customer_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_customer_trigger
    AFTER DELETE ON customer
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_after_customer_vendor_delete();


--
-- Name: after_delete_delivery_term_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_delivery_term_trigger
    AFTER DELETE ON delivery_terms
    FOR EACH ROW
    EXECUTE PROCEDURE generic_translations_delete_on_delivery_terms_delete_trigger();


--
-- Name: after_delete_gl_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_gl_trigger
    AFTER DELETE ON gl
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_acc_trans_after_ar_ap_gl_delete();


--
-- Name: after_delete_payment_term_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_payment_term_trigger
    AFTER DELETE ON payment_terms
    FOR EACH ROW
    EXECUTE PROCEDURE generic_translations_delete_on_payment_terms_delete_trigger();


--
-- Name: after_delete_tax_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_tax_trigger
    AFTER DELETE ON tax
    FOR EACH ROW
    EXECUTE PROCEDURE generic_translations_delete_on_tax_delete_trigger();


--
-- Name: after_delete_vendor_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER after_delete_vendor_trigger
    AFTER DELETE ON vendor
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_after_customer_vendor_delete();


--
-- Name: before_delete_ap_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER before_delete_ap_trigger
    BEFORE DELETE ON ap
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_record_links_before_ap_delete();


--
-- Name: before_delete_ar_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER before_delete_ar_trigger
    BEFORE DELETE ON ar
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_record_links_before_ar_delete();


--
-- Name: before_delete_delivery_orders_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER before_delete_delivery_orders_trigger
    BEFORE DELETE ON delivery_orders
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_record_links_before_delivery_orders_delete();


--
-- Name: before_delete_oe_trigger; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER before_delete_oe_trigger
    BEFORE DELETE ON oe
    FOR EACH ROW
    EXECUTE PROCEDURE clean_up_record_links_before_oe_delete();


--
-- Name: check_inventory; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER check_inventory
    AFTER UPDATE ON oe
    FOR EACH ROW
    EXECUTE PROCEDURE check_inventory();


--
-- Name: customer_before_delete_clear_follow_ups; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER customer_before_delete_clear_follow_ups
    AFTER DELETE ON customer
    FOR EACH ROW
    EXECUTE PROCEDURE follow_up_delete_when_customer_vendor_is_deleted_trigger();


--
-- Name: del_customer; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER del_customer
    AFTER DELETE ON customer
    FOR EACH ROW
    EXECUTE PROCEDURE del_customer();


--
-- Name: del_vendor; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER del_vendor
    AFTER DELETE ON vendor
    FOR EACH ROW
    EXECUTE PROCEDURE del_vendor();


--
-- Name: delete_contact_custom_variables; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_contact_custom_variables
    BEFORE DELETE ON contacts
    FOR EACH ROW
    EXECUTE PROCEDURE delete_contact_custom_variables_trigger();


--
-- Name: delete_cv_custom_variables; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_cv_custom_variables
    BEFORE DELETE ON customer
    FOR EACH ROW
    EXECUTE PROCEDURE delete_cv_custom_variables_trigger();


--
-- Name: delete_cv_custom_variables; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_cv_custom_variables
    BEFORE DELETE ON vendor
    FOR EACH ROW
    EXECUTE PROCEDURE delete_cv_custom_variables_trigger();


--
-- Name: delete_delivery_order_items_dependencies; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_delivery_order_items_dependencies
    BEFORE DELETE ON delivery_order_items
    FOR EACH ROW
    EXECUTE PROCEDURE delivery_order_items_before_delete_trigger();


--
-- Name: delete_delivery_orders_dependencies; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_delivery_orders_dependencies
    BEFORE DELETE ON delivery_orders
    FOR EACH ROW
    EXECUTE PROCEDURE delivery_orders_before_delete_trigger();


--
-- Name: delete_invoice_dependencies; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_invoice_dependencies
    BEFORE DELETE ON invoice
    FOR EACH ROW
    EXECUTE PROCEDURE invoice_before_delete_trigger();


--
-- Name: delete_oe_dependencies; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_oe_dependencies
    BEFORE DELETE ON oe
    FOR EACH ROW
    EXECUTE PROCEDURE oe_before_delete_trigger();


--
-- Name: delete_orderitems_dependencies; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_orderitems_dependencies
    BEFORE DELETE ON orderitems
    FOR EACH ROW
    EXECUTE PROCEDURE orderitems_before_delete_trigger();


--
-- Name: delete_part_custom_variables; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_part_custom_variables
    BEFORE DELETE ON parts
    FOR EACH ROW
    EXECUTE PROCEDURE delete_part_custom_variables_trigger();


--
-- Name: delete_project_custom_variables; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delete_project_custom_variables
    BEFORE DELETE ON project
    FOR EACH ROW
    EXECUTE PROCEDURE delete_project_custom_variables_trigger();


--
-- Name: delivery_orders_on_update_close_follow_up; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER delivery_orders_on_update_close_follow_up
    AFTER UPDATE ON delivery_orders
    FOR EACH ROW
    EXECUTE PROCEDURE follow_up_close_when_oe_closed_trigger();


--
-- Name: follow_up_delete_notes; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER follow_up_delete_notes
    AFTER DELETE ON follow_ups
    FOR EACH ROW
    EXECUTE PROCEDURE follow_up_delete_notes_trigger();


--
-- Name: mtime_acc_trans; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_acc_trans
    BEFORE UPDATE ON acc_trans
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_ap; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_ap
    BEFORE UPDATE ON ap
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_ar; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_ar
    BEFORE UPDATE ON ar
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_bin; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_bin
    BEFORE UPDATE ON bin
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_chart; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_chart
    BEFORE UPDATE ON chart
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_contacts; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_contacts
    BEFORE UPDATE ON contacts
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_custom_variable_configs; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_custom_variable_configs
    BEFORE UPDATE ON custom_variable_configs
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_custom_variables; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_custom_variables
    BEFORE UPDATE ON custom_variables
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_customer; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_customer
    BEFORE UPDATE ON customer
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_delivery_order_items_id; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_delivery_order_items_id
    BEFORE UPDATE ON delivery_order_items
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_delivery_order_items_stock; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_delivery_order_items_stock
    BEFORE UPDATE ON delivery_order_items_stock
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_delivery_orders; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_delivery_orders
    BEFORE UPDATE ON delivery_orders
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_delivery_terms; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_delivery_terms
    BEFORE UPDATE ON delivery_terms
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_department; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_department
    BEFORE UPDATE ON department
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_dunning; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_dunning
    BEFORE UPDATE ON dunning
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_follow_up_links; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_follow_up_links
    BEFORE UPDATE ON follow_up_links
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_follow_ups; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_follow_ups
    BEFORE UPDATE ON follow_ups
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_gl; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_gl
    BEFORE UPDATE ON gl
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_inventory; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_inventory
    BEFORE UPDATE ON inventory
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_invoice; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_invoice
    BEFORE UPDATE ON invoice
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_notes; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_notes
    BEFORE UPDATE ON notes
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_oe; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_oe
    BEFORE UPDATE ON oe
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_orderitems; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_orderitems
    BEFORE UPDATE ON orderitems
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_parts; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_parts
    BEFORE UPDATE ON parts
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_partsgroup; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_partsgroup
    BEFORE UPDATE ON partsgroup
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_status; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_status
    BEFORE UPDATE ON status
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_tax; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_tax
    BEFORE UPDATE ON tax
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_transfer_type; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_transfer_type
    BEFORE UPDATE ON transfer_type
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_vendor; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_vendor
    BEFORE UPDATE ON vendor
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: mtime_warehouse; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER mtime_warehouse
    BEFORE UPDATE ON warehouse
    FOR EACH ROW
    EXECUTE PROCEDURE set_mtime();


--
-- Name: oe_before_delete_clear_follow_ups; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER oe_before_delete_clear_follow_ups
    BEFORE DELETE ON oe
    FOR EACH ROW
    EXECUTE PROCEDURE follow_up_delete_when_oe_is_deleted_trigger();


--
-- Name: oe_on_update_close_follow_up; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER oe_on_update_close_follow_up
    AFTER UPDATE ON oe
    FOR EACH ROW
    EXECUTE PROCEDURE follow_up_close_when_oe_closed_trigger();


--
-- Name: priceupdate_parts; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER priceupdate_parts
    AFTER UPDATE ON parts
    FOR EACH ROW
    EXECUTE PROCEDURE set_priceupdate_parts();


--
-- Name: trig_assembly_purchase_price; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trig_assembly_purchase_price
    AFTER INSERT OR DELETE OR UPDATE ON assembly
    FOR EACH ROW
    EXECUTE PROCEDURE update_purchase_price();


--
-- Name: trig_update_onhand; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER trig_update_onhand
    AFTER INSERT OR DELETE OR UPDATE ON inventory
    FOR EACH ROW
    EXECUTE PROCEDURE update_onhand();


--
-- Name: vendor_before_delete_clear_follow_ups; Type: TRIGGER; Schema: public; Owner: -
--

CREATE TRIGGER vendor_before_delete_clear_follow_ups
    AFTER DELETE ON vendor
    FOR EACH ROW
    EXECUTE PROCEDURE follow_up_delete_when_customer_vendor_is_deleted_trigger();


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY invoice
    ADD CONSTRAINT "$1" FOREIGN KEY (parts_id) REFERENCES parts(id);


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT "$1" FOREIGN KEY (customer_id) REFERENCES customer(id);


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT "$1" FOREIGN KEY (vendor_id) REFERENCES vendor(id);


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY prices
    ADD CONSTRAINT "$1" FOREIGN KEY (parts_id) REFERENCES parts(id);


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY units
    ADD CONSTRAINT "$1" FOREIGN KEY (base_unit) REFERENCES units(name);


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT "$1" FOREIGN KEY (buchungsgruppen_id) REFERENCES buchungsgruppen(id);


--
-- Name: $1; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY acc_trans
    ADD CONSTRAINT "$1" FOREIGN KEY (chart_id) REFERENCES chart(id);


--
-- Name: $2; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY prices
    ADD CONSTRAINT "$2" FOREIGN KEY (pricegroup_id) REFERENCES pricegroup(id);


--
-- Name: acc_trans_project_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY acc_trans
    ADD CONSTRAINT acc_trans_project_id_fkey FOREIGN KEY (project_id) REFERENCES project(id);


--
-- Name: acc_trans_tax_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY acc_trans
    ADD CONSTRAINT acc_trans_tax_id_fkey FOREIGN KEY (tax_id) REFERENCES tax(id);


--
-- Name: ap_cp_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_cp_id_fkey FOREIGN KEY (cp_id) REFERENCES contacts(cp_id);


--
-- Name: ap_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: ap_delivery_term_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_delivery_term_id_fkey FOREIGN KEY (delivery_term_id) REFERENCES delivery_terms(id);


--
-- Name: ap_department_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_department_id_fkey FOREIGN KEY (department_id) REFERENCES department(id);


--
-- Name: ap_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: ap_globalproject_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_globalproject_id_fkey FOREIGN KEY (globalproject_id) REFERENCES project(id);


--
-- Name: ap_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: ap_payment_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_payment_id_fkey FOREIGN KEY (payment_id) REFERENCES payment_terms(id);


--
-- Name: ap_storno_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ap
    ADD CONSTRAINT ap_storno_id_fkey FOREIGN KEY (storno_id) REFERENCES ap(id);


--
-- Name: ar_cp_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_cp_id_fkey FOREIGN KEY (cp_id) REFERENCES contacts(cp_id);


--
-- Name: ar_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: ar_delivery_term_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_delivery_term_id_fkey FOREIGN KEY (delivery_term_id) REFERENCES delivery_terms(id);


--
-- Name: ar_department_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_department_id_fkey FOREIGN KEY (department_id) REFERENCES department(id);


--
-- Name: ar_dunning_config_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_dunning_config_id_fkey FOREIGN KEY (dunning_config_id) REFERENCES dunning_config(id);


--
-- Name: ar_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: ar_globalproject_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_globalproject_id_fkey FOREIGN KEY (globalproject_id) REFERENCES project(id);


--
-- Name: ar_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: ar_payment_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_payment_id_fkey FOREIGN KEY (payment_id) REFERENCES payment_terms(id);


--
-- Name: ar_salesman_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_salesman_id_fkey FOREIGN KEY (salesman_id) REFERENCES employee(id);


--
-- Name: ar_shipto_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_shipto_id_fkey FOREIGN KEY (shipto_id) REFERENCES shipto(shipto_id);


--
-- Name: ar_storno_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY ar
    ADD CONSTRAINT ar_storno_id_fkey FOREIGN KEY (storno_id) REFERENCES ar(id);


--
-- Name: bank_accounts_chart_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY bank_accounts
    ADD CONSTRAINT bank_accounts_chart_id_fkey FOREIGN KEY (chart_id) REFERENCES chart(id);


--
-- Name: bin_warehouse_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY bin
    ADD CONSTRAINT bin_warehouse_id_fkey FOREIGN KEY (warehouse_id) REFERENCES warehouse(id);


--
-- Name: csv_import_profile_settings_csv_import_profile_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY csv_import_profile_settings
    ADD CONSTRAINT csv_import_profile_settings_csv_import_profile_id_fkey FOREIGN KEY (csv_import_profile_id) REFERENCES csv_import_profiles(id);


--
-- Name: csv_import_report_rows_csv_import_report_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY csv_import_report_rows
    ADD CONSTRAINT csv_import_report_rows_csv_import_report_id_fkey FOREIGN KEY (csv_import_report_id) REFERENCES csv_import_reports(id);


--
-- Name: csv_import_report_status_csv_import_report_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY csv_import_report_status
    ADD CONSTRAINT csv_import_report_status_csv_import_report_id_fkey FOREIGN KEY (csv_import_report_id) REFERENCES csv_import_reports(id);


--
-- Name: csv_import_reports_profile_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY csv_import_reports
    ADD CONSTRAINT csv_import_reports_profile_id_fkey FOREIGN KEY (profile_id) REFERENCES csv_import_profiles(id);


--
-- Name: custom_variables_config_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY custom_variables
    ADD CONSTRAINT custom_variables_config_id_fkey FOREIGN KEY (config_id) REFERENCES custom_variable_configs(id);


--
-- Name: custom_variables_validity_config_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY custom_variables_validity
    ADD CONSTRAINT custom_variables_validity_config_id_fkey FOREIGN KEY (config_id) REFERENCES custom_variable_configs(id);


--
-- Name: customer_business_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_business_id_fkey FOREIGN KEY (business_id) REFERENCES business(id);


--
-- Name: customer_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: customer_delivery_term_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_delivery_term_id_fkey FOREIGN KEY (delivery_term_id) REFERENCES delivery_terms(id);


--
-- Name: customer_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: customer_payment_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY customer
    ADD CONSTRAINT customer_payment_id_fkey FOREIGN KEY (payment_id) REFERENCES payment_terms(id);


--
-- Name: defaults_bin_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY defaults
    ADD CONSTRAINT defaults_bin_id_fkey FOREIGN KEY (bin_id) REFERENCES bin(id);


--
-- Name: defaults_bin_id_ignore_onhand_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY defaults
    ADD CONSTRAINT defaults_bin_id_ignore_onhand_fkey FOREIGN KEY (bin_id_ignore_onhand) REFERENCES bin(id);


--
-- Name: defaults_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY defaults
    ADD CONSTRAINT defaults_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: defaults_warehouse_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY defaults
    ADD CONSTRAINT defaults_warehouse_id_fkey FOREIGN KEY (warehouse_id) REFERENCES warehouse(id);


--
-- Name: defaults_warehouse_id_ignore_onhand_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY defaults
    ADD CONSTRAINT defaults_warehouse_id_ignore_onhand_fkey FOREIGN KEY (warehouse_id_ignore_onhand) REFERENCES warehouse(id);


--
-- Name: delivery_order_items_delivery_order_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items
    ADD CONSTRAINT delivery_order_items_delivery_order_id_fkey FOREIGN KEY (delivery_order_id) REFERENCES delivery_orders(id) ON DELETE CASCADE;


--
-- Name: delivery_order_items_parts_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items
    ADD CONSTRAINT delivery_order_items_parts_id_fkey FOREIGN KEY (parts_id) REFERENCES parts(id) ON DELETE RESTRICT;


--
-- Name: delivery_order_items_price_factor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items
    ADD CONSTRAINT delivery_order_items_price_factor_id_fkey FOREIGN KEY (price_factor_id) REFERENCES price_factors(id) ON DELETE RESTRICT;


--
-- Name: delivery_order_items_pricegroup_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items
    ADD CONSTRAINT delivery_order_items_pricegroup_id_fkey FOREIGN KEY (pricegroup_id) REFERENCES pricegroup(id) ON DELETE RESTRICT;


--
-- Name: delivery_order_items_project_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items
    ADD CONSTRAINT delivery_order_items_project_id_fkey FOREIGN KEY (project_id) REFERENCES project(id) ON DELETE SET NULL;


--
-- Name: delivery_order_items_stock_bin_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items_stock
    ADD CONSTRAINT delivery_order_items_stock_bin_id_fkey FOREIGN KEY (bin_id) REFERENCES bin(id) ON DELETE RESTRICT;


--
-- Name: delivery_order_items_stock_delivery_order_item_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items_stock
    ADD CONSTRAINT delivery_order_items_stock_delivery_order_item_id_fkey FOREIGN KEY (delivery_order_item_id) REFERENCES delivery_order_items(id) ON DELETE CASCADE;


--
-- Name: delivery_order_items_stock_warehouse_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_order_items_stock
    ADD CONSTRAINT delivery_order_items_stock_warehouse_id_fkey FOREIGN KEY (warehouse_id) REFERENCES warehouse(id) ON DELETE RESTRICT;


--
-- Name: delivery_orders_cp_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_cp_id_fkey FOREIGN KEY (cp_id) REFERENCES contacts(cp_id);


--
-- Name: delivery_orders_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: delivery_orders_customer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_customer_id_fkey FOREIGN KEY (customer_id) REFERENCES customer(id);


--
-- Name: delivery_orders_delivery_term_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_delivery_term_id_fkey FOREIGN KEY (delivery_term_id) REFERENCES delivery_terms(id);


--
-- Name: delivery_orders_department_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_department_id_fkey FOREIGN KEY (department_id) REFERENCES department(id);


--
-- Name: delivery_orders_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: delivery_orders_globalproject_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_globalproject_id_fkey FOREIGN KEY (globalproject_id) REFERENCES project(id);


--
-- Name: delivery_orders_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: delivery_orders_salesman_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_salesman_id_fkey FOREIGN KEY (salesman_id) REFERENCES employee(id);


--
-- Name: delivery_orders_shipto_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_shipto_id_fkey FOREIGN KEY (shipto_id) REFERENCES shipto(shipto_id);


--
-- Name: delivery_orders_vendor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY delivery_orders
    ADD CONSTRAINT delivery_orders_vendor_id_fkey FOREIGN KEY (vendor_id) REFERENCES vendor(id);


--
-- Name: drafts_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY drafts
    ADD CONSTRAINT drafts_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: dunning_dunning_config_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY dunning
    ADD CONSTRAINT dunning_dunning_config_id_fkey FOREIGN KEY (dunning_config_id) REFERENCES dunning_config(id);


--
-- Name: dunning_fee_interest_ar_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY dunning
    ADD CONSTRAINT dunning_fee_interest_ar_id_fkey FOREIGN KEY (fee_interest_ar_id) REFERENCES ar(id);


--
-- Name: exchangerate_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY exchangerate
    ADD CONSTRAINT exchangerate_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: follow_up_access_what_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY follow_up_access
    ADD CONSTRAINT follow_up_access_what_fkey FOREIGN KEY (what) REFERENCES employee(id);


--
-- Name: follow_up_access_who_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY follow_up_access
    ADD CONSTRAINT follow_up_access_who_fkey FOREIGN KEY (who) REFERENCES employee(id);


--
-- Name: follow_up_links_follow_up_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY follow_up_links
    ADD CONSTRAINT follow_up_links_follow_up_id_fkey FOREIGN KEY (follow_up_id) REFERENCES follow_ups(id) ON DELETE CASCADE;


--
-- Name: follow_ups_created_by_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY follow_ups
    ADD CONSTRAINT follow_ups_created_by_fkey FOREIGN KEY (created_by) REFERENCES employee(id);


--
-- Name: follow_ups_created_for_user_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY follow_ups
    ADD CONSTRAINT follow_ups_created_for_user_fkey FOREIGN KEY (created_for_user) REFERENCES employee(id);


--
-- Name: follow_ups_note_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY follow_ups
    ADD CONSTRAINT follow_ups_note_id_fkey FOREIGN KEY (note_id) REFERENCES notes(id);


--
-- Name: generic_translations_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY generic_translations
    ADD CONSTRAINT generic_translations_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: gl_department_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY gl
    ADD CONSTRAINT gl_department_id_fkey FOREIGN KEY (department_id) REFERENCES department(id);


--
-- Name: gl_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY gl
    ADD CONSTRAINT gl_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: gl_storno_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY gl
    ADD CONSTRAINT gl_storno_id_fkey FOREIGN KEY (storno_id) REFERENCES gl(id);


--
-- Name: history_erp_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY history_erp
    ADD CONSTRAINT history_erp_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: inventory_bin_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_bin_id_fkey FOREIGN KEY (bin_id) REFERENCES bin(id);


--
-- Name: inventory_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: inventory_parts_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_parts_id_fkey FOREIGN KEY (parts_id) REFERENCES parts(id);


--
-- Name: inventory_project_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_project_id_fkey FOREIGN KEY (project_id) REFERENCES project(id);


--
-- Name: inventory_trans_type_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_trans_type_id_fkey FOREIGN KEY (trans_type_id) REFERENCES transfer_type(id);


--
-- Name: inventory_warehouse_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY inventory
    ADD CONSTRAINT inventory_warehouse_id_fkey FOREIGN KEY (warehouse_id) REFERENCES warehouse(id);


--
-- Name: invoice_price_factor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY invoice
    ADD CONSTRAINT invoice_price_factor_id_fkey FOREIGN KEY (price_factor_id) REFERENCES price_factors(id);


--
-- Name: invoice_pricegroup_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY invoice
    ADD CONSTRAINT invoice_pricegroup_id_fkey FOREIGN KEY (pricegroup_id) REFERENCES pricegroup(id);


--
-- Name: invoice_project_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY invoice
    ADD CONSTRAINT invoice_project_id_fkey FOREIGN KEY (project_id) REFERENCES project(id);


--
-- Name: notes_created_by_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY notes
    ADD CONSTRAINT notes_created_by_fkey FOREIGN KEY (created_by) REFERENCES employee(id);


--
-- Name: oe_cp_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_cp_id_fkey FOREIGN KEY (cp_id) REFERENCES contacts(cp_id);


--
-- Name: oe_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: oe_customer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_customer_id_fkey FOREIGN KEY (customer_id) REFERENCES customer(id);


--
-- Name: oe_delivery_customer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_delivery_customer_id_fkey FOREIGN KEY (delivery_customer_id) REFERENCES customer(id);


--
-- Name: oe_delivery_term_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_delivery_term_id_fkey FOREIGN KEY (delivery_term_id) REFERENCES delivery_terms(id);


--
-- Name: oe_delivery_vendor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_delivery_vendor_id_fkey FOREIGN KEY (delivery_vendor_id) REFERENCES vendor(id);


--
-- Name: oe_department_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_department_id_fkey FOREIGN KEY (department_id) REFERENCES department(id);


--
-- Name: oe_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: oe_globalproject_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_globalproject_id_fkey FOREIGN KEY (globalproject_id) REFERENCES project(id);


--
-- Name: oe_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: oe_payment_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_payment_id_fkey FOREIGN KEY (payment_id) REFERENCES payment_terms(id);


--
-- Name: oe_salesman_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_salesman_id_fkey FOREIGN KEY (salesman_id) REFERENCES employee(id);


--
-- Name: oe_shipto_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_shipto_id_fkey FOREIGN KEY (shipto_id) REFERENCES shipto(shipto_id);


--
-- Name: oe_vendor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY oe
    ADD CONSTRAINT oe_vendor_id_fkey FOREIGN KEY (vendor_id) REFERENCES vendor(id);


--
-- Name: orderitems_parts_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY orderitems
    ADD CONSTRAINT orderitems_parts_id_fkey FOREIGN KEY (parts_id) REFERENCES parts(id) ON DELETE RESTRICT;


--
-- Name: orderitems_price_factor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY orderitems
    ADD CONSTRAINT orderitems_price_factor_id_fkey FOREIGN KEY (price_factor_id) REFERENCES price_factors(id) ON DELETE RESTRICT;


--
-- Name: orderitems_pricegroup_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY orderitems
    ADD CONSTRAINT orderitems_pricegroup_id_fkey FOREIGN KEY (pricegroup_id) REFERENCES pricegroup(id) ON DELETE RESTRICT;


--
-- Name: orderitems_project_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY orderitems
    ADD CONSTRAINT orderitems_project_id_fkey FOREIGN KEY (project_id) REFERENCES project(id) ON DELETE SET NULL;


--
-- Name: orderitems_trans_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY orderitems
    ADD CONSTRAINT orderitems_trans_id_fkey FOREIGN KEY (trans_id) REFERENCES oe(id) ON DELETE CASCADE;


--
-- Name: parts_bin_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_bin_id_fkey FOREIGN KEY (bin_id) REFERENCES bin(id);


--
-- Name: parts_partsgroup_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_partsgroup_id_fkey FOREIGN KEY (partsgroup_id) REFERENCES partsgroup(id);


--
-- Name: parts_payment_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_payment_id_fkey FOREIGN KEY (payment_id) REFERENCES payment_terms(id);


--
-- Name: parts_price_factor_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_price_factor_id_fkey FOREIGN KEY (price_factor_id) REFERENCES price_factors(id);


--
-- Name: parts_unit_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_unit_fkey FOREIGN KEY (unit) REFERENCES units(name);


--
-- Name: parts_warehouse_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY parts
    ADD CONSTRAINT parts_warehouse_id_fkey FOREIGN KEY (warehouse_id) REFERENCES warehouse(id);


--
-- Name: periodic_invoices_ar_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY periodic_invoices
    ADD CONSTRAINT periodic_invoices_ar_id_fkey FOREIGN KEY (ar_id) REFERENCES ar(id) ON DELETE CASCADE;


--
-- Name: periodic_invoices_config_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY periodic_invoices
    ADD CONSTRAINT periodic_invoices_config_id_fkey FOREIGN KEY (config_id) REFERENCES periodic_invoices_configs(id) ON DELETE CASCADE;


--
-- Name: periodic_invoices_configs_ar_chart_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY periodic_invoices_configs
    ADD CONSTRAINT periodic_invoices_configs_ar_chart_id_fkey FOREIGN KEY (ar_chart_id) REFERENCES chart(id) ON DELETE RESTRICT;


--
-- Name: periodic_invoices_configs_oe_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY periodic_invoices_configs
    ADD CONSTRAINT periodic_invoices_configs_oe_id_fkey FOREIGN KEY (oe_id) REFERENCES oe(id) ON DELETE CASCADE;


--
-- Name: periodic_invoices_configs_printer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY periodic_invoices_configs
    ADD CONSTRAINT periodic_invoices_configs_printer_id_fkey FOREIGN KEY (printer_id) REFERENCES printers(id) ON DELETE SET NULL;


--
-- Name: project_customer_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY project
    ADD CONSTRAINT project_customer_id_fkey FOREIGN KEY (customer_id) REFERENCES customer(id);


--
-- Name: project_project_type_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY project
    ADD CONSTRAINT project_project_type_id_fkey FOREIGN KEY (project_type_id) REFERENCES project_types(id);


--
-- Name: sepa_export_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sepa_export
    ADD CONSTRAINT sepa_export_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: sepa_export_items_ap_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sepa_export_items
    ADD CONSTRAINT sepa_export_items_ap_id_fkey FOREIGN KEY (ap_id) REFERENCES ap(id);


--
-- Name: sepa_export_items_ar_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sepa_export_items
    ADD CONSTRAINT sepa_export_items_ar_id_fkey FOREIGN KEY (ar_id) REFERENCES ar(id);


--
-- Name: sepa_export_items_chart_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sepa_export_items
    ADD CONSTRAINT sepa_export_items_chart_id_fkey FOREIGN KEY (chart_id) REFERENCES chart(id);


--
-- Name: sepa_export_items_sepa_export_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY sepa_export_items
    ADD CONSTRAINT sepa_export_items_sepa_export_id_fkey FOREIGN KEY (sepa_export_id) REFERENCES sepa_export(id);


--
-- Name: tax_chart_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY tax
    ADD CONSTRAINT tax_chart_id_fkey FOREIGN KEY (chart_id) REFERENCES chart(id);


--
-- Name: taxkeys_chart_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY taxkeys
    ADD CONSTRAINT taxkeys_chart_id_fkey FOREIGN KEY (chart_id) REFERENCES chart(id);


--
-- Name: taxkeys_tax_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY taxkeys
    ADD CONSTRAINT taxkeys_tax_id_fkey FOREIGN KEY (tax_id) REFERENCES tax(id);


--
-- Name: todo_user_config_employee_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY todo_user_config
    ADD CONSTRAINT todo_user_config_employee_id_fkey FOREIGN KEY (employee_id) REFERENCES employee(id);


--
-- Name: translation_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY translation
    ADD CONSTRAINT translation_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: units_language_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY units_language
    ADD CONSTRAINT units_language_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: units_language_unit_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY units_language
    ADD CONSTRAINT units_language_unit_fkey FOREIGN KEY (unit) REFERENCES units(name);


--
-- Name: vendor_business_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY vendor
    ADD CONSTRAINT vendor_business_id_fkey FOREIGN KEY (business_id) REFERENCES business(id);


--
-- Name: vendor_currency_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY vendor
    ADD CONSTRAINT vendor_currency_id_fkey FOREIGN KEY (currency_id) REFERENCES currencies(id);


--
-- Name: vendor_delivery_term_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY vendor
    ADD CONSTRAINT vendor_delivery_term_id_fkey FOREIGN KEY (delivery_term_id) REFERENCES delivery_terms(id);


--
-- Name: vendor_language_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY vendor
    ADD CONSTRAINT vendor_language_id_fkey FOREIGN KEY (language_id) REFERENCES language(id);


--
-- Name: vendor_payment_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: -
--

ALTER TABLE ONLY vendor
    ADD CONSTRAINT vendor_payment_id_fkey FOREIGN KEY (payment_id) REFERENCES payment_terms(id);


SET search_path = tax, pg_catalog;

--
-- Name: report_headings_category_id_fkey; Type: FK CONSTRAINT; Schema: tax; Owner: -
--

ALTER TABLE ONLY report_headings
    ADD CONSTRAINT report_headings_category_id_fkey FOREIGN KEY (category_id) REFERENCES report_categories(id);


--
-- Name: report_variables_heading_id_fkey; Type: FK CONSTRAINT; Schema: tax; Owner: -
--

ALTER TABLE ONLY report_variables
    ADD CONSTRAINT report_variables_heading_id_fkey FOREIGN KEY (heading_id) REFERENCES report_headings(id);


--
-- Name: public; Type: ACL; Schema: -; Owner: -
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

